<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
define('IN_FORUM_ADMIN', 1);
require dirname(__FILE__) . '/../include/init.php';
if (($forum_user['g_id'] > USER_MOD && $forum_user['g_global_moderation'] != '1') || (($forum_user['g_id'] == USER_MOD || $forum_user['g_global_moderation']) && bb_mod_ban_users == '0'))
    BB_Functions::Message($lang['No permission'], true, 1);
$page = isset($_GET['Page']) ? BB_Input::Htmlspecialchars($_GET['Page']) : null;
$submenu = array($lang['Add'] => 'bans.php?Page=Add', $lang['Edit'] => 'bans.php?Page=Edit');
if (isset($_REQUEST['add_ban']) || isset($_GET['edit_ban']))
{
    if (isset($_GET['add_ban']) || isset($_POST['add_ban']))
    {
        if (isset($_GET['add_ban']))
        {
            $add_ban = intval($_GET['add_ban']);
            if ($add_ban < 2)
                BB_Functions::Message($lang['Bad request']);
            $user_id = $add_ban;
            $result = $db->query('SELECT gid, username, email FROM ' . $db->prefix . 'users WHERE id=' . $db->escape($user_id)) or BB_Functions::Error($lang['error_29'], __FILE__, __LINE__, $db->error());
            if ($db->num_rows($result))
                list($gid, $ban_user, $ban_email) = $db->fetch_row($result);
            else
                BB_Functions::Message($lang['ban_no_user_id']);
        }
        else
        {
            $ban_user = trim($_POST['new_ban_user']);
            if ($ban_user != '')
            {
                $result = $db->query('SELECT id, gid, username, email FROM ' . $db->prefix . 'users WHERE username=\'' . $db->escape($ban_user) . '\' AND id>1') or BB_Functions::Error($lang['error_29'], __FILE__, __LINE__, $db->error());
                if ($db->num_rows($result))
                    list($user_id, $gid, $ban_user, $ban_email) = $db->fetch_row($result);
                else
                    BB_Functions::Message($lang['ban_no_user']);
            }
        }
        if (isset($gid) && $gid == USER_ADMIN)
            BB_Functions::Message($lang['ban_is_admin']);
        if (isset($user_id))
        {
            $result = $db->query('SELECT poster_ip FROM ' . $db->prefix . 'posts WHERE poster_id=' . $db->escape($user_id) . ' ORDER BY posted DESC LIMIT 1') or BB_Functions::Error($lang['error_3'], __FILE__, __LINE__, $db->error());
            $ban_ip = ($db->num_rows($result)) ? $db->result($result) : '';
        }
        $mode = 'add';
    }
    else
    {
        $ban_id = intval($_GET['edit_ban']);
        if ($ban_id < 1)
            BB_Functions::Message($lang['Bad request']);
        $result = $db->query('SELECT username, ip, email, message, expire FROM ' . $db->prefix . 'bans WHERE id=' . $db->escape($ban_id)) or BB_Functions::Error($lang['error_63'], __FILE__, __LINE__, $db->error());
        if ($db->num_rows($result))
            list($ban_user, $ban_ip, $ban_email, $ban_message, $ban_expire) = $db->fetch_row($result);
        else
            BB_Functions::Message($lang['Bad request']);
        $ban_expire = ($ban_expire != '') ? date('Y-m-d', $ban_expire) : '';
        $mode = 'edit';
    }
    $page_title = BB_Input::Htmlspecialchars($lang['Admin'] . $lang['Bans']);
    $focus_element = array('bans2', 'ban_user');
    require FORUM_ROOT . 'admin/header.php';
    ?>
    <div class="blockform">
        <h2><?php echo $lang['Supplement ban'] ?></h2>
        <form id="bans2" method="post" action="bans.php">
            <div class="inform">
                <input type="hidden" name="mode" value="<?php echo $mode ?>" />
    <?php
    if ($mode == 'edit')
    {
        ?>
                    <input type="hidden" name="ban_id" value="<?php echo $ban_id ?>" />
        <?php
    }
    ?>	
                <div class="infldset file" style="padding:10px">
                    <table class="aligntop" cellspacing="0">
                        <tr>
                            <th class="header"><?php echo $lang['Username'] ?></th>
                            <td class="tips"><?php BB_Template::Print_Tooltip($lang['tip_27']) ?></td>
                            <td><input type="text" class="textbox" name="ban_user" size="30" maxlength="25" value="<?php if (isset($ban_user))
        echo BB_Input::Htmlspecialchars($ban_user); ?>" tabindex="1" /></td>
                        </tr>
                        <tr>
                            <th class="header"><?php echo $lang['IP address'] ?></th>
                            <td class="tips"><?php BB_Template::Print_Tooltip($lang['tip_28']) ?></td>
                            <td><input type="text" class="textbox" name="ban_ip" size="30" maxlength="255" value="<?php if (isset($ban_ip))
        echo $ban_ip; ?>" tabindex="2" /></td>
                        </tr>
                        <tr>
                            <th class="header"><?php echo $lang['E-Mail / domain'] ?></th>
                            <td class="tips"><?php BB_Template::Print_Tooltip($lang['tip_29']) ?></td>
                            <td><input type="text" class="textbox" name="ban_email" size="30" maxlength="50" value="<?php if (isset($ban_email))
        echo strtolower($ban_email); ?>" tabindex="3" /></td>
                        </tr>
                        <tr>
                            <th class="header"><?php echo $lang['New ban message'] ?></th>
                            <td class="tips"><?php BB_Template::Print_Tooltip($lang['tip_30']) ?></td>
                            <td><input type="text" class="textbox" name="ban_message" size="30" maxlength="255" value="<?php if (isset($ban_message))
        echo BB_Input::Htmlspecialchars($ban_message); ?>" tabindex="4" /></td>
                        </tr>
                        <tr>
                            <th class="header"><?php echo $lang['Ban expire date'] ?></th>
                            <td class="tips"><?php BB_Template::Print_Tooltip($lang['tip_31']) ?></td>
                            <td><input type="text" class="textbox" name="ban_expire" size="30" maxlength="10" value="<?php if (isset($ban_expire))
        echo $ban_expire; ?>" tabindex="5" /></td>
                        </tr>
                    </table>
                </div>
            </div>
            <div><input type="button" class="b1" onclick="javascript:history.go(-1)" value="<?php echo $lang['Go back'] ?>"> <input type="submit" class="b1" name="add_edit_ban" value="<?php echo $lang['Save'] ?>" tabindex="6" /></div>
        </form>
    </div>
    <?php
    require FORUM_ROOT . 'admin/footer.php';
}
else if (isset($_POST['add_edit_ban']))
{
    BB_Input::Confirm_Referrer('bans.php');
    $ban_user = trim($_POST['ban_user']);
    $ban_ip = trim($_POST['ban_ip']);
    $ban_email = strtolower(trim($_POST['ban_email']));
    $ban_message = trim($_POST['ban_message']);
    $ban_expire = trim($_POST['ban_expire']);
    if ($ban_user == '' && $ban_ip == '' && $ban_email == '')
        BB_Functions::Message($lang['Ban_error_message']);
    else if (strtolower($ban_user) == 'guest')
        BB_Functions::Message('The guest user cannot be banned.');
    if ($ban_ip != '')
    {
        $ban_ip = preg_replace('/[\s]{2,}/', ' ', $ban_ip);
        $addresses = explode(' ', $ban_ip);
        $addresses = array_map('trim', $addresses);
        for ($i = 0; $i < count($addresses); ++$i)
        {
            $octets = explode('.', $addresses[$i]);
            for ($c = 0; $c < count($octets); ++$c)
            {
                $octets[$c] = (strlen($octets[$c]) > 1) ? ltrim($octets[$c], "0") : $octets[$c];
                if ($c > 3 || preg_match('/[^0-9]/', $octets[$c]) || intval($octets[$c]) > 255)
                    BB_Functions::Message($lang['Ban_ip_error']);
            }
            $cur_address = implode('.', $octets);
            $addresses[$i] = $cur_address;
        }
        $ban_ip = implode(' ', $addresses);
    }
    if ($ban_email != '' && !BB_Email::Is_Valid_Email($ban_email))
    {
        if (!preg_match('/^[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,4})$/', $ban_email))
            BB_Functions::Message($lang['Ban_email_error']);
    }
    if ($ban_expire != '' && $ban_expire != 'Never')
    {
        $ban_expire = strtotime($ban_expire);
        if ($ban_expire == -1 || $ban_expire <= time())
            BB_Functions::Message($lang['Ban_date_error']);
    }
    else
        $ban_expire = 'NULL';
    $ban_user = ($ban_user != '') ? '\'' . $db->escape($ban_user) . '\'' : 'NULL';
    $ban_ip = ($ban_ip != '') ? '\'' . $db->escape($ban_ip) . '\'' : 'NULL';
    $ban_email = ($ban_email != '') ? '\'' . $db->escape($ban_email) . '\'' : 'NULL';
    $ban_message = ($ban_message != '') ? '\'' . $db->escape($ban_message) . '\'' : 'NULL';
    if ($_POST['mode'] == 'add')
        $db->query('INSERT INTO ' . $db->prefix . 'bans (username, ip, email, message, expire) VALUES(' . $ban_user . ', ' . $ban_ip . ', ' . $ban_email . ', ' . $ban_message . ', ' . $db->escape($ban_expire) . ')') or BB_Functions::Error($lang['error_64'], __FILE__, __LINE__, $db->error());
    else
        $db->query('UPDATE ' . $db->prefix . 'bans SET username=' . $ban_user . ', ip=' . $ban_ip . ', email=' . $ban_email . ', message=' . $ban_message . ', expire=' . $ban_expire . ' WHERE id=' . $db->escape($_POST['ban_id'])) or BB_Functions::Error($lang['error_65'], __FILE__, __LINE__, $db->error());
    BB_Cache::Generate_Bans();
    BB_Admin_Functions::Log_Action('User ban added ' . $ban_user, 3);
    BB_Functions::Redirect('bans.php?Page=Edit', $lang['Ban'] . (($_POST['mode'] == 'edit') ? $lang['edited'] : $lang['added']) . '. Redirecting &hellip;');
}
else if (isset($_GET['del_ban']))
{
    BB_Input::Confirm_Referrer('bans.php');
    $ban_id = intval($_GET['del_ban']);
    if ($ban_id < 1)
        BB_Functions::Message($lang['Bad request']);
    $db->query('DELETE FROM ' . $db->prefix . 'bans WHERE id=' . $db->escape($ban_id)) or BB_Functions::Error($lang['error_66'], __FILE__, __LINE__, $db->error());
    BB_Cache::Generate_Bans();
    BB_Admin_Functions::Log_Action('User ban removed ' . $ban_id, 3);
    BB_Functions::Redirect('bans.php?Page=Edit', $lang['redirect_ban_deleted']);
}
$page_title = BB_Input::Htmlspecialchars($lang['Admin'] . $lang['Bans']);
require FORUM_ROOT . 'admin/header.php';
if ($page == 'Add')
{
    echo BB_Template::Generate_Menu($submenu);
    ?>
    <div class="blockform">
        <form id="bans" method="post" action="bans.php?action=more">
            <div class="inform">
                <div class="infldset file" style="padding:10px">
                    <table class="aligntop" cellspacing="0">
                        <tr>
                            <th class="header"><?php echo $lang['Username'] ?></th>
                            <td class="tips"><?php BB_Template::Print_Tooltip($lang['tip_32']) ?></td>
                            <td><input type="text" class="textbox" name="new_ban_user" size="25" maxlength="25" tabindex="1" /></td>
                        </tr>
                    </table>
                </div>
            </div>
            <div><input type="submit" class="b1" name="add_ban" value="<?php echo $lang['Add'] ?>" tabindex="2" /></div>
        </form>
    </div>
    <?php
}
else if ($page == 'Edit')
{
    echo BB_Template::Generate_Menu($submenu);
    $focus_element = array('bans', 'new_ban_user');
    ?>
    <div class="blockform">
        <div class="fakeform">
    <?php
    $result = $db->query('SELECT id, username, ip, email, message, expire FROM ' . $db->prefix . 'bans ORDER BY id') or BB_Functions::Error($lang['error_67'], __FILE__, __LINE__, $db->error());
    if ($db->num_rows($result))
    {
        while ($cur_ban = $db->fetch_assoc($result))
        {
            $expire = BB_Input::Format_Time($cur_ban['expire'], true);
            ?>
                    <div class="inform">
                        <div class="infldset file" style="padding:10px">
                            <table cellspacing="0">
            <?php
            if ($cur_ban['username'] != '')
            {
                ?>
                                    <tr>
                                        <th style="width:150px"><?php echo $lang['Username'] ?></th>
                                        <td><?php echo BB_Input::Htmlspecialchars($cur_ban['username']) ?></td>
                                    </tr>
                <?php
            }
            if ($cur_ban['email'] != '')
            {
                ?>
                                    <tr>
                                        <th style="width:150px"><?php echo $lang['E-Mail'] ?></th>
                                        <td><?php echo $cur_ban['email'] ?></td>
                                    </tr>
                        <?php
                    }
                    if ($cur_ban['ip'] != '')
                    {
                        ?>
                                    <tr>
                                        <th style="width:150px"><?php echo $lang['IP Range'] ?></th>
                                        <td><?php echo $cur_ban['ip'] ?></td>
                                    </tr>
                <?php
            }
            if ($cur_ban['message'] != '')
            {
                ?>
                                    <tr>
                                        <th style="width:150px"><?php echo $lang['Reason'] ?></th>
                                        <td><?php echo BB_Input::Htmlspecialchars($cur_ban['message']) ?></td>
                                    </tr>
                <?php
            }
            ?>
                            </table>
                            <p class="linkactions"><a href="bans.php?edit_ban=<?php echo $cur_ban['id'] ?>"><?php echo $lang['Edit'] ?></a> - <a href="bans.php?del_ban=<?php echo $cur_ban['id'] ?>"><?php echo $lang['Remove'] ?></a></p>
                        </div>
                    </div>
            <?php
        }
    }
    else
        echo "\t\t\t\t" . '<p>' . $lang['No bans'] . '</p>' . "\n";
    ?>
        </div>
    </div>
    <?php
}
else
    BB_Functions::Message($lang['Bad request']);
require FORUM_ROOT . 'admin/footer.php';
?>