<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
define('IN_FORUM_ADMIN', 1);
require dirname(__FILE__) . '/../include/init.php';
if ($forum_user['g_id'] > USER_MOD && !$forum_user['g_global_moderation'])
    BB_Functions::Message($lang['No permission'], true, 1);
$page = isset($_GET['Page']) ? BB_Input::Htmlspecialchars($_GET['Page']) : null;
$submenu = array($lang['New'] => 'reports.php?Page=New', $lang['Zapped'] => 'reports.php?Page=Old');
if (isset($_POST['zap_id']))
{
    BB_Input::Confirm_Referrer('reports.php');
    $zap_id = intval(key($_POST['zap_id']));
    $result = $db->query('SELECT zapped FROM ' . $db->prefix . 'reports WHERE id=' . $db->escape($zap_id)) or BB_Functions::Error($lang['error_23'], __FILE__, __LINE__, $db->error());
    $zapped = $db->result($result);
    if ($zapped == '')
        $db->query('UPDATE ' . $db->prefix . 'reports SET zapped=' . time() . ', zapped_by=' . $forum_user['id'] . ' WHERE id=' . $db->escape($zap_id)) or BB_Functions::Error($lang['error_24'], __FILE__, __LINE__, $db->error());
    BB_Functions::Redirect('reports.php?Page=Old', $lang['redirect_report_zapped']);
}
$page_title = BB_Input::Htmlspecialchars($lang['Admin'] . $lang['Reports']);
require FORUM_ROOT . 'admin/header.php';
if ($page == 'New')
{
    echo BB_Template::Generate_Menu($submenu);
    ?>
    <div class="blockform">
        <form method="post" action="reports.php?action=zap">
            <?php
            $result = $db->query('SELECT r.id, r.post_id, r.topic_id, r.forum_id, r.reported_by, r.created, r.message, t.subject, f.forum_name, u.username AS reporter FROM ' . $db->prefix . 'reports AS r LEFT JOIN ' . $db->prefix . 'topics AS t ON r.topic_id=t.id LEFT JOIN ' . $db->prefix . 'forums AS f ON r.forum_id=f.id LEFT JOIN ' . $db->prefix . 'users AS u ON r.reported_by=u.id WHERE r.zapped IS NULL ORDER BY created DESC') or BB_Functions::Error($lang['error_25'], __FILE__, __LINE__, $db->error());
            if ($db->num_rows($result))
            {
                while ($cur_report = $db->fetch_assoc($result))
                {
                    $reporter = ($cur_report['reporter'] != '') ? '<a href="' . bb_forum_url . 'member.php?id=' . $cur_report['reported_by'] . '">' . BB_Input::Htmlspecialchars($cur_report['reporter']) . '</a>' : 'Deleted user';
                    $forum = ($cur_report['forum_name'] != '') ? '<a href="' . bb_forum_url . 'forum.php?id=' . $cur_report['forum_id'] . '">' . BB_Input::Htmlspecialchars($cur_report['forum_name']) . '</a>' : 'Deleted';
                    $topic = ($cur_report['subject'] != '') ? '<a href="' . bb_forum_url . 'topic.php?id=' . $cur_report['topic_id'] . '">' . BB_Input::Htmlspecialchars($cur_report['subject']) . '</a>' : 'Deleted';
                    $post = ($cur_report['post_id'] != '') ? str_replace("\n", '<br />', BB_Input::Htmlspecialchars($cur_report['message'])) : 'Deleted';
                    $postid = ($cur_report['post_id'] != '') ? '<a href="' . bb_forum_url . 'topic.php?pid=' . $cur_report['post_id'] . '#p' . $cur_report['post_id'] . '">Post #' . $cur_report['post_id'] . '</a>' : 'Deleted';
                    ?>
                    <div class="inform">
                        <h2><?php echo $lang['Reported']; ?> <?php echo BB_Input::Format_Time($cur_report['created']) ?></h2>
                        <div class="infldset file" style="padding:0px">
                            <table cellspacing="0">
                                <tr>
                                    <th style="width:150px"><?php echo $lang['Forum']; ?>&nbsp;&raquo;&nbsp;<?php echo $lang['Topic']; ?>&nbsp;&raquo;&nbsp;<?php echo $lang['Post']; ?></th>
                                    <td><?php echo $forum ?>&nbsp;&raquo;&nbsp;<?php echo $topic ?>&nbsp;&raquo;&nbsp;<?php echo $postid ?></td>
                                </tr>
                                <tr>
                                    <th><?php echo $lang['Report by']; ?> <?php echo $reporter ?><div><input type="submit" class="b1" name="zap_id[<?php echo $cur_report['id'] ?>]" value="<?php echo $lang['Zap'] ?>" /></div></th>
                                    <td><?php echo $post ?></td>
                                </tr>
                            </table>
                        </div>
                    </div>
                    <?php
                }
            }
            else
                echo "\t\t\t\t" . '<p>' . $lang['no_new_reports'] . '</p>' . "\n";
            ?>
        </form>
    </div>
    <?php
}
else if ($page == 'Old')
{
    echo BB_Template::Generate_Menu($submenu);
    ?>
    <div class="blockform">
        <div class="fakeform">
            <?php
            $result = $db->query('SELECT r.id, r.post_id, r.topic_id, r.forum_id, r.reported_by, r.message, r.zapped, r.zapped_by AS zapped_by_id, t.subject, f.forum_name, u.username AS reporter, u2.username AS zapped_by FROM ' . $db->prefix . 'reports AS r LEFT JOIN ' . $db->prefix . 'topics AS t ON r.topic_id=t.id LEFT JOIN ' . $db->prefix . 'forums AS f ON r.forum_id=f.id LEFT JOIN ' . $db->prefix . 'users AS u ON r.reported_by=u.id LEFT JOIN ' . $db->prefix . 'users AS u2 ON r.zapped_by=u2.id WHERE r.zapped IS NOT NULL ORDER BY zapped DESC LIMIT 10') or BB_Functions::Error($lang['error_25'], __FILE__, __LINE__, $db->error());
            if ($db->num_rows($result))
            {
                while ($cur_report = $db->fetch_assoc($result))
                {
                    $reporter = ($cur_report['reporter'] != '') ? '<a href="' . bb_forum_url . 'member.php?id=' . $cur_report['reported_by'] . '">' . BB_Input::Htmlspecialchars($cur_report['reporter']) . '</a>' : 'Deleted user';
                    $forum = ($cur_report['forum_name'] != '') ? '<a href="' . bb_forum_url . 'forum.php?id=' . $cur_report['forum_id'] . '">' . BB_Input::Htmlspecialchars($cur_report['forum_name']) . '</a>' : 'Deleted';
                    $topic = ($cur_report['subject'] != '') ? '<a href="' . bb_forum_url . 'topic.php?id=' . $cur_report['topic_id'] . '">' . BB_Input::Htmlspecialchars($cur_report['subject']) . '</a>' : 'Deleted';
                    $post = ($cur_report['post_id'] != '') ? str_replace("\n", '<br />', BB_Input::Htmlspecialchars($cur_report['message'])) : 'Post deleted';
                    $post_id = ($cur_report['post_id'] != '') ? '<a href="' . bb_forum_url . 'topic.php?pid=' . $cur_report['post_id'] . '#p' . $cur_report['post_id'] . '">Post #' . $cur_report['post_id'] . '</a>' : 'Deleted';
                    $zapped_by = ($cur_report['zapped_by'] != '') ? '<a href="' . bb_forum_url . 'member.php?id=' . $cur_report['zapped_by_id'] . '">' . BB_Input::Htmlspecialchars($cur_report['zapped_by']) . '</a>' : 'N/A';
                    ?>
                    <div class="inform">
                        <h2><?php echo $lang['Zapped']; ?> <?php echo BB_Input::Format_Time($cur_report['zapped']) ?></h2>
                        <div class="infldset file" style="padding:0px">
                            <table cellspacing="0">
                                <tr>
                                    <th style="width:150px"><?php echo $lang['Forum']; ?>&nbsp;&raquo;&nbsp;<?php echo $lang['Topic']; ?>&nbsp;&raquo;&nbsp;<?php echo $lang['Post']; ?></th>
                                    <td><?php echo $forum ?>&nbsp;&raquo;&nbsp;<?php echo $topic ?>&nbsp;&raquo;&nbsp;<?php echo $post_id ?></td>
                                </tr>
                                <tr>
                                    <th><?php echo $lang['Reported by']; ?> <?php echo $reporter ?><div class="topspace"><?php echo $lang['Zapped by']; ?> <?php echo $zapped_by ?></div></th>
                                    <td><?php echo $post ?></td>
                                </tr>
                            </table>
                        </div>
                    </div>
                    <?php
                }
            }
            else
                echo "\t\t\t\t" . '<p>' . $lang['no_zapped_reports'] . '</p>' . "\n";
            ?>
        </div>
    </div>
    <?php
}
else
    BB_Functions::Message($lang['Bad request']);
require FORUM_ROOT . 'admin/footer.php';
?>