<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
require dirname(__FILE__) . '/../include/init.php';
if ($forum_user['g_read_board'] == '0')
    BB_Functions::Message($lang['No view']);
$id = isset($_GET['id']) ? intval($_GET['id']) : 0;
if ($id < 1)
    BB_Functions::Message($lang['Bad request']);
$result = $db->query('SELECT t.subject, t.num_replies, f.id AS forum_id, f.forum_name FROM ' . $db->prefix . 'topics AS t INNER JOIN ' . $db->prefix . 'forums AS f ON f.id=t.forum_id WHERE t.id=' . $db->escape($id)) or BB_Functions::Error($lang['error_4'], __FILE__, __LINE__, $db->error());
if (!$db->num_rows($result))
    BB_Functions::Message($lang['Bad request']);
$cur_topic = $db->fetch_assoc($result);
$page_title = BB_Input::Htmlspecialchars($cur_topic['subject']);
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html dir="<?php echo $lang['lang_direction']; ?>">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=<?php echo $lang['lang_encoding']; ?>" />
        <link rel="stylesheet" href="<?php echo bb_website_url ?>/include/css/archive.css" type="text/css" />
        <title><?php echo $page_title; ?></title>
    </head>
    <body>
        <table width="100%" class="links">
            <tr>
                <td>
                    <b>&raquo;</b> <a href="<?php echo bb_forum_url; ?>index.php"><b><?php echo bb_board_title ?></b></a><br />
                    &nbsp;&nbsp;&nbsp;<b>&raquo;</b> <a href="<?php echo bb_forum_url; ?>forum.php?id=<?php echo $cur_topic['forum_id']; ?>"><b><?php echo $cur_topic['forum_name'] ?></b></a><br />
                    &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>&raquo;</b> <a href="<?php echo bb_forum_url; ?>topic.php?id=<?php echo $id ?>"><b><?php echo $cur_topic['subject'] ?></b></a><br />
                    <br /><br />
                </td>
            </tr>
        </table>
        <div style="text-align:center;">
            <table style="text-align:left;" width="100%" cellspacing="5" cellpadding="3">
                <tbody>
                    <?php
                    $alt = 0;
                    require_once FORUM_ROOT . 'include/functions/Parser.php';
                    $result = $db->query('SELECT p.poster AS username, p.message, p.id, p.posted FROM ' . $db->prefix . 'posts AS p WHERE p.topic_id=' . $db->escape($id) . ' ORDER BY p.id') or BB_Functions::Error($lang['error_3'], __FILE__, __LINE__, $db->error());
                    while ($cur_post = $db->fetch_assoc($result))
                    {
                        $username = BB_Input::Htmlspecialchars($cur_post['username']);
                        $cur_post['message'] = BB_Parser::Parse_Message($cur_post['message'], true);
                        ?>
                        <tr><td class="user<?php echo $alt ?>"><b><?php echo $username; ?>&nbsp;-&nbsp;<?php echo BB_Input::Format_Time($cur_post['posted']); ?></b></td></tr>
                        <tr><td class="post<?php echo $alt ?>"><?php echo $cur_post['message'] . "\n" ?></td></tr>
                        <?php
                        if ($alt)
                            $alt = 0;
                        else
                            $alt = 1;
                    }
                    ?>
                </tbody>
            </table>
        </div>
        <table width="100%" class="links">
            <tr>
                <td><br /><b>&raquo; <a href="javascript:window.print();"><?php echo $lang['Print this topic']; ?></a></b></td>
            </tr>
        </table>
    </body>
</html>
