<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
require dirname(__FILE__) . '/../include/init.php';
if ($forum_user['g_read_board'] == '0')
    BB_Functions::Message($lang['No permission'], true, 1);
$id = isset($_GET['id']) ? intval($_GET['id']) : 0;
if ($id < 1)
    BB_Functions::Message($lang['Bad request']);
$result = $db->query('SELECT f.id AS fid, f.forum_name, f.moderators, f.redirect_url, fp.post_replies, fp.post_topics, t.id AS tid, t.subject, t.posted, t.closed, p.poster, p.poster_id, p.message, p.hide_smilies FROM ' . $db->prefix . 'posts AS p INNER JOIN ' . $db->prefix . 'topics AS t ON t.id=p.topic_id INNER JOIN ' . $db->prefix . 'forums AS f ON f.id=t.forum_id LEFT JOIN ' . $db->prefix . 'permissions AS fp ON (fp.forum_id=f.id AND fp.gid=' . $forum_user['g_id'] . ') WHERE (fp.read_forum IS NULL OR fp.read_forum=1) AND p.id=' . $db->escape($id)) or BB_Functions::Error($lang['error_3'], __FILE__, __LINE__, $db->error());
if (!$db->num_rows($result))
    BB_Functions::Message($lang['Bad request']);
$cur_post = $db->fetch_assoc($result);
$mods_array = ($cur_post['moderators'] != '') ? unserialize($cur_post['moderators']) : array();
$is_admmod = ($forum_user['g_id'] == USER_ADMIN || ($forum_user['g_id'] == USER_MOD && array_key_exists($forum_user['username'], $mods_array)) || $forum_user['g_global_moderation']) ? true : false;
$result = $db->query('SELECT id FROM ' . $db->prefix . 'posts WHERE topic_id=' . $db->escape($cur_post['tid']) . ' ORDER BY posted LIMIT 1') or BB_Functions::Error($lang['error_3'], __FILE__, __LINE__, $db->error());
$topic_post_id = $db->result($result);
$is_topic_post = ($id == $topic_post_id) ? true : false;
if (($forum_user['g_delete_posts'] == '0' || ($forum_user['g_delete_topics'] == '0' && $is_topic_post) || $cur_post['poster_id'] != $forum_user['id'] || $cur_post['closed'] == '1') && !$is_admmod)
    BB_Functions::Message($lang['No permission'], true, 1);
if (isset($_POST['delete']))
{
    if ($is_admmod)
        BB_Input::Confirm_Referrer('delete.php');
    if ($is_topic_post)
    {
        BB_Core::Delete_Topic($cur_post['tid']);
        BB_Core::Update_Forum($cur_post['fid']);
        BB_Functions::Redirect(bb_forum_url . BB_Input::Rewrite_URL("f", $cur_post['fid'], $cur_post['forum_name']), $lang['Topic del redirect']);
    }
    else
    {
        BB_Core::Delete_Post($id, $cur_post['tid']);
        BB_Core::Update_Forum($cur_post['fid']);
        BB_Functions::Redirect(bb_forum_url . BB_Input::Rewrite_URL("t", $cur_post['tid'], $cur_post['subject']), $lang['Post del redirect']);
    }
}
$page_title = BB_Input::Htmlspecialchars($lang['Delete post']);
require FORUM_ROOT . $forum_folder . '/header.php';
require_once FORUM_ROOT . 'include/functions/Parser.php';
$cur_post['message'] = BB_Parser::Parse_Message($cur_post['message'], $cur_post['hide_smilies']);
?>
<div class="blockform">
    <h2><span><?php echo $lang['Delete post'] ?></span></h2>
    <form method="post" action="delete.php?id=<?php echo $id ?>">
        <div class="inform">
            <div class="infldset file" style="padding:10px">
                <div class="postmsg">
                    <p><?php echo $lang['Author'] ?>: <strong><?php echo BB_Input::Htmlspecialchars($cur_post['poster']) ?></strong></p>
                    <p><?php echo $lang['Subject'] ?>: <strong><?php echo BB_Input::Htmlspecialchars($cur_post['subject']) ?></strong></p>
                    <br /><br /><?php echo $cur_post['message'] ?>
                </div>
            </div>
        </div>
        <div><input type="button" class="b1" onclick="javascript:history.go(-1)" value="<?php echo $lang['Go back'] ?>" /> <input class="b1" type="submit" name="delete" value="<?php echo $lang['Delete'] ?>" /></div>
    </form>
</div>
<?php
require FORUM_ROOT . $forum_folder . '/footer.php';
?>