<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
require dirname(__FILE__) . '/../include/init.php';
if ($forum_user['g_read_board'] == '0')
    BB_Functions::Message($lang['No permission'], true, 1);
$id = isset($_GET['id']) ? intval($_GET['id']) : 0;
if ($id < 1)
    BB_Functions::Message($lang['Bad request']);
$result = $db->query('SELECT f.id AS fid, f.forum_name, f.moderators, f.redirect_url, fp.post_replies, fp.post_topics, fp.image_upload, t.id AS tid, t.subject, t.tags, t.posted, t.closed, t.icon_topic, p.poster, p.poster_id, p.message, p.hide_smilies FROM ' . $db->prefix . 'posts AS p INNER JOIN ' . $db->prefix . 'topics AS t ON t.id=p.topic_id INNER JOIN ' . $db->prefix . 'forums AS f ON f.id=t.forum_id LEFT JOIN ' . $db->prefix . 'permissions AS fp ON (fp.forum_id=f.id AND fp.gid=' . $forum_user['g_id'] . ') WHERE (fp.read_forum IS NULL OR fp.read_forum=1) AND p.id=' . $db->escape($id)) or BB_Functions::Error($lang['error_3'], __FILE__, __LINE__, $db->error());
if (!$db->num_rows($result))
    BB_Functions::Message($lang['Bad request']);
$cur_post = $db->fetch_assoc($result);
$mods_array = ($cur_post['moderators'] != '') ? unserialize($cur_post['moderators']) : array();
$is_admmod = ($forum_user['g_id'] == USER_ADMIN || ($forum_user['g_id'] == USER_MOD && array_key_exists($forum_user['username'], $mods_array)) || $forum_user['g_global_moderation']) ? true : false;
$result = $db->query('SELECT id FROM ' . $db->prefix . 'posts WHERE topic_id=' . $db->escape($cur_post['tid']) . ' ORDER BY posted LIMIT 1') or BB_Functions::Error($lang['error_3'], __FILE__, __LINE__, $db->error());
$topic_post_id = $db->result($result);
$can_edit_subject = ($id == $topic_post_id && (($forum_user['g_edit_subjects_interval'] == '0' || (time() - $cur_post['posted']) < $forum_user['g_edit_subjects_interval']) || $is_admmod)) ? true : false;
if (($forum_user['g_edit_posts'] == '0' || $cur_post['poster_id'] != $forum_user['id'] || $cur_post['closed'] == '1') && !$is_admmod)
    BB_Functions::Message($lang['No permission'], true, 1);
$errors = array();
if (isset($_POST['form_sent']))
{
    if ($is_admmod)
        BB_Input::Confirm_Referrer('edit.php');
    if ($can_edit_subject)
    {
        $subject = BB_Input::Trim($_POST['req_subject']);
        $tags = BB_Input::Trim($_POST['tags']);
        if ($subject == '')
            $errors[] = $lang['No subject'];
        else if (BB_Input::Strlen($subject) > 70)
            $errors[] = $lang['Too long subject'];
        else if (bb_subject_all_caps == '0' && strtoupper($subject) == $subject && ($forum_user['g_id'] > USER_MOD && !$forum_user['g_global_moderation']))
            $subject = ucwords(strtolower($subject));
    }
    $message = BB_Input::Linebreaks(BB_Input::Trim($_POST['req_message']));
    if ($message == '')
        $errors[] = $lang['No message'];
    else if (strlen($message) > 65535)
        $errors[] = $lang['Too long message'];
    else if (bb_subject_all_caps == '0' && strtoupper($message) == $message && ($forum_user['g_id'] > USER_MOD && !$forum_user['g_global_moderation']))
        $subject = ucwords(strtolower($subject));
    if (bb_message_bbcode == '1' && strpos($message, '[') !== false && strpos($message, ']') !== false)
    {
        require_once FORUM_ROOT . 'include/functions/Parser.php';
        $message = BB_Parser::Preparse_BBCode($message, $errors);
    }
    $hide_smilies = isset($_POST['hide_smilies']) ? intval($_POST['hide_smilies']) : 0;
    if ($hide_smilies != '1')
        $hide_smilies = '0';
    if (empty($errors) && !isset($_POST['preview']))
    {
        $edited_sql = (!isset($_POST['silent']) || !$is_admmod) ? $edited_sql = ', edited=' . time() . ', edited_by=\'' . $db->escape($forum_user['username']) . '\'' : '';
        if ($can_edit_subject)
        {
            $icon_topic = intval($_POST['icon_topic']);
            $db->query('UPDATE ' . $db->prefix . 'topics SET subject=\'' . $db->escape($subject) . '\', tags=\'' . $db->escape($tags) . '\', icon_topic=' . $db->escape($icon_topic) . ' WHERE id=' . $db->escape($cur_post['tid']) . ' OR moved_to=' . $db->escape($cur_post['tid'])) or BB_Functions::Error($lang['error_6'], __FILE__, __LINE__, $db->error());
            BB_Core::Set_Search_Index('edit', $id, $message, $subject);
        }
        else
            BB_Core::Set_Search_Index('edit', $id, $message);
        $db->query('UPDATE ' . $db->prefix . 'posts SET message=\'' . $db->escape($message) . '\', hide_smilies=\'' . $db->escape($hide_smilies) . '\'' . $edited_sql . ' WHERE id=' . $db->escape($id)) or BB_Functions::Error($lang['error_56'], __FILE__, __LINE__, $db->error());
        $upload_result = BB_Image_Upload::Process_Uploaded_Images($id);
        BB_Image_Upload::Process_Deleted_Images($id);
        $resultpost = $db->query('SELECT p.topic_id, t.question FROM ' . $db->prefix . 'posts AS p INNER JOIN ' . $db->prefix . 'topics AS t WHERE p.id=' . $db->escape($id) . ' AND t.id=p.topic_id') or BB_Functions::Error($lang['error_57'], __FILE__, __LINE__, $db->error());
        $cur_question = $db->fetch_assoc($resultpost);
        if ($cur_question['question'] != '')
            BB_Functions::Redirect(bb_forum_url . BB_Input::Rewrite_URL("l", $cur_post['tid'], $subject) . '#p' . $id, $upload_result . $lang['Edit redirect']);
        else
            BB_Functions::Redirect(bb_forum_url . BB_Input::Rewrite_URL("t", $cur_post['tid'], $subject) . '#p' . $id, $upload_result . $lang['Edit redirect']);
    }
}
$page_title = BB_Input::Htmlspecialchars($lang['Edit post']);
$required_fields = array('req_subject' => $lang['Subject'], 'req_message' => $lang['Message']);
$focus_element = array('post', 'req_message');
require FORUM_ROOT . $forum_folder . '/header.php';
$cur_index = 1;
if (!empty($errors))
{
    ?>
    <div id="posterror" class="xenno_block">
        <h2><span><?php echo $lang['Post errors'] ?></span></h2>
        <div class="box">
            <div class="inbox"
                 <p><?php echo $lang['Post errors info'] ?></p>
                <ul>
    <?php
    while (list(, $cur_error) = each($errors))
        echo "\t\t\t\t" . '<li><strong>' . $cur_error . '</strong></li>' . "\n";
    ?>
                </ul>
            </div>
        </div>
    </div>
    <?php
}
else if (isset($_POST['preview']))
{
    require_once FORUM_ROOT . 'include/functions/Parser.php';
    $preview_message = BB_Parser::Parse_Message($message, $hide_smilies);
    ?>
    <div id="postpreview" class="blockpost">
        <h2><span><?php echo $lang['Post preview'] ?></span></h2>
        <div class="box">
            <div class="inbox">
                <div class="postright">
                    <div class="postmsg">
                        <?php echo $preview_message . "\n" ?>
                    </div>
                </div>
            </div>
        </div>
    </div>
                                <?php
                            }
                            ?>
<div class="blockform">
    <h2><span><?php echo $lang['Edit post'] . ' ' . BB_Input::Htmlspecialchars($cur_post['subject']) ?></span></h2>
    <div class="box">
        <form name="spelling_mod" id="post" method="post" action="edit.php?id=<?php echo $id ?>&amp;action=edit" onsubmit="return process_form(this)" enctype="multipart/form-data">
            <h2><?php echo $lang['Edit post legend'] ?></h2>
            <div class="inform file" style="padding:20px">
                <div class="infldset txtarea" style="padding:10px;">
                    <input type="hidden" name="form_sent" value="1" />
                            <?php
                            if ($can_edit_subject)
                            {
                                ?>
                        <fieldset><legend><?php echo $lang['Topic icons'] ?></legend>
                            <div id="topic_icons">
                                <?php
                                $icons_topic = array();
                                $d = dir(FORUM_ROOT . $forum_folder . '/img/general/icons');
                                while (($entry = $d->read()) !== false)
                                {
                                    if (substr($entry, strlen($entry) - 4) == '.png')
                                        $icons_topic[] = substr($entry, 0, strlen($entry) - 4);
                                }
                                $d->close();
                                if (count($icons_topic) > 1)
                                {
                                    while (list(, $temp) = @each($icons_topic))
                                    {
                                        $checked = ' ';
                                        if ($cur_post['icon_topic'] == $temp)
                                            $checked = ' checked="checked"';
                                        if ($cur_post['icon_topic'] == '0')
                                            $aucune = ' checked="checked"';
                                        echo '<input type="radio" name="icon_topic" value="' . $temp . '"' . $checked . ' />&nbsp;<img src="' . bb_forum_url . 'img/general/icons/' . $temp . '.png" alt="' . $temp . '" />&nbsp;';
                                    }
                                    echo '<input type="radio" name="icon_topic" value="0"' . $aucune . ' />&nbsp;' . $lang['None'];
                                }
                                ?>
                            </div>
                        </fieldset>
                        <fieldset><legend><?php echo $lang['Subject'] ?></legend>
                            <input class="textbox" type="text" name="req_subject" style="width:510px" maxlength="70" tabindex="<?php echo $cur_index++ ?>" value="<?php echo BB_Input::Htmlspecialchars(isset($_POST['req_subject']) ? $_POST['req_subject'] : $cur_post['subject']) ?>" />
                        </fieldset>
                    <?php
                }
                ?>
                    <fieldset><legend><?php echo $lang['Formatting'] ?></legend>
                <?php
                require FORUM_ROOT . 'include/functions/BBCodes.php';
                ?>
                    </fieldset>
                    <fieldset><legend><?php echo $lang['Message'] ?></legend>
                        <textarea name="req_message" id="req_message" class="post" style="width:510px" rows="20" tabindex="<?php echo $cur_index++ ?>"><?php echo BB_Input::Htmlspecialchars(isset($_POST['req_message']) ? $message : $cur_post['message']) ?></textarea>
                    </fieldset>
                    <p style="width:510px"><input type="button" class="b1" onclick="javascript:history.go(-1);" value="<?php echo $lang['Go back'] ?>" /><input type="submit" class="b1" name="submit" value="<?php echo $lang['Post message'] ?>" tabindex="<?php echo $cur_index++ ?>" accesskey="s" /><input class="b1" type="submit" name="preview" onclick="xBB_Clear_Upload_Slots();" value="<?php echo $lang['Preview'] ?>" tabindex="<?php echo $cur_index++ ?>" accesskey="p" /></p>
                </div>
<?php
$checkboxes = array();
if (bb_smilies == '1')
{
    if (isset($_POST['hide_smilies']) || $cur_post['hide_smilies'] == '1')
        $checkboxes[] = '<label><input type="checkbox" name="hide_smilies" value="1" checked="checked" tabindex="' . ($cur_index++) . '" />&nbsp;' . $lang['Hide smilies'];
    else
        $checkboxes[] = '<label><input type="checkbox" name="hide_smilies" value="1" tabindex="' . ($cur_index++) . '" />&nbsp;' . $lang['Hide smilies'];
}
if ($is_admmod)
{
    if ((isset($_POST['form_sent']) && isset($_POST['silent'])) || !isset($_POST['form_sent']))
        $checkboxes[] = '<label><input type="checkbox" name="silent" value="1" tabindex="' . ($cur_index++) . '" checked="checked" />&nbsp;' . $lang['Silent edit'];
    else
        $checkboxes[] = '<label><input type="checkbox" name="silent" value="1" tabindex="' . ($cur_index++) . '" />&nbsp;' . $lang['Silent edit'];
}
if (!empty($checkboxes))
{
    ?>
                </div><br />
                <div id="div_imageshack" class="file" style="display: none;">
                    <h2><?php echo $lang['Upload IS'] ?></h2>
                    <div class="inform">
                        <div class="infldset" style="padding:10px;">
                            <div class="rbox">
                                <iframe src="http://imageshack.us/iframe.php?txtcolor=111111&type=blank&size=30" scrolling="no" allowtransparency="true" frameborder="0" width="280" height="80">Update your browser for ImageShack.us!</iframe><br />
                    <?php echo $lang['imageshack_note'] ?>
                            </div>
                        </div>
                    </div>
                </div><br />
                <?php
                $qpost_ids = (isset($_COOKIE['qpostprefs'])) ? $_COOKIE['qpostprefs'] . ',' : FALSE;
                if (strstr($qpost_ids, '993,'))
                {
                    $div_ido = "none";
                    $div_idx = "block";
                }
                else
                {
                    $div_ido = "block";
                    $div_idx = "none";
                }
                ?>
                <div id="ido993" class="file" style="display:<?php echo $div_ido ?>">
                    <h2><span class="icons"><a href="javascript:xBB_Toggle_Category(993, 0);"><img src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/down.png" alt="+" /></a></span><span><?php echo $lang['Image_Upload'] ?></span></h2>
                </div>
                <div id="idx993" class="file" style="display:<?php echo $div_idx ?>">
                    <h2><span class="icons"><a href="javascript:xBB_Toggle_Category(993, 1);"><img src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/up.png" alt="-" /></a></span><span><?php echo $lang['Image_Upload'] ?></span></h2>
                                <?php BB_Image_Upload::Show($cur_post, true); ?>
                </div><br />
                                <?php
                                $qpost_ids = (isset($_COOKIE['qpostprefs'])) ? $_COOKIE['qpostprefs'] . ',' : FALSE;
                                if (strstr($qpost_ids, '992,'))
                                {
                                    $div_ido = "none";
                                    $div_idx = "block";
                                }
                                else
                                {
                                    $div_ido = "block";
                                    $div_idx = "none";
                                }
                                ?>
                <div id="ido992" class="file" style="display:<?php echo $div_ido ?>">
                    <h2><span class="icons"><a href="javascript:xBB_Toggle_Category(992, 0);"><img src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/down.png" alt="+" /></a></span><span><?php echo $lang['Options'] ?></span></h2>
                </div>
                <div id="idx992" class="file" style="display:<?php echo $div_idx ?>">
                    <h2><span class="icons"><a href="javascript:xBB_Toggle_Category(992, 1);"><img src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/up.png" alt="-" /></a></span><span><?php echo $lang['Options'] ?></span></h2>
                    <div class="inform">
                        <div class="infldset" style="padding:10px;">
                            <div class="rbox">
    <?php
    echo implode('</label>' . "\n\t\t\t\t\t\t\t", $checkboxes) . '</label>' . "\n";
    if ($can_edit_subject)
        echo '<label>' . $lang['Tags'] . '&nbsp;&nbsp;<input type="text" class="textbox" name="tags" value="' . BB_Input::Htmlspecialchars($cur_post['tags']) . '" style="width:400px" maxlength="70" tabindex="' . $cur_index++ . '" /><br /></label>';
    ?>
                            </div>
                        </div>

    <?php
}
?>
                </div>
            </div>
        </form>
    </div>
</div>
<?php
require FORUM_ROOT . $forum_folder . '/footer.php';
?>