<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
require dirname(__FILE__) . '/../include/init.php';
if ($forum_user['g_read_board'] == '0')
    BB_Functions::Message($lang['No view']);
$id = isset($_GET['id']) ? intval($_GET['id']) : 0;
if ($id < 1)
    BB_Functions::Message($lang['Bad request']);
require_once FORUM_ROOT . 'include/functions/Parser.php';
$result = $db->query('SELECT f.forum_name, pf.forum_name AS parent_forum, f.forum_name, f.redirect_url, f.moderators, f.num_topics, f.sort_by, f.parent_forum_id, fp.post_topics FROM ' . $db->prefix . 'forums AS f LEFT JOIN ' . $db->prefix . 'permissions AS fp ON (fp.forum_id=f.id AND fp.gid=' . $forum_user['g_id'] . ') LEFT JOIN ' . $db->prefix . 'forums AS pf ON f.parent_forum_id=pf.id WHERE (fp.read_forum IS NULL OR fp.read_forum=1) AND f.id=' . $db->escape($id)) or BB_Functions::Error($lang['error_87'], __FILE__, __LINE__, $db->error());
if (!$db->num_rows($result))
    BB_Functions::Message($lang['Bad request']);
$cur_forum = $db->fetch_assoc($result);
if ($cur_forum['redirect_url'] != '')
{
    header('Location: ' . $cur_forum['redirect_url']);
    exit;
}
$mods_array = array();
if ($cur_forum['moderators'] != '')
    $mods_array = unserialize($cur_forum['moderators']);
$is_admmod = ($forum_user['g_id'] == USER_ADMIN || ($forum_user['g_id'] == USER_MOD && array_key_exists($forum_user['username'], $mods_array)) || $forum_user['g_global_moderation']) ? true : false;
if (($cur_forum['post_topics'] == '' && $forum_user['g_post_topics'] == '1') || $cur_forum['post_topics'] == '1' || $is_admmod)
    $post_link = "\t\t" . '<p class="conr"><a href="post.php?fid=' . $id . '" title="' . $lang['Post topic'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/new_topic.png" alt="' . $lang['Post topic'] . '" /></a>&nbsp;&nbsp;&nbsp;<a href="post.php?type=poll&amp;fid=' . $id . '" title="' . $lang['New poll'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/new_poll.png" alt="' . $lang['New poll'] . '" /></a></p>' . "\n";
else
    $post_link = "\t\t" . '<p class="conr"><a href="login.php" title="' . $lang['Post topic'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/new_topic.png" alt="' . $lang['Post topic'] . '" /></a>&nbsp;&nbsp;&nbsp;<a href="login.php" title="' . $lang['New poll'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/new_poll.png" alt="' . $lang['New poll'] . '" /></a></p>' . "\n";
$num_pages = ceil($cur_forum['num_topics'] / $forum_user['disp_topics']);
$p = (!isset($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $num_pages) ? 1 : $_GET['p'];
$start_from = $forum_user['disp_topics'] * ($p - 1);
if (bb_rewrite_urls == '1')
    $paging_links = '<strong class="pagination">' . $lang['Pages'] . '</strong> ' . BB_Core::Paginate($num_pages, $p, 'f' . $id . '-page', true);
else
    $paging_links = '<strong class="pagination">' . $lang['Pages'] . '</strong> ' . BB_Core::Paginate($num_pages, $p, 'forum.php?id=' . $id, true);
$page_title = BB_Input::Htmlspecialchars($cur_forum['forum_name'] . ' ' . $lang['Forum']);
define('ALLOW_INDEX', 1);
require FORUM_ROOT . $forum_folder . '/header.php';
$subforum_result = $db->query('SELECT forum_desc, forum_name, id, last_post, last_post_id, last_poster, moderators, num_posts, num_topics, redirect_url FROM ' . $db->prefix . 'forums WHERE parent_forum_id=' . $db->escape($id)) or BB_Functions::Error($lang['error_75'], __FILE__, __LINE__, $db->error());
if ($db->num_rows($subforum_result))
{
    ?>
    <div id="vf" class="blocktable">
        <h2><span><?php echo $lang['Sub forums'] ?></span></h2>
        <div class="box">
            <div class="inbox">
                <table cellspacing="0">
                    <thead>
                        <tr>
                            <th class="tcl"><?php echo $lang['Forum'] ?></th>
                            <th class="tcr"><?php echo $lang['Last post'] ?></th>
                            <th class="tc2"><?php echo $lang['Topics'] ?></th>
                            <th class="tc3"><?php echo $lang['Posts'] ?></th>
                        </tr>
                    </thead>
                    <tbody>
                        <?php
                        while ($cur_subforum = $db->fetch_assoc($subforum_result))
                        {
                            $item_status = '';
                            $icon_text = $lang['Normal icon'];
                            $icon_type = 'icon';
                            if (!$forum_user['is_guest'] && $cur_subforum['last_post'] > $forum_user['last_visit'])
                            {
                                $item_status = 'inew';
                                $icon_text = $lang['New icon'];
                                $icon_type = 'icon inew';
                            }
                            if ($cur_subforum['redirect_url'] != '')
                            {
                                $forum_field = '<h3><a href="' . BB_Input::Htmlspecialchars($cur_subforum['redirect_url']) . '" title="' . $lang['Link to'] . ' ' . BB_Input::Htmlspecialchars($cur_subforum['redirect_url']) . '">' . BB_Input::Htmlspecialchars($cur_subforum['forum_name']) . '</a></h3>';
                                $num_topics = $num_posts = '&nbsp;';
                                $item_status = 'iredirect';
                                $icon_text = $lang['Redirect icon'];
                                $icon_type = 'icon';
                            }
                            else
                            {
                                $forum_field = '<h3><a href="' . BB_Input::Rewrite_URL("f", $cur_subforum['id'], $cur_forum['forum_name']) . '">' . BB_Input::Htmlspecialchars($cur_subforum['forum_name']) . '</a></h3>';
                                $num_topics = $cur_subforum['num_topics'];
                                $num_posts = $cur_subforum['num_posts'];
                            }
                            if ($cur_subforum['forum_desc'] != '')
                                $forum_field .= "\n\t\t\t\t\t\t\t\t" . $cur_subforum['forum_desc'];
                            if ($cur_subforum['last_post'] != '')
                            {
                                $result = $db->query('SELECT topic_id FROM ' . $db->prefix . 'posts WHERE id=' . $db->escape($cur_subforum['last_post_id']));
                                $idz = $db->result($result);
                                $result = $db->query('SELECT subject, question FROM ' . $db->prefix . 'topics WHERE id=' . $db->escape($idz));
                                $idm = $db->fetch_assoc($result);
                                if (strlen($idm['subject']) > 30)
                                {
                                    $idm['subject'] = str_replace('"', "''", $idm['subject']);
                                    $idm['subject'] = substr($idm['subject'], 0, 30) . '...';
                                }
                                if ($idm['question'] != '')
                                    $last_post = '<a href="' . BB_Input::Rewrite_URL("l", $idz, $idm['subject']) . '#p' . $cur_subforum['last_post_id'] . '">' . $idm['subject'] . '</a><br /><span class="byuser">' . $lang['by'] . '&nbsp;' . BB_Input::Htmlspecialchars($cur_subforum['last_poster']) . '</span><br />' . BB_Input::Format_Time($cur_subforum['last_post']);
                                else
                                    $last_post = '<a href="' . BB_Input::Rewrite_URL("t", $idz, $idm['subject']) . '#p' . $cur_subforum['last_post_id'] . '">' . $idm['subject'] . '</a><br /><span class="byuser">' . $lang['by'] . '&nbsp;' . BB_Input::Htmlspecialchars($cur_subforum['last_poster']) . '</span><br />' . BB_Input::Format_Time($cur_subforum['last_post']);
                            }
                            else
                                $last_post = '&nbsp;';
                            $moderators = array();
                            if ($cur_subforum['moderators'] != '')
                            {
                                $mods_array = unserialize($cur_subforum['moderators']);
                                while (list($mod_username, $mod_id) = @each($mods_array))
                                    $moderators[] = '<a href="member.php?id=' . $mod_id . '">' . BB_Input::Htmlspecialchars($mod_username) . '</a>';
                                $moderators = "\t\t\t\t\t\t\t\t" . '<p><em>' . $lang['Moderated by'] . '</em>: ' . implode(', ', $moderators) . '</p>' . "\n";
                            }
                            ?>
                            <tr<?php if ($item_status != '')
                                echo ' class="' . $item_status . '"'; ?>>
                                <td class="tcl">
                                    <div class="intd">
                                        <div class="<?php echo $icon_type ?>"><div class="nosize"><?php echo $icon_text ?></div></div>
                                        <div class="tclcon">
        <?php echo $forum_field . "\n";
        if (count($moderators) > 0)
            echo $moderators; ?>
                                        </div>
                                    </div>
                                </td>
                                <td class="tcr"><?php echo $last_post ?></td>
                                <td class="tc2"><?php echo $num_topics ?></td>
                                <td class="tc3"><?php echo $num_posts ?></td>
                            </tr>
                <?php
            }
            ?>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
    <?php
}
?>
<div class="linkst">
    <div class="inbox">
        <p class="pagelink conl"><?php echo $paging_links ?></p>
<?php
echo $post_link;
if ($cur_forum['parent_forum'])
    echo "\t\t" . '<ul><li><a href="index.php">' . $lang['Index'] . '</a>&nbsp;</li><li>&raquo;&nbsp;<a href="' . BB_Input::Rewrite_URL("f", $cur_forum['parent_forum_id'], $cur_forum['parent_forum']) . '">' . BB_Input::Htmlspecialchars($cur_forum['parent_forum']) . '</a>&nbsp;</li><li>&raquo;&nbsp;' . BB_Input::Htmlspecialchars($cur_forum['forum_name']) . '</li></ul>';
else
    echo "\t\t" . '<ul><li><a href="index.php">' . $lang['Index'] . ' </a>&nbsp;</li><li>&raquo;&nbsp;' . BB_Input::Htmlspecialchars($cur_forum['forum_name']) . '</li></ul>';
?>
        <div class="clearer"></div>
    </div>
</div>
<div id="vf1" class="blocktable">
    <h2><?php if (bb_rss_type == "1")
    echo '<span class="icons"><a rel="nofollow" href="' . bb_website_url . '/syndicate.php?type=rss10&amp;fid=' . $id . '"><img src="' . BB_Template::Get_Image_Folder() . 'misc/button-feed.png" alt="RSS 1.0" /></a></span>'; else if (bb_rss_type == "2")
    echo '<span class="icons"><a rel="nofollow" href="' . bb_website_url . '/syndicate.php?type=rss10&amp;fid=' . $id . '"><img src="' . BB_Template::Get_Image_Folder() . 'misc/button-feed.png" alt="RSS 2.0" /></a></span>'; ?><span><?php echo BB_Input::Htmlspecialchars($cur_forum['forum_name']) ?></span></h2>
    <div class="box">
        <div class="inbox">
            <table cellspacing="0">
                <thead>
                    <tr>
                        <th class="tcl"><?php echo $lang['Topic'] ?></th>
                        <th class="tcr"><?php echo $lang['Last post'] ?></th>
                        <th class="tc2"><?php echo $lang['Replies'] ?></th>
                        <th class="tc3"><?php echo $lang['Views'] ?></th>
                    </tr>
                </thead>
                <tbody>
                    <?php
                    if ($forum_user['is_guest'] || bb_show_dot == '0')
                        $sql = 'SELECT id, poster, subject, posted, rating, rating_votes, last_post, last_post_id, last_poster, num_views, num_replies, closed, sticky, moved_to, question, icon_topic FROM ' . $db->prefix . 'topics WHERE forum_id=' . $db->escape($id) . ' ORDER BY sticky DESC, ' . (($cur_forum['sort_by'] == '1') ? 'posted' : 'last_post') . ' DESC LIMIT ' . $db->escape($start_from) . ', ' . $forum_user['disp_topics'];
                    else
                    {
                        switch ($db_type)
                        {
                            case 'mysql':
                            case 'mysqli':
                                $sql = 'SELECT p.poster_id AS has_posted, t.id, t.subject, t.poster, t.posted, t.rating_votes, t.rating, t.last_post, t.last_post_id, t.last_poster, t.num_views, t.num_replies, t.closed, t.sticky, t.moved_to, t.question, t.icon_topic FROM ' . $db->prefix . 'topics AS t LEFT JOIN ' . $db->prefix . 'posts AS p ON t.id=p.topic_id AND p.poster_id=' . $forum_user['id'] . ' WHERE t.forum_id=' . $db->escape($id) . ' GROUP BY t.id ORDER BY sticky DESC, ' . (($cur_forum['sort_by'] == '1') ? 'posted' : 'last_post') . ' DESC LIMIT ' . $db->escape($start_from) . ', ' . $forum_user['disp_topics'];
                                break;
                            case 'sqlite':
                                $sql = 'SELECT p.poster_id AS has_posted, t.id, t.subject, t.poster, t.posted, t.rating_votes, t.rating, t.last_post, t.last_post_id, t.last_poster, t.num_views, t.num_replies, t.closed, t.sticky, t.moved_to, t.question, t.icon_topic FROM ' . $db->prefix . 'topics AS t LEFT JOIN ' . $db->prefix . 'posts AS p ON t.id=p.topic_id AND p.poster_id=' . $forum_user['id'] . ' WHERE t.id IN(SELECT id FROM ' . $db->prefix . 'topics WHERE forum_id=' . $db->escape($id) . ' ORDER BY sticky DESC, ' . (($cur_forum['sort_by'] == '1') ? 'posted' : 'last_post') . ' DESC LIMIT ' . $db->escape($start_from) . ', ' . $forum_user['disp_topics'] . ') GROUP BY t.id ORDER BY t.sticky DESC, t.last_post DESC';
                                break;
                            default:
                                $sql = 'SELECT p.poster_id AS has_posted, t.id, t.subject, t.poster, t.posted, t.rating_votes, t.rating, t.last_post, t.last_post_id, t.last_poster, t.num_views, t.num_replies, t.closed, t.sticky, t.moved_to, t.question, t.icon_topic FROM ' . $db->prefix . 'topics AS t LEFT JOIN ' . $db->prefix . 'posts AS p ON t.id=p.topic_id AND p.poster_id=' . $forum_user['id'] . ' WHERE t.forum_id=' . $db->escape($id) . ' GROUP BY t.id, t.subject, t.poster, t.posted, t.last_post, t.last_post_id, t.last_poster, t.num_views, t.num_replies, t.closed, t.sticky, t.moved_to, t.question, p.poster_id ORDER BY sticky DESC, ' . (($cur_forum['sort_by'] == '1') ? 'posted' : 'last_post') . ' DESC LIMIT ' . $db->escape($start_from) . ', ' . $forum_user['disp_topics'];
                                break;
                        }
                    }
                    $result = $db->query($sql) or BB_Functions::Error($lang['error_37'], __FILE__, __LINE__, $db->error());
                    if ($db->num_rows($result))
                    {
                        while ($cur_topic = $db->fetch_assoc($result))
                        {
                            $topic_icons = '';
                            $icon_text = $lang['Normal icon'];
                            $item_status = '';
                            $icon_type = 'icon';
                            if ($cur_topic['moved_to'] == null)
                            {
                                if ($cur_topic['question'] != '')
                                    $last_post = '<a href="' . BB_Input::Rewrite_URL("l", $cur_topic['id'], $cur_topic['subject']) . '#p' . $cur_topic['last_post_id'] . '">' . BB_Input::Format_Time($cur_topic['last_post']) . '</a><br /><span class="byuser">' . $lang['by'] . '&nbsp;' . BB_Input::Htmlspecialchars($cur_topic['last_poster']) . '</span>';
                                else
                                    $last_post = '<a href="' . BB_Input::Rewrite_URL("t", $cur_topic['id'], $cur_topic['subject']) . '#p' . $cur_topic['last_post_id'] . '">' . BB_Input::Format_Time($cur_topic['last_post']) . '</a><br /><span class="byuser">' . $lang['by'] . '&nbsp;' . BB_Input::Htmlspecialchars($cur_topic['last_poster']) . '</span>';
                            }
                            else
                                $last_post = '&nbsp;';
                            if (bb_censoring == '1')
                                $cur_topic['subject'] = BB_Input::Censor_Words($cur_topic['subject']);
                            if ($cur_topic['question'] != '')
                            {
                                if (bb_censoring == '1')
                                    $cur_topic['question'] = BB_Input::Censor_Words($cur_topic['question']);
                                if ($cur_topic['moved_to'] != 0)
                                {
                                    $subject = '<a href="' . BB_Input::Rewrite_URL("l", $cur_topic['id'], $cur_topic['subject']) . '">' . BB_Input::Htmlspecialchars($cur_topic['question']) . '</a><br /><span class="byuser"> ' . $lang['by'] . '&nbsp;' . BB_Input::Htmlspecialchars($cur_topic['poster']) . '</span>';
                                    $icon_text = $lang['Poll'];
                                    $item_status = 'imoved';
                                }
                                else if ($cur_topic['closed'] == '0')
                                {
                                    $subject = '<a href="' . BB_Input::Rewrite_URL("l", $cur_topic['id'], $cur_topic['subject']) . '">' . BB_Input::Htmlspecialchars($cur_topic['question']) . '</a><br /><span class="byuser"> ' . $lang['by'] . '&nbsp;' . BB_Input::Htmlspecialchars($cur_topic['poster']) . '</span>';
                                    $icon_text = $lang['Poll'];
                                    $item_status = 'ipoll';
                                }
                                else
                                {
                                    $subject = '<a href="' . BB_Input::Rewrite_URL("l", $cur_topic['id'], $cur_topic['subject']) . '">' . BB_Input::Htmlspecialchars($cur_topic['question']) . '</a><br /><span class="byuser"> ' . $lang['by'] . '&nbsp;' . BB_Input::Htmlspecialchars($cur_topic['poster']) . '</span>';
                                    $icon_text = $lang['Closed icon'];
                                    $item_status = 'iclosed';
                                }
                                if (!$forum_user['is_guest'] && BB_Core::Is_New_Topic($cur_topic['id'], $id, $cur_topic['last_post']) && $cur_topic['moved_to'] == null)
                                {
                                    $icon_text .= ' ' . $lang['New icon'];
                                    $item_status .= ' ipollnew';
                                    $icon_type = 'icon ipollnew';
                                    $subject = '<strong>' . $subject . '</strong>';
                                    $subject_new_posts = '<span class="newtext">[&nbsp;<a href="topic.php?type=poll&amp;id=' . $cur_topic['id'] . '&amp;action=new" title="' . $lang['New posts info'] . '">' . $lang['New posts'] . '</a>&nbsp;]</span>';
                                }
                                else
                                    $subject_new_posts = null;
                                if (!$forum_user['is_guest'] && bb_show_dot == '1')
                                {
                                    if ($cur_topic['has_posted'] == $forum_user['id'])
                                        $subject = '<strong>&middot;</strong>&nbsp;' . $subject;
                                    else
                                        $subject = '&nbsp;&nbsp;' . $subject;
                                }
                            }
                            else
                            {
                                if ($cur_topic['moved_to'] != 0)
                                {
                                    $subject = '<a href="' . BB_Input::Rewrite_URL("t", $cur_topic['moved_to'], $cur_topic['subject']) . '">' . BB_Input::Htmlspecialchars($cur_topic['subject']) . '</a><br /><span class="byuser">' . $lang['by'] . '&nbsp;' . BB_Input::Htmlspecialchars($cur_topic['poster']) . '</span>';
                                    $icon_text = $lang['Moved'];
                                    $item_status = 'imoved';
                                }
                                else if ($cur_topic['num_replies'] > 30)
                                {
                                    $subject = '<a href="' . BB_Input::Rewrite_URL("t", $cur_topic['id'], $cur_topic['subject']) . '">' . BB_Input::Htmlspecialchars($cur_topic['subject']) . '</a><br /><span class="byuser">' . $lang['by'] . '&nbsp;' . BB_Input::Htmlspecialchars($cur_topic['poster']) . '</span>';
                                    $item_status = 'ihot';
                                }
                                else if ($cur_topic['closed'] == '0')
                                    $subject = '<a href="' . BB_Input::Rewrite_URL("t", $cur_topic['id'], $cur_topic['subject']) . '">' . BB_Input::Htmlspecialchars($cur_topic['subject']) . '</a><br /><span class="byuser">' . $lang['by'] . '&nbsp;' . BB_Input::Htmlspecialchars($cur_topic['poster']) . '</span>';
                                else
                                {
                                    $subject = '<a href="' . BB_Input::Rewrite_URL("t", $cur_topic['id'], $cur_topic['subject']) . '">' . BB_Input::Htmlspecialchars($cur_topic['subject']) . '</a><br /><span class="byuser">' . $lang['by'] . '&nbsp;' . BB_Input::Htmlspecialchars($cur_topic['poster']) . '</span>';
                                    $icon_text = $lang['Closed icon'];
                                    $item_status = 'iclosed';
                                }
                                if (!$forum_user['is_guest'] && $cur_topic['last_post'] > $forum_user['last_visit'] && $cur_topic['moved_to'] == null)
                                {
                                    $icon_text .= ' ' . $lang['New icon'];
                                    $item_status .= ' inew';
                                    $icon_type = 'icon inew';
                                    $subject = '<strong>' . $subject . '</strong>';
                                    $subject_new_posts = '<span class="newtext">[&nbsp;<a href="topic.php?id=' . $cur_topic['id'] . '&amp;action=new" title="' . $lang['New posts info'] . '">' . $lang['New posts'] . '</a>&nbsp;]</span>';
                                }
                                else
                                    $subject_new_posts = null;
                                if (!$forum_user['is_guest'] && bb_show_dot == '1')
                                {
                                    if ($cur_topic['has_posted'] == $forum_user['id'])
                                        $subject = '<strong>&middot;</strong>&nbsp;' . $subject;
                                    else
                                        $subject = '&nbsp;&nbsp;' . $subject;
                                }
                            }
                            if ($cur_topic['sticky'] == '1')
                            {
                                $stickydivide = 1;
                                $stickyflag = 1;
                                $item_status .= ' isticky';
                                $icon_text .= ' ' . $lang['Sticky'];
                            }
                            else
                                $stickyflag = 0;
                            if ($cur_topic['icon_topic'] != 0)
                            {
                                $icon_topic = '<img src="./img/general/icons/' . $cur_topic['icon_topic'] . '.png" alt="" />';
                                $subject = $icon_topic . ' ' . $subject;
                            }
                            $num_pages_topic = ceil(($cur_topic['num_replies'] + 1) / $forum_user['disp_posts']);
                            if ($num_pages_topic > 1)
                            {
                                if ($cur_topic['question'] != '')
                                {
                                    if (bb_rewrite_urls == '1')
                                        $subject_multipage = ' ' . BB_Core::Paginate($num_pages_topic, -1, 'l' . $cur_topic['id'] . '-page', true);
                                    else
                                        $subject_multipage = ' ' . BB_Core::Paginate($num_pages_topic, -1, 'topic.php?type=poll&amp;id=' . $cur_topic['id'], true) . ' ';
                                }
                                else
                                {
                                    if (bb_rewrite_urls == '1')
                                        $subject_multipage = ' ' . BB_Core::Paginate($num_pages_topic, -1, 't' . $cur_topic['id'] . '-page', true);
                                    else
                                        $subject_multipage = ' ' . BB_Core::Paginate($num_pages_topic, -1, 'topic.php?id=' . $cur_topic['id'], true) . ' ';
                                }
                            }
                            else
                                $subject_multipage = null;
                            if (!empty($subject_new_posts) || !empty($subject_multipage))
                            {
                                $subject .= '&nbsp; ' . (!empty($subject_new_posts) ? $subject_new_posts : '');
                                $subject .= ! empty($subject_multipage) ? ' ' . $subject_multipage : '';
                            }
                            if ($stickyflag == 0 && $stickydivide == 1)
                            {
                                echo "<tr><td colspan=\"4\" style=\"padding:0;margin:0;\"><h2><strong>" . $lang['Forum Topics'] . "</strong></h2></td></tr>";
                                $stickydivide = 0;
                            }
                            if ($cur_topic['rating_votes'] > 0 && $cur_topic['rating'] > 0)
                            {
                                $topic_rating = ceil($cur_topic['rating'] / $cur_topic['rating_votes']);
                                $topic_icons .= '<img src="' . BB_Template::Get_Image_Folder() . 'rating/d_rating_' . $topic_rating . '.png" alt=""/>';
                            }
                            ?>
                            <tr<?php if ($item_status != '')
            echo ' class="' . trim($item_status) . '"'; ?>> 
                                <td class="tcl">
                                    <div class="intd">
                                        <div class="<?php echo $icon_type ?>"><div class="nosize"><?php echo trim($icon_text) ?></div></div>
                                        <div class="tclcon">
                                            <span class="topic_icons"><?php echo $topic_icons ?></span>
        <?php echo $subject . "\n" ?>
                                        </div>
                                    </div>
                                </td>
                                <td class="tcr"><?php echo $last_post ?></td>
                                <td class="tc2"><?php echo ($cur_topic['moved_to'] == null) ? $cur_topic['num_replies'] : '&nbsp;' ?></td>
                                <td class="tc3"><?php echo ($cur_topic['moved_to'] == null) ? $cur_topic['num_views'] : '&nbsp;' ?></td>
                            </tr>
        <?php
    }
}
else
{
    ?>
                        <tr>
                            <td class="tcl" colspan="4"><?php echo $lang['Empty forum'] ?></td>
                        </tr>
    <?php
}
?>
                </tbody>
            </table>
        </div>
    </div>
</div>
<div class="linksb">
    <div class="inbox">
        <p class="pagelink conl"><?php echo $paging_links ?></p>
<?php
echo $post_link;
if ($cur_forum['parent_forum'])
    echo "\t\t" . '<ul><li><a href="index.php">' . $lang['Index'] . '</a>&nbsp;</li><li>&raquo;&nbsp;<a href="' . BB_Input::Rewrite_URL("f", $cur_forum['parent_forum_id'], $cur_forum['parent_forum']) . '">' . BB_Input::Htmlspecialchars($cur_forum['parent_forum']) . '</a>&nbsp;</li><li>&raquo;&nbsp;' . BB_Input::Htmlspecialchars($cur_forum['forum_name']) . '</li></ul>';
else
    echo "\t\t" . '<ul><li><a href="index.php">' . $lang['Index'] . ' </a>&nbsp;</li><li>&raquo;&nbsp;' . BB_Input::Htmlspecialchars($cur_forum['forum_name']) . '</li></ul>';
?>
        <div class="clearer"></div>
    </div>
</div>
<?php
$forum_id = $id;
$footer_style = 'view_forum';
require FORUM_ROOT . $forum_folder . '/footer.php';
?>