<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
define('QUIET_VISIT', 1);
require dirname(__FILE__) . '/../include/init.php';
$page_title = BB_Input::Htmlspecialchars(bb_board_title);
define('ALLOW_INDEX', 1);
require FORUM_ROOT . $forum_folder . '/header.php';
require_once FORUM_ROOT . 'include/functions/Parser.php';

function xBB_Check_Parameters()
{
    if (!isset($_GET['pid']) || !isset($_GET['filename']))
        BB_Functions::Error($lang['error_129'], __FILE__, __LINE__);
    $pid = intval($_GET['pid']);
    $filename = BB_Input::Htmlspecialchars($_GET['filename']);
    $source = bb_upload_path . $pid . '/';
    if (!is_dir($source))
        BB_Functions::Error($lang['error_144'], __FILE__, __LINE__);
    if (!is_file($source . $filename))
        BB_Functions::Error($lang['error_143'], __FILE__, __LINE__);
}

function xBB_Show_Gallery()
{
    global $lang;
    if (!BB_Image_Upload::Check_Configuration())
        BB_Functions::Error($lang['error_142'], __FILE__, __LINE__);
    xBB_Check_Parameters();
    $pid = intval($_GET['pid']);
    $filename = BB_Input::Htmlspecialchars($_GET['filename']);
    $source = bb_upload_path . $pid . '/';
    $contents = BB_File_Manager::Get_Dir_Contents($source, true);
    $nav = array();
    $ulimit = count($contents) - 1;
    $idx = array_search($filename, $contents);
    if ($idx > 0)
    {
        $before = urlencode($contents[$idx - 1]);
        $nav[] = "\t\t\t\t\t\t<a href='gallery.php?pid=$pid&amp;filename=$before'>";
    }
    $nav[] = "\t\t\t\t\t\t\t&lt; " . $lang['Previous Image'];
    if (isset($before))
        $nav[] = "\t\t\t\t\t\t</a>";
    $nav[] = "\t\t\t\t\t\t | <a href='topic.php?pid=$pid#p$pid'>" . $lang['Back to Topic'] . "</a> | ";
    if ($idx < $ulimit)
    {
        $after = urlencode($contents[$idx + 1]);
        $nav[] = "\t\t\t\t\t\t<a href='gallery.php?pid=$pid&amp;filename=$after'>";
    }
    $nav[] = "\t\t\t\t\t\t\t" . $lang['Next Image'] . " &gt;";
    if (isset($after))
        $nav[] = "\t\t\t\t\t\t</a>";
    $nav = implode("\n", $nav);
    $filename = urlencode($filename);
    return "<br />\n" . $nav . "\n\t\t\t\t\t\t<br />\n\t\t\t\t\t\t<br />\n\t\t\t\t\t\t<img src='image.php?pid=$pid&amp;filename=$filename' alt='$filename' />\n\t\t\t\t\t\t<br />\n\t\t\t\t\t\t<br />\n" . $nav . "\n\t\t\t\t\t\t<br />\n\t\t\t\t\t\t<br />\n";
}
?>
<div class="blockform">
    <h2><span><?php echo $lang['Post Gallery'] ?></span></h2>
    <div class="box">
        <div class="inbox">
            <table cellspacing="0" cellpadding="0" border="0">
                <tr>
                    <td align="center" valign="top" style="border:none;padding:0px"><?php echo xBB_Show_Gallery(); ?></td>
                </tr>
            </table>
        </div>
    </div>
</div>
<br />
<?php
require FORUM_ROOT . $forum_folder . '/footer.php';
?>
