<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
if (isset($_GET['action']))
    define('QUIET_VISIT', 1);
define('TURN_OFF_MAINT', '1');
require dirname(__FILE__) . '/../include/init.php';
$action = isset($_GET['action']) ? $_GET['action'] : null;
if (isset($_POST['form_sent']) && $action == 'in')
{
    $form_invisible = trim($_POST['as_invisible']);
    $form_username = trim($_POST['req_username']);
    $form_password = trim($_POST['req_password']);
    $username_sql = ($db_type == 'mysql' || $db_type == 'mysqli') ? 'username=\'' . $db->escape($form_username) . '\'' : 'LOWER(username)=LOWER(\'' . $db->escape($form_username) . '\')';
    $result = $db->query('SELECT id, gid, password, save_pass FROM ' . $db->prefix . 'users WHERE ' . $username_sql) or BB_Functions::Error($lang['error_29'], __FILE__, __LINE__, $db->error());
    list($user_id, $gid, $db_password_hash, $save_pass) = $db->fetch_row($result);
    $authorized = false;
    if (!empty($db_password_hash))
    {
        $sha1_in_db = (strlen($db_password_hash) == 40) ? true : false;
        $sha1_available = (function_exists('sha1') || function_exists('mhash')) ? true : false;
        $form_password_hash = BB_Input::Hash($form_password);
        if ($sha1_in_db && $sha1_available && $db_password_hash == $form_password_hash)
            $authorized = true;
        else if (!$sha1_in_db && $db_password_hash == md5($form_password))
        {
            $authorized = true;
            if ($sha1_available)
                $db->query('UPDATE ' . $db->prefix . 'users SET password=\'' . $db->escape($form_password_hash) . '\' WHERE id=' . $db->escape($user_id)) or BB_Functions::Error($lang['error_30'], __FILE__, __LINE__, $db->error());
        }
    }
    if (!$authorized)
        BB_Functions::Message($lang['Wrong user/pass'] . ' <a href="login.php?action=forget">' . $lang['Forgotten pass'] . '</a>');
    if ($gid == USER_UNVERIFIED)
    {
        $db->query('UPDATE ' . $db->prefix . 'users SET gid=' . $db->escape(bb_default_user_group) . ' WHERE id=' . $db->escape($user_id)) or BB_Functions::Error($lang['error_31'], __FILE__, __LINE__, $db->error());
        $result = $db->query('SELECT g_invitations FROM ' . $db->prefix . 'usergroups WHERE g_id=' . $db->escape(bb_default_user_group)) or BB_Functions::Error($lang['error_32'], __FILE__, __LINE__, $db->error());
    }
    if ($form_invisible == '1')
        $db->query('UPDATE ' . $db->prefix . 'users SET invisible=1 WHERE username = \'' . $db->escape($form_username) . '\'') or BB_Functions::Error($lang['error_33'], __FILE__, __LINE__, $db->error());
    $db->query('DELETE FROM ' . $db->prefix . 'online WHERE ident=\'' . $db->escape(BB_Input::Get_Remote_Address()) . '\'') or BB_Functions::Error($lang['error_34'], __FILE__, __LINE__, $db->error());
    $expire = ($save_pass == '1') ? time() + 31536000 : 0;
    BB_Input::Set_Cookie($user_id, $form_password_hash, $expire);
    BB_Functions::Redirect(BB_Input::Htmlspecialchars($_POST['redirect_url']), $lang['Login redirect']);
}
else if ($action == 'out')
{
    $redirect_url = (isset($_SERVER['HTTP_REFERER'])) ? BB_Input::Htmlspecialchars($_SERVER['HTTP_REFERER']) : 'index.php';
    if ($forum_user['g_id'] == USER_ADMIN)
        $redirect_url = 'index.php';
    if ($forum_user['is_guest'] || !isset($_GET['id']) || $_GET['id'] != $forum_user['id'])
    {
        header('Location: index.php');
        exit;
    }
    $db->query('DELETE FROM ' . $db->prefix . 'online WHERE user_id=' . $forum_user['id']) or BB_Functions::Error($lang['error_34'], __FILE__, __LINE__, $db->error());
    if (isset($forum_user['logged']))
        $db->query('UPDATE ' . $db->prefix . 'users SET last_visit=' . $forum_user['logged'] . ', invisible=0, read_topics=NULL WHERE id=' . $forum_user['id']) or BB_Functions::Error($lang['error_33'], __FILE__, __LINE__, $db->error());
    BB_Input::Set_Cookie(1, BB_Input::Random_Pass(8), time() + 31536000);
    BB_Functions::Redirect(BB_Input::Htmlspecialchars($redirect_url), $lang['Logout redirect']);
}
else if ($action == 'forget' || $action == 'forget_2')
{
    if (!$forum_user['is_guest'])
        header('Location: index.php');
    if (isset($_POST['form_sent']))
    {
        $email = strtolower(trim($_POST['req_email']));
        if (!BB_Email::Is_Valid_Email($email))
            BB_Functions::Message($lang['Invalid e-mail']);
        $result = $db->query('SELECT id, username FROM ' . $db->prefix . 'users WHERE email=\'' . $db->escape($email) . '\'') or BB_Functions::Error($lang['error_29'], __FILE__, __LINE__, $db->error());
        if ($db->num_rows($result))
        {
            $mail_tpl = trim(file_get_contents(FORUM_ROOT . 'include/languages/' . $forum_user['language'] . '/mail_templates/activate_password.tpl'));
            $first_crlf = strpos($mail_tpl, "\n");
            $mail_subject = trim(substr($mail_tpl, 8, $first_crlf - 8));
            $mail_message = trim(substr($mail_tpl, $first_crlf));
            $mail_message = str_replace('<base_url>', bb_forum_url . '/', $mail_message);
            $mail_message = str_replace('<board_mailer>', bb_board_title . ' ' . $lang['Mailer'], $mail_message);
            while ($cur_hit = $db->fetch_assoc($result))
            {
                $new_password = BB_Input::Random_Pass(8);
                $new_password_key = BB_Input::Random_Pass(8);
                $db->query('UPDATE ' . $db->prefix . 'users SET activate_string=\'' . BB_Input::Hash($new_password) . '\', activate_key=\'' . $db->escape($new_password_key) . '\' WHERE id=' . $db->escape($cur_hit['id'])) or BB_Functions::Error($lang['error_35'], __FILE__, __LINE__, $db->error());
                $cur_mail_message = str_replace('<username>', $cur_hit['username'], $mail_message);
                $cur_mail_message = str_replace('<activation_url>', bb_forum_url . '/member.php?id=' . $cur_hit['id'] . '&action=change_pass&key=' . $new_password_key, $cur_mail_message);
                $cur_mail_message = str_replace('<new_password>', $new_password, $cur_mail_message);
                BB_Email::Mail($email, $mail_subject, $cur_mail_message);
            }
            BB_Functions::Message($lang['Forget mail'] . ' <a href="mailto:' . bb_admin_email . '">' . bb_admin_email . '</a>.');
        }
        else
            BB_Functions::Message($lang['No e-mail match'] . ' ' . BB_Input::Htmlspecialchars($email) . '.');
    }
    $page_title = BB_Input::Htmlspecialchars($lang['Request pass']);
    $required_fields = array('req_email' => $lang['E-mail']);
    $focus_element = array('request_pass', 'req_email');
    require FORUM_ROOT . $forum_folder . '/header.php';
    ?>
    <div class="blockform">
        <h2><span><?php echo $lang['Request pass'] ?></span></h2>
        <form id="request_pass" method="post" action="login.php?action=forget_2" onsubmit="this.request_pass.disabled=true;if(process_form(this)){return true;}else{this.request_pass.disabled=false;return false;}">
            <div class="inform">
                <div class="infldset file" style="padding:10px">
                    <input type="hidden" name="form_sent" value="1" />
                    <input id="req_email" class="textbox" type="text" name="req_email" size="50" maxlength="50" />&nbsp;&nbsp;<img src="img/admin/tooltip.png" alt="tooltip" onmouseover="return xBB_Show_Tooltip('<?php echo $lang['Request pass info'] ?>');" onmouseout="return nd();" />
                </div>
            </div>
            <div><input type="button" class="b1" onclick="javascript:history.go(-1);" value="<?php echo $lang['Go back'] ?>" /> <input type="submit" name="request_pass" class="b1" value="<?php echo $lang['Request password'] ?>" /></div>
        </form>
    </div>
    <?php
    require FORUM_ROOT . $forum_folder . '/footer.php';
}
if (!$forum_user['is_guest'])
    header('Location: index.php');
$redirect_url = (isset($_SERVER['HTTP_REFERER'])) ? BB_Input::Htmlspecialchars($_SERVER['HTTP_REFERER']) : 'index.php';
$page_title = BB_Input::Htmlspecialchars(bb_board_title) . ' :: ' . $lang['Login'];
$required_fields = array('req_username' => $lang['Username'], 'req_password' => $lang['Password']);
$focus_element = array('login', 'req_username');
require FORUM_ROOT . $forum_folder . '/header.php';
?>
<div class="blockform">
    <form id="login" method="post" action="login.php?action=in" onsubmit="return process_form(this)">
        <div class="inform" style="width:300px;text-align:left">
            <h2><?php echo $lang['Login'] ?></h2>
            <div class="infldset file" style="padding:10px">
                <input type="hidden" name="form_sent" value="1" />
                <input type="hidden" name="redirect_url" value="<?php echo $redirect_url ?>" />
                <label class="conl"><strong><?php echo $lang['Username'] ?></strong><br /><input class="textbox" type="text" name="req_username" size="25" maxlength="25" tabindex="1" /><br /></label><br />
                <label class="conl"><strong><?php echo $lang['Password'] ?></strong><br /><input class="textbox" type="password" name="req_password" size="25" maxlength="16" tabindex="2" /><br /></label>
                <p class="clearb"><input type="checkbox" name="as_invisible" value="1" /><?php echo $lang['login_invisible'] ?>&nbsp;&nbsp;<img src="<?php echo bb_forum_url ?>img/admin/tooltip.png" alt="tooltip" onmouseover="return xBB_Show_Tooltip('<?php echo $lang['tip_192'] ?>');" onmouseout="return nd();" /></p>
                <p class="clearb"><?php echo $lang['Login info'] ?></p>
                <p><a href="register.php" tabindex="4"><?php echo $lang['Not registered'] ?></a>&nbsp;&nbsp;
                    <a href="login.php?action=forget" tabindex="5"><?php echo $lang['Forgotten pass'] ?></a></p>
            </div>
        </div>
        <p><input type="submit" class="b1" name="login" value="<?php echo $lang['Login'] ?>" tabindex="3" /></p>
    </form>
</div>
<?php
require FORUM_ROOT . $forum_folder . '/footer.php';
?>