<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
require '../include/init.php';
$action = isset($_GET['action']) ? $_GET['action'] : null;
$section = isset($_GET['section']) ? $_GET['section'] : null;
$id = isset($_GET['id']) ? intval($_GET['id']) : 0;
if ($id < 2)
    BB_Functions::Message($lang['Bad request']);
if (($forum_user['g_read_board'] == '0' || ($forum_user['g_view_users'] == 0 && $forum_user['id'] != $id)) && ($action != 'change_pass' || !isset($_GET['key'])))
    BB_Functions::Message($lang['No permission'], true, 1);
if ($action == 'change_pass')
    require FORUM_ROOT . 'include/functions/profile/change_pass.php';
else if ($action == 'change_email')
    require FORUM_ROOT . 'include/functions/profile/change_email.php';
else if ($action == 'avatar_gallery')
    require FORUM_ROOT . 'include/functions/profile/avatar_gallery.php';
else if ($action == 'upload_avatar' || $action == 'upload_avatar2')
    require FORUM_ROOT . 'include/functions/profile/upload_avatar.php';
else if ($action == 'delete_avatar')
{
    if ($forum_user['id'] != $id && $forum_user['g_id'] > USER_MOD)
        BB_Functions::Message($lang['No permission'], true, 1);
    BB_Input::Confirm_Referrer('member.php');
    @unlink(bb_avatars_dir . '/' . $id . '.jpg');
    @unlink(bb_avatars_dir . '/' . $id . '.png');
    @unlink(bb_avatars_dir . '/' . $id . '.gif');
    $db->query('UPDATE ' . $db->prefix . 'users SET use_avatar=0 WHERE id=' . $db->escape($id)) or BB_Functions::Error('Unable to update avatar state', __FILE__, __LINE__, $db->error());
    BB_Functions::Redirect(bb_forum_url . 'member.php?section=personality&amp;id=' . $id, $lang['Avatar deleted redirect']);
}
else if (isset($_POST['update_group_membership']))
{
    if ($forum_user['g_id'] > USER_ADMIN)
        BB_Functions::Message($lang['No permission'], true, 1);
    BB_Input::Confirm_Referrer('member.php');
    $new_group_id = intval($_POST['gid']);
    $db->query('UPDATE ' . $db->prefix . 'users SET gid=' . $db->escape($new_group_id) . ' WHERE id=' . $db->escape($id)) or BB_Functions::Error('Unable to change user group', __FILE__, __LINE__, $db->error());
    if ($new_group_id > USER_MOD)
    {
        $result = $db->query('SELECT id, moderators FROM ' . $db->prefix . 'forums') or BB_Functions::Error('Unable to fetch forum list', __FILE__, __LINE__, $db->error());
        while ($cur_forum = $db->fetch_assoc($result))
        {
            $cur_moderators = ($cur_forum['moderators'] != '') ? unserialize($cur_forum['moderators']) : array();
            if (in_array($id, $cur_moderators))
            {
                $username = array_search($id, $cur_moderators);
                unset($cur_moderators[$username]);
                $cur_moderators = (!empty($cur_moderators)) ? '\'' . $db->escape(serialize($cur_moderators)) . '\'' : 'NULL';
                $db->query('UPDATE ' . $db->prefix . 'forums SET moderators=' . $cur_moderators . ' WHERE id=' . $cur_forum['id']) or BB_Functions::Error('Unable to update forum', __FILE__, __LINE__, $db->error());
            }
        }
    }
    BB_Functions::Redirect(bb_forum_url . 'member.php?section=admin&amp;id=' . $id, $lang['Group membership redirect']);
}
else if (isset($_POST['update_forums']))
{
    if ($forum_user['g_id'] > USER_ADMIN)
        BB_Functions::Message($lang['No permission'], true, 1);
    BB_Input::Confirm_Referrer('member.php');
    $result = $db->query('SELECT username FROM ' . $db->prefix . 'users WHERE id=' . $id) or BB_Functions::Error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
    $username = $db->result($result);
    $moderator_in = (isset($_POST['moderator_in'])) ? array_keys($_POST['moderator_in']) : array();
    $result = $db->query('SELECT id, moderators FROM ' . $db->prefix . 'forums') or BB_Functions::Error('Unable to fetch forum list', __FILE__, __LINE__, $db->error());
    while ($cur_forum = $db->fetch_assoc($result))
    {
        $cur_moderators = ($cur_forum['moderators'] != '') ? unserialize($cur_forum['moderators']) : array();
        if (in_array($cur_forum['id'], $moderator_in) && !in_array($id, $cur_moderators))
        {
            $cur_moderators[$username] = $id;
            ksort($cur_moderators);
            $db->query('UPDATE ' . $db->prefix . 'forums SET moderators=\'' . $db->escape(serialize($cur_moderators)) . '\' WHERE id=' . $cur_forum['id']) or BB_Functions::Error('Unable to update forum', __FILE__, __LINE__, $db->error());
        }
        else if (!in_array($cur_forum['id'], $moderator_in) && in_array($id, $cur_moderators))
        {
            unset($cur_moderators[$username]);
            $cur_moderators = (!empty($cur_moderators)) ? '\'' . $db->escape(serialize($cur_moderators)) . '\'' : 'NULL';
            $db->query('UPDATE ' . $db->prefix . 'forums SET moderators=' . $cur_moderators . ' WHERE id=' . $cur_forum['id']) or BB_Functions::Error('Unable to update forum', __FILE__, __LINE__, $db->error());
        }
    }
    BB_Functions::Redirect(bb_forum_url . 'member.php?section=admin&amp;id=' . $id, $lang['Update forums redirect']);
}
else if (isset($_POST['ban']))
{
    if ($forum_user['g_id'] > USER_MOD || $forum_user['g_global_moderation'] || ($forum_user['g_id'] == USER_MOD && bb_mod_ban_users == '0'))
        BB_Functions::Message($lang['No permission'], true, 1);
    BB_Functions::Redirect(bb_forum_url . 'admin/bans.php?add_ban=' . $id, $lang['Ban redirect']);
}
else if (isset($_POST['delete_user']) || isset($_POST['delete_user_comply']))
{
    if ($forum_user['g_id'] > USER_ADMIN)
        BB_Functions::Message($lang['No permission'], true, 1);
    BB_Input::Confirm_Referrer('member.php');
    $result = $db->query('SELECT gid, username FROM ' . $db->prefix . 'users WHERE id=' . $db->escape($id)) or BB_Functions::Error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
    list($gid, $username) = $db->fetch_row($result);
    if ($gid == USER_ADMIN)
        BB_Functions::Message('Administrators cannot be deleted. In order to delete this user, you must first move him/her to a different user group.');
    if (isset($_POST['delete_user_comply']))
    {
        if ($gid < USER_GUEST)
        {
            $result = $db->query('SELECT id, moderators FROM ' . $db->prefix . 'forums') or BB_Functions::Error('Unable to fetch forum list', __FILE__, __LINE__, $db->error());
            while ($cur_forum = $db->fetch_assoc($result))
            {
                $cur_moderators = ($cur_forum['moderators'] != '') ? unserialize($cur_forum['moderators']) : array();
                if (in_array($id, $cur_moderators))
                {
                    unset($cur_moderators[$username]);
                    $cur_moderators = (!empty($cur_moderators)) ? '\'' . $db->escape(serialize($cur_moderators)) . '\'' : 'NULL';
                    $db->query('UPDATE ' . $db->prefix . 'forums SET moderators=' . $cur_moderators . ' WHERE id=' . $cur_forum['id']) or BB_Functions::Error('Unable to update forum', __FILE__, __LINE__, $db->error());
                }
            }
        }
        $db->query('DELETE FROM ' . $db->prefix . 'subscriptions WHERE user_id=' . $db->escape($id)) or BB_Functions::Error('Unable to delete subscriptions', __FILE__, __LINE__, $db->error());
        $db->query('DELETE FROM ' . $db->prefix . 'online WHERE user_id=' . $db->escape($id)) or BB_Functions::Error('Unable to remove user from online list', __FILE__, __LINE__, $db->error());
        if (isset($_POST['delete_posts']))
        {
            @set_time_limit(0);
            $result = $db->query('SELECT p.id, p.topic_id, t.forum_id FROM ' . $db->prefix . 'posts AS p INNER JOIN ' . $db->prefix . 'topics AS t ON t.id=p.topic_id INNER JOIN ' . $db->prefix . 'forums AS f ON f.id=t.forum_id WHERE p.poster_id=' . $db->escape($id)) or BB_Functions::Error('Unable to fetch posts', __FILE__, __LINE__, $db->error());
            if ($db->num_rows($result))
            {
                while ($cur_post = $db->fetch_assoc($result))
                {
                    $result2 = $db->query('SELECT id FROM ' . $db->prefix . 'posts WHERE topic_id=' . $cur_post['topic_id'] . ' ORDER BY posted LIMIT 1') or BB_Functions::Error('Unable to fetch post info', __FILE__, __LINE__, $db->error());
                    if ($db->result($result2) == $cur_post['id'])
                        BB_Core::Delete_Topic($cur_post['topic_id']);
                    else
                        BB_Core::Delete_Post($cur_post['id'], $cur_post['topic_id']);
                    BB_Core::Update_Forum($cur_post['forum_id']);
                }
            }
        }
        else
            $db->query('UPDATE ' . $db->prefix . 'posts SET poster_id=1 WHERE poster_id=' . $db->escape($id)) or BB_Functions::Error('Unable to update posts', __FILE__, __LINE__, $db->error());
        $db->query('DELETE FROM ' . $db->prefix . 'users WHERE id=' . $db->escape($id)) or BB_Functions::Error('Unable to delete user', __FILE__, __LINE__, $db->error());
        $db->query('DELETE FROM ' . $db->prefix . 'messages WHERE owner=' . $db->escape($id)) or BB_Functions::Error('Unable to delete users messages', __FILE__, __LINE__, $db->error());
        BB_Functions::Redirect(bb_forum_url . 'index.php', $lang['User delete redirect']);
    }
    $page_title = BB_Input::Htmlspecialchars($lang['Profile']);
    require FORUM_ROOT . $forum_folder . '/header.php';
    BB_Functions::Set_Profile_Menu('admin');
    ?>
    <div class="blockform">
        <h2><span><?php echo $lang['Confirm delete user'] ?></span></h2>
        <div class="box">
            <form id="confirm_del_user" method="post" action="member.php?id=<?php echo $id ?>">
                <div class="inform">
                    <div class="infldset file" style="padding:6px">
                        <p class="warntext"><strong><?php echo $lang['Delete warning'] ?></strong></p>

                    </div>
                </div>
                <div class="inform">
                    <div class="infldset file" style="padding:6px">
                        <p><?php echo $lang['Confirmation info'] . ' <strong>' . BB_Input::Htmlspecialchars($username) . '</strong>.' ?></p>
                        <div class="rbox">
                            <label><input type="checkbox" name="delete_posts" value="1" checked="checked" /><?php echo $lang['Delete posts'] ?><br /></label>
                        </div>
                    </div>
                </div>
                <div><input type="button" class="b1" onclick="javascript:history.go(-1);" value="<?php echo $lang['Go back'] ?>"> <input type="submit" class="b1" name="delete_user_comply" value="<?php echo $lang['Delete'] ?>" /></div>
            </form>
        </div>
    </div>
    <div class="clearer"></div>
    <?php
    require FORUM_ROOT . $forum_folder . '/footer.php';
}
else if (isset($_POST['form_sent']))
    require FORUM_ROOT . 'include/functions/profile/form_sent.php';

$result = $db->query('SELECT u.email_alert, u.username, u.email, u.title, u.realname, u.url, u.jabber, u.icq, u.msn, u.aim, u.new_window_link, u.yahoo, u.gtalk, u.skype, u.xfire, u.sex, u.location, u.birthday, u.use_avatar, u.signature, u.disp_topics, u.disp_posts, u.email_setting, u.save_pass, u.notify_with_post, u.show_smilies, u.show_img, u.show_img_sig, u.reverse_posts, u.show_avatars, u.show_sig, u.timezone, u.language, u.template, u.num_posts, u.last_post, u.registered, u.registration_ip, u.admin_note, u.country, u.quicklinks, g.g_id, g.g_user_title, g.g_color, u.absent, u.absence_message FROM ' . $db->prefix . 'users AS u LEFT JOIN ' . $db->prefix . 'usergroups AS g ON g.g_id=u.gid WHERE u.id=' . $db->escape($id)) or BB_Functions::Error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
if (!$db->num_rows($result))
    BB_Functions::Message($lang['Bad request']);
$user = $db->fetch_assoc($result);
$last_post = BB_Input::Format_Time($user['last_post']);
if ($user['signature'] != '')
{
    require_once FORUM_ROOT . 'include/functions/Parser.php';
    $parsed_signature = BB_Parser::Parse_Signature($user['signature']);
}

if ($forum_user['id'] != $id && ($forum_user['g_id'] > USER_MOD || ($forum_user['g_id'] == USER_MOD && bb_mod_edit_users == '0') || ($forum_user['g_id'] == USER_MOD && $user['g_id'] < USER_GUEST)) || ($action == 'view'))
    require FORUM_ROOT . 'include/functions/profile/view.php';
else
{
    if ($section == 'essentials')
        require FORUM_ROOT . 'include/functions/profile/essentials.php';
    else if ($section == 'personal')
        require FORUM_ROOT . 'include/functions/profile/personal.php';
    else if ($section == 'messaging')
        require FORUM_ROOT . 'include/functions/profile/messaging.php';
    else if ($section == 'personality')
        require FORUM_ROOT . 'include/functions/profile/personality.php';
    else if ($section == 'display')
        require FORUM_ROOT . 'include/functions/profile/display.php';
    else if ($section == 'privacy')
        require FORUM_ROOT . 'include/functions/profile/privacy.php';
    else if ($section == 'admin')
        require FORUM_ROOT . 'include/functions/profile/admin.php';
    else if ($_GET['Page'] == 'List')
        require FORUM_ROOT . 'include/functions/profile/pms.php';
    else
        require FORUM_ROOT . 'include/functions/profile/personal.php';
    ?>
    <div class="clearer"></div>

    <?php
    require FORUM_ROOT . $forum_folder . '/footer.php';
}
?>
