<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
require dirname(__FILE__) . '/../include/init.php';
$page = isset($_GET['Page']) ? BB_Input::Htmlspecialchars($_GET['Page']) : null;
if ($page == 'userlist')
{
    if ($forum_user['g_read_board'] == '0' || $forum_user['g_view_users'] == '0')
        BB_Functions::Message($lang['No permission'], true, 1);
    $show_post_count = (bb_show_post_count == '1' || $forum_user['g_id'] < USER_GUEST || $forum_user['g_global_moderation']) ? true : false;
    $username = (isset($_GET['username']) && $forum_user['g_search_users'] == '1') ? $_GET['username'] : '';
    $show_group = (!isset($_GET['show_group']) || intval($_GET['show_group']) < -1 && intval($_GET['show_group']) > 2) ? -1 : intval($_GET['show_group']);
    $sort_by = (!isset($_GET['sort_by']) || $_GET['sort_by'] != 'username' && $_GET['sort_by'] != 'registered' && ($_GET['sort_by'] != 'num_posts' || !$show_post_count)) ? 'username' : $_GET['sort_by'];
    $sort_dir = (!isset($_GET['sort_dir']) || $_GET['sort_dir'] != 'ASC' && $_GET['sort_dir'] != 'DESC') ? 'ASC' : strtoupper($_GET['sort_dir']);
    $page_title = BB_Input::Htmlspecialchars($lang['User list']);
    if ($forum_user['g_search_users'] == '1')
        $focus_element = array('userlist', 'username');
    require FORUM_ROOT . $forum_folder . '/header.php';
    ?>
    <div class="blockform">
        <h2><span><?php echo $lang['User search'] ?></span></h2>
        <div class="box">
            <form id="userlist" method="get" action="members.php">
                <div class="inform">
                    <div class="infldset file" style="padding:10px">
    <?php if ($forum_user['g_search_users'] == '1')
        echo '<label class="conl">' . $lang['Username'] . '<br /><input type="text" class="textbox" name="username" value="' . BB_Input::Htmlspecialchars($username) . '" size="25" maxlength="25" /><br /></label>'; ?>
                        <label class="conl"><?php echo $lang['User group'] . "\n" ?>
                            <br /><select name="show_group">
                                <option value="-1"<?php if ($show_group == -1)
                                echo ' selected="selected"' ?>><?php echo $lang['All users'] ?></option>
                                <?php
                                $result = $db->query('SELECT g_id, g_title FROM ' . $db->prefix . 'usergroups WHERE g_id!=' . USER_GUEST . ' ORDER BY g_id') or BB_Functions::Error($lang['error_28'], __FILE__, __LINE__, $db->error());
                                while ($cur_group = $db->fetch_assoc($result))
                                {
                                    if ($cur_group['g_id'] == $show_group)
                                        echo "\t\t\t\t\t\t" . '<option value="' . $cur_group['g_id'] . '" selected="selected">' . BB_Input::Htmlspecialchars($cur_group['g_title']) . '</option>' . "\n";
                                    else
                                        echo "\t\t\t\t\t\t" . '<option value="' . $cur_group['g_id'] . '">' . BB_Input::Htmlspecialchars($cur_group['g_title']) . '</option>' . "\n";
                                }
                                ?>
                            </select>
                            <br /></label>
                        <label class="conl"><?php echo $lang['Sort by'] . "\n" ?>
                            <br /><select name="sort_by">
                                <option value="username"<?php if ($sort_by == 'username')
                                echo ' selected="selected"' ?>><?php echo $lang['Username'] ?></option>
                                <option value="registered"<?php if ($sort_by == 'registered')
                                echo ' selected="selected"' ?>><?php echo $lang['Registered'] ?></option>
    <?php
    if ($show_post_count)
    {
        ?>
                                    <option value="num_posts"<?php if ($sort_by == 'num_posts')
            echo ' selected="selected"' ?>><?php echo $lang['No of posts'] ?></option>
        <?php
    }
    ?>
                            </select>
                            <br /></label>
                        <label class="conl"><?php echo $lang['Sort order'] . "\n" ?>
                            <br /><select name="sort_dir">
                                <option value="ASC"<?php if ($sort_dir == 'ASC')
        echo ' selected="selected"' ?>><?php echo $lang['Ascending'] ?></option>
                                <option value="DESC"<?php if ($sort_dir == 'DESC')
                    echo ' selected="selected"' ?>><?php echo $lang['Descending'] ?></option>
                            </select>
                            <br /></label>
                        <p class="clearb"><?php echo $lang['User search info'] ?></p>
                    </div>
                    <input type="hidden" name="Page" value="userlist" />
                    <br /><div><input type="submit" class="b1" name="search" value="<?php echo $lang['Search'] ?>" accesskey="s" /></div>
                    <?php
                    $where_sql = array();
                    $like_command = ($db_type == 'pgsql') ? 'ILIKE' : 'LIKE';
                    if ($forum_user['g_search_users'] == '1' && $username != '')
                        $where_sql[] = 'u.username ' . $like_command . ' \'' . $db->escape(str_replace('*', '%', $username)) . '\'';
                    if ($show_group > -1)
                        $where_sql[] = 'u.gid=' . $show_group;
                    $result = $db->query('SELECT COUNT(id) FROM ' . $db->prefix . 'users AS u WHERE u.id>1' . (!empty($where_sql) ? ' AND ' . implode(' AND ', $where_sql) : '')) or BB_Functions::Error($lang['error_27'], __FILE__, __LINE__, $db->error());
                    $num_users = $db->result($result);
                    $num_pages = ceil($num_users / 30);
                    $p = (!isset($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $num_pages) ? 1 : $_GET['p'];
                    if (isset($_GET['letter']) && $_REQUEST['letter'] != '*')
                    {
                        $like = BB_Input::Htmlspecialchars(strtolower($_REQUEST['letter'])) . '%';
                        $letter = BB_Input::Htmlspecialchars(strtolower($_REQUEST['letter']));
                    }
                    else
                    {
                        $letter = '*';
                        $like = '%';
                    }
                    $start_from = 30 * ($p - 1);
                    if ($_GET['skip_page'] != 1)
                        $paging_links = '<strong class="pagination">' . $lang['Pages'] . '</strong> ' . BB_Core::Paginate($num_pages, $p, 'members.php?Page=userlist&username=' . urlencode($username) . '&amp;show_group=' . $show_group . '&amp;sort_by=' . $sort_by . '&amp;sort_dir=' . strtoupper($sort_dir));
                    ?>
                </div>
            </form>
        </div>
    </div>
    <div class="blockform" style="border:0px;">
        <div class="inbox">
            <table width=100% cellspacing="0" cellpadding="0">
                <tr>
                    <td style="text-align:center;border:0px;"><a class="pagination_members" href="members.php?Page=userlist&letter=*" title="">ALL</a>
                        <a class="pagination_members" href="members.php?Page=userlist&letter=A&amp;skip_page=1" title="">A</a>
                        <a class="pagination_members" href="members.php?Page=userlist&letter=B&amp;skip_page=1" title="">B</a>
                        <a class="pagination_members" href="members.php?Page=userlist&letter=C&amp;skip_page=1" title="">C</a>
                        <a class="pagination_members" href="members.php?Page=userlist&letter=D&amp;skip_page=1" title="">D</a>
                        <a class="pagination_members" href="members.php?Page=userlist&letter=E&amp;skip_page=1" title="">E</a>
                        <a class="pagination_members" href="members.php?Page=userlist&letter=F&amp;skip_page=1" title="">F</a>
                        <a class="pagination_members" href="members.php?Page=userlist&letter=G&amp;skip_page=1" title="">G</a>
                        <a class="pagination_members" href="members.php?Page=userlist&letter=H&amp;skip_page=1" title="">H</a>
                        <a class="pagination_members" href="members.php?Page=userlist&letter=I&amp;skip_page=1" title="">I</a>
                        <a class="pagination_members" href="members.php?Page=userlist&letter=J&amp;skip_page=1" title="">J</a>
                        <a class="pagination_members" href="members.php?Page=userlist&letter=K&amp;skip_page=1" title="">K</a>
                        <a class="pagination_members" href="members.php?Page=userlist&letter=L&amp;skip_page=1" title="">L</a>
                        <a class="pagination_members" href="members.php?Page=userlist&letter=M&amp;skip_page=1" title="">M</a>
                        <a class="pagination_members" href="members.php?Page=userlist&letter=N&amp;skip_page=1" title="">N</a>
                        <a class="pagination_members" href="members.php?Page=userlist&letter=O&amp;skip_page=1" title="">O</a>
                        <a class="pagination_members" href="members.php?Page=userlist&letter=P&amp;skip_page=1" title="">P</a>
                        <a class="pagination_members" href="members.php?Page=userlist&letter=Q&amp;skip_page=1" title="">Q</a>
                        <a class="pagination_members" href="members.php?Page=userlist&letter=R&amp;skip_page=1" title="">R</a>
                        <a class="pagination_members" href="members.php?Page=userlist&letter=S&amp;skip_page=1" title="">S</a>
                        <a class="pagination_members" href="members.php?Page=userlist&letter=T&amp;skip_page=1" title="">T</a>
                        <a class="pagination_members" href="members.php?Page=userlist&letter=U&amp;skip_page=1" title="">U</a>
                        <a class="pagination_members" href="members.php?Page=userlist&letter=V&amp;skip_page=1" title="">V</a>
                        <a class="pagination_members" href="members.php?Page=userlist&letter=W&amp;skip_page=1" title="">W</a>
                        <a class="pagination_members" href="members.php?Page=userlist&letter=X&amp;skip_page=1" title="">X</a>
                        <a class="pagination_members" href="members.php?Page=userlist&letter=Y&amp;skip_page=1" title="">Y</a>
                        <a class="pagination_members" href="members.php?Page=userlist&letter=Z&amp;skip_page=1" title="">Z</a></td>
                </tr>
            </table>
        </div>
    </div>
    <div class="linkst">
        <div class="inbox">
            <p class="pagelink"><?php echo $paging_links ?></p>
        </div>
    </div>
    <div id="users1" class="blocktable">
        <h2><span><?php echo $lang['User list'] ?></span></h2>
        <div class="box">
            <div class="inbox">
                <table cellspacing="0">
                    <thead>
                        <tr>
                            <th class="tcl"><?php echo $lang['Username'] ?></th>
                            <th class="tc2"><?php echo $lang['Title'] ?></th>
                        <?php if ($show_post_count)
                            echo '<th class="tc4">' . $lang['Posts'] . '</th>'; ?>
                            <th class="tc3"><?php echo $lang['Registered'] ?></th>
                            <th class="tcr"><?php echo $lang['Country'] ?></th>
                        </tr>
                    </thead>
                    <tbody>
                            <?php
                            $result = $db->query('SELECT u.id, u.username, u.title, u.num_posts, u.registered, u.country, u.gid, g.g_id, g.g_user_title, g.g_color FROM ' . $db->prefix . 'users AS u LEFT JOIN ' . $db->prefix . 'usergroups AS g ON g.g_id=u.gid WHERE u.id>1' . (!empty($where_sql) ? ' AND ' . implode(' AND ', $where_sql) : '') . ' AND username LIKE \'' . $db->escape($like) . '\' ORDER BY ' . $db->escape($sort_by) . ' ' . $db->escape($sort_dir) . ' LIMIT ' . $db->escape($start_from) . ', 30') or BB_Functions::Error($lang['error_26'], __FILE__, __LINE__, $db->error());
                            if ($db->num_rows($result))
                            {
                                while ($user_data = $db->fetch_assoc($result))
                                {
                                    $user_title_field = BB_Core::Get_User_Title($user_data);
                                    if ($user_data['g_color'] == '')
                                        $user_data['g_color'] = '#000000';
                                    if ($user_data['gid'] == USER_UNVERIFIED)
                                        $user_title_field = ' <font color="red">' . $lang['not_activated'] . '</font>';
                                    $user_country = $user_data['country'];
                                    if ($user_title_field == $lang['Banned'])
                                        $user_data['g_color'] = '#FF0000';
                                    ?>
                                <tr>
                                    <td class="tcl"><?php echo '<a href="' . BB_Input::Rewrite_URL("u", $user_data['id'], $user_data['username']) . '"><span style="color:' . $user_data['g_color'] . '">' . BB_Input::Htmlspecialchars($user_data['username']) . '</span></a>'; ?></td>
                                    <td class="tc2"><?php echo $user_title_field ?></td>
            <?php if ($show_post_count)
                echo '<td class="tc4">' . $user_data['num_posts'] . '</td>'; ?>
                                    <td class="tc3"><?php echo BB_Input::Format_Time($user_data['registered'], true) ?></td>
                                    <td class="tcr"><?php if ($user_country != '')
                echo '<img src="' . bb_forum_url . 'img/general/flags/' . BB_Input::Htmlspecialchars($user_country) . '.png" alt="' . BB_Input::Htmlspecialchars($user_country) . '" title="' . BB_Input::Htmlspecialchars($user_country) . '" />'; else
                echo '&nbsp;'; ?></td>
                                </tr>
                                <?php
                            }
                        }
                        else
                            echo "\t\t\t" . '<tr>' . "\n\t\t\t\t\t" . '<td class="tcl" colspan="' . (($show_post_count) ? 4 : 3) . '">' . $lang['No hits'] . '</td></tr>' . "\n";
                        ?>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
    <div class="linksb">
        <div class="inbox">
            <p class="pagelink"><?php echo $paging_links ?></p>
        </div>
    </div>
    <div class="blockform">
        <h2><span><?php echo $lang['Legend'] ?></span></h2>
        <div class="box">
            <form id="userlist" method="get" action="members.php">
                <div class="inform">
                    <div class="infldset file" style="padding:10px;text-align:center;">
    <?php
    $result = $db->query('SELECT g_title, g_id, g_color FROM ' . $db->prefix . 'usergroups WHERE g_id <> 3 ORDER BY g_id', true) or BB_Functions::Error($lang['error_10'], __FILE__, __LINE__, $db->error());
    while ($groups_legend = $db->fetch_assoc($result))
    {
        if ($groups_legend['g_color'] == '')
            $groups_legend['g_color'] = '#000000';
        echo '<span style="color: ' . $groups_legend['g_color'] . '"><b><a style="color:' . $groups_legend['g_color'] . '" href="members.php?username=&show_group=' . $groups_legend['g_id'] . '&sort_by=username&sort_dir=ASC&Page=userlist&search=Search">' . BB_Input::Htmlspecialchars($groups_legend['g_title']) . '</b></a></span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
    }
    ?>
                        <br />
                    </div>
                </div>
            </form>
        </div>
    </div>
                        <?php
                    }
                    else if ($page == 'online')
                    {
                        if ($forum_user['is_guest'])
                            BB_Functions::Message($lang['No permission'], true, 1);
                        $page_title = BB_Input::Htmlspecialchars($lang['Online List']);
                        require FORUM_ROOT . $forum_folder . '/header.php';
                        ?>
    <div class="blocktable">
        <h2><span><?php echo $lang['Online List'] ?></span></h2>
        <div class="box">
            <div class="inbox">
                <table cellspacing="0">
                    <thead>
                        <tr>
                            <th class="tcl"><?php echo $lang['Username'] ?></th>
                            <th class="tc2"><?php echo $lang['Last action'] ?></th>
                            <th class="tc3"><?php echo $lang['Time'] ?></th>
                        <? if ($forum_user['g_id'] <= USER_MOD)
                        { ?><th class="tcr"><?php echo $lang['IP'] ?></th><?php echo "\n";
                } ?>
                        </tr>
                    </thead>
                    <tbody>
                        <?php
                        $result = $db->query('SELECT * FROM ' . $db->prefix . 'online WHERE user_id > 0 AND idle=0 ORDER BY ident') or BB_Functions::Error($lang['error_10'], __FILE__, __LINE__, $db->error());
                        $num_users_page = $db->num_rows($result);
                        if ($num_users_page)
                        {
                            while ($num_users_page--)
                            {
                                $user_data = $db->fetch_assoc($result);
                                if ($user_data['invisible'] != 1 || $forum_user['g_id'] < USER_MOD)
                                {
                                    if ($user_data['current_page'])
                                    {
                                        echo"\t\t\t\t\t\t\t\t" . '<tr>' . "\n";
                                        if ($user_data['user_id'] > 1)
                                            echo "\t\t\t\t\t\t\t\t\t" . '<td class="tcl"><a href="' . bb_forum_url . BB_Input::Rewrite_URL("u", $user_data['user_id'], $user_data['ident']) . '"><span style="color:' . $user_data['color'] . '">' . $user_data['ident'] . '</span></a></td>' . "\n";
                                        else
                                            echo "\t\t\t\t\t\t\t\t\t" . '<td class="tcl">' . $lang['Guest'] . '</td>' . "\n";
                                        $pathinfo = pathinfo($user_data['current_page']);
                                        $current_page = $pathinfo['basename'];
                                        if ($user_data['current_page_id'] > 0)
                                        {
                                            if ($current_page == "topic.php" || $current_page == "post.php")
                                            {
                                                $current_page_name = $db->query('SELECT subject FROM ' . $db->prefix . 'topics WHERE id=\'' . $db->escape($user_data['current_page_id']) . '\'') or BB_Functions::Error('Unable to fetch topic info', __FILE__, __LINE__, $db->error());
                                            }
                                            if ($current_page == "forum.php")
                                            {
                                                $current_page_name = $db->query('SELECT forum_name FROM ' . $db->prefix . 'forums WHERE id=\'' . $db->escape($user_data['current_page_id']) . '\'') or BB_Functions::Error('Unable to fetch forum info', __FILE__, __LINE__, $db->error());
                                            }
                                            if ($current_page == "member.php")
                                            {
                                                $current_page_name = $db->query('SELECT username FROM ' . $db->prefix . 'users WHERE id=\'' . $db->escape($user_data['current_page_id']) . '\'') or BB_Functions::Error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
                                            }
                                            if ($current_page == "post.php" || $current_page == "edit.php")
                                            {
                                                echo"\t\t\t\t\t" . '<td class="tc2" style="width:50%;text-align:left">' . $lang[$user_data['current_page']] . ': <b><a href="' . bb_forum_url . 'topic.php?id=' . $user_data['current_page_id'] . '">' . $db->result($current_page_name, 0) . '</a></b></td>' . "\n";
                                            }
                                            else
                                            {
                                                echo"\t\t\t\t\t\t\t\t\t" . '<td class="tc2">' . $lang[$user_data['current_page']] . ': <b><a href="' . $user_data['current_page'] . '?id=' . $user_data['current_page_id'] . '">' . $db->result($current_page_name, 0) . '</a></b></td>' . "\n";
                                            }
                                        }
                                        else if ((@$lang[$user_data['current_page']]) == '')
                                            echo"\t\t\t\t\t\t\t\t\t" . '<td class="tc2">' . $lang['Hiding Somewhere'] . '</td>' . "\n";
                                        else
                                            echo"\t\t\t\t\t\t\t\t\t" . '<td class="tc2"><a href="' . $user_data['current_page'] . '">' . $lang[$user_data['current_page']] . '</a></td>' . "\n";
                                        echo"\t\t\t\t\t\t\t\t\t" . '<td class="tcr">' . BB_Input::Format_Time($user_data['logged']) . '</td>' . "\n";
                                        if ($forum_user['g_id'] <= USER_MOD)
                                            echo"\t\t\t\t\t\t\t\t\t" . '<td class="tcr"><a href="' . bb_website_url . '/admin/users.php?show_users=' . $user_data['current_ip'] . '">' . $user_data['current_ip'] . '</a></td>' . "\n";
                                        echo"\t\t\t\t\t\t\t\t" . '</tr>' . "\n";
                                    }
                                }
                            }
                        }
                        else
                            echo "\t\t\t\t" . '<tr><td class="tcl" colspan="4">' . $lang['No users'] . '</td>' . "\n\t\t\t\t" . '</tr>' . "\n";
                        ?>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
    <?php
}
else
    BB_Functions::Message($lang['Bad request']);
require FORUM_ROOT . $forum_folder . '/footer.php';
?>
