<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
if (isset($_GET['action']))
    define('QUIET_VISIT', 1);
require dirname(__FILE__) . '/../include/init.php';
$action = isset($_GET['action']) ? $_GET['action'] : null;
if ($action == 'rules')
{
    $page_title = $lang['Forum rules'];
    require FORUM_ROOT . $forum_folder . '/header.php';
    ?>
    <div class="xenno_block">
        <h2><span><?php echo $lang['Forum rules'] ?></span></h2>
        <div class="box">
            <div class="inbox">
                <p><?php echo bb_rules_message ?></p>
            </div>
        </div>
    </div>
    <?php
    require FORUM_ROOT . $forum_folder . '/footer.php';
}
else if ($action == 'markread')
{
    if ($forum_user['is_guest'])
        BB_Functions::Message($lang['No permission'], true, 1);
    $db->query('UPDATE ' . $db->prefix . 'users SET last_visit=' . $forum_user['logged'] . ', read_topics=NULL WHERE id=' . $forum_user['id']) or BB_Functions::Error($lang['error_41'], __FILE__, __LINE__, $db->error());
    BB_Functions::Redirect(bb_forum_url . 'index.php', $lang['Mark read redirect']);
}
else if ($action == 'markforumread')
{
    $id = isset($_GET['id']) ? intval($_GET['id']) : 0;
    if ($forum_user['is_guest'])
        BB_Functions::Message($lang['No permission'], true, 1);
    if ($id < 1)
        BB_Functions::Message($lang['Bad request']);
    $forum_user['read_topics']['f'][$id] = time();
    $db->query('UPDATE ' . $db->prefix . 'users SET read_topics=\'' . $db->escape(serialize($forum_user['read_topics'])) . '\' WHERE id=' . $forum_user['id']) or BB_Functions::Error($lang['error_42'], __FILE__, __LINE__, $db->error());
    BB_Functions::Redirect(bb_forum_url . 'forum.php?id=' . $id, $lang['Mark forum read redirect']);
}
else if (isset($_GET['email']))
{
    if ($forum_user['is_guest'])
        BB_Functions::Message($lang['No permission'], true, 1);
    $recipient_id = intval($_GET['email']);
    if ($recipient_id < 2)
        BB_Functions::Message($lang['Bad request']);
    $result = $db->query('SELECT username, email, email_setting FROM ' . $db->prefix . 'users WHERE id=' . $db->escape($recipient_id)) or BB_Functions::Error($lang['error_29'], __FILE__, __LINE__, $db->error());
    if (!$db->num_rows($result))
        BB_Functions::Message($lang['Bad request']);
    list($recipient, $recipient_email, $email_setting) = $db->fetch_row($result);
    if ($email_setting == 2 && ($forum_user['g_id'] > USER_MOD && !$forum_user['g_global_moderation']))
        BB_Functions::Message($lang['Form e-mail disabled']);
    if (isset($_POST['form_sent']))
    {
        $subject = BB_Input::Trim($_POST['req_subject']);
        $message = BB_Input::Trim($_POST['req_message']);
        if ($subject == '')
            BB_Functions::Message($lang['No e-mail subject']);
        else if ($message == '')
            BB_Functions::Message($lang['No e-mail message']);
        else if (strlen($message) > 65535)
            BB_Functions::Message($lang['Too long e-mail message']);
        $mail_tpl = trim(file_get_contents(FORUM_ROOT . 'include/languages/' . $forum_user['language'] . '/mail_templates/form_email.tpl'));
        $first_crlf = strpos($mail_tpl, "\n");
        $mail_subject = trim(substr($mail_tpl, 8, $first_crlf - 8));
        $mail_message = trim(substr($mail_tpl, $first_crlf));
        $mail_subject = str_replace('<mail_subject>', $subject, $mail_subject);
        $mail_message = str_replace('<sender>', $forum_user['username'], $mail_message);
        $mail_message = str_replace('<board_title>', bb_board_title, $mail_message);
        $mail_message = str_replace('<mail_message>', $message, $mail_message);
        $mail_message = str_replace('<board_mailer>', bb_board_title . ' ' . $lang['Mailer'], $mail_message);
        BB_Email::Mail($recipient_email, $mail_subject, $mail_message, '"' . str_replace('"', '', $forum_user['username']) . '" <' . $forum_user['email'] . '>');
        BB_Functions::Redirect(BB_Input::Htmlspecialchars($_POST['redirect_url']), $lang['E-mail sent redirect']);
    }
    $redirect_url = (isset($_SERVER['HTTP_REFERER']) && preg_match('#^' . preg_quote(bb_forum_url) . '/(.*?)\.php#i', $_SERVER['HTTP_REFERER'])) ? $_SERVER['HTTP_REFERER'] : 'index.php';
    $page_title = BB_Input::Htmlspecialchars(bb_board_title) . ' :: ' . $lang['Send e-mail to'] . ' ' . BB_Input::Htmlspecialchars($recipient);
    $required_fields = array('req_subject' => $lang['E-mail subject'], 'req_message' => $lang['E-mail message']);
    $focus_element = array('email', 'req_subject');
    require FORUM_ROOT . $forum_folder . '/header.php';
    ?>
    <div class="blockform">
        <h2><span><?php echo $lang['Send e-mail to'] ?> <?php echo BB_Input::Htmlspecialchars($recipient) ?></span></h2>
        <form id="email" method="post" action="misc.php?email=<?php echo $recipient_id ?>" onsubmit="this.submit.disabled=true;if(process_form(this)){return true;}else{this.submit.disabled=false;return false;}">
            <h2><?php echo $lang['Write e-mail'] ?></h2>
            <div class="inform">
                <div class="infldset file" style="padding:20px;">
                    <input type="hidden" name="form_sent" value="1" />
                    <input type="hidden" name="redirect_url" value="<?php echo $redirect_url ?>" />
                    <fieldset>
                        <legend><?php echo $lang['E-mail subject'] ?></legend>
                        <input class="textbox" type="text" name="req_subject" style="width:510px" maxlength="70" tabindex="1" />
                    </fieldset>
                    <fieldset>
                        <legend><?php echo $lang['E-mail message'] ?></legend>
                        <textarea id="qp1" name="req_message" rows="10" style="width:510px" tabindex="2"><?php echo $quote ?></textarea>
                    </fieldset>
                </div>
            </div>
            <div><input type="button" class="b1" onclick="javascript:history.go(-1)" value="<?php echo $lang['Go back'] ?>"> <input class="b1" type="submit" name="submit" value="<?php echo $lang['Send e-mail'] ?>" tabindex="3" accesskey="s" /></div>
        </form>
    </div>
    <?php
    require FORUM_ROOT . $forum_folder . '/footer.php';
}
else if (isset($_GET['report']))
{
    if ($forum_user['is_guest'])
        BB_Functions::Message($lang['No permission'], true, 1);
    $post_id = intval($_GET['report']);
    $type = isset($_GET['type']) ? BB_Input::Htmlspecialchars($_GET['type']) : 'topic';
    if ($post_id < 1)
        BB_Functions::Message($lang['Bad request']);
    if (isset($_POST['form_sent']))
    {
        $reason = BB_Input::Linebreaks(BB_Input::Trim($_POST['req_reason']));
        if ($reason == '')
            BB_Functions::Message($lang['No reason']);
        $result = $db->query('SELECT topic_id FROM ' . $db->prefix . 'posts WHERE id=' . $db->escape($post_id)) or BB_Functions::Error($lang['error_3'], __FILE__, __LINE__, $db->error());
        if (!$db->num_rows($result))
            BB_Functions::Message($lang['Bad request']);
        $topic_id = $db->result($result);
        $result = $db->query('SELECT subject, forum_id FROM ' . $db->prefix . 'topics WHERE id=' . $db->escape($topic_id)) or BB_Functions::Error($lang['error_4'], __FILE__, __LINE__, $db->error());
        if (!$db->num_rows($result))
            BB_Functions::Message($lang['Bad request']);
        list($subject, $forum_id) = $db->fetch_row($result);
        if (bb_report_method == 0 || bb_report_method == 2)
            $db->query('INSERT INTO ' . $db->prefix . 'reports (post_id, topic_id, forum_id, reported_by, created, message) VALUES(' . $db->escape($post_id) . ', ' . $db->escape($topic_id) . ', ' . $db->escape($forum_id) . ', ' . $forum_user['id'] . ', ' . time() . ', \'' . $db->escape($reason) . '\')') or BB_Functions::Error($lang['error_43'], __FILE__, __LINE__, $db->error());
        if (bb_report_method == 1 || bb_report_method == 2)
        {
            if (bb_mailing_list != '')
            {
                $mail_subject = 'Report(' . $forum_id . ') - \'' . $subject . '\'';
                $mail_message = 'User \'' . $forum_user['username'] . '\' has reported the following message:' . "\n" . bb_forum_url . '/topic.php?pid=' . $post_id . '#p' . $post_id . "\n\n" . 'Reason:' . "\n" . $reason;
                BB_Email::Mail(bb_mailing_list, $mail_subject, $mail_message);
            }
        }
        BB_Functions::Redirect(bb_forum_url . 'topic.php?type=' . $type . '&pid=' . $post_id . '#p' . $post_id, $lang['Report redirect']);
    }
    $page_title = BB_Input::Htmlspecialchars($lang['Report post']);
    $required_fields = array('req_reason' => $lang['Reason']);
    $focus_element = array('report', 'req_reason');
    require FORUM_ROOT . $forum_folder . '/header.php';
    ?>
    <div class="blockform">
        <h2><span><?php echo $lang['Report post'] ?></span></h2>
        <form id="report" method="post" action="misc.php?report=<?php echo $post_id ?>&type=<?php echo $type ?>" onsubmit="this.submit.disabled=true;if(process_form(this)){return true;}else{this.submit.disabled=false;return false;}">
            <h2><?php echo $lang['Reason desc'] ?></h2>
            <div class="inform">
                <div class="infldset file" style="padding:20px">
                    <input type="hidden" name="form_sent" value="1" />
                    <fieldset>
                        <legend><?php echo $lang['Reason'] ?></legend>
                        <textarea name="req_reason" rows="7" style="width:510px"></textarea>
                    </fieldset>
                </div>
            </div>
            <div><input type="button" class="b1" onclick="javascript:history.go(-1)" value="<?php echo $lang['Go back'] ?>"> <input type="submit" class="b1" name="submit" value="<?php echo $lang['Send report'] ?>" accesskey="s" /></div>
        </form>
    </div>
    <?php
    require FORUM_ROOT . $forum_folder . '/footer.php';
}
else if (isset($_GET['forward']))
{
    if ($forum_user['is_guest'])
        BB_Functions::Message($lang['No permission'], true, 1);
    $type = isset($_GET['type']) ? BB_Input::Htmlspecialchars($_GET['type']) : 'topic';
    $sender_id = intval($_GET['forward']);
    $post_id = intval($_GET['pid']);
    if ($sender_id < 1 || $post_id < 1)
        BB_Functions::Message($lang['Bad request']);
    $result = $db->query('SELECT username,email FROM ' . $db->prefix . 'users WHERE id=' . $db->escape($sender_id)) or BB_Functions::Error($lang['error_998'], __FILE__, __LINE__, $db->error());
    if (!$db->num_rows($result))
        BB_Functions::Message($lang['Bad request']);
    list($sender, $sender_email) = $db->fetch_row($result);
    $result = $db->query('SELECT topic_id FROM ' . $db->prefix . 'posts WHERE id=' . $db->escape($post_id)) or BB_Functions::Error($lang['error_998'], __FILE__, __LINE__, $db->error());
    if (!$db->num_rows($result))
        BB_Functions::Message($lang['Bad request']);
    $topic_id = $db->result($result);
    $result = $db->query('SELECT subject FROM ' . $db->prefix . 'topics WHERE id=' . $db->escape($topic_id)) or BB_Functions::Error($lang['error_998'], __FILE__, __LINE__, $db->error());
    if (!$db->num_rows($result))
        BB_Functions::Message($lang['Bad request']);
    list($subject, $forum_id) = $db->fetch_row($result);
    if (isset($_POST['form_sent']))
    {
        $subject = BB_Input::Trim($_POST['req_subject']);
        $message = BB_Input::Trim($_POST['req_message']);
        $recipient = BB_Input::Trim($_POST['req_address']);
        if ($recipient == '')
            BB_Functions::Message($lang['Invalid e-mail address']);
        else if ($subject == '')
            BB_Functions::Message($lang['No e-mail subject']);
        else if ($message == '')
            BB_Functions::Message($lang['No e-mail message']);
        else if (strlen($message) > 65535)
            BB_Functions::Message($lang['Too long e-mail message']);
        $mail_tpl = trim(file_get_contents(FORUM_ROOT . 'include/languages/' . $forum_user['language'] . '/mail_templates/forward_email.tpl'));
        $first_crlf = strpos($mail_tpl, "\n");
        $mail_subject = trim(substr($mail_tpl, 8, $first_crlf - 8));
        $mail_message = trim(substr($mail_tpl, $first_crlf));
        $mail_subject = str_replace('<mail_subject>', $subject, $mail_subject);
        $mail_message = str_replace('<sender>', $forum_user['username'], $mail_message);
        $mail_message = str_replace('<board_title>', bb_board_title, $mail_message);
        $mail_message = str_replace('<mail_message>', $message, $mail_message);
        $mail_message = str_replace('<board_mailer>', bb_board_title . ' ' . $lang['Mailer'], $mail_message);
        if (BB_Email::Is_Valid_Email($recipient))
            BB_Email::Mail($recipient, $mail_subject, $mail_message, $forum_user['username'] . ' <' . $forum_user['email'] . '>');
        else
            BB_Functions::Message($lang['Invalid e-mail address']);
        BB_Functions::Redirect(BB_Input::Htmlspecialchars($_POST['redirect_url']), $lang['E-mail sent redirect']);
    }
    $redirect_url = (isset($_SERVER['HTTP_REFERER']) && preg_match('#^' . preg_quote(bb_forum_url) . '/(.*?)\.php#i', $_SERVER['HTTP_REFERER'])) ? $_SERVER['HTTP_REFERER'] : 'index.php';
    $page_title = BB_Input::Htmlspecialchars($lang['Forward'] . ' ' . BB_Input::Htmlspecialchars($subject));
    $required_fields = array('req_address' => $lang['E-mail address'], 'req_subject' => $lang['E-mail subject'], 'req_message' => $lang['E-mail message']);
    $focus_element = array('email', 'req_subject');
    require FORUM_ROOT . $forum_folder . '/header.php';
    ?>
    <div class="blockform">
        <h2><span><?php echo $lang['Forward post via E-Mail'] ?></span></h2>
        <form id="forward" method="post" action="misc.php?forward=<?php echo $sender_id . '&pid=' . $post_id ?>" onsubmit="this.submit.disabled=true;if(process_form(this)){return true;}else{this.submit.disabled=false;return false;}">
            <h2><?php echo $lang['Send e-mail from'] ?> <?php echo BB_Input::Htmlspecialchars($sender) ?></h2>
            <div class="inform">
                <div class="infldset file" style="padding:20px;">
                    <input type="hidden" name="form_sent" value="1" />
                    <input type="hidden" name="redirect_url" value="<?php echo $redirect_url ?>" />
                    <fieldset>
                        <legend><?php echo $lang['Forward e-mail to'] ?></legend>
                        <input type="text" class="textbox" name="req_address" style="width:510px" maxlength="70" tabindex="1" />
                    </fieldset>
                    <fieldset>
                        <legend><?php echo $lang['E-mail subject'] ?></legend>
                        <input type="text" class="textbox" name="req_subject" value="<?php echo $subject ?>" style="width:510px" maxlength="70" tabindex="1" />
                    </fieldset>
                    <fieldset>
                        <legend><?php echo $lang['E-mail message'] ?></legend>
                        <textarea name="req_message" rows="10" style="width:510px" tabindex="2" ><?php echo bb_forum_url . 'topic.php?type=' . $type . '&pid=' . $post_id ?></textarea>
                    </fieldset>
                </div>
            </div>
            <div><input type="button" class="b1" onclick="javascript:history.go(-1);" value="<?php echo $lang['Go back'] ?>" /> <input type="submit" name="submit" class="b1" value="<?php echo $lang['Submit'] ?>" tabindex="3" accesskey="s" /></div>
        </form>
    </div>
    <?php
    require FORUM_ROOT . $forum_folder . '/footer.php';
}
else if (isset($_GET['subscribe']))
{
    if ($forum_user['is_guest'] || bb_subscriptions != '1')
        BB_Functions::Message($lang['No permission'], true, 1);
    $topic_id = intval($_GET['subscribe']);
    $type = isset($_GET['type']) ? BB_Input::Htmlspecialchars($_GET['type']) : 'topic';
    if ($topic_id < 1)
        BB_Functions::Message($lang['Bad request']);
    $result = $db->query('SELECT 1 FROM ' . $db->prefix . 'subscriptions WHERE user_id=' . $forum_user['id'] . ' AND topic_id=' . $db->escape($topic_id)) or BB_Functions::Error($lang['error_44'], __FILE__, __LINE__, $db->error());
    if ($db->num_rows($result))
        BB_Functions::Message($lang['Already subscribed']);
    $db->query('INSERT INTO ' . $db->prefix . 'subscriptions (user_id, topic_id) VALUES(' . $forum_user['id'] . ' ,' . $db->escape($topic_id) . ')') or BB_Functions::Error($lang['error_45'], __FILE__, __LINE__, $db->error());
    BB_Functions::Redirect(bb_forum_url . 'topic.php?type=' . $type . '&id=' . $topic_id, $lang['Subscribe redirect']);
}
else if (isset($_GET['unsubscribe']))
{
    if ($forum_user['is_guest'] || bb_subscriptions != '1')
        BB_Functions::Message($lang['No permission'], true, 1);
    $topic_id = intval($_GET['unsubscribe']);
    $type = isset($_GET['type']) ? BB_Input::Htmlspecialchars($_GET['type']) : 'topic';
    if ($topic_id < 1)
        BB_Functions::Message($lang['Bad request']);
    $result = $db->query('SELECT 1 FROM ' . $db->prefix . 'subscriptions WHERE user_id=' . $forum_user['id'] . ' AND topic_id=' . $db->escape($topic_id)) or BB_Functions::Error($lang['error_44'], __FILE__, __LINE__, $db->error());
    if (!$db->num_rows($result))
        BB_Functions::Message($lang['Not subscribed']);
    $db->query('DELETE FROM ' . $db->prefix . 'subscriptions WHERE user_id=' . $forum_user['id'] . ' AND topic_id=' . $db->escape($topic_id)) or BB_Functions::Error($lang['error_46'], __FILE__, __LINE__, $db->error());
    BB_Functions::Redirect(bb_forum_url . 'topic.php?type=' . $type . '&id=' . $topic_id, $lang['Unsubscribe redirect']);
}
else
    BB_Functions::Message($lang['Bad request']);
?>