<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
require dirname(__FILE__) . '/../include/init.php';
if ($forum_user['g_id'] > USER_MOD && !$forum_user['g_global_moderation'])
    BB_Functions::Message($lang['No permission'], true, 1);
$type = isset($_GET['type']) ? BB_Input::Htmlspecialchars($_GET['type']) : 'topic';
$page = isset($_GET['page']) ? BB_Input::Htmlspecialchars($_GET['page']) : null;
if (isset($_GET['get_host']))
{
    if (preg_match('/[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}/', $_GET['get_host']))
        $ip = $_GET['get_host'];
    else
    {
        $get_host = intval($_GET['get_host']);
        if ($get_host < 1)
            BB_Functions::Message($lang['Bad request']);
        $result = $db->query('SELECT poster_ip FROM ' . $db->prefix . 'posts WHERE id=' . $get_host) or BB_Functions::Error($lang['error_95'], __FILE__, __LINE__, $db->error());
        if (!$db->num_rows($result))
            BB_Functions::Message($lang['Bad request']);
        $ip = $db->result($result);
    }
    BB_Functions::Message('The IP address is: ' . $ip . '<br />The host name is: ' . @gethostbyaddr($ip) . '<br /><br /><a href="../admin/users.php?show_users=' . $ip . '">Show more users for this IP</a>');
}
$fid = isset($_GET['fid']) ? intval($_GET['fid']) : 0;
if ($fid < 1)
    BB_Functions::Message($lang['Bad request']);
$result = $db->query('SELECT moderators FROM ' . $db->prefix . 'forums WHERE id=' . $fid) or BB_Functions::Error($lang['error_87'], __FILE__, __LINE__, $db->error());
$moderators = $db->result($result);
$mods_array = ($moderators != '') ? unserialize($moderators) : array();
if ($forum_user['g_id'] != USER_ADMIN && ($forum_user['g_id'] != USER_MOD || !array_key_exists($forum_user['username'], $mods_array)) && (!$forum_user['g_global_moderation']))
    BB_Functions::Message($lang['No permission']);
if (isset($_GET['tid']))
{
    $tid = intval($_GET['tid']);
    if ($tid < 1)
        BB_Functions::Message($lang['Bad request']);
    $result = $db->query('SELECT t.subject, t.num_replies, f.id AS forum_id, forum_name FROM ' . $db->prefix . 'topics AS t INNER JOIN ' . $db->prefix . 'forums AS f ON f.id=t.forum_id LEFT JOIN ' . $db->prefix . 'subscriptions AS s ON (t.id=s.topic_id AND s.user_id=' . $forum_user['id'] . ') LEFT JOIN ' . $db->prefix . 'permissions AS fp ON (fp.forum_id=f.id AND fp.gid=' . $forum_user['g_id'] . ') WHERE (fp.read_forum IS NULL OR fp.read_forum=1) AND f.id=' . $fid . ' AND t.id=' . $tid . ' AND t.moved_to IS NULL') or BB_Functions::Error($lang['error_4'], __FILE__, __LINE__, $db->error());
    if (!$db->num_rows($result))
        BB_Functions::Message($lang['Bad request']);
    $cur_topic = $db->fetch_assoc($result);
    if (isset($_POST['delete_posts']) || isset($_POST['delete_posts_comply']))
    {
        $posts = $_POST['posts'];
        if (empty($posts))
            BB_Functions::Message($lang['No posts selected']);
        if (isset($_POST['delete_posts_comply']))
        {
            BB_Input::Confirm_Referrer('moderate.php');
            if (preg_match('/[^0-9,]/', $posts))
                BB_Functions::Message($lang['Bad request']);
            $posts_array = split(',', $posts);
            foreach ($posts_array as $pid)
                BB_Image_Upload::Delete_Images($pid);
            $db->query('DELETE FROM ' . $db->prefix . 'posts WHERE id IN(' . $posts . ')') or BB_Functions::Error($lang['error_96'], __FILE__, __LINE__, $db->error());
            BB_Core::Remove_Search_Index($posts);
            $result = $db->query('SELECT id, poster, posted FROM ' . $db->prefix . 'posts WHERE topic_id=' . $tid . ' ORDER BY id DESC LIMIT 1') or BB_Functions::Error($lang['error_3'], __FILE__, __LINE__, $db->error());
            $last_post = $db->fetch_assoc($result);
            $num_posts_deleted = substr_count($posts, ',') + 1;
            $db->query('UPDATE ' . $db->prefix . 'topics SET last_post=' . $last_post['posted'] . ', last_post_id=' . $last_post['id'] . ', last_poster=\'' . $db->escape($last_post['poster']) . '\', num_replies=num_replies-' . $num_posts_deleted . ' WHERE id=' . $tid) or BB_Functions::Error($lang['error_6'], __FILE__, __LINE__, $db->error());
            BB_Core::Update_Forum($fid);
            BB_Functions::Redirect(bb_forum_url . 'topic.php?type=' . $type . '&id=' . $tid, $lang['Delete posts redirect']);
        }
        $page_title = BB_Input::Htmlspecialchars($lang['Moderate']);
        require FORUM_ROOT . $forum_folder . '/header.php';
        ?>
        <div class="blockform">
            <h2><span><?php echo $lang['Delete posts'] ?></span></h2>
            <div class="box">
                <form method="post" action="moderate.php?&type='.$type.'&fid=<?php echo $fid ?>&amp;tid=<?php echo $tid ?>">
                    <div class="inform">
                        <fieldset>
                            <legend><?php echo $lang['Confirm delete legend'] ?></legend>
                            <div class="infldset">
                                <input type="hidden" name="posts" value="<?php echo implode(',', array_keys($posts)) ?>" />
                                <p><?php echo $lang['Delete posts comply'] ?></p>
                            </div>
                        </fieldset>
                    </div>
                    <p><input type="button" class="b1" onclick="javascript:history.go(-1)" value="<?php echo $lang['Go back'] ?>"><input class="b1" type="submit" name="delete_posts_comply" value="<?php echo $lang['Delete'] ?>" /></p>
                </form>
            </div>
        </div>
        <?php
        require FORUM_ROOT . $forum_folder . '/footer.php';
    }
    $button_status = ($cur_topic['num_replies'] == 0) ? ' disabled' : '';
    $num_pages = ceil(($cur_topic['num_replies'] + 1) / $forum_user['disp_posts']);
    $p = (!isset($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $num_pages) ? 1 : $_GET['p'];
    $start_from = $forum_user['disp_posts'] * ($p - 1);
    $paging_links = '<strong class="pagination">' . $lang['Pages'] . '</strong> ' . BB_Core::Paginate($num_pages, $p, 'moderate.php?type=' . $type . '&fid=' . $fid . '&amp;tid=' . $tid);
    if (bb_censoring == '1')
        $cur_topic['subject'] = BB_Input::Censor_Words($cur_topic['subject']);
    $page_title = BB_Input::Htmlspecialchars($cur_topic['subject']);
    require FORUM_ROOT . $forum_folder . '/header.php';
    ?>
    <div class="linkst">
        <div class="inbox">
            <p class="pagelink conl"><?php echo $paging_links ?></p>
            <ul><li><a href="index.php"><?php echo $lang['Index'] ?></a></li><li>&nbsp;&raquo;&nbsp;<a href="forum.php?id=<?php echo $fid ?>"><?php echo BB_Input::Htmlspecialchars($cur_topic['forum_name']) ?></a></li><li>&nbsp;&raquo;&nbsp;<?php echo BB_Input::Htmlspecialchars($cur_topic['subject']) ?></li></ul>
            <div class="clearer"></div>
        </div>
    </div>
    <form method="post" action="moderate.php?type=<?php echo $type ?>&amp;fid=<?php echo $fid ?>&amp;tid=<?php echo $tid ?>">
        <?php
        require_once FORUM_ROOT . 'include/functions/Parser.php';
        $bg_switch = true;
        $post_count = 0;
        $result = $db->query('SELECT u.title, u.num_posts, g.g_id, g.g_user_title, p.id, p.poster, p.poster_id, p.message, p.hide_smilies, p.posted, p.edited, p.edited_by FROM ' . $db->prefix . 'posts AS p INNER JOIN ' . $db->prefix . 'users AS u ON u.id=p.poster_id INNER JOIN ' . $db->prefix . 'usergroups AS g ON g.g_id=u.gid WHERE p.topic_id=' . $tid . ' ORDER BY p.id LIMIT ' . $start_from . ',' . $forum_user['disp_posts'], true) or BB_Functions::Error($lang['error_3'], __FILE__, __LINE__, $db->error());
        while ($cur_post = $db->fetch_assoc($result))
        {
            $post_count++;
            if ($cur_post['poster_id'] > 1)
            {
                $poster = '<a href="member.php?id=' . $cur_post['poster_id'] . '">' . BB_Input::Htmlspecialchars($cur_post['poster']) . '</a>';
                $cur_post['username'] = $cur_post['poster'];
                $user_title = BB_Core::Get_User_Title($cur_post);
                if (bb_censoring == '1')
                    $user_title = BB_Input::Censor_Words($user_title);
            }
            else
            {
                $poster = BB_Input::Htmlspecialchars($cur_post['poster']);
                $user_title = $lang['Guest'];
            }
            $bg_switch = ($bg_switch) ? $bg_switch = false : $bg_switch = true;
            $vtbg = ($bg_switch) ? ' roweven' : ' rowodd';
            $cur_post['message'] = BB_Parser::Parse_Message($cur_post['message'], $cur_post['hide_smilies']);
            ?>
            <div class="blockpost<?php echo $vtbg ?>">
                <a name="<?php echo $cur_post['id'] ?>"></a>
                <h2><span><span class="conr">#<?php echo ($start_from + $post_count) ?>&nbsp;</span><a href="topic.php?type=<?php $type ?>&amp;pid=<?php echo $cur_post['id'] . '#p' . $cur_post['id'] ?>"><?php echo BB_Input::Format_Time($cur_post['posted']) ?></a></span></h2>
                <div class="box">
                    <div class="inbox">
                        <div class="postleft">
                            <dl>
                                <dt><strong><?php echo $poster ?></strong></dt>
                                <dd><strong><?php echo $user_title ?></strong></dd>
                            </dl>
                        </div>
                        <div class="postright">
                            <h3 class="nosize"><?php echo $lang['Message'] ?></h3>
                            <div class="postmsg">
            <?php echo $cur_post['message'] . "\n" ?>
        <?php
        if ($cur_post['edited'] != '')
            echo "\t\t\t\t\t" . '<p class="postedit"><em>' . $lang['Last edit'] . ' ' . BB_Input::Htmlspecialchars($cur_post['edited_by']) . ' (' . BB_Input::Format_Time($cur_post['edited']) . ')</em></p>' . "\n";
        ?>
                            </div>
        <?php if ($start_from + $post_count > 1)
            echo '<p class="multidelete"><label><strong>' . $lang['Select'] . '</strong>&nbsp;&nbsp;<input type="checkbox" name="posts[' . $cur_post['id'] . ']" value="1" /></label></p>' . "\n" ?>
                        </div>
                        <div class="clearer"></div>
                    </div>
                </div>
            </div>
        <?php
    }
    ?>
        <div class="postlinksb">
            <div class="inbox">
                <p class="pagelink conl"><?php echo $paging_links ?></p>
                <p class="conr"><input type="submit" class="b1" name="delete_posts" value="<?php echo $lang['Delete'] ?>"<?php echo $button_status ?> /></p>
                <div class="clearer"></div>
            </div>
        </div>
    </form>
    <?php
    require FORUM_ROOT . $forum_folder . '/footer.php';
}
if (isset($_REQUEST['move_topics']) || isset($_POST['move_topics_to']))
{
    if (isset($_POST['move_topics_to']))
    {
        BB_Input::Confirm_Referrer('moderate.php');
        if (preg_match('/[^0-9,]/', $_POST['topics']))
            BB_Functions::Message($lang['Bad request']);
        $topics = explode(',', $_POST['topics']);
        $move_to_forum = isset($_POST['move_to_forum']) ? intval($_POST['move_to_forum']) : 0;
        if (empty($topics) || $move_to_forum < 1)
            BB_Functions::Message($lang['Bad request']);
        $db->query('DELETE FROM ' . $db->prefix . 'topics WHERE forum_id=' . $move_to_forum . ' AND moved_to IN(' . implode(',', $topics) . ')') or BB_Functions::Error($lang['error_51'], __FILE__, __LINE__, $db->error());
        $db->query('UPDATE ' . $db->prefix . 'topics SET forum_id=' . $move_to_forum . ' WHERE id IN(' . implode(',', $topics) . ')') or BB_Functions::Error($lang['error_97'], __FILE__, __LINE__, $db->error());
        if (isset($_POST['with_redirect']))
        {
            while (list(, $cur_topic) = @each($topics))
            {
                $result = $db->query('SELECT poster, subject, posted, last_post FROM ' . $db->prefix . 'topics WHERE id=' . $cur_topic) or BB_Functions::Error($lang['error_4'], __FILE__, __LINE__, $db->error());
                $moved_to = $db->fetch_assoc($result);
                $db->query('INSERT INTO ' . $db->prefix . 'topics (poster, subject, posted, last_post, moved_to, forum_id) VALUES(\'' . $db->escape($moved_to['poster']) . '\', \'' . $db->escape($moved_to['subject']) . '\', ' . $moved_to['posted'] . ', ' . $moved_to['last_post'] . ', ' . $cur_topic . ', ' . $fid . ')') or BB_Functions::Error($lang['error_98'], __FILE__, __LINE__, $db->error());
            }
        }
        BB_Core::Update_Forum($fid);
        BB_Core::Update_Forum($move_to_forum);
        $redirect_msg = (count($topics) > 1) ? $lang['Move topics redirect'] : $lang['Move topic redirect'];
        BB_Functions::Redirect(bb_forum_url . 'forum.php?id=' . $move_to_forum, $redirect_msg);
    }
    if (isset($_POST['move_topics']))
    {
        $topics = isset($_POST['topics']) ? $_POST['topics'] : array();
        if (empty($topics))
            BB_Functions::Message($lang['No topics selected']);
        $topics = implode(',', array_keys($topics));
        $action = 'multi';
    }
    else
    {
        $topics = intval($_GET['move_topics']);
        if ($topics < 1)
            BB_Functions::Message($lang['Bad request']);
        $action = 'single';
    }
    $page_title = BB_Input::Htmlspecialchars($lang['Moderate']);
    require FORUM_ROOT . $forum_folder . '/header.php';
    ?>
    <div class="blockform">
        <h2><span><?php echo ($action == 'single') ? $lang['Move topic'] : $lang['Move topics'] ?></span></h2>
        <div class="box">
            <form method="post" action="moderate.php?type=<?php echo $type ?>&fid=<?php echo $fid ?>">
                <div class="inform">
                    <input type="hidden" name="topics" value="<?php echo $topics ?>" />
                    <fieldset>
                        <legend><?php echo $lang['Move legend'] ?></legend>
                        <div class="infldset">
                            <label><?php echo $lang['Move to'] ?>
                                <br /><select name="move_to_forum">
    <?php
    $result = $db->query('SELECT c.id AS cid, c.cat_name, f.id AS fid, f.forum_name FROM ' . $db->prefix . 'categories AS c INNER JOIN ' . $db->prefix . 'forums AS f ON c.id=f.cat_id LEFT JOIN ' . $db->prefix . 'permissions AS fp ON (fp.forum_id=f.id AND fp.gid=' . $forum_user['gid'] . ') WHERE (fp.read_forum IS NULL OR fp.read_forum=1) AND f.redirect_url IS NULL ORDER BY c.disp_position, c.id, f.disp_position', true) or BB_Functions::Error($lang['error_57'], __FILE__, __LINE__, $db->error());
    $cur_category = 0;
    while ($cur_forum = $db->fetch_assoc($result))
    {
        if ($cur_forum['cid'] != $cur_category)
        {
            if ($cur_category)
                echo "\t\t\t\t\t\t\t" . '</optgroup>' . "\n";
            echo "\t\t\t\t\t\t\t" . '<optgroup label="' . BB_Input::Htmlspecialchars($cur_forum['cat_name']) . '">' . "\n";
            $cur_category = $cur_forum['cid'];
        }
        if ($cur_forum['fid'] != $fid)
            echo "\t\t\t\t\t\t\t\t" . '<option value="' . $cur_forum['fid'] . '">' . BB_Input::Htmlspecialchars($cur_forum['forum_name']) . '</option>' . "\n";
    }
    ?>
                                    </optgroup>
                                </select>
                                <br /></label>
                            <div class="rbox">
                                <label><input type="checkbox" name="with_redirect" value="1"<?php if ($action == 'single')
        echo ' checked="checked"' ?> /><?php echo $lang['Leave redirect'] ?><br /></label>
                            </div>
                        </div>
                    </fieldset>
                </div>
                <p><input type="button" class="b1" onclick="javascript:history.go(-1)" value="<?php echo $lang['Go back'] ?>"><input class="b1" type="submit" name="move_topics_to" value="<?php echo $lang['Move'] ?>" /></p>
            </form>
        </div>
    </div>
    <?php
    require FORUM_ROOT . $forum_folder . '/footer.php';
}
if (isset($_REQUEST['delete_topics']) || isset($_POST['delete_topics_comply']))
{
    $topics = isset($_POST['topics']) ? $_POST['topics'] : array();
    if (empty($topics))
        BB_Functions::Message($lang['No topics selected']);
    if (isset($_POST['delete_topics_comply']))
    {
        BB_Input::Confirm_Referrer('moderate.php');
        if (preg_match('/[^0-9,]/', $topics))
            BB_Functions::Message($lang['Bad request']);
        $db->query('DELETE FROM ' . $db->prefix . 'topics WHERE id IN(' . $topics . ') OR moved_to IN(' . $topics . ')') or BB_Functions::Error($lang['error_99'], __FILE__, __LINE__, $db->error());
        $db->query('DELETE FROM ' . $db->prefix . 'subscriptions WHERE topic_id IN(' . $topics . ')') or BB_Functions::Error($lang['error_100'], __FILE__, __LINE__, $db->error());
        $result = $db->query('SELECT id FROM ' . $db->prefix . 'posts WHERE topic_id IN(' . $topics . ')') or BB_Functions::Error($lang['error_101'], __FILE__, __LINE__, $db->error());
        $post_ids = '';
        while ($row = $db->fetch_row($result))
        {
            $post_ids .= ( $post_ids != '') ? ',' . $row[0] : $row[0];
            BB_Image_Upload::Delete_Images($row[0]);
        }
        if ($post_ids != '')
            BB_Core::Remove_Search_Index($post_ids);
        $db->query('DELETE FROM ' . $db->prefix . 'posts WHERE topic_id IN(' . $topics . ')') or BB_Functions::Error($lang['error_96'], __FILE__, __LINE__, $db->error());
        BB_Core::Update_Forum($fid);
        BB_Functions::Redirect(bb_forum_url . 'moderate.php?fid=' . $fid, $lang['Delete topics redirect']);
    }
    $page_title = BB_Input::Htmlspecialchars($lang['Moderate']);
    require FORUM_ROOT . $forum_folder . '/header.php';
    ?>
    <div class="blockform">
        <h2><?php echo $lang['Delete topics'] ?></h2>
        <div class="box">
            <form method="post" action="moderate.php?type=<?php echo $type ?>&fid=<?php echo $fid ?>">
                <input type="hidden" name="topics" value="<?php echo implode(',', array_keys($topics)) ?>" />
                <div class="inform">
                    <fieldset>
                        <legend><?php echo $lang['Confirm delete legend'] ?></legend>
                        <div class="infldset">
                            <p><?php echo $lang['Delete topics comply'] ?></p>
                        </div>
                    </fieldset>
                </div>
                <p><input type="button" class="b1" onclick="javascript:history.go(-1)" value="<?php echo $lang['Go back'] ?>"><input class="b1" type="submit" name="delete_topics_comply" value="<?php echo $lang['Delete'] ?>" /></p>
            </form>
        </div>
    </div>
    <?php
    require FORUM_ROOT . $forum_folder . '/footer.php';
}
else if (isset($_REQUEST['open']) || isset($_REQUEST['close']))
{
    $action = (isset($_REQUEST['open'])) ? 0 : 1;
    if (isset($_POST['open']) || isset($_POST['close']))
    {
        BB_Input::Confirm_Referrer('moderate.php');
        $topics = isset($_POST['topics']) ? @array_map('intval', @array_keys($_POST['topics'])) : array();
        if (empty($topics))
            BB_Functions::Message($lang['No topics selected']);
        $db->query('UPDATE ' . $db->prefix . 'topics SET closed=' . $action . ' WHERE id IN(' . implode(',', array_keys($topics)) . ')') or BB_Functions::Error('Unable to close topics', __FILE__, __LINE__, $db->error());
        $redirect_msg = ($action) ? $lang['Close topics redirect'] : $lang['Open topics redirect'];
        BB_Functions::Redirect(bb_forum_url . 'moderate.php?type=' . $type . '&fid=' . $fid, $redirect_msg);
    }
    else
    {
        BB_Input::Confirm_Referrer('topic.php');
        $topic_id = ($action) ? intval($_GET['close']) : intval($_GET['open']);
        if ($topic_id < 1)
            BB_Functions::Message($lang['Bad request']);
        $db->query('UPDATE ' . $db->prefix . 'topics SET closed=' . $action . ' WHERE id=' . $topic_id) or BB_Functions::Error($lang['error_103'], __FILE__, __LINE__, $db->error());
        $redirect_msg = ($action) ? $lang['Close topic redirect'] : $lang['Open topic redirect'];
        BB_Functions::Redirect(bb_forum_url . 'topic.php?type=' . $type . '&id=' . $topic_id, $redirect_msg);
    }
}
else if (isset($_REQUEST['stick']) || isset($_REQUEST['unstick']))
{
    $action = (isset($_REQUEST['unstick'])) ? 0 : 1;
    if (isset($_POST['stick']) || isset($_POST['unstick']))
    {
        BB_Input::Confirm_Referrer('moderate.php');
        $topics = isset($_POST['topics']) ? @array_map('intval', @array_keys($_POST['topics'])) : array();
        if (empty($topics))
            BB_Functions::Message($lang['No topics selected']);
        $db->query('UPDATE ' . $db->prefix . 'topics SET sticky=' . $action . ' WHERE id IN(' . implode(',', $topics) . ')') or BB_Functions::Error($lang['error_104'], __FILE__, __LINE__, $db->error());
        $redirect_msg = ($action) ? $lang['Stick topics redirect'] : $lang['Unstick topics redirect'];
        BB_Functions::Redirect(bb_forum_url . 'moderate.php?type=' . $type . '&fid=' . $fid, $redirect_msg);
    }
    else
    {
        BB_Input::Confirm_Referrer('topic.php');
        $topic_id = ($action) ? intval($_GET['stick']) : intval($_GET['unstick']);
        if ($topic_id < 1)
            BB_Functions::Message($lang['Bad request']);
        $db->query('UPDATE ' . $db->prefix . 'topics SET sticky=' . $action . ' WHERE id=' . $topic_id) or BB_Functions::Error($lang['error_105'], __FILE__, __LINE__, $db->error());
        $redirect_msg = ($action) ? $lang['Stick topic redirect'] : $lang['Unstick topic redirect'];
        BB_Functions::Redirect(bb_forum_url . 'topic.php?type=' . $type . '&id=' . $topic_id, $redirect_msg);
    }
}
else if (isset($_GET['topic_yes']))
{
    BB_Input::Confirm_Referrer('topic.php');
    $now = time();
    $topic_yes = intval($_GET['topic_yes']);
    if ($topic_yes < 1)
        BB_Functions::Message($lang['Bad request']);
    $db->query('UPDATE ' . $db->prefix . 'topics SET closed=\'0\', posted=' . $now . ', last_post=' . $now . ' WHERE id=' . $topic_yes) or BB_Functions::Error($lang['error_106'], __FILE__, __LINE__, $db->error());
    $db->query('UPDATE ' . $db->prefix . 'posts SET posted=' . $now . ' WHERE topic_id=' . $topic_yes) or BB_Functions::Error($lang['error_106'], __FILE__, __LINE__, $db->error());
    BB_Functions::Redirect(bb_forum_url . 'topic.php?id=' . $topic_yes, $lang['Valide topic redirect']);
}
$result = $db->query('SELECT f.forum_name, f.redirect_url, f.num_topics FROM ' . $db->prefix . 'forums AS f LEFT JOIN ' . $db->prefix . 'permissions AS fp ON (fp.forum_id=f.id AND fp.gid=' . $forum_user['g_id'] . ') WHERE (fp.read_forum IS NULL OR fp.read_forum=1) AND f.id=' . $fid) or BB_Functions::Error($lang['error_87'], __FILE__, __LINE__, $db->error());
if (!$db->num_rows($result))
    BB_Functions::Message($lang['Bad request']);
$cur_forum = $db->fetch_assoc($result);
if ($cur_forum['redirect_url'] != '')
    BB_Functions::Message($lang['Bad request']);
$page_title = BB_Input::Htmlspecialchars($cur_forum['forum_name']);
require FORUM_ROOT . $forum_folder . '/header.php';
$num_pages = ceil($cur_forum['num_topics'] / $forum_user['disp_topics']);
$p = (!isset($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $num_pages) ? 1 : $_GET['p'];
$start_from = $forum_user['disp_topics'] * ($p - 1);
$paging_links = '<strong class="pagination">' . $lang['Pages'] . '</strong> ' . BB_Core::Paginate($num_pages, $p, 'moderate.php?type=' . $type . '&fid=' . $fid)
?>
<div class="linkst">
    <div class="inbox">
        <p class="pagelink conl"><?php echo $paging_links ?></p>
        <ul><li><a href="index.php"><?php echo $lang['Index'] ?></a>&nbsp;</li><li>&raquo;&nbsp;<?php echo BB_Input::Htmlspecialchars($cur_forum['forum_name']) ?></li></ul>
        <div class="clearer"></div>
    </div>
</div>
<form method="post" name="multiselect" action="moderate.php?type=<?php echo $type ?>&fid=<?php echo $fid ?>">
    <div id="vf" class="blocktable">
        <h2><span><?php echo BB_Input::Htmlspecialchars($cur_forum['forum_name']) ?></span></h2>
        <div class="box">
            <div class="inbox">
                <table cellspacing="0">
                    <thead>
                        <tr>
                            <th class="tcl"><?php echo $lang['Topic'] ?></th>
                            <th class="tc2"><?php echo $lang['Replies'] ?></th>
                            <th class="tc3"><?php echo $lang['Views'] ?></th>
                            <th class="tcr"><?php echo $lang['Last post'] ?></th>
                            <th class="tcmod"><input name="allbox" type="checkbox" value="Check All" onclick="InboxCheckAll();" /></th>
                        </tr>
                    </thead>
                    <tbody>
                        <?php
                        $result = $db->query('SELECT id, poster, subject, icon_topic, posted, question, last_post, last_post_id, last_poster, num_views, num_replies, closed, sticky, moved_to FROM ' . $db->prefix . 'topics WHERE forum_id=' . $fid . ' ORDER BY sticky DESC, last_post DESC LIMIT ' . $start_from . ', ' . $forum_user['disp_topics']) or BB_Functions::Error($lang['error_107'], __FILE__, __LINE__, $db->error());
                        if ($db->num_rows($result))
                        {
                            $button_status = '';
                            while ($cur_topic = $db->fetch_assoc($result))
                            {
                                $icon_text = $lang['Normal icon'];
                                $item_status = '';
                                $icon_type = 'icon';
                                if ($cur_topic['moved_to'] == null)
                                {
                                    if ($cur_topic['question'] != '')
                                        $last_post = '<a href="topic.php?type=poll&pid=' . $cur_topic['last_post_id'] . '#p' . $cur_topic['last_post_id'] . '">' . BB_Input::Format_Time($cur_topic['last_post']) . '</a><br />' . $lang['by'] . '&nbsp;' . BB_Input::Htmlspecialchars($cur_topic['last_poster']);
                                    else
                                        $last_post = '<a href="topic.php?type=' . $type . '&pid=' . $cur_topic['last_post_id'] . '#p' . $cur_topic['last_post_id'] . '">' . BB_Input::Format_Time($cur_topic['last_post']) . '</a><br />' . $lang['by'] . '&nbsp;' . BB_Input::Htmlspecialchars($cur_topic['last_poster']);
                                    $ghost_topic = false;
                                }
                                else
                                {
                                    $last_post = '&nbsp;';
                                    $ghost_topic = true;
                                }
                                if (bb_censoring == '1')
                                    $cur_topic['subject'] = BB_Input::Censor_Words($cur_topic['subject']);
                                if ($cur_topic['question'] != '')
                                {
                                    if ($cur_topic['moved_to'] != 0)
                                    {
                                        $subject = '<a href="topic.php?type=poll&id=' . $cur_topic['moved_to'] . '">' . BB_Input::Htmlspecialchars($cur_topic['question']) . '</a><br /><span class="byuser">' . $lang['by'] . ' ' . BB_Input::Htmlspecialchars($cur_topic['poster']) . '</span>';
                                        $icon_text = $lang['Poll'];
                                        $item_status = 'imoved';
                                    }
                                    else if ($cur_topic['closed'] == '0')
                                    {
                                        $subject = '<a href="topic.php?type=poll&id=' . $cur_topic['id'] . '">' . BB_Input::Htmlspecialchars($cur_topic['question']) . '</a><br /><span>' . $lang['by'] . '&nbsp;' . BB_Input::Htmlspecialchars($cur_topic['poster']) . '</span>';
                                        $icon_text = $lang['Poll'];
                                        $item_status = 'ipoll';
                                    }
                                    else
                                    {
                                        $subject = '<a href="topic.php?type=poll&id=' . $cur_topic['id'] . '">' . BB_Input::Htmlspecialchars($cur_topic['subject']) . '</a><br /><span class="byuser">' . $lang['by'] . ' ' . BB_Input::Htmlspecialchars($cur_topic['poster']) . '</span>';
                                        $icon_text = $lang['Closed icon'];
                                        $item_status = 'iclosed';
                                    }
                                    if (BB_Core::Is_New_Topic($cur_topic['id'], $fid, $cur_topic['last_post']) && !$ghost_topic)
                                    {
                                        $icon_text .= ' ' . $lang['New icon'];
                                        $item_status .= ' ipollnew';
                                        $icon_type = 'icon ipollnew';
                                        $subject = '<strong>' . $subject . '</strong>';
                                        $subject_new_posts = '<span class="newtext">[&nbsp;<a href="topic.php?type=poll&id=' . $cur_topic['id'] . '&amp;action=new" title="' . $lang['New posts info'] . '">' . $lang['New posts'] . '</a>&nbsp;]</span>';
                                    }
                                    else
                                        $subject_new_posts = null;
                                    if (bb_show_dot == '1')
                                        $subject = '&nbsp;&nbsp;' . $subject;
                                }
                                else
                                {
                                    if ($cur_topic['moved_to'] != 0)
                                    {
                                        $subject = '<a href="topic.php?type=' . $type . '&id=' . $cur_topic['moved_to'] . '">' . BB_Input::Htmlspecialchars($cur_topic['subject']) . '</a><br /><span class="byuser">' . $lang['by'] . ' ' . BB_Input::Htmlspecialchars($cur_topic['poster']) . '</span>';
                                        $icon_text = $lang['Poll'];
                                        $item_status = 'imoved';
                                    }
                                    else if ($cur_topic['closed'] == '0')
                                        $subject = '<a href="topic.php?type=' . $type . '&id=' . $cur_topic['id'] . '">' . BB_Input::Htmlspecialchars($cur_topic['subject']) . '</a><br /><span>' . $lang['by'] . '&nbsp;' . BB_Input::Htmlspecialchars($cur_topic['poster']) . '</span>';
                                    else
                                    {
                                        $subject = '<a href="topic.php?type=' . $type . '&id=' . $cur_topic['id'] . '">' . BB_Input::Htmlspecialchars($cur_topic['subject']) . '</a><br /><span class="byuser">' . $lang['by'] . ' ' . BB_Input::Htmlspecialchars($cur_topic['poster']) . '</span>';
                                        $icon_text = $lang['Closed icon'];
                                        $item_status = 'iclosed';
                                    }
                                    if (BB_Core::Is_New_Topic($cur_topic['id'], $fid, $cur_topic['last_post']) && !$ghost_topic)
                                    {
                                        $icon_text .= ' ' . $lang['New icon'];
                                        $item_status .= ' inew';
                                        $icon_type = 'icon inew';
                                        $subject = '<strong>' . $subject . '</strong>';
                                        $subject_new_posts = '<span class="newtext">[&nbsp;<a href="topic.php?type=' . $type . '&id=' . $cur_topic['id'] . '&amp;action=new" title="' . $lang['New posts info'] . '">' . $lang['New posts'] . '</a>&nbsp;]</span>';
                                    }
                                    else
                                        $subject_new_posts = null;
                                    if (bb_show_dot == '1')
                                        $subject = '&nbsp;&nbsp;' . $subject;
                                }
                                if ($cur_topic['sticky'] == '1')
                                {
                                    $stickydivide = 1;
                                    $stickyflag = 1;
                                    $item_status .= ' isticky';
                                    $icon_text .= ' ' . $lang['Sticky'];
                                }
                                else
                                    $stickyflag = 0;
                                if ($cur_topic['icon_topic'] != 0)
                                {
                                    $icon_topic = '<img src="./img/general/icons/' . $cur_topic['icon_topic'] . '.png" alt="" />';
                                    $subject = $icon_topic . ' ' . $subject;
                                }
                                $num_pages_topic = ceil(($cur_topic['num_replies'] + 1) / $forum_user['disp_posts']);
                                if ($num_pages_topic > 1)
                                    $subject_multipage = '[ ' . BB_Core::Paginate($num_pages_topic, -1, 'topic.php?type=' . $type . '&id=' . $cur_topic['id']) . ' ]';
                                else
                                    $subject_multipage = null;
                                if (!empty($subject_new_posts) || !empty($subject_multipage))
                                {
                                    $subject .= '&nbsp; ' . (!empty($subject_new_posts) ? $subject_new_posts : '');
                                    $subject .= ! empty($subject_multipage) ? ' ' . $subject_multipage : '';
                                }
                                if ($stickyflag == 0 && $stickydivide == 1)
                                {
                                    echo "<tr><td colspan=\"5\" style=\"padding:0;margin:0;\"><h2><strong>" . $lang['Forum Topics'] . "</strong></h2></td></tr>";
                                    $stickydivide = 0;
                                }
                                if ($cur_topic['rating_votes'] > 0 && $cur_topic['rating'] > 0)
                                {
                                    $topic_rating = ceil($cur_topic['rating'] / $cur_topic['rating_votes']);
                                    $topic_icons .= '<img src="' . bb_website_url . '/include/templates/' . $forum_user['template'] . '/img/rating/d_rating_' . $topic_rating . '.png" alt=""/>';
                                }
                                ?>
                                <tr<?php if ($item_status != '')
                                    echo ' class="' . trim($item_status) . '"'; ?>>
                                    <td class="tcl">
                                        <div class="<?php echo $icon_type ?>"><div class="nosize"><?php echo trim($icon_text) ?></div></div>
                                        <div class="tclcon">
                                            <span class="topic_icons"><?php echo $topic_icons ?></span>
        <?php echo $subject . "\n" ?>
                                        </div>
                                    </td>
                                    <td class="tc2"><?php echo (!$ghost_topic) ? $cur_topic['num_replies'] : '&nbsp;' ?></td>
                                    <td class="tc3"><?php echo (!$ghost_topic) ? $cur_topic['num_views'] : '&nbsp;' ?></td>
                                    <td class="tcr"><?php echo $last_post ?></td>
                                    <td class="tcmod"><input type="checkbox" onclick="cca(this);" name="topics[<?php echo $cur_topic['id'] ?>]" value="1"></td>
                                </tr>
        <?php
    }
}
else
{
    $button_status = ' disabled';
    echo "\t\t\t\t\t" . '<tr><td class="tcl" colspan="5">' . $lang['Empty forum'] . '</td></tr>' . "\n";
}
?>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
    <div class="linksb">
        <div class="inbox">
            <p class="pagelink conl"><?php echo $paging_links ?></p>
            <p class="conr" style="width:70%"><input type="submit" class="b1" name="move_topics" value="<?php echo $lang['Move'] ?>"<?php echo $button_status ?> />&nbsp;&nbsp;<input type="submit" class="b1" name="delete_topics" value="<?php echo $lang['Delete'] ?>"<?php echo $button_status ?> />&nbsp;&nbsp;<input type="submit" class="b1" name="open" value="<?php echo $lang['Open'] ?>"<?php echo $button_status ?> />&nbsp;&nbsp;<input type="submit" class="b1" name="close" value="<?php echo $lang['Close'] ?>"<?php echo $button_status ?> />&nbsp;&nbsp;<input type="submit" class="b1" name="stick" value="<?php echo $lang['Stick'] ?>"<?php echo $button_status ?> />&nbsp;&nbsp;<input type="submit" class="b1" name="unstick" value="<?php echo $lang['Unstick'] ?>"<?php echo $button_status ?> /></p>
            <div class="clearer"></div>
        </div>
    </div>
</form>
<?php
require FORUM_ROOT . $forum_folder . '/footer.php';
?>