<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
require dirname(__FILE__) . '/../include/init.php';
if ($forum_user['g_id'] > USER_MOD && !$forum_user['g_global_moderation'])
    BB_Functions::Message($lang['No permission'], true, 1);
if (isset($_GET['id']))
{
    $post_id = intval($_GET['id']);
    $result = $db->query('SELECT p.message, t.id, t.subject, t.forum_id, f.forum_name FROM ' . $db->prefix . 'posts as p INNER JOIN ' . $db->prefix . 'topics as t ON p.topic_id=t.id INNER JOIN ' . $db->prefix . 'forums as f ON t.forum_id=f.id WHERE p.id=' . $db->escape($post_id)) or BB_Functions::Error($lang['error_132'], __FILE__, __LINE__, $db->error());
    if (!$db->num_rows($result))
        BB_Functions::Message($lang['Bad request']);
    list($message, $old_topic_id, $subject, $old_fid, $forum_name) = $db->fetch_row($result);
    if (isset($_GET['new_fid']))
    {
        $fid = $new_fid = intval($_GET['new_fid']);
        if ($new_fid != $old_fid)
            $new_forum = TRUE;
        else
            $fid = $old_fid;
    }
    else
        $fid = $old_fid;
    if ($fid < 1)
        BB_Functions::Message($lang['Bad request']);
    $result = $db->query('SELECT count(id) FROM ' . $db->prefix . 'posts WHERE topic_id=' . $db->escape($old_topic_id)) or BB_Functions::Error($lang['error_133'], __FILE__, __LINE__, $db->error());
    $num_post = $db->result($result);
    if ($num_post < 1)
        BB_Functions::Message($lang['Bad request']);
    if ($num_post == 1)
        $del_old_topic = TRUE;
    if (isset($_POST['form_sent']))
    {
        $form_sent = intval($_POST['form_sent']);
        $new_topic_id = intval($_POST['topic_to_move']);
        if ($new_topic_id == '' && $form_sent != 2)
            BB_Functions::Message($lang['Bad topic']);
        if ($form_sent == 2)
        {
            $new_subject = BB_Input::Trim($_POST['create_topic']);
            if ($new_subject == '')
                BB_Functions::Message($form_sent . $lang['Bad new topic']);
            if (bb_subject_all_caps == '0' && strtoupper($new_subject) == $new_subject && $forum_user['g_id'] > USER_MOD)
                ;
            $new_subject = ucwords(strtolower($new_subject));
            $db->query('INSERT INTO ' . $db->prefix . 'topics (subject, forum_id) VALUES(\'' . $db->escape($new_subject) . '\', ' . $db->escape($fid) . ')') or BB_Functions::Error($lang['error_92'], __FILE__, __LINE__, $db->error());
            $new_topic_id = $db->insert_id();
        }
        if (isset($_POST['move_all_post']))
        {
            $result = $db->query('SELECT id FROM ' . $db->prefix . 'posts WHERE topic_id=' . $db->escape($old_topic_id)) or BB_Functions::Error($lang['error_41'], __FILE__, __LINE__, $db->error());
            if ($db->num_rows($result))
            {
                $all_id = '';
                while ($row = $db->fetch_row($result))
                    $all_id .= ( ($all_id != '') ? ',' : '') . $row[0];
            }
        }
        if ($all_id)
            $db->query('UPDATE ' . $db->prefix . 'posts SET topic_id=' . $db->escape($new_topic_id) . ' WHERE id IN(' . $all_id . ')') or BB_Functions::Error($lang['error_41'], __FILE__, __LINE__, $db->error());
        else
            $db->query('UPDATE ' . $db->prefix . 'posts SET topic_id=' . $db->escape($new_topic_id) . ' WHERE id=' . $db->escape($post_id)) or BB_Functions::Error($lang['error_41'], __FILE__, __LINE__, $db->error());
        BB_Core::Update_Topic($new_topic_id);
        if ($del_old_topic || $all_id)
        {
            BB_Core::Delete_Topic($old_topic_id);
            BB_Core::Update_Forum($old_fid);
            if ($new_forum)
                BB_Core::Update_Forum($new_fid);
            BB_Core::Remove_Search_Index($post_id);
            BB_Core::Set_Search_Index('post', $post_id, $message);
        }
        else
        {
            BB_Core::Update_Topic($old_topic_id);
            if ($new_forum)
            {
                BB_Core::Update_Forum($old_fid);
                BB_Core::Update_Forum($new_fid);
            }
        }
        BB_Functions::Redirect(bb_forum_url . 'topic.php?pid=' . $post_id . '#p' . $post_id, $lang['Mark move redirect']);
    }
    else
    {
        $result = $db->query('SELECT count(id) FROM ' . $db->prefix . 'topics WHERE forum_id =' . $db->escape($fid) . ' AND moved_to IS NULL') or BB_Functions::Error($lang['error_134'], __FILE__, __LINE__, $db->error());
        $num_topics = $db->result($result);
        if ($fid == $old_fid)
            $num_topics = $num_topics - 1;
        $var_query_img = $var_query = '';
        if (isset($_GET['new_fid']))
            $var_query_img .= $var_query .='&new_fid=' . $fid;
        if (isset($_GET['sort']))
        {
            $sort_list = $_GET['sort'];
            $var_query .='&sort=' . $sort_list;
            if (isset($_GET['desc']))
            {
                $sort_list .=' DESC';
                $var_query .='&desc=1';
            }
        }
        else
            $sort_list= 'last_post DESC';
        $num_pages = ceil($num_topics / $forum_user['disp_topics']);
        $p = (!isset($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $num_pages) ? 1 : $_GET['p'];
        $start_from = $forum_user['disp_topics'] * ($p - 1);
        $paging_links = $lang['Pages'] . ': ' . BB_Core::Paginate($num_pages, $p, 'move.php?id=' . $post_id . $var_query);
        $result_topic = $db->query('SELECT id, subject, poster, last_post, num_replies FROM ' . $db->prefix . 'topics WHERE moved_to IS NULL AND forum_id=' . $db->escape($fid) . ' AND id <> ' . $db->escape($old_topic_id) . ' ORDER BY ' . $db->escape($sort_list) . ' LIMIT ' . $db->escape($start_from) . ',' . $forum_user['disp_topics']) or BB_Functions::Error($lang['error_135'], __FILE__, __LINE__, $db->error());
        require FORUM_ROOT . $forum_folder . '/header.php';
        ?>
        <div class="blockform">
            <h2><span><?php echo $lang['Mod move post'] ?></span></h2>
            <div class="box">
                <form id="qjump" method="get" action="move.php?id=<?php echo $post_id ?>">
                    <h2><?php echo $lang['Introduction'] ?></h2>
                    <div class="infldset file" style="padding:10px">
                        <p><?php echo $lang['Intro'] ?></p><br />
                        <p><?php echo $lang['Original topic'] ?> <strong><?php echo BB_Input::Htmlspecialchars($subject) ?></strong></p>
                        <p><?php echo $lang['Original forum'] ?> <strong><?php echo BB_Input::Htmlspecialchars($forum_name) ?></strong></p>
                        <p><?php echo $lang['Select forum'] ?>:</p>
                        <div><select name="id" onchange="window.location=('move.php?id=<?php echo $post_id ?>&new_fid='+this.options[this.selectedIndex].value)">
        <?php
        $result = $db->query('SELECT c.id AS cid, c.cat_name, f.id AS fid, f.forum_name FROM ' . $db->prefix . 'categories AS c INNER JOIN ' . $db->prefix . 'forums AS f ON c.id=f.cat_id LEFT JOIN ' . $db->prefix . 'permissions AS fp ON (fp.forum_id=f.id AND fp.gid=' . $forum_user['g_id'] . ') WHERE (fp.read_forum IS NULL OR fp.read_forum=1) AND f.redirect_url IS NULL ORDER BY c.disp_position, c.id, f.disp_position', true) or BB_Functions::Error($lang['error_57'], __FILE__, __LINE__, $db->error());
        $cur_category = 0;
        while ($cur_forum = $db->fetch_assoc($result))
        {
            if ($cur_forum['cid'] != $cur_category)
            {
                if ($cur_category)
                    echo "\t\t\t\t\t\t" . '</optgroup>' . "\n";
                echo "\t\t\t\t\t\t" . '<optgroup label="' . BB_Input::Htmlspecialchars($cur_forum['cat_name']) . '">' . "\n";
                $cur_category = $cur_forum['cid'];
            }
            echo "\t\t\t\t\t\t\t<option value=" . $cur_forum['fid'];
            if ($cur_forum['fid'] == $fid)
                echo " selected='selected'";
            echo " >" . BB_Input::Htmlspecialchars($cur_forum['forum_name']) . "</option>\n";
        }
        ?>
                                </optgroup></select></div>
                    </div>
                    <input type="hidden" name="form_sent" value="1" />
                </form>
                <form id="movepost_create" method="post" action="move.php?id=<?php echo $post_id ?>&new_fid=<?php echo $fid ?>">
                    <h2><?php echo $lang['Create topic'] ?></h2>
                    <div class="infldset file" style="padding:10px">
                        <p><?php echo $lang['Explain create topic'] ?></p><br />
                        <input class="textbox" name="create_topic" size="40" maxlength="70" tabindex="1" type="text" />
                        <input name="save" class="b1" value="<?php echo $lang['Submit'] ?>" type="submit" />
                        <br /><br />
                        <p><?php echo $lang['Move all posts'] ?> (<strong><?php echo $num_post ?></strong>)</p>
                        <div class="rbox"><label><input name="move_all_post" value="1" type="checkbox" /><?php echo $lang['Explain move all posts'] ?> <br /></label></div>
                    </div>
                    <input type="hidden" name="form_sent" value="2" />
                </form>
                <form id="movepost_move" method="post" action="move.php?id=<?php echo $post_id ?>">
                    <h2><?php echo $lang['Move post'] ?></h2>
                    <div class="infldset file" style="padding:10px">
                        <p><?php echo $lang['Explain move post'] ?></p><br />
                        <p><?php echo $lang['Move all posts'] ?> (<strong><?php echo $num_post ?></strong>)</p>
                        <div class="rbox"><label><input name="move_all_post" value="1" type="checkbox" /><?php echo $lang['Explain move all posts'] ?> <br /></label></div>
                        <br /><br />
                        <p class="pagelink conl"><?php echo $paging_links ?></p><p>&nbsp;</p>
                        <table class="aligntop" cellspacing="0">
                            <tr>
                                <th class="tc2" scope="col"><input name="topic_to_move" value="" type="radio" /></th>
                                <th scope="col"><strong><?php echo $lang['Topic'] ?></strong><br /><a href="move.php?id=<?php echo $post_id . $var_query_img ?>&sort=subject"><img alt="up" src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/up.png"></a><a href="move.php?id=<?php echo $post_id . $var_query_img ?>&sort=subject&desc=1"><img alt="down" src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/down.png"></a></th>
                                <th scope="col"><strong><?php echo $lang['Poster'] ?></strong><br /><a href="move.php?id=<?php echo $post_id . $var_query_img ?>&sort=poster"><img alt="up" src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/up.png"></a><a href="move.php?id=<?php echo $post_id . $var_query_img ?>&sort=poster&desc=1"><img alt="down" src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/down.png"></a></th>
                                <th scope="col"><strong><?php echo $lang['Last'] ?></strong><br /><a href="move.php?id=<?php echo $post_id . $var_query_img ?>&sort=last_post"><img alt="up" src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/up.png"></a><a href="move.php?id=<?php echo $post_id . $var_query_img ?>&sort=last_post&desc=1"><img alt="down" src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/down.png"></a></th>
                                <th class="tc2" scope="col"><strong><?php echo $lang['Replies'] ?></strong><br /><a href="move.php?id=<?php echo $post_id . $var_query_img ?>&sort=num_replies"><img alt="up" src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/up.png"></a><a href="move.php?id=<?php echo $post_id . $var_query_img ?>&sort=num_replies&desc=1"><img alt="down" src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/down.png"></a></th>
                            </tr>
        <?php
        if ($db->num_rows($result_topic))
        {
            while ($cur_topic = $db->fetch_assoc($result_topic))
            {
                ?>
                                    <tr>
                                        <td class="tc2"><input name="topic_to_move" value="<?php echo $cur_topic['id'] ?>" type="radio" /></td>
                                        <td><?php echo BB_Input::Htmlspecialchars($cur_topic['subject']) ?></td>
                                        <td><?php echo BB_Input::Htmlspecialchars($cur_topic['poster']) ?></td>
                                        <td><?php echo BB_Input::Format_Time($cur_topic['last_post']) ?></td>
                                        <td class="tc2"><?php echo $cur_topic['num_replies'] ?></td>
                                    </tr>
                <?php
            }
        }
        ?>
                            <tr>
                                <th class="tc2" scope="col"><input name="topic_to_move" value="" checked="checked" type="radio" /></th>
                                <th scope="col"><a href="move.php?id=<?php echo $post_id . $var_query_img ?>&sort=subject"><img alt="up" src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/up.png"></a><a href="move.php?id=<?php echo $post_id . $var_query_img ?>&sort=subject&desc=1"><img alt="down" src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/down.png"></a><br /><strong><?php echo $lang['Topic'] ?></strong></th>
                                <th scope="col"><a href="move.php?id=<?php echo $post_id . $var_query_img ?>&sort=poster"><img alt="up" src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/up.png"></a><a href="move.php?id=<?php echo $post_id . $var_query_img ?>&sort=poster&desc=1"><img alt="down" src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/down.png"></a><br /><strong><?php echo $lang['Poster'] ?></strong></th>
                                <th scope="col"><a href="move.php?id=<?php echo $post_id . $var_query_img ?>&sort=last_post"><img alt="up" src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/up.png"></a><a href="move.php?id=<?php echo $post_id . $var_query_img ?>&sort=last_post&desc=1"><img alt="down" src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/down.png"></a><br /><strong><?php echo $lang['Last'] ?></strong></th>
                                <th class="tc2" scope="col"><a href="move.php?id=<?php echo $post_id . $var_query_img ?>&sort=num_replies"><img alt="up" src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/up.png"></a><a href="move.php?id=<?php echo $post_id . $var_query_img ?>&sort=num_replies&desc=1"><img alt="down" src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/down.png"></a><br /><strong><?php echo $lang['Replies'] ?></strong></th>
                            </tr>
                        </table>
                        <p class="pagelink conl"><?php echo $paging_links ?></p><p>&nbsp;</p>
                        <p style="text-align:center;"><?php echo "<a href=\"topic.php?pid=" . $post_id . "#p" . $post_id . "\" />" ?><?php echo $lang['Go back'] ?></a><input name="save" class="b1" value="<?php echo $lang['Submit'] ?>" type="submit" /></p>
                    </div>
                    <input type="hidden" name="form_sent" value="3" />
                </form>
            </div>
        </div>
        <?php
        require FORUM_ROOT . $forum_folder . '/footer.php';
    }
}
else
    BB_Functions::Message($lang['Bad request']);
?>
