<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
require dirname(__FILE__) . '/../include/init.php';
if ($forum_user['g_read_board'] == '0')
    BB_Functions::Message($lang['No permission'], true, 1);
$type = isset($_GET['type']) ? BB_Input::Htmlspecialchars($_GET['type']) : 'topic';
$tid = isset($_GET['tid']) ? intval($_GET['tid']) : 0;
$ptype = isset($_POST['ptype']) ? intval($_POST['ptype']) : 0;
$fid = isset($_GET['fid']) ? intval($_GET['fid']) : 0;
if ($tid < 1 && $fid < 1 || $tid > 0 && $fid > 0)
    BB_Functions::Message($lang['Bad request']);
if ($tid)
    $result = $db->query('SELECT f.id, f.forum_name, f.moderators, f.redirect_url, fp.post_replies, fp.post_topics, fp.image_upload, t.subject, t.closed FROM ' . $db->prefix . 'topics AS t INNER JOIN ' . $db->prefix . 'forums AS f ON f.id=t.forum_id LEFT JOIN ' . $db->prefix . 'permissions AS fp ON (fp.forum_id=f.id AND fp.gid=' . $forum_user['g_id'] . ') WHERE (fp.read_forum IS NULL OR fp.read_forum=1) AND t.id=' . $db->escape($tid)) or BB_Functions::Error($lang['error_87'], __FILE__, __LINE__, $db->error());
else
    $result = $db->query('SELECT f.id, f.forum_name, f.moderators, f.redirect_url, fp.post_replies, fp.post_topics, fp.image_upload FROM ' . $db->prefix . 'forums AS f LEFT JOIN ' . $db->prefix . 'permissions AS fp ON (fp.forum_id=f.id AND fp.gid=' . $forum_user['g_id'] . ') WHERE (fp.read_forum IS NULL OR fp.read_forum=1) AND f.id=' . $db->escape($fid)) or BB_Functions::Error($lang['error_87'], __FILE__, __LINE__, $db->error());
if (!$db->num_rows($result))
    BB_Functions::Message($lang['Bad request']);
$cur_posting = $db->fetch_assoc($result);
if ($cur_posting['redirect_url'] != '')
    BB_Functions::Message($lang['Bad request']);
$mods_array = ($cur_posting['moderators'] != '') ? unserialize($cur_posting['moderators']) : array();
$is_admmod = ($forum_user['g_id'] == USER_ADMIN || ($forum_user['g_id'] == USER_MOD && array_key_exists($forum_user['username'], $mods_array)) || $forum_user['g_global_moderation']) ? true : false;
if ((($tid && (($cur_posting['post_replies'] == '' && $forum_user['g_post_replies'] == '0') || $cur_posting['post_replies'] == '0')) || ($fid && (($cur_posting['post_topics'] == '' && $forum_user['g_post_topics'] == '0') || $cur_posting['post_topics'] == '0')) || (isset($cur_posting['closed']) && $cur_posting['closed'] == '1')) && !$is_admmod)
    BB_Functions::Message($lang['No permission'], true, 1);
$errors = array();
if (isset($_POST['form_sent']))
{
    if (($forum_user['is_guest'] && $_POST['form_user'] != 'Guest') || (!$forum_user['is_guest'] && $_POST['form_user'] != $forum_user['username']))
        BB_Functions::Message($lang['Bad request']);
    if (!$forum_user['is_guest'] && !isset($_POST['preview']) && $forum_user['last_post'] != '' && (time() - $forum_user['last_post']) < $forum_user['g_post_flood'])
        $errors[] = $lang['Flood start'] . ' ' . $forum_user['g_post_flood'] . ' ' . $lang['flood end'];
    if ($fid)
    {
        if ($type == 'poll')
        {
            if (!empty($_POST['create_poll']))
            {
                $subject = BB_Input::Trim($_POST['req_subject']);
                $tags = BB_Input::Trim($_POST['tags']);
                if ($subject == '')
                    $errors[] = $lang['No subject'];
                else if ((BB_Input::Strlen($subject) > 70) && !$lang['lang_multibyte'])
                    $errors[] = $lang['Too long subject'];
                else if (bb_subject_all_caps == '0' && strtoupper($subject) == $subject && ($forum_user['g_id'] > USER_MOD && !$forum_user['g_global_moderation']))
                    $subject = ucwords(strtolower($subject));
                $question = BB_Input::Trim($_POST['req_question']);
                if ($question == '')
                    $errors[] = $lang['No question'];
                else if ((BB_Input::Strlen($question) > 70) && !$lang['lang_multibyte'])
                    $errors[] = $lang['Too long question'];
                else if (bb_subject_all_caps == '0' && strtoupper($question) == $question && ($forum_user['g_id'] > USER_MOD && !$forum_user['g_global_moderation']))
                    $question = ucwords(strtolower($question));
                if ($ptype == 3)
                {
                    $yesval = BB_Input::Trim($_POST['poll_yes']);
                    if ($yesval == '')
                        $errors[] = $lang['No yes'];
                    else if (BB_Input::Strlen($yesval) > 35)
                        $errors[] = $lang['Too long yes'];
                    else if (bb_subject_all_caps == '0' && strtoupper($yesval) == $yesval && ($forum_user['g_id'] > USER_MOD && !$forum_user['g_global_moderation']))
                        $yesval = ucwords(strtolower($yesval));
                    $noval = BB_Input::Trim($_POST['poll_no']);
                    if ($noval == '')
                        $errors[] = $lang['No no'];
                    else if (BB_Input::Strlen($noval) > 35)
                        $errors[] = $lang['Too long no'];
                    else if (bb_subject_all_caps == '0' && strtoupper($noval) == $noval && ($forum_user['g_id'] > USER_MOD && !$forum_user['g_global_moderation']))
                        $noval = ucwords(strtolower($noval));
                }
                $option = array();
                $lastoption = "null";
                while (list($key, $value) = each($_POST['poll_option']))
                {
                    $value = BB_Input::Trim($value);
                    if ($value != "")
                    {
                        if ($lastoption == '')
                            $errors[] = $lang['Empty option'];
                        else
                        {
                            $option[$key] = BB_Input::Trim($value);
                            if (BB_Input::Strlen($option[$key]) > 55)
                                $errors[] = $lang['Too long option'];
                            else if ($key > bb_poll_max_fields)
                                BB_Functions::Message($lang['Bad request']);
                            else if (bb_subject_all_caps == '0' && strtoupper($option[$key]) == $option[$key] && ($forum_user['g_id'] > USER_MOD && !$forum_user['g_global_moderation']))
                                $option[$key] = ucwords(strtolower($option[$key]));
                        }
                    }
                    $lastoption = BB_Input::Trim($value);
                }
                if (empty($option))
                    $errors[] = $lang['No options'];
                if (!array_key_exists(2, $option))
                    $errors[] = $lang['Low options'];
            }
        }
        else
        {
            $subject = BB_Input::Trim($_POST['req_subject']);
            $tags = BB_Input::Trim($_POST['tags']);
            if ($subject == '')
                $errors[] = $lang['No subject'];
            else if ((BB_Input::Strlen($subject) > 70) && !$lang['lang_multibyte'])
                $errors[] = $lang['Too long subject'];
            else if (bb_subject_all_caps == '0' && strtoupper($subject) == $subject && ($forum_user['g_id'] > USER_MOD && !$forum_user['g_global_moderation']))
                $subject = ucwords(strtolower($subject));
        }
    }
    if (!$forum_user['is_guest'])
    {
        $username = $forum_user['username'];
        $email = $forum_user['email'];
    }
    else
    {
        $username = trim($_POST['req_username']);
        $email = strtolower(trim((bb_force_guest_email == '1') ? $_POST['req_email'] : $_POST['email']));
        if (strlen($username) < 2)
            $errors[] = $lang['Username too short'];
        else if (!strcasecmp($username, 'Guest') || !strcasecmp($username, $lang['Guest']))
            $errors[] = $lang['Username guest'];
        else if (preg_match('/[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}/', $username))
            $errors[] = $lang['Username IP'];
        if ((strpos($username, '[') !== false || strpos($username, ']') !== false) && strpos($username, '\'') !== false && strpos($username, '"') !== false)
            $errors[] = $lang['Username reserved chars'];
        if (preg_match('#\[b\]|\[/b\]|\[u\]|\[/u\]|\[i\]|\[/i\]|\[color|\[/color\]|\[quote\]|\[quote=|\[/quote\]|\[code\]|\[/code\]|\[img\]|\[/img\]|\[url|\[/url\]|\[email|\[/email\]#i', $username))
            $errors[] = $lang['Username BBCode'];
        $temp = BB_Input::Censor_Words($username);
        if ($temp != $username)
            $errors[] = $lang['Username censor'];
        $result = $db->query('SELECT username FROM ' . $db->prefix . 'users WHERE username=\'' . $db->escape($username) . '\' OR username=\'' . $db->escape(preg_replace('/[^\w]/', '', $username)) . '\'') or BB_Functions::Error($lang['error_29'], __FILE__, __LINE__, $db->error());
        if ($db->num_rows($result))
        {
            $busy = $db->result($result);
            $errors[] = $lang['Username dupe 1'] . ' ' . BB_Input::Htmlspecialchars($busy) . '. ' . $lang['Username dupe 2'];
        }
        if (bb_force_guest_email == '1' || $email != '')
        {
            if (!BB_Email::Is_Valid_Email($email))
                $errors[] = $lang['Invalid e-mail'];
        }
    }
    $message = BB_Input::Linebreaks(BB_Input::Trim($_POST['req_message']));
    if ($message == '')
        $errors[] = $lang['No message'];
    else if (strlen($message) > 65535)
        $errors[] = $lang['Too long message'];
    else if (bb_message_all_caps == '0' && strtoupper($message) == $message && ($forum_user['g_id'] > USER_MOD && !$forum_user['g_global_moderation']))
        $message = ucwords(strtolower($message));
    if (bb_message_bbcode == '1' && strpos($message, '[') !== false && strpos($message, ']') !== false)
    {
        require_once FORUM_ROOT . 'include/functions/Parser.php';
        $message = BB_Parser::Preparse_BBCode($message, $errors);
    }
    $hide_smilies = isset($_POST['hide_smilies']) ? 1 : 0;
    $subscribe = isset($_POST['subscribe']) ? 1 : 0;
    $now = time();
    if (empty($errors) && !isset($_POST['preview']))
    {
        if ($tid)
        {
            if (!$forum_user['is_guest'])
            {
                $db->query('INSERT INTO ' . $db->prefix . 'posts (poster, poster_id, poster_ip, message, hide_smilies, posted, topic_id) VALUES(\'' . $db->escape($username) . '\', ' . $forum_user['id'] . ', \'' . $db->escape(BB_Input::Get_Remote_Address()) . '\', \'' . $db->escape($message) . '\', \'' . $db->escape($hide_smilies) . '\', ' . $now . ', ' . $db->escape($tid) . ')') or BB_Functions::Error($lang['error_88'], __FILE__, __LINE__, $db->error());
                $new_pid = $db->insert_id();
                if (bb_subscriptions == '1' && $subscribe)
                {
                    $result = $db->query('SELECT 1 FROM ' . $db->prefix . 'subscriptions WHERE user_id=' . $forum_user['id'] . ' AND topic_id=' . $db->escape($tid)) or BB_Functions::Error($lang['error_89'], __FILE__, __LINE__, $db->error());
                    if (!$db->num_rows($result))
                        $db->query('INSERT INTO ' . $db->prefix . 'subscriptions (user_id, topic_id) VALUES(' . $forum_user['id'] . ' ,' . $db->escape($tid) . ')') or BB_Functions::Error($lang['error_90'], __FILE__, __LINE__, $db->error());
                }
            }
            else
            {
                $email_sql = (bb_force_guest_email == '1' || $email != '') ? '\'' . $db->escape($email) . '\'' : 'NULL';
                $db->query('INSERT INTO ' . $db->prefix . 'posts (poster, poster_ip, poster_email, message, hide_smilies, posted, topic_id) VALUES(\'' . $db->escape($username) . '\', \'' . $db->escape(BB_Input::Get_Remote_Address()) . '\', ' . $email_sql . ', \'' . $db->escape($message) . '\', \'' . $db->escape($hide_smilies) . '\', ' . $now . ', ' . $db->escape($tid) . ')') or BB_Functions::Error($lang['error_88'], __FILE__, __LINE__, $db->error());
                $new_pid = $db->insert_id();
            }
            $result = $db->query('SELECT COUNT(id) FROM ' . $db->prefix . 'posts WHERE topic_id=' . $db->escape($tid)) or BB_Functions::Error($lang['error_91'], __FILE__, __LINE__, $db->error());
            $num_replies = $db->result($result, 0) - 1;
            $db->query('UPDATE ' . $db->prefix . 'topics SET num_replies=' . $db->escape($num_replies) . ', last_post=' . $now . ', last_post_id=' . $db->escape($new_pid) . ', last_poster=\'' . $db->escape($username) . '\' WHERE id=' . $db->escape($tid)) or BB_Functions::Error($lang['error_6'], __FILE__, __LINE__, $db->error());
            BB_Core::Set_Search_Index('post', $new_pid, $message);
            BB_Core::Update_Forum($cur_posting['id']);
            if (bb_subscriptions == '1')
            {
                $result = $db->query('SELECT posted FROM ' . $db->prefix . 'posts WHERE topic_id=' . $db->escape($tid) . ' ORDER BY id DESC LIMIT 1, 1') or BB_Functions::Error($lang['error_3'], __FILE__, __LINE__, $db->error());
                $previous_post_time = $db->result($result);
                $result = $db->query('SELECT u.id, u.email, u.notify_with_post, u.language FROM ' . $db->prefix . 'users AS u INNER JOIN ' . $db->prefix . 'subscriptions AS s ON u.id=s.user_id LEFT JOIN ' . $db->prefix . 'permissions AS fp ON (fp.forum_id=' . $db->escape($cur_posting['id']) . ' AND fp.gid=u.gid) LEFT JOIN ' . $db->prefix . 'online AS o ON u.id=o.user_id LEFT JOIN ' . $db->prefix . 'bans AS b ON u.username=b.username WHERE b.username IS NULL AND COALESCE(o.logged, u.last_visit)>' . $db->escape($previous_post_time) . ' AND (fp.read_forum IS NULL OR fp.read_forum=1) AND s.topic_id=' . $db->escape($tid) . ' AND u.id!=' . $db->escape($forum_user['id'])) or BB_Functions::Error($lang['error_44'], __FILE__, __LINE__, $db->error());
                if ($db->num_rows($result))
                {
                    $notification_emails = array();
                    while ($cur_subscriber = $db->fetch_assoc($result))
                    {
                        if (!isset($notification_emails[$cur_subscriber['language']]))
                        {
                            if (file_exists(FORUM_ROOT . 'include/languages/' . $cur_subscriber['language'] . '/mail_templates/new_reply.tpl'))
                            {
                                $mail_tpl = trim(file_get_contents(FORUM_ROOT . 'include/languages/' . $cur_subscriber['language'] . '/mail_templates/new_reply.tpl'));
                                $mail_tpl_full = trim(file_get_contents(FORUM_ROOT . 'include/languages/' . $cur_subscriber['language'] . '/mail_templates/new_reply_full.tpl'));
                                $first_crlf = strpos($mail_tpl, "\n");
                                $mail_subject = trim(substr($mail_tpl, 8, $first_crlf - 8));
                                $mail_message = trim(substr($mail_tpl, $first_crlf));
                                $first_crlf = strpos($mail_tpl_full, "\n");
                                $mail_subject_full = trim(substr($mail_tpl_full, 8, $first_crlf - 8));
                                $mail_message_full = trim(substr($mail_tpl_full, $first_crlf));
                                $mail_subject = str_replace('<topic_subject>', '\'' . $cur_posting['subject'] . '\'', $mail_subject);
                                $mail_message = str_replace('<topic_subject>', '\'' . $cur_posting['subject'] . '\'', $mail_message);
                                $mail_message = str_replace('<replier>', $username, $mail_message);
                                $mail_message = str_replace('<post_url>', bb_forum_url . '/topic.php?pid=' . $new_pid . '#p' . $new_pid, $mail_message);
                                $mail_message = str_replace('<unsubscribe_url>', bb_forum_url . '/misc.php?unsubscribe=' . $tid, $mail_message);
                                $mail_message = str_replace('<board_mailer>', bb_board_title . ' ' . $lang['Mailer'], $mail_message);
                                $mail_subject_full = str_replace('<topic_subject>', '\'' . $cur_posting['subject'] . '\'', $mail_subject_full);
                                $mail_message_full = str_replace('<topic_subject>', '\'' . $cur_posting['subject'] . '\'', $mail_message_full);
                                $mail_message_full = str_replace('<replier>', $username, $mail_message_full);
                                $mail_message_full = str_replace('<message>', $message, $mail_message_full);
                                $mail_message_full = str_replace('<post_url>', bb_forum_url . '/topic.php?pid=' . $new_pid . '#p' . $new_pid, $mail_message_full);
                                $mail_message_full = str_replace('<unsubscribe_url>', bb_forum_url . '/misc.php?unsubscribe=' . $tid, $mail_message_full);
                                $mail_message_full = str_replace('<board_mailer>', bb_board_title . ' ' . $lang['Mailer'], $mail_message_full);
                                $notification_emails[$cur_subscriber['language']][0] = $mail_subject;
                                $notification_emails[$cur_subscriber['language']][1] = $mail_message;
                                $notification_emails[$cur_subscriber['language']][2] = $mail_subject_full;
                                $notification_emails[$cur_subscriber['language']][3] = $mail_message_full;
                                $mail_subject = $mail_message = $mail_subject_full = $mail_message_full = null;
                            }
                        }
                        if (isset($notification_emails[$cur_subscriber['language']]))
                        {
                            if ($cur_subscriber['notify_with_post'] == '0')
                                BB_Email::Mail($cur_subscriber['email'], $notification_emails[$cur_subscriber['language']][0], $notification_emails[$cur_subscriber['language']][1]);
                            else
                                BB_Email::Mail($cur_subscriber['email'], $notification_emails[$cur_subscriber['language']][2], $notification_emails[$cur_subscriber['language']][3]);
                        }
                    }
                }
            }
        }
        else if ($fid)
        {
            if ($type == 'topic')
            {
                $closed = '0';
                $icon_topic = intval($_POST['icon_topic']);
                $db->query('INSERT INTO ' . $db->prefix . 'topics (poster, subject, tags, posted, last_post, last_poster, closed, forum_id, icon_topic) VALUES(\'' . $db->escape($username) . '\', \'' . $db->escape($subject) . '\', \'' . $db->escape($tags) . '\', ' . $now . ', ' . $now . ', \'' . $db->escape($username) . '\', ' . $db->escape($closed) . ', ' . $db->escape($fid) . ', ' . $db->escape($icon_topic) . ')') or BB_Functions::Error($lang['error_92'], __FILE__, __LINE__, $db->error());
                $new_tid = $db->insert_id();
                if (!$forum_user['is_guest'])
                {
                    if (bb_subscriptions == '1' && (isset($_POST['subscribe']) && $_POST['subscribe'] == '1'))
                        $db->query('INSERT INTO ' . $db->prefix . 'subscriptions (user_id, topic_id) VALUES(' . $forum_user['id'] . ' ,' . $db->escape($new_tid) . ')') or BB_Functions::Error($lang['error_90'], __FILE__, __LINE__, $db->error());
                    $db->query('INSERT INTO ' . $db->prefix . 'posts (poster, poster_id, poster_ip, message, hide_smilies, posted, topic_id) VALUES(\'' . $db->escape($username) . '\', ' . $forum_user['id'] . ', \'' . $db->escape(BB_Input::Get_Remote_Address()) . '\', \'' . $db->escape($message) . '\', \'' . $db->escape($hide_smilies) . '\', ' . $now . ', ' . $db->escape($new_tid) . ')') or BB_Functions::Error($lang['error_88'], __FILE__, __LINE__, $db->error());
                }
                else
                {
                    $email_sql = (bb_force_guest_email == '1' || $email != '') ? '\'' . $db->escape($email) . '\'' : 'NULL';
                    $db->query('INSERT INTO ' . $db->prefix . 'posts (poster, poster_ip, poster_email, message, hide_smilies, posted, topic_id) VALUES(\'' . $db->escape($username) . '\', \'' . $db->escape(BB_Input::Get_Remote_Address()) . '\', ' . $email_sql . ', \'' . $db->escape($message) . '\', \'' . $db->escape($hide_smilies) . '\', ' . $now . ', ' . $db->escape($new_tid) . ')') or BB_Functions::Error($lang['error_88'], __FILE__, __LINE__, $db->error());
                }
                $new_pid = $db->insert_id();
                $db->query('UPDATE ' . $db->prefix . 'topics SET last_post_id=' . $new_pid . ' WHERE id=' . $db->escape($new_tid)) or BB_Functions::Error($lang['error_6'], __FILE__, __LINE__, $db->error());
                BB_Core::Set_Search_Index('post', $new_pid, $message, $subject);
                BB_Core::Update_Forum($fid);
            }
            else
            {
                $closed = '0';
                $icon_topic = intval($_POST['icon_topic']);
                if ($ptype == 3)
                    $db->query('INSERT INTO ' . $db->prefix . 'topics (poster, subject, tags, posted, last_post, last_poster, closed, forum_id, icon_topic, question, yes, no) VALUES(\'' . $db->escape($username) . '\', \'' . $db->escape($subject) . '\', \'' . $db->escape($tags) . '\', ' . $now . ', ' . $now . ', \'' . $db->escape($username) . '\', ' . $db->escape($closed) . ', ' . $db->escape($fid) . ', ' . $db->escape($icon_topic) . ', \'' . $db->escape($question) . '\', \'' . $db->escape($yesval) . '\', \'' . $db->escape($noval) . '\')') or BB_Functions::Error($lang['error_92'], __FILE__, __LINE__, $db->error());
                else
                    $db->query('INSERT INTO ' . $db->prefix . 'topics (poster, subject, tags, posted, last_post, last_poster, closed, forum_id, icon_topic, question) VALUES(\'' . $db->escape($username) . '\', \'' . $db->escape($subject) . '\', \'' . $db->escape($tags) . '\', ' . $now . ', ' . $now . ', \'' . $db->escape($username) . '\', ' . $db->escape($closed) . ', ' . $db->escape($fid) . ', ' . $db->escape($icon_topic) . ', \'' . $db->escape($question) . '\')') or BB_Functions::Error($lang['error_92'], __FILE__, __LINE__, $db->error());
                $new_tid = $db->insert_id();
                $db->query('INSERT INTO ' . $db->prefix . 'polls (pollid, options, ptype) VALUES(' . $db->escape($new_tid) . ', \'' . $db->escape(serialize($option)) . '\', ' . $db->escape($ptype) . ')') or BB_Functions::Error($lang['error_123'], __FILE__, __LINE__, $db->error());
                if (!$forum_user['is_guest'])
                    $db->query('INSERT INTO ' . $db->prefix . 'posts (poster, poster_id, poster_ip, message, hide_smilies, posted, topic_id) VALUES(\'' . $db->escape($username) . '\', ' . $forum_user['id'] . ', \'' . $db->escape(BB_Input::Get_Remote_Address()) . '\', \'' . $db->escape($message) . '\', \'' . $db->escape($hide_smilies) . '\', ' . $now . ', ' . $db->escape($new_tid) . ')') or BB_Functions::Error($lang['error_88'], __FILE__, __LINE__, $db->error());
                else
                {
                    $email_sql = (bb_force_guest_email == '1' || $email != '') ? '\'' . $db->escape($email) . '\'' : 'NULL';
                    $db->query('INSERT INTO ' . $db->prefix . 'posts (poster, poster_ip, poster_email, message, hide_smilies, posted, topic_id) VALUES(\'' . $db->escape($username) . '\', \'' . $db->escape(BB_Input::Get_Remote_Address()) . '\', ' . $email_sql . ', \'' . $db->escape($message) . '\', \'' . $db->escape($hide_smilies) . '\', ' . $now . ', ' . $db->escape($new_tid) . ')') or BB_Functions::Error($lang['error_88'], __FILE__, __LINE__, $db->error());
                }
                $new_pid = $db->insert_id();
                $db->query('UPDATE ' . $db->prefix . 'topics SET last_post_id=' . $db->escape($new_pid) . ' WHERE id=' . $db->escape($new_tid)) or BB_Functions::Error($lang['error_6'], __FILE__, __LINE__, $db->error());
                BB_Core::Set_Search_Index('post', $new_pid, $message, $subject);
                BB_Core::Update_Forum($fid);
            }
        }
        if (!$forum_user['is_guest'])
        {
            $low_prio = ($db_type == 'mysql') ? 'LOW_PRIORITY ' : '';
            $db->query('UPDATE ' . $low_prio . $db->prefix . 'users SET num_posts=num_posts+1, last_post=' . $now . ' WHERE id=' . $forum_user['id']) or BB_Functions::Error($lang['error_93'], __FILE__, __LINE__, $db->error());
        }
        $upload_result = BB_Image_Upload::Process_Uploaded_Images($new_pid);
        if ($type == 'topic')
        {
            if ($fid)
                BB_Functions::Redirect(bb_forum_url . BB_Input::Rewrite_URL("t", $new_tid, $subject) . '#p' . $new_pid, $upload_result . $lang['Post redirect']);
            else
                BB_Functions::Redirect(bb_forum_url . BB_Input::Rewrite_URL("t", $tid, $cur_posting['subject']) . '#p' . $new_pid, $upload_result . $lang['Post redirect']);
        }
        else
        {
            if ($fid)
                BB_Functions::Redirect(bb_forum_url . BB_Input::Rewrite_URL("l", $new_tid, $subject) . '#p' . $new_pid, $upload_result . $lang['Post redirect']);
            else
                BB_Functions::Redirect(bb_forum_url . BB_Input::Rewrite_URL("l", $tid, $cur_posting['subject']) . '#p' . $new_pid, $upload_result . $lang['Post redirect']);
        }
    }
}
if ($tid)
{
    $action = $lang['Post a reply'];
    $form = '<form name="spelling_mod" id="post" method="post" action="post.php?action=post&amp;type=' . $type . '&amp;tid=' . $tid . '" onsubmit="this.submit.disabled=true;if(process_form(this)){return true;}else{this.submit.disabled=false;return false;}"  enctype="multipart/form-data">';
    if (isset($_GET['qid']))
    {
        $qid = intval($_GET['qid']);
        if ($qid < 1)
            BB_Functions::Message($lang['Bad request']);
        $result = $db->query('SELECT poster, message FROM ' . $db->prefix . 'posts WHERE id=' . $db->escape($qid) . ' AND topic_id=' . $db->escape($tid)) or BB_Functions::Error($lang['error_124'], __FILE__, __LINE__, $db->error());
        if (!$db->num_rows($result))
            BB_Functions::Message($lang['Bad request']);
        list($q_poster, $q_message) = $db->fetch_row($result);
        if (bb_formatting == 'BBCode')
        {
            $q_message = str_replace('[img]', '[url]', $q_message);
            $q_message = str_replace('[/img]', '[/url]', $q_message);
            $q_message = preg_replace("/\[mp3=([^ ]+)\]/", "[url]$1[/url]", $q_message);
        }
        else if (bb_formatting == 'Textile')
        {
            $q_message = str_replace('!h', '"' . $lang['Image link'] . '":h', $q_message);
            $q_message = str_replace('!f', '"' . $lang['Image link'] . '":f', $q_message);
            $q_message = str_replace('!', '', $q_message);
        }
        $q_message = BB_Input::Htmlspecialchars($q_message);
        if (bb_message_bbcode == '1')
        {
            if (strpos($q_poster, '[') !== false || strpos($q_poster, ']') !== false)
            {
                if (strpos($q_poster, '\'') !== false)
                    $q_poster = '"' . $q_poster . '"';
                else
                    $q_poster = '\'' . $q_poster . '\'';
            }
            else
            {
                $ends = substr($q_poster, 0, 1) . substr($q_poster, -1, 1);
                if ($ends == '\'\'')
                    $q_poster = '"' . $q_poster . '"';
                else if ($ends == '""')
                    $q_poster = '\'' . $q_poster . '\'';
            }
            if (bb_formatting == 'BBCode')
                $quote = '[quote=' . $q_poster . ']' . $q_message . '[/quote]' . "\n";
            else if (bb_formatting == 'Textile')
                $quote = $q_poster . ' ' . $lang['wrote'] . ":\n\nbq. " . $q_message . "\n";
        }
        else
            $quote = '> ' . $q_poster . ' ' . $lang['wrote'] . ':' . "\n\n" . '> ' . $q_message . "\n";
    }
    $forum_name = '<a href="forum.php?id=' . $cur_posting['id'] . '">' . BB_Input::Htmlspecialchars($cur_posting['forum_name']) . '</a>';
}
else if ($fid)
{
    if ($type == 'topic')
        $action = $lang['Post new topic'];
    else
        $action = $lang['Create new poll'];
    $form = '<form name="spelling_mod" id="post" method="post" action="post.php?action=post&amp;type=' . $type . '&amp;fid=' . $fid . '" onsubmit="return process_form(this)" enctype="multipart/form-data">';
    $forum_name = BB_Input::Htmlspecialchars($cur_posting['forum_name']);
}
else
    BB_Functions::Message($lang['Bad request']);
$page_title = BB_Input::Htmlspecialchars($action);
if ($type == 'topic')
{
    $required_fields = array('req_email' => $lang['E-mail'], 'req_subject' => $lang['Subject'], 'req_message' => $lang['Message']);
    $focus_element = array('post');
    if (!$forum_user['is_guest'])
        $focus_element[] = ($fid) ? 'req_subject' : 'req_message';
    else
    {
        $required_fields['req_username'] = $lang['Guest name'];
        $focus_element[] = 'req_username';
    }
    require FORUM_ROOT . $forum_folder . '/header.php';
    if (!empty($errors))
    {
        ?>
        <div id="posterror" class="blockform">
            <h2><span><?php echo $lang['Post errors'] ?></span></h2>
            <div class="box">
                <div class="inbox" style="padding:10px">
                    <p><?php echo $lang['Post errors info'] ?></p>
                    <ul>
                                <?php
                                while (list(, $cur_error) = each($errors))
                                    echo "\t\t\t\t" . '<li><strong>' . $cur_error . '</strong></li>' . "\n";
                                ?>
                    </ul>
                </div>
            </div>
        </div>
        <?php
    }
    else if (isset($_POST['preview']))
    {
        require_once FORUM_ROOT . 'include/functions/Parser.php';
        $preview_message = BB_Parser::Parse_Message($message, $hide_smilies);
        ?>
        <div id="postpreview" class="blockpost">
            <h2><span><?php echo $lang['Post preview'] ?></span></h2>
            <div class="box">
                <div class="inbox">
                    <div class="postright">
                        <div class="postmsg">
        <?php echo $preview_message . "\n" ?>
                        </div>
                    </div>
                </div>
            </div>
        </div>
                    <?php
                }
                $cur_index = 1;
                ?>
    <div class="blockform">
        <h2><span><?php echo $action . ' ' . BB_Input::Htmlspecialchars($cur_posting['subject']) ?></span></h2>
        <div class="box">
                <?php echo $form . "\n" ?>
            <h2><?php echo $lang['Message'] ?></h2>
            <div class="inform file" style="padding:20px;">
                <div class="infldset txtarea" style="padding:10px;">
                    <input type="hidden" name="form_sent" value="1" />
                    <input type="hidden" name="form_user" value="<?php echo (!$forum_user['is_guest']) ? BB_Input::Htmlspecialchars($forum_user['username']) : 'Guest'; ?>" />
    <?php
    if ($forum_user['is_guest'])
    {
        $email_label = (bb_force_guest_email == '1') ? '<strong>' . $lang['E-mail'] . '</strong>' : $lang['E-mail'];
        $email_form_name = (bb_force_guest_email == '1') ? 'req_email' : 'email';
        ?>
                        <fieldset><legend><?php echo $lang['Your data'] ?></legend>
                            <input type="text" class="textbox" name="req_username" value="<?php if (isset($_POST['req_username']))
            echo BB_Input::Htmlspecialchars($username); ?>" style="width:510px" maxlength="25" tabindex="<?php echo $cur_index++ ?>" /><br /><br />
                            <input type="text" class="textbox" name="<?php echo $email_form_name ?>" value="<?php if (isset($_POST[$email_form_name]))
            echo BB_Input::Htmlspecialchars($email); ?>" style="width:510px" maxlength="50" tabindex="<?php echo $cur_index++ ?>" />
                        </fieldset>
                <?php
            }
            if ($fid)
            {
                ?>
                        <fieldset><legend><?php echo $lang['Topic icons'] ?></legend>
                            <div id="topic_icons">
                <?php
                $icons_topic = array();
                $d = dir(FORUM_ROOT . $forum_folder . '/img/general/icons');
                while (($entry = $d->read()) !== false)
                {
                    if (substr($entry, strlen($entry) - 4) == '.png')
                        $icons_topic[] = substr($entry, 0, strlen($entry) - 4);
                }
                $d->close();
                if (count($icons_topic) > 1)
                {
                    while (list(, $temp) = @each($icons_topic))
                        echo '<input type="radio" name="icon_topic" value="' . $temp . '" />&nbsp;<img src="' . bb_forum_url . 'img/general/icons/' . $temp . '.png" alt="' . $temp . '" />&nbsp;';
                    echo '<input type="radio" name="icon_topic" value="0" checked="checked" />&nbsp;' . $lang['None'];
                }
                ?>
                            </div>
                        </fieldset>
                        <fieldset><legend><?php echo $lang['Subject'] ?></legend>
                            <input type="text" class="textbox" name="req_subject" value="<?php if (isset($_POST['req_subject']))
            echo BB_Input::Htmlspecialchars($subject); ?>" style="width:510px" maxlength="70" tabindex="<?php echo $cur_index++ ?>" />
                        </fieldset>
                <?php
            }
            ?>
                    <fieldset><legend><?php echo $lang['Formatting'] ?></legend>
            <?php
            require FORUM_ROOT . 'include/functions/BBCodes.php';
            ?>
                    </fieldset>
                    <fieldset><legend><?php echo $lang['Message'] ?></legend>
                        <textarea name="req_message" id="req_message" class="post" style="width:510px" rows="20" tabindex="<?php echo $cur_index++ ?>"><?php echo isset($_POST['req_message']) ? BB_Input::Htmlspecialchars($message) : (isset($quote) ? $quote : ''); ?></textarea>
                    </fieldset>
                </div>
                <p style="width:510px"><input type="button" class="b1" name="submit" onclick="javascript:history.go(-1);" value="<?php echo $lang['Go back'] ?>"><input type="submit" class="b1" name="submit" value="<?php echo $lang['Post message'] ?>" tabindex="<?php echo $cur_index++ ?>" accesskey="s" /><input class="b1" type="submit" name="preview" onclick="xBB_Clear_Upload_Slots();" value="<?php echo $lang['Preview'] ?>" tabindex="<?php echo $cur_index++ ?>" accesskey="p" /></p>

    <?php
    $checkboxes = array();
    if (!$forum_user['is_guest'])
    {
        if (bb_smilies == '1')
            $checkboxes[] = '<label><input type="checkbox" name="hide_smilies" value="1" tabindex="' . ($cur_index++) . '"' . (isset($_POST['hide_smilies']) ? ' checked="checked"' : '') . ' />' . $lang['Hide smilies'];
        if (bb_subscriptions == '1')
            $checkboxes[] = '<label><input type="checkbox" name="subscribe" value="1" tabindex="' . ($cur_index++) . '"' . (isset($_POST['subscribe']) ? ' checked="checked"' : '') . ' />' . $lang['Subscribe'];
    }
    else if (bb_smilies == '1')
        $checkboxes[] = '<label><input type="checkbox" name="hide_smilies" value="1" tabindex="' . ($cur_index++) . '"' . (isset($_POST['hide_smilies']) ? ' checked="checked"' : '') . ' />' . $lang['Hide smilies'];
    if (!empty($checkboxes))
    {
        ?>
                </div><br />
                <div id="div_imageshack" class="file" style="display: none;">
                    <h2><?php echo $lang['Upload IS'] ?></h2>
                    <div class="inform">
                        <div class="infldset" style="padding:10px;">
                            <div class="rbox">
                                <iframe src="http://imageshack.us/iframe.php?txtcolor=111111&amp;type=blank&amp;size=30" scrolling="no" allowtransparency="true" frameborder="0" width="280" height="80">Update your browser for ImageShack.us!</iframe><br />
                                Note: To include image on post, use the form above and after it is uploaded, choose option "<b>Hotlink for forums (1)</b>, copy and paste inside message box.
                            </div>
                        </div>
                    </div>
                </div><br />
        <?php
        $qpost_ids = (isset($_COOKIE['qpostprefs'])) ? $_COOKIE['qpostprefs'] . ',' : FALSE;
        if (strstr($qpost_ids, '997,'))
        {
            $div_ido = "none";
            $div_idx = "block";
        }
        else
        {
            $div_ido = "block";
            $div_idx = "none";
        }
        ?>
                <div id="ido997" class="file" style="display:<?php echo $div_ido ?>">
                    <h2>
                        <span class="icons"><a href="javascript:xBB_Toggle_Category(997, 0);"><img src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/down.png" alt="+" /></a></span>
                        <span><?php echo $lang['Image_Upload'] ?></span>
                    </h2>
                </div>
                <div id="idx997" class="file" style="display:<?php echo $div_idx ?>">
                    <h2>
                        <span class="icons"><a href="javascript:xBB_Toggle_Category(997, 1);"><img src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/up.png" alt="-" /></a></span>
                        <span><?php echo $lang['Image_Upload'] ?></span>
                    </h2>
        <?php BB_Image_Upload::Show($cur_posting); ?>
                </div><br />
                            <?php
                            $qpost_ids = (isset($_COOKIE['qpostprefs'])) ? $_COOKIE['qpostprefs'] . ',' : FALSE;
                            if (strstr($qpost_ids, '996,'))
                            {
                                $div_ido = "none";
                                $div_idx = "block";
                            }
                            else
                            {
                                $div_ido = "block";
                                $div_idx = "none";
                            }
                            ?>
                <div id="ido996" class="file" style="display:<?php echo $div_ido ?>">
                    <h2>
                        <span class="icons"><a href="javascript:xBB_Toggle_Category(996, 0);"><img src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/down.png" alt="+" /></a></span>
                        <span><?php echo $lang['Options'] ?></span>
                    </h2>
                </div>
                <div id="idx996" class="file" style="display:<?php echo $div_idx ?>">
                    <h2>
                        <span class="icons"><a href="javascript:xBB_Toggle_Category(996, 1);"><img src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/up.png" alt="-" /></a></span>
                        <span><?php echo $lang['Options'] ?></span>
                    </h2>
                    <div class="inform">
                        <div class="infldset" style="padding:10px;">
                            <div class="rbox">
                <?php echo implode('<br /></label>' . "\n\t\t\t\t", $checkboxes) . '<br /></label>' . "\n" ?>
                <?php
                if ($fid)
                {
                    ?>
                                    <label><?php echo $lang['Tags']; ?>&nbsp;&nbsp;<input type="text" class="textbox" name="tags" value="<?php if (isset($_POST['tags']))
                        echo BB_Input::Htmlspecialchars($tags); ?>" style="width:400px" maxlength="70" tabindex="<?php echo $cur_index++ ?>" /><br /></label>
            <?php
        }
        ?>
                            </div>
                        </div>
        <?php
    }
    ?>
                </div>
            </div>
            </form>
        </div>
    </div>
    <?php
    if ($tid && bb_topic_review != '0')
    {
        require_once FORUM_ROOT . 'include/functions/Parser.php';
        $result = $db->query('SELECT poster, message, hide_smilies, posted FROM ' . $db->prefix . 'posts WHERE topic_id=' . $db->escape($tid) . ' ORDER BY id DESC LIMIT ' . bb_topic_review) or BB_Functions::Error($lang['error_94'], __FILE__, __LINE__, $db->error());
        ?>
        <div id="postreview" class="blockpost">
            <h2><span><?php echo $lang['Topic review'] ?></span></h2>
        <?php
        $bg_switch = true;
        $post_count = 0;
        while ($cur_post = $db->fetch_assoc($result))
        {
            $bg_switch = ($bg_switch) ? $bg_switch = false : $bg_switch = true;
            $vtbg = ($bg_switch) ? ' roweven' : ' rowodd';
            $post_count++;
            $cur_post['message'] = BB_Parser::Parse_Message($cur_post['message'], $cur_post['hide_smilies']);
            ?>
                <div class="box<?php echo $vtbg ?>">
                    <div class="inbox">
                        <div class="postleft">
                            <dl>
                                <dt><strong><?php echo BB_Input::Htmlspecialchars($cur_post['poster']) ?></strong></dt>
                                <dd><?php echo BB_Input::Format_Time($cur_post['posted']) ?></dd>
                            </dl>
                        </div>
                        <div class="postright">
                            <div class="postmsg">
            <?php echo $cur_post['message'] ?>
                            </div>
                        </div>
                        <div class="clearer"></div>
                    </div>
                </div>
            <?php
        }
        ?>
        </div>
                            <?php
                        }
                        require FORUM_ROOT . $forum_folder . '/footer.php';
                    }
                    else
                    {
                        $cur_index = 1;
                        if ($fid)
                        {
                            if ($ptype == 0)
                            {
                                $form = '<form id="post" method="post" action="post.php?&amp;fid=' . $fid . '&amp;type=poll">';
                                require FORUM_ROOT . $forum_folder . '/header.php';
                                ?>
            <div class="blockform">
                <h2><span><?php echo $action ?></span></h2>
                <div class="box">
                                <?php echo $form . "\n" ?>
                    <div class="inform">
                        <div class="infldset file" style="padding:10px;">
                            <div class="infldset">
                                <center><select tabindex="<?php echo $cur_index++ ?>" name="ptype">
                                        <option value="1"><?php echo $lang['Regular'] ?>
                                        <option value="2"><?php echo $lang['Multiselect'] ?>
                                        <option value="3"><?php echo $lang['Yesno'] ?>
                                    </select></center>
                            </div>
                        </div>
                        <p><center><input type="button" class="b1" onclick="javascript:history.go(-1);" value="<?php echo $lang['Go back'] ?>">&nbsp;<input type="submit" class="b1" name="submit" value="<?php echo $lang['Submit'] ?>" tabindex="<?php echo $cur_index++ ?>" accesskey="s" /></center></p>
                    </div>
                    </form>
                </div>
            </div>
            <?php
        }
        elseif ($ptype == 1 || $ptype == 2 || $ptype == 3)
        {
            $required_fields = array('req_email' => $lang['E-mail'], 'req_question' => $lang['Question'], 'req_subject' => $lang['Subject'], 'req_message' => $lang['Message']);
            $focus_element = array('post');
            if (!$forum_user['is_guest'])
                $focus_element[] = 'req_question';
            else
            {
                $required_fields['req_username'] = $lang['Guest name'];
                $focus_element[] = 'req_question';
            }
            require FORUM_ROOT . $forum_folder . '/header.php';
            if (!empty($errors))
            {
                ?>
                <div id="posterror" class="blockform">
                    <h2><span><?php echo $lang['Post errors'] ?></span></h2>
                    <div class="box">
                        <div class="inbox" style="padding:10px">
                            <p><?php echo $lang['Post errors info'] ?></p>
                            <ul>
                <?php while (list(, $cur_error) = each($errors))
                    echo "\t\t\t\t" . '<li><strong>' . $cur_error . '</strong></li>' . "\n"; ?>
                            </ul>
                        </div>
                    </div>
                </div>
                                    <?php
                                }
                                else if (isset($_POST['preview']))
                                {
                                    require_once FORUM_ROOT . 'include/functions/Parser.php';
                                    $preview_message = BB_Parser::Parse_Message($message, $hide_smilies);
                                    ?>
                <div id="postpreview" class="blockpost">
                    <h2><span><?php echo $lang['Poll preview'] ?></span></h2>
                    <div class="box">
                        <div class="inbox">
                            <div class="postright">
                                <div class="postmsg">
                        <?php
                        if ($ptype == 1)
                        {
                            echo '<strong>' . BB_Input::Htmlspecialchars($question) . '</strong><br /><br /><form action="" method="POST">';
                            while (list($key, $value) = each($option))
                            {
                                if (!empty($value))
                                    echo '<input type="radio">&nbsp;' . BB_Input::Htmlspecialchars($value) . '<br />';
                            }
                            echo '</form>';
                        }
                        elseif ($ptype == 2)
                        {
                            echo '<strong>' . BB_Input::Htmlspecialchars($question) . '></strong><br /><br /><form action="" method="POST">';
                            while (list($key, $value) = each($option))
                            {
                                if (!empty($value))
                                    echo '<input type="checkbox">&nbsp;' . BB_Input::Htmlspecialchars($value) . '<br />';
                            }
                            echo '</form>';
                        }
                        elseif ($ptype == 3)
                        {
                            echo '<strong>' . BB_Input::Htmlspecialchars($question) . '</strong><br /><br /><form action="" method="POST">';
                            while (list($key, $value) = each($option))
                            {
                                if (!empty($value))
                                    echo '<strong>' . BB_Input::Htmlspecialchars($value) . '</strong><br /><input type="radio"> ' . BB_Input::Htmlspecialchars($yesval) . '<input type="radio"> ' . BB_Input::Htmlspecialchars($noval) . '<br />';
                            }
                            echo '</form>';
                        }
                        ?>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div id="postpreview" class="blockpost">
                    <h2><span><?php echo $lang['Post preview'] ?></span></h2>
                    <div class="box">
                        <div class="inbox">
                            <div class="postright">
                                <div class="postmsg">
                <?php echo $preview_message . "\n" ?>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                                                    <?php
                                                }
                                                if ($ptype == 1)
                                                {
                                                    ?>
                <div class="blockform">
                    <h2><span><?php echo $action ?></span></h2>
                    <div class="box">
                <?php echo $form . "\n" ?>
                        <h2><?php echo $lang['New poll legend'] ?></h2>
                        <div class="inform">
                            <div class="infldset file" style="padding:10px;padding-left:30px">
                                <input type="hidden" name="ptype" value="1" />
                                <fieldset><legend><?php echo $lang['Question'] ?></legend>
                                    <input type="text" class="textbox" name="req_question" value="<?php if (isset($_POST['req_question']))
                            echo BB_Input::Htmlspecialchars($question); ?>" style="width:510px" maxlength="70" tabindex="<?php echo $cur_index++ ?>" />
                                </fieldset>
                                <fieldset><legend><?php echo $lang['Option'] ?></legend>
                                        <?php
                                        for ($x = 1; $x <= bb_poll_max_fields; $x++)
                                        {
                                            ?>
                                        <input class="textbox" type="text" name="poll_option[<?php echo $x; ?>]" value="<?php if (isset($_POST['poll_option'][$x]))
                            echo BB_Input::Htmlspecialchars($option[$x]); ?>" style="width:510px" maxlength="55" tabindex="<?php echo $cur_index++ ?>" /><br /><br />
                                            <?php
                                        }
                                        ?>
                                </fieldset>
                            </div>
                        </div>
                                        <?php
                                    }
                                    elseif ($ptype == 2)
                                    {
                                        ?>
                        <div class="blockform">
                            <h2><span><?php echo $action ?></span></h2>
                            <div class="box">
                                                        <?php echo $form . "\n" ?>
                                <h2><?php echo $lang['New poll legend multiselect'] ?></h2>
                                <div class="inform">
                                    <div class="infldset file" style="padding:10px;padding-left:30px">
                                        <input type="hidden" name="ptype" value="2" />
                                        <fieldset><legend><?php echo $lang['Question'] ?></legend>
                                            <input type="text" class="textbox" name="req_question" value="<?php if (isset($_POST['req_question']))
                            echo BB_Input::Htmlspecialchars($question); ?>" style="width:510px" maxlength="70" tabindex="<?php echo $cur_index++ ?>" />
                                        </fieldset>
                                        <fieldset><legend><?php echo $lang['Option'] ?></legend>
                                        <?php
                                        for ($x = 1; $x <= bb_poll_max_fields; $x++)
                                        {
                                            ?>
                                                <input class="textbox" type="text" name="poll_option[<?php echo $x; ?>]" value="<?php if (isset($_POST['poll_option'][$x]))
                                                echo BB_Input::Htmlspecialchars($option[$x]); ?>" style="width:510px" maxlength="55" tabindex="<?php echo $cur_index++ ?>" /><br /><br />
                    <?php
                }
                ?>
                                        </fieldset>
                                    </div>
                                </div>
                <?php
            }
            elseif ($ptype == 3)
            {
                ?>
                                <div class="blockform">
                                    <h2><span><?php echo $action ?></span></h2>
                                    <div class="box">
                                        <?php echo $form . "\n" ?>
                                        <h2><?php echo $lang['New poll legend yesno'] ?></h2>
                                        <div class="inform">
                                            <div class="infldset file" style="padding:10px;padding-left:30px">
                                                <input type="hidden" name="ptype" value="3" />
                                                <fieldset><legend><?php echo $lang['Question'] ?></legend>
                                                    <input type="text" class="textbox" name="req_question" value="<?php if (isset($_POST['req_question']))
                                    echo BB_Input::Htmlspecialchars($question); ?>" style="width:510px" maxlength="70" tabindex="<?php echo $cur_index++ ?>" />
                                                </fieldset>
                                                <fieldset><legend><?php echo $lang['Poll_Yes'] ?></legend>
                                                    <input type="text" class="textbox" name="poll_yes" value="<?php if (isset($_POST['poll_yes']))
                                            echo BB_Input::Htmlspecialchars($yesval); ?>" style="width:510px" maxlength="35" tabindex="<?php echo $cur_index++ ?>" />
                                                </fieldset>
                                                <fieldset><legend><?php echo $lang['Poll_No'] ?></legend>
                                                    <input type="text" class="textbox" name="poll_no" value="<?php if (isset($_POST['poll_no']))
                                            echo BB_Input::Htmlspecialchars($noval); ?>" style="width:510px" maxlength="35" tabindex="<?php echo $cur_index++ ?>" />
                                                </fieldset>
                                                <fieldset><legend><?php echo $lang['Option'] ?></legend>
                <?php
                for ($x = 1; $x <= bb_poll_max_fields; $x++)
                {
                    ?>
                                                        <input class="textbox" type="text" name="poll_option[<?php echo $x; ?>]" value="<?php if (isset($_POST['poll_option'][$x]))
                                            echo BB_Input::Htmlspecialchars($option[$x]); ?>" style="width:510px" maxlength="55" tabindex="<?php echo $cur_index++ ?>" /><br /><br />
                                                            <?php
                                                        }
                                                        ?>
                                                </fieldset>
                                            </div>
                                        </div>
                                                                <?php
                                                            }
                                                            else
                                                                BB_Functions::Message($lang['Bad request']);
                                                        }
                                                        else
                                                            BB_Functions::Message($lang['Bad request']);
                                                    }
                                                    else
                                                    {
                                                        $page_title = BB_Input::Htmlspecialchars($action);
                                                        $required_fields = array('req_email' => $lang['E-mail'], 'req_question' => $lang['Question'], 'req_subject' => $lang['Subject'], 'req_message' => $lang['Message']);
                                                        $focus_element = array('post');
                                                        if (!$forum_user['is_guest'])
                                                            $focus_element[] = ($fid) ? 'req_subject' : 'req_message';
                                                        else
                                                        {
                                                            $required_fields['req_username'] = $lang['Guest name'];
                                                            $focus_element[] = 'req_username';
                                                        }
                                                        require FORUM_ROOT . $forum_folder . '/header.php';
                                                        if (!empty($errors))
                                                        {
                                                            ?>
                                    <div id="posterror" class="blockform">
                                        <h2><span><?php echo $lang['Post errors'] ?></span></h2>
                                        <div class="box">
                                            <div class="inbox" style="padding:10px">
                                                <p><?php echo $lang['Post errors info'] ?></p>
                                                <ul>
            <?php while (list(, $cur_error) = each($errors))
                echo "\t\t\t\t" . '<li><strong>' . $cur_error . '</strong></li>' . "\n"; ?>
                                                </ul>
                                            </div>
                                        </div>
                                    </div>
                                                <?php
                                            }
                                            else if (isset($_POST['preview']))
                                            {
                                                require_once FORUM_ROOT . 'include/functions/Parser.php';
                                                $preview_message = BB_Parser::Parse_Message($message, $hide_smilies);
                                                ?>
                                    <div id="postpreview" class="blockpost">
                                        <h2><span><?php echo $lang['Post preview'] ?></span></h2>
                                        <div class="box">
                                            <div class="inbox">
                                                <div class="postright">
                                                    <div class="postmsg">
            <?php echo $preview_message . "\n" ?>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                            <?php
                                        }
                                    }
                                    if (($tid) || ($ptype != 0))
                                    {
                                        if ($tid):
                                            $cur_index = 1;
                                            ?>
                                    <div class="blockform">
                                        <h2><span><?php echo $action ?></span></h2>
                                        <div class="box">
                                            <?php echo $form . "\n" ?> <?php endif; ?>
                                        <h2>Message</h2>
                                        <div class="inform file" style="padding:20px">
                                            <div class="infldset txtarea" style="padding:10px;">
        <?php if ($fid): ?><input type="hidden" name="create_poll" value="1" /> <?php endif; ?>
                                                <input type="hidden" name="form_sent" value="1" />
                                                <input type="hidden" name="form_user" value="<?php echo (!$forum_user['is_guest']) ? BB_Input::Htmlspecialchars($forum_user['username']) : 'Guest'; ?>" />
                                            <?php
                                            if ($forum_user['is_guest'])
                                            {
                                                $email_label = (bb_force_guest_email == '1') ? '<strong>' . $lang['E-mail'] . '</strong>' : $lang['E-mail'];
                                                $email_form_name = (bb_force_guest_email == '1') ? 'req_email' : 'email';
                                                ?>
                                                    <fieldset><legend><?php echo $lang['Your data'] ?></legend>
                                                        <input type="text" class="textbox" name="req_username" value="<?php if (isset($_POST['req_username']))
                                    echo BB_Input::Htmlspecialchars($username); ?>" style="width:510px" maxlength="25" tabindex="<?php echo $cur_index++ ?>" /><br /><br />
                                                        <input type="text" class="textbox" name="<?php echo $email_form_name ?>" value="<?php if (isset($_POST[$email_form_name]))
                                    echo BB_Input::Htmlspecialchars($email); ?>" style="width:510px" maxlength="50" tabindex="<?php echo $cur_index++ ?>" />
                                                    </fieldset>
                                            <?php
                                        }
                                        if ($fid)
                                        {
                                            ?>
                                                    <fieldset><legend><?php echo $lang['Topic icons'] ?></legend>
                                                        <div id="topic_icons">
            <?php
            $icons_topic = array();
            $d = dir(FORUM_ROOT . $forum_folder . '/img/general/icons');
            while (($entry = $d->read()) !== false)
            {
                if (substr($entry, strlen($entry) - 4) == '.png')
                    $icons_topic[] = substr($entry, 0, strlen($entry) - 4);
            }
            $d->close();
            if (count($icons_topic) > 1)
            {
                while (list(, $temp) = @each($icons_topic))
                    echo '<input type="radio" name="icon_topic" value="' . $temp . '" />&nbsp;<img src="' . bb_forum_url . 'img/general/icons/' . $temp . '.png" alt="' . $temp . '" />&nbsp;';
                echo '<input type="radio" name="icon_topic" value="0" checked="checked" />&nbsp;None';
            }
            ?>
                                                        </div>
                                                    </fieldset>
                                                    <fieldset><legend><?php echo $lang['Subject'] ?></legend>
                                                        <input type="text" class="textbox" name="req_subject"  value="<?php if (isset($_POST['req_subject']))
                                            echo BB_Input::Htmlspecialchars($subject); ?>" style="width:510px" maxlength="70" tabindex="<?php echo $cur_index++ ?>" />
                                                    </fieldset>
                                    <?php
                                }
                                ?>
                                                <fieldset><legend><?php echo $lang['Formatting'] ?></legend>
                                <?php
                                require FORUM_ROOT . 'include/functions/BBCodes.php';
                                ?>

                                                </fieldset>
                                                <fieldset><legend><?php echo $lang['Message'] ?></legend>
                                                    <textarea name="req_message" id="req_message" class="post" style="width:510px" rows="20" tabindex="<?php echo $cur_index++ ?>"><?php echo isset($_POST['req_message']) ? BB_Input::Htmlspecialchars($message) : (isset($quote) ? $quote : ''); ?></textarea>
                                                </fieldset>
                                                <p style="width:510px"><input type="button" class="b1" onclick="javascript:history.go(-1);" value="<?php echo $lang['Go back'] ?>">&nbsp;<input type="submit" class="b1" name="submit" value="<?php echo $lang['Submit'] ?>" tabindex="<?php echo $cur_index++ ?>" accesskey="s" />&nbsp;<input type="submit" class="b1" name="preview" value="<?php echo $lang['Preview'] ?>" tabindex="<?php echo $cur_index++ ?>" accesskey="p" /></p>
                                            </div>
                                    <?php
                                    $checkboxes = array();
                                    if (!$forum_user['is_guest'])
                                    {
                                        if (bb_smilies == '1')
                                            $checkboxes[] = '<label><input type="checkbox" name="hide_smilies" value="1" tabindex="' . ($cur_index++) . '"' . (isset($_POST['hide_smilies']) ? ' checked="checked"' : '') . ' />' . $lang['Hide smilies'];
                                        if (bb_subscriptions == '1')
                                            $checkboxes[] = '<label><input type="checkbox" name="subscribe" value="1" tabindex="' . ($cur_index++) . '"' . (isset($_POST['subscribe']) ? ' checked="checked"' : '') . ' />' . $lang['Subscribe'];
                                    }
                                    else if (bb_smilies == '1')
                                        $checkboxes[] = '<label><input type="checkbox" name="hide_smilies" value="1" tabindex="' . ($cur_index++) . '"' . (isset($_POST['hide_smilies']) ? ' checked="checked"' : '') . ' />' . $lang['Hide smilies'];
                                    if (!empty($checkboxes))
                                    {
                                        ?>
                                            </div><br />
                                            <div id="div_imageshack" class="file" style="display: none;">
                                                <h2><?php echo $lang['Upload IS'] ?></h2>
                                                <div class="inform">
                                                    <div class="infldset" style="padding:10px;">
                                                        <div class="rbox">
                                                            <iframe src="http://imageshack.us/iframe.php?txtcolor=111111&amp;type=blank&amp;size=30" scrolling="no" allowtransparency="true" frameborder="0" width="280" height="80">Update your browser for ImageShack.us!</iframe><br />
                                                            Note: To include image on post, use the form above and after it is uploaded, choose option "<b>Hotlink for forums (1)</b>, copy and paste inside message box.
                                                        </div>
                                                    </div>
                                                </div>
                                            </div><br />
                                    <?php
                                    $qpost_ids = (isset($_COOKIE['qpostprefs'])) ? $_COOKIE['qpostprefs'] . ',' : FALSE;
                                    if (strstr($qpost_ids, '995,'))
                                    {
                                        $div_ido = "none";
                                        $div_idx = "block";
                                    }
                                    else
                                    {
                                        $div_ido = "block";
                                        $div_idx = "none";
                                    }
                                    ?>
                                            <div id="ido995" class="file" style="display:<?php echo $div_ido ?>">
                                                <h2><span style="float:right"><a href="javascript:xBB_Toggle_Category(995, 0);"><img src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/down.png" alt="+" /></a></span><span><?php echo $lang['Image_Upload'] ?></span></h2>
                                            </div>
                                            <div id="idx995" class="file" style="display:<?php echo $div_idx ?>">
                                                <h2><span style="float:right"><a href="javascript:xBB_Toggle_Category(995, 1);"><img src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/up.png" alt="-" /></a></span><span><?php echo $lang['Image_Upload'] ?></span></h2>
            <?php BB_Image_Upload::Show($cur_posting); ?>
                                            </div><br />
            <?php
            $qpost_ids = (isset($_COOKIE['qpostprefs'])) ? $_COOKIE['qpostprefs'] . ',' : FALSE;
            if (strstr($qpost_ids, '994,'))
            {
                $div_ido = "none";
                $div_idx = "block";
            }
            else
            {
                $div_ido = "block";
                $div_idx = "none";
            }
            ?>
                                            <div id="ido994" class="file" style="display:<?php echo $div_ido ?>">
                                                <h2><span style="float:right"><a href="javascript:xBB_Toggle_Category(994, 0);"><img src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/down.png" alt="+" /></a></span><span><?php echo $lang['Options'] ?></span></h2>
                                            </div>
                                            <div id="idx994" class="file" style="display:<?php echo $div_idx ?>">
                                                <h2><span style="float:right"><a href="javascript:xBB_Toggle_Category(994, 1);"><img src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/up.png" alt="-" /></a></span><span><?php echo $lang['Options'] ?></span></h2>
                                                <div class="inform">
                                                    <div class="infldset" style="padding:10px;">
                                                        <div class="rbox">
            <?php echo implode('<br /></label>' . "\n\t\t\t\t", $checkboxes) . '<br /></label>' . "\n" ?>
            <?php
            if ($fid)
            {
                ?>
                                                                <label><?php echo $lang['Tags']; ?>&nbsp;&nbsp;<input type="text" class="textbox" name="tags" value="<?php if (isset($_POST['tags']))
                    echo BB_Input::Htmlspecialchars($tags); ?>" style="width:400px" maxlength="70" tabindex="<?php echo $cur_index++ ?>" /><br /></label>
                <?php
            }
            ?>
                                                        </div>
                                                    </div>
            <?php
        }
        ?>
                                            </div>
                                        </div>
                                        </form>
                                    </div>
                                </div>
        <?php
        if ($tid && bb_topic_review != '0')
        {
            require_once FORUM_ROOT . 'include/functions/Parser.php';
            $result = $db->query('SELECT poster, message, hide_smilies, posted FROM ' . $db->prefix . 'posts WHERE topic_id=' . $db->escape($tid) . ' ORDER BY id DESC LIMIT ' . bb_topic_review) or BB_Functions::Error($lang['error_94'], __FILE__, __LINE__, $db->error());
            ?>
                                    <div id="postreview" class="blockpost">
                                        <h2><span><?php echo $lang['Topic review'] ?></span></h2>
            <?php
            $bg_switch = true;
            $post_count = 0;
            while ($cur_post = $db->fetch_assoc($result))
            {
                $bg_switch = ($bg_switch) ? $bg_switch = false : $bg_switch = true;
                $vtbg = ($bg_switch) ? ' roweven' : ' rowodd';
                $post_count++;
                $cur_post['message'] = BB_Parser::Parse_Message($cur_post['message'], $cur_post['hide_smilies']);
                ?>
                                            <div class="box<?php echo $vtbg ?>">
                                                <div class="inbox">
                                                    <div class="postleft">
                                                        <dl>
                                                            <dt><strong><?php echo BB_Input::Htmlspecialchars($cur_post['poster']) ?></strong></dt>
                                                            <dd><?php echo BB_Input::Format_Time($cur_post['posted']) ?></dd>
                                                        </dl>
                                                    </div>
                                                    <div class="postright">
                                                        <div class="postmsg">
                <?php echo $cur_post['message'] ?>
                                                        </div>
                                                    </div>
                                                    <div class="clearer"></div>
                                                </div>
                                            </div>
                <?php
            }
            ?>
                                    </div>
            <?php
        }
    }
    require FORUM_ROOT . $forum_folder . '/footer.php';
}
?>
