<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
require dirname(__FILE__) . '/../include/init.php';
if ($forum_user['g_read_board'] == '0')
    BB_Functions::Message($lang['No permission'], true, 1);
$action = isset($_GET['action']) ? BB_Input::Htmlspecialchars($_GET['action']) : null;
$type = isset($_GET['type']) ? BB_Input::Htmlspecialchars($_GET['type']) : 'topic';
$id = isset($_GET['id']) ? intval($_GET['id']) : 0;
$pid = isset($_GET['pid']) ? intval($_GET['pid']) : 0;
$rate = isset($_GET['rate']) ? intval($_GET['rate']) : 0;
$do_rate = isset($_GET['do_rate']) ? 1 : 0;
if ($id < 1 && $pid < 1)
    BB_Functions::Message($lang['Bad request']);
require_once FORUM_ROOT . 'include/functions/Parser.php';
if ($do_rate)
{
    if ($rate >= 0 && $rate <= 5)
    {
        $result = $db->query('UPDATE ' . $db->prefix . 'topics SET rating=rating +' . $db->escape($rate) . ' WHERE id=' . $db->escape($id));
        $result = $db->query('UPDATE ' . $db->prefix . 'topics SET rating_votes=rating_votes+1 WHERE id=' . $db->escape($id));
        BB_Functions::Redirect('topic.php?type=' . $type . '&id=' . $id, $lang['rate_redirect']);
    }
}
if ($pid)
{
    $result = $db->query('SELECT topic_id FROM ' . $db->prefix . 'posts WHERE id=' . $db->escape($pid)) or BB_Functions::Error($lang['error_3'], __FILE__, __LINE__, $db->error());
    if (!$db->num_rows($result))
        BB_Functions::Message($lang['Bad request']);
    $id = $db->result($result);
    $result = $db->query('SELECT id FROM ' . $db->prefix . 'posts WHERE topic_id=' . $db->escape($id) . ' ORDER BY posted' . ($forum_user['reverse_posts'] ? ' DESC' : '')) or BB_Functions::Error($lang['error_3'], __FILE__, __LINE__, $db->error());
    $num_posts = $db->num_rows($result);
    for ($i = 0; $i < $num_posts; ++$i)
    {
        $cur_id = $db->result($result, $i);
        if ($cur_id == $pid)
            break;
    }
    ++$i;
    $_GET['p'] = ceil($i / $forum_user['disp_posts']);
}
else if ($action == 'new' && !$forum_user['is_guest'])
{
    if (!empty($forum_user['read_topic']['t'][$id]))
        $last_read = $forum_user['read_topic']['t'][$id];
    else
        $last_read = $forum_user['last_visit'];
    $result = $db->query('SELECT MIN(id) FROM ' . $db->prefix . 'posts WHERE topic_id=' . $db->escape($id) . ' AND posted>' . $last_read) or BB_Functions::Error($lang['error_3'], __FILE__, __LINE__, $db->error());
    $first_new_post_id = $db->result($result);
    if ($first_new_post_id)
        header('Location: topic.php?pid=' . $first_new_post_id . '#p' . $first_new_post_id);
    else
        header('Location: topic.php?type=' . $type . '&id=' . $id . '&action=last');
    exit;
}
else if ($action == 'last')
{
    $result = $db->query('SELECT MAX(id) FROM ' . $db->prefix . 'posts WHERE topic_id=' . $db->escape($id)) or BB_Functions::Error($lang['error_3'], __FILE__, __LINE__, $db->error());
    $last_post_id = $db->result($result);
    if ($last_post_id)
    {
        header('Location: topic.php?type=' . $type . '&pid=' . $last_post_id . '#p' . $last_post_id);
        exit;
    }
}
if (!$forum_user['is_guest'])
    $result = $db->query('SELECT pf.forum_name AS parent_forum, f.parent_forum_id, t.question, t.yes, t.no, t.subject, t.tags, t.rating, t.rating_votes, t.closed, t.num_replies, t.sticky, t.last_post, f.id AS forum_id, f.forum_name, f.moderators, fp.post_replies, s.user_id AS is_subscribed FROM ' . $db->prefix . 'topics AS t INNER JOIN ' . $db->prefix . 'forums AS f ON f.id=t.forum_id LEFT JOIN ' . $db->prefix . 'subscriptions AS s ON (t.id=s.topic_id AND s.user_id=' . $forum_user['id'] . ') LEFT JOIN ' . $db->prefix . 'permissions AS fp ON (fp.forum_id=f.id AND fp.gid=' . $forum_user['g_id'] . ') LEFT JOIN ' . $db->prefix . 'forums AS pf ON f.parent_forum_id=pf.id WHERE (fp.read_forum IS NULL OR fp.read_forum=1) AND t.id=' . $db->escape($id) . ' AND t.moved_to IS NULL') or BB_Functions::Error($lang['error_4'], __FILE__, __LINE__, $db->error());
else
    $result = $db->query('SELECT pf.forum_name AS parent_forum, f.parent_forum_id, t.subject, t.tags, t.question, t.yes, t.no, t.rating, t.rating_votes, t.closed, t.num_replies, t.sticky, f.id AS forum_id, f.forum_name, f.moderators, fp.post_replies, 0 FROM ' . $db->prefix . 'topics AS t INNER JOIN ' . $db->prefix . 'forums AS f ON f.id=t.forum_id LEFT JOIN ' . $db->prefix . 'permissions AS fp ON (fp.forum_id=f.id AND fp.gid=' . $forum_user['g_id'] . ') LEFT JOIN ' . $db->prefix . 'forums AS pf ON f.parent_forum_id=pf.id WHERE (fp.read_forum IS NULL OR fp.read_forum=1) AND t.id=' . $db->escape($id) . ' AND t.moved_to IS NULL') or BB_Functions::Error($lang['error_4'], __FILE__, __LINE__, $db->error());
if (!$db->num_rows($result))
    BB_Functions::Message($lang['Bad request']);
$cur_topic = $db->fetch_assoc($result);
if (!$forum_user['is_guest'])
    BB_Core::Set_Topic_Read($id, $cur_topic['forum_id'], $cur_topic['last_post']);
$mods_array = ($cur_topic['moderators'] != '') ? unserialize($cur_topic['moderators']) : array();
$is_admmod = ($forum_user['g_id'] == USER_ADMIN || ($forum_user['g_id'] == USER_MOD && array_key_exists($forum_user['username'], $mods_array)) || $forum_user['g_global_moderation']) ? true : false;
if ($type == 'poll')
{
    if ($cur_topic['closed'] == '0')
    {
        if (($cur_topic['post_replies'] == '' && $forum_user['g_post_replies'] == '1') || $cur_topic['post_replies'] == '1' || $is_admmod)
            $post_link = '<a href="post.php?type=' . $type . '&amp;tid=' . $id . '" title="' . $lang['Post a reply'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/new_reply.png" alt="' . $lang['Post a reply'] . '" /></a>';
        else
            $post_link = '<a href="login.php" title="' . $lang['Post a reply'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/new_reply.png" alt="' . $lang['Post a reply'] . '" /></a>';
    }
    else
        $post_link = '<img src="' . BB_Template::Get_Image_Folder() . 'buttons/topic_closed.png" alt="' . $lang['Topic closed'] . '" />';
}
else
{
    if ($cur_topic['closed'] == '0')
    {
        if (($cur_topic['post_replies'] == '' && $forum_user['g_post_replies'] == '1') || $cur_topic['post_replies'] == '1' || $is_admmod)
            $post_link = '<a href="post.php?type=' . $type . '&amp;tid=' . $id . '" title="' . $lang['Post a reply'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/new_reply.png" alt="' . $lang['Post a reply'] . '" /></a>';
        else
            $post_link = '<a href="login.php" title="' . $lang['Post a reply'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/new_reply.png" alt="' . $lang['Post a reply'] . '" /></a>';
    }
    else
        $post_link = '<img src="' . BB_Template::Get_Image_Folder() . 'buttons/topic_closed.png" alt="' . $lang['Topic closed'] . '" />';
}
$num_pages = ceil(($cur_topic['num_replies'] + 1) / $forum_user['disp_posts']);
$p = (!isset($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $num_pages) ? 1 : $_GET['p'];
$start_from = $forum_user['disp_posts'] * ($p - 1);
if (bb_rewrite_urls == '1')
    $paging_links = '<strong class="pagination">' . $lang['Pages'] . '</strong> ' . BB_Core::Paginate($num_pages, $p, 't' . $id . '-page', true);
else
    $paging_links = '<strong class="pagination">' . $lang['Pages'] . '</strong> ' . BB_Core::Paginate($num_pages, $p, 'topic.php?id=' . $id, true);
if (bb_censoring == '1')
    $cur_topic['subject'] = BB_Input::Censor_Words($cur_topic['subject']);
$quickpost = false;
if (bb_quickpost == '1' && !$forum_user['is_guest'] && ($cur_topic['post_replies'] == '1' || ($cur_topic['post_replies'] == '' && $forum_user['g_post_replies'] == '1')) && ($cur_topic['closed'] == '0' || $is_admmod))
{
    $required_fields = array('req_message' => $lang['Message']);
    $quickpost = true;
}
$subscraction = '<div class="clearer"></div>' . "\n";
$result = $db->query('SELECT message FROM ' . $db->prefix . 'posts WHERE topic_id = ' . $db->escape($id) . ' LIMIT 1') or BB_Functions::Error($lang['error_4'], __FILE__, __LINE__, $db->error());
if (!$db->num_rows($result))
    BB_Functions::Message($lang['Bad request']);
$page_meta_description = $db->result($result);
$page_meta_description = BB_Parser::Do_BBCode_Preview(str_replace('"', "''", preg_replace('#[\n\r]+#s', ' ', $page_meta_description)));
if (strlen($page_meta_description) > 70)
    $page_meta_description = substr($page_meta_description, 0, 70) . '...';
if ($cur_topic['question'])
    $page_title = BB_Input::Htmlspecialchars($cur_topic['question'] . ' - ' . $cur_topic['subject']);
else
    $page_title = BB_Input::Htmlspecialchars($cur_topic['subject']);
define('ALLOW_INDEX', 1);
require FORUM_ROOT . $forum_folder . '/header.php';
?>
<div class="linkst">
    <div class="inbox">
        <p class="pagelink conl"><?php echo $paging_links ?></p>
        <p class="conr"><?php echo $post_link ?></p>
        <?php
        if ($cur_topic['parent_forum'])
            echo "\t\t" . '<ul><li><a href="index.php">' . $lang['Index'] . '</a>&nbsp;</li><li>&raquo;&nbsp;<a href="' . BB_Input::Rewrite_URL("f", $cur_topic['parent_forum_id'], $cur_topic['parent_forum']) . '">' . BB_Input::Htmlspecialchars($cur_topic['parent_forum']) . '</a>&nbsp;</li><li>&raquo;&nbsp;<a href="' . BB_Input::Rewrite_URL("f", $cur_topic['forum_id'], $cur_topic['forum_name']) . '">' . BB_Input::Htmlspecialchars($cur_topic['forum_name']) . '</a>&nbsp;</li><li>&raquo;&nbsp;' . BB_Input::Htmlspecialchars($cur_topic['subject']) . '</li></ul>';
        else
            echo "\t\t" . '<ul><li><a href="index.php">' . $lang['Index'] . '</a></li><li>&nbsp;&raquo;&nbsp;<a href="' . BB_Input::Rewrite_URL("f", $cur_topic['forum_id'], $cur_topic['forum_name']) . '">' . BB_Input::Htmlspecialchars($cur_topic['forum_name']) . '</a></li><li>&nbsp;&raquo;&nbsp;' . BB_Input::Htmlspecialchars($cur_topic['subject']) . '</li></ul>';
        ?>
        <div class="clearer"></div>
    </div>
</div>
<?php
$bg_switch = true;
$post_count = 0;
if ($type == 'poll')
{
    $result = $db->query('SELECT ptype,options,voters,votes FROM ' . $db->prefix . 'polls WHERE pollid=' . $db->escape($id) . '') or BB_Functions::Error($lang['error_115'], __FILE__, __LINE__, $db->error());
    if (!$db->num_rows($result))
        BB_Functions::Message($lang['Bad request']);
    $cur_poll = $db->fetch_assoc($result);
    $options = unserialize($cur_poll['options']);
    if (!empty($cur_poll['voters']))
        $voters = unserialize($cur_poll['voters']);
    else
        $voters = array();
    $ptype = $cur_poll['ptype'];
    $firstcheck = false;
    ?>
    <div class="blockform">
        <h2><span><?php echo $lang['Poll'] ?> - <?php echo BB_Input::Htmlspecialchars($cur_topic['question']) ?></span></h2>
        <div class="box">
                            <?php
                            if ((!$forum_user['is_guest']) && (!in_array($forum_user['id'], $voters)) && ($cur_topic['closed'] == '0'))
                            {
                                $showsubmit = true;
                                ?>
                <form id="post" method="post" action="vote.php">
                    <div class="inform">
                        <div class="rbox" style="text-align:center;">
                            <input type="hidden" name="poll_id" value="<?php echo $id; ?>" />
                            <input type="hidden" name="form_sent" value="1" />
                            <input type="hidden" name="form_user" value="<?php echo (!$forum_user['is_guest']) ? BB_Input::Htmlspecialchars($forum_user['username']) : 'Guest'; ?>" /><strong><?php echo BB_Input::Htmlspecialchars($cur_topic['question']) ?></strong><br /><br />
                            <table style="width:auto;table-layout:auto;text-align:left">
                                <?php
                                if ($ptype == 1)
                                {
                                    while (list($key, $value) = each($options))
                                    {
                                        ?>
                                        <tr><td style="width:10;border:0;"><input name="vote" <?php if (!$firstcheck)
                        {
                            echo "checked";
                            $firstcheck = true;
                        }; ?> type="radio" value="<?php echo $key ?>"></td><td style="border:0;width:auto;"><span><?php echo BB_Input::Htmlspecialchars($value); ?></span></td></tr>
                                                    <?php
                                                }
                                            }
                                            elseif ($ptype == 2)
                                            {
                                                while (list($key, $value) = each($options))
                                                {
                                                    ?>
                                        <tr><td style="width:10;border:0;"><input name="options[<?php echo $key ?>]" type="checkbox" value="1"></td><td style="border:0;width:auto;"><span><?php echo BB_Input::Htmlspecialchars($value); ?></span></td></tr>
                                                    <?php
                                                }
                                            }
                                            elseif ($ptype == 3)
                                            {
                                                while (list($key, $value) = each($options))
                                                {
                                                    ?>
                                        <tr><td style="width: auto; border: 0;"><?php echo BB_Input::Htmlspecialchars($value); ?></td><td style="border: 0; width: auto;"><input name="options[<?php echo $key ?>]" checked type="radio" value="yes"> <?php echo $cur_topic['yes']; ?></td><td style="BORDER: 0; WIDTH: auto;"><input name="options[<?php echo $key ?>]" type="radio" value="no"> <?php echo $cur_topic['no']; ?></td></tr>
                                                    <?php
                                                }
                                            }
                                            else
                                                BB_Functions::Message($lang['Bad request']);
                                        }
                                        else
                                        {
                                            $showsubmit = false;
                                            ?>
                                <div class="inform">
                                    <div class="rbox" style="text-align:center;">
                                        <table style="width:auto;table-layout:auto;text-align:left">
                                            <?php
                                            if (!empty($cur_poll['votes']))
                                                $votes = unserialize($cur_poll['votes']);
                                            else
                                                $votes = array();
                                            if ($ptype == 1 || $ptype == 2)
                                            {
                                                $total = 0;
                                                $percent = 0;
                                                $percent_int = 0;
                                                while (list($key, $val) = each($options))
                                                {
                                                    if (isset($votes[$key]))
                                                        $total += $votes[$key];
                                                }
                                                reset($options);
                                            }
                                            while (list($key, $value) = each($options))
                                            {
                                                if ($ptype == 1 || $ptype == 2)
                                                {
                                                    if (isset($votes[$key]))
                                                    {
                                                        $percent = $votes[$key] * 100 / $total;
                                                        $percent_int = floor($percent);
                                                    }
                                                    if (isset($votes[$key]))
                                                        $vote_bar = '<span><img src="' . BB_Template::Get_Image_Folder() . 'misc/bar.png" width="' . $percent_int . '" height="12px" alt="" /></span>';
                                                    else
                                                        $vote_bar = '<span><img src="' . BB_Template::Get_Image_Folder() . 'misc/bar.png" height="12px" alt="" /></span>';
                                                    ?>
                                                    <tr>
                                                        <td style="border:0;width:auto"><?php echo BB_Input::Htmlspecialchars($value); ?></td>
                                                        <td style="border:0;width:auto"><?php echo $vote_bar ?></td>
                                                        <td style="border:0;width:auto"><?php if (isset($votes[$key]))
                                        echo $percent_int . "% - " . $votes[$key]; else
                                        echo ' 0% - 0'; ?></td>
                                                    </tr>
                                                        <?php
                                                    }
                                                    else if ($ptype == 3)
                                                    {
                                                        $total = 0;
                                                        $yes_percent = 0;
                                                        $no_percent = 0;
                                                        $vote_yes = 0;
                                                        $vote_no = 0;
                                                        if (isset($votes[$key]['yes']))
                                                            $vote_yes = $votes[$key]['yes'];
                                                        if (isset($votes[$key]['no']))
                                                            $vote_no += $votes[$key]['no'];
                                                        $total = $vote_yes + $vote_no;
                                                        if (isset($votes[$key]))
                                                        {
                                                            $yes_percent = floor(($vote_yes * 100) / $total);
                                                            $no_percent = floor(($vote_no * 100) / $total);
                                                        }
                                                        if (isset($votes[$key]))
                                                        {
                                                            $vote_bar_yes = '<span><img src="' . BB_Template::Get_Image_Folder() . 'misc/bar.png" width="' . $yes_percent . '" height="12px" alt="" /></span>';
                                                            $vote_bar_no = '<span><img src="' . BB_Template::Get_Image_Folder() . 'misc/bar.png" width="' . $no_percent . '" height="12px" alt="" /></span>';
                                                        }
                                                        if ($yes_percent == 0)
                                                            $vote_bar_yes = '<span><img src="' . BB_Template::Get_Image_Folder() . 'misc/bar.png" height="12px" alt="" /></span>';
                                                        if ($no_percent == 0)
                                                            $vote_bar_no = '<span><img src="' . BB_Template::Get_Image_Folder() . 'misc/bar.png" height="12px" alt="" /></span>';
                                                        ?>
                                                    <tr>
                                                        <td style="border:0;width:auto"><?php echo BB_Input::Htmlspecialchars($value); ?></td>
                                                        <td style="border:0;width:auto"><b><?php echo $cur_topic['yes']; ?></b></td>
                                                        <td style="border:0;width:auto"><?php echo $vote_bar_yes; ?></td>
                                                        <td style="border:0;width:auto"><?php if (isset($votes[$key]['yes']))
                    echo $yes_percent . "% - " . $votes[$key]['yes']; else
                    echo "0% - " . 0; ?></td>
                                                        <td style="border:0;width:auto"><b><?php echo $cur_topic['no']; ?></b></td>
                                                        <td style="border:0;width:auto"><?php echo $vote_bar_no; ?></td>
                                                        <td style="border:0;width:auto"><?php if (isset($votes[$key]['no']))
                    echo $no_percent . "% - " . $votes[$key]['no']; else
                    echo "0% - " . 0; ?></td>
                                                    </tr>
                            <?php
                        }
                        else
                            BB_Functions::Message($lang['Bad request']);
                    }
                    ?>
                                            <tr>
                                                <td colspan="7" style="border:0;width:auto"><div style="text-align:center;"><?php echo $lang['Total'] ?>: <?php echo $total; ?> <?php echo $lang['vote(s)'] ?></div></td>
                    <?php
                }
                ?>
                                        </tr>
                                    </table>
                                </div>
                            </div>
                <?php
                if ($showsubmit == true)
                {
                    ?>
                                <p align="center"><input type="submit" class="b1" name="submit" tabindex="2" value="<?php echo $lang['Submit'] ?>" accesskey="s" /> <input type="submit" class="b1" name="null" tabindex="2" value="<?php echo $lang['Null vote'] ?>" accesskey="n" /></p>
                    <?php
                }
                ?>
                            </form>
                    </div>
                </div>
                <?php
            }
            $result = $db->query("SELECT COUNT(*) FROM " . $db->prefix . "posts WHERE topic_id=" . $db->escape($id)) or BB_Functions::Error($lang['error_7'], __FILE__, __LINE__, $db->error());
            $num_posts = $db->result($result);
            $result = $db->query('SELECT DISTINCT u.email, u.sex, u.title, u.url, u.yahoo, u.location, u.use_avatar, u.signature, u.email_setting, u.num_posts, u.registered, u.admin_note, u.country, SUM(r.rep_plus) AS count_rep_plus, SUM(r.rep_minus) AS count_rep_minus, u.reputation_enable, p.id, p.topic_id, p.poster AS username, p.poster_id, p.poster_ip, p.poster_email, p.message, p.hide_smilies, p.posted, p.edited, p.edited_by, g.g_id, g.g_title, g.g_user_title, g.g_color, o.user_id AS is_online FROM ' . $db->prefix . 'posts AS p INNER JOIN ' . $db->prefix . 'users AS u ON u.id=p.poster_id INNER JOIN ' . $db->prefix . 'usergroups AS g ON g.g_id=u.gid LEFT JOIN ' . $db->prefix . 'online AS o ON (o.user_id=u.id AND o.user_id!=1 AND o.idle=0) LEFT JOIN ' . $db->prefix . 'reputation as r ON (r.user_id=u.id) WHERE p.topic_id=' . $db->escape($id) . ' GROUP BY p.id ORDER BY p.id ' . ($forum_user['reverse_posts'] ? 'DESC ' : '') . 'LIMIT ' . $start_from . ',' . $forum_user['disp_posts'], true) or BB_Functions::Error($lang['error_3'], __FILE__, __LINE__, $db->error());
            while ($cur_post = $db->fetch_assoc($result))
            {
                $post_count++;
                $user_avatar = '';
                $user_info = array();
                $user_contacts = array();
                $post_actions = array();
                if ($cur_post['g_color'] == '')
                    $cur_post['g_color'] = '#000000';
                $is_online = '';
                $signature = '';
                if ($cur_post['poster_id'] > 1)
                {
                    $rank_icons = "";
                    if (bb_ranks_enable)
                    {
                        if ($cur_post['num_posts'] > 5000)
                            $num_ranks = 10;
                        elseif ($cur_post['num_posts'] > 3000 && $cur_post['num_posts'] < 5000)
                            $num_ranks = 9;
                        elseif ($cur_post['num_posts'] > 2000 && $cur_post['num_posts'] < 3000)
                            $num_ranks = 8;
                        elseif ($cur_post['num_posts'] > 1000 && $cur_post['num_posts'] < 2000)
                            $num_ranks = 7;
                        elseif ($cur_post['num_posts'] > 500 && $cur_post['num_posts'] < 1000)
                            $num_ranks = 6;
                        elseif ($cur_post['num_posts'] > 300 && $cur_post['num_posts'] < 500)
                            $num_ranks = 5;
                        elseif ($cur_post['num_posts'] > 100 && $cur_post['num_posts'] < 300)
                            $num_ranks = 4;
                        elseif ($cur_post['num_posts'] > 50 && $cur_post['num_posts'] < 100)
                            $num_ranks = 3;
                        elseif ($cur_post['num_posts'] > 30 && $cur_post['num_posts'] < 50)
                            $num_ranks = 2;
                        elseif ($cur_post['num_posts'] > 10 && $cur_post['num_posts'] < 50)
                            $num_ranks = 1;
                        else
                            $num_ranks = 0;
                        if ($cur_post['g_id'] == 1)
                            $rank_icons = '<img style="border:0;" src="' . BB_Template::Get_Image_Folder() . 'ranks/rank_1.png" alt="' . $lang['Administrator'] . '" />';
                        else if ($cur_post['g_id'] == 2)
                            $rank_icons = '<img style="border:0;" src="' . BB_Template::Get_Image_Folder() . 'ranks/rank_2.png" alt="' . $lang['Moderator'] . '" />';
                        else if ($img_size = @getimagesize(FORUM_ROOT . 'include/templates/' . $forum_user['template'] . '/img/ranks/rank_' . $cur_post['g_id'] . '.png'))
                            $rank_icons = '<img style="border:0;" src="' . BB_Template::Get_Image_Folder() . 'ranks/rank_' . $cur_post['g_id'] . '.png" alt="" />';
                        else
                            $rank_icons = '<img style="border:0;" src="' . BB_Template::Get_Image_Folder() . 'ranks/stars_' . $num_ranks . '.png" alt="' . $lang['Ranks'] . '" />';
                    }
                    $username = '<a href="' . BB_Input::Rewrite_URL("u", $cur_post['poster_id'], $cur_post['username']) . '"><span style="color:' . $cur_post['g_color'] . '">' . BB_Input::Htmlspecialchars($cur_post['username']) . '</span></a>';
                    $user_title = BB_Core::Get_User_Title($cur_post);
                    $user_country = $cur_post['country'];
                    if (bb_censoring == '1')
                        $user_title = BB_Input::Censor_Words($user_title);
                    $is_online = ($cur_post['is_online'] == $cur_post['poster_id']) ? '<strong>&nbsp;</strong>' : '&nbsp;';
                    if (bb_avatars == '1' && $cur_post['use_avatar'] == '1' && $forum_user['show_avatars'] != '0')
                    {
                        if ($img_size = @getimagesize(bb_avatars_dir . '/' . $cur_post['poster_id'] . '.gif'))
                            $user_avatar = '<img src="' . bb_avatars_dir . '/' . $cur_post['poster_id'] . '.gif" ' . $img_size[3] . ' alt="" />';
                        else if ($img_size = @getimagesize(bb_avatars_dir . '/' . $cur_post['poster_id'] . '.jpg'))
                            $user_avatar = '<img src="' . bb_avatars_dir . '/' . $cur_post['poster_id'] . '.jpg" ' . $img_size[3] . ' alt="" />';
                        else if ($img_size = @getimagesize(bb_avatars_dir . '/' . $cur_post['poster_id'] . '.png'))
                            $user_avatar = '<img src="' . bb_avatars_dir . '/' . $cur_post['poster_id'] . '.png" ' . $img_size[3] . ' alt="" />';
                    }
                    else
                        $user_avatar = '<img src="' . bb_avatars_dir . '/noavatar.png" alt="" />';
                    if (bb_avatars == '1' && $forum_user['show_avatars'] != '1')
                        $user_avatar = '';
                    if (bb_show_user_info == '1')
                    {
                        if ($cur_post['sex'] != '')
                        {
                            if ($cur_post['sex'] == 'male')
                                $user_info[] = '<dd class="info">' . $lang['Sex'] . ': <img style="border:0;" src="' . BB_Template::Get_Image_Folder() . 'misc/male.png" alt="" />';
                            else
                                $user_info[] = '<dd class="info">' . $lang['Sex'] . ': <img style="border:0;" src="' . BB_Template::Get_Image_Folder() . 'misc/female.png" alt="" />';
                        }
                        if ($cur_post['location'] != '')
                        {
                            if (bb_censoring == '1')
                                $cur_post['location'] = BB_Input::Censor_Words($cur_post['location']);
                            $user_info[] = '<dd class="info">' . $lang['From'] . ': ' . BB_Input::Htmlspecialchars($cur_post['location']);
                        }
                        $user_info[] = '<dd class="info">' . $lang['Registered'] . ': ' . date(bb_date_format, $cur_post['registered']);
                        if (bb_show_post_count == '1' || $forum_user['g_id'] < USER_GUEST)
                            $user_info[] = '<dd class="info">' . $lang['Posts'] . ': ' . $cur_post['num_posts'];
                        if ($forum_user['g_id'] < USER_GUEST || $forum_user['g_global_moderation'])
                            $user_contacts[] = '<a href="moderate.php?get_host=' . $cur_post['id'] . '" rel="nofollow" title="' . $cur_post['poster_ip'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/btn_icon_ip.png" alt="' . $cur_post['poster_ip'] . '" /></a>';
                        if (($cur_post['email_setting'] == '0' && !$forum_user['is_guest']) || $forum_user['g_id'] < USER_GUEST)
                            $user_contacts[] = '<a href="mailto:' . $cur_post['email'] . '" rel="nofollow" title="' . $lang['Send e-mail'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/btn_icon_email.png" alt="' . $lang['Send e-mail'] . '" /></a>';
                        else if ($cur_post['email_setting'] == '1' && !$forum_user['is_guest'])
                            $user_contacts[] = '<a href="misc.php?email=' . $cur_post['poster_id'] . '" rel="nofollow" title="' . $lang['Send e-mail'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/btn_icon_email.png" alt="' . $lang['Send e-mail'] . '" /></a>';
                        if (bb_pms_enabled && !$forum_user['is_guest'] && $forum_user['g_pm'] == 1)
                        {
                            $pid = isset($cur_post['poster_id']) ? $cur_post['poster_id'] : $cur_post['id'];
                            $user_contacts[] = '<a href="messages.php?Page=Send&id=' . $pid . '&tid=' . $id . '" rel="nofollow" title="' . $lang['Quick message'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/btn_icon_pm.png" alt="' . $lang['Quick message'] . '" /></a>';
                        }
                        if ($cur_post['url'] != '')
                            $user_contacts[] = '<a href="' . BB_Input::Htmlspecialchars($cur_post['url']) . '" rel="nofollow" title="' . $lang['Visit website'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/btn_icon_www.png" alt="' . $lang['Visit website'] . '" /></a>';
                    }
                    if ($forum_user['g_id'] < USER_GUEST || $forum_user['g_global_moderation'])
                    {
                        if ($cur_post['admin_note'] != '')
                            $user_info[] = '<dd class="info">' . $lang['Note'] . ': <strong>' . BB_Input::Htmlspecialchars($cur_post['admin_note']) . '</strong>';
                    }
                }
                else
                {
                    $username = BB_Input::Htmlspecialchars($cur_post['username']);
                    $user_title = BB_Core::Get_User_Title($cur_post);
                    if ($forum_user['g_id'] < USER_GUEST || $forum_user['g_global_moderation'])
                        $user_contacts[] = '<a href="moderate.php?get_host=' . $cur_post['id'] . '" rel="nofollow" title="' . $cur_post['poster_ip'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/btn_icon_ip.png" alt="' . $cur_post['poster_ip'] . '" /></a>';
                    if (bb_show_user_info == '1' && $cur_post['poster_email'] != '' && !$forum_user['is_guest'])
                        $user_contacts[] = '<a href="mailto:' . $cur_post['poster_email'] . '" rel="nofollow" title="' . $lang['Send e-mail'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/btn_icon_email.png" alt="' . $lang['Send e-mail'] . '" /></a>';
                }
                if (!$is_admmod)
                {
                    if (!$forum_user['is_guest'])
                    {
                        $post_actions[] = '<li class="postreport"><a href="misc.php?report=' . $cur_post['id'] . '&amp;type=' . $type . '" rel="nofollow" title="' . $lang['Report'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/btn_icon_report.png" alt="' . $lang['Report'] . '" /></a>';
                        $post_actions[] = '<li class="postforward"><a href="misc.php?forward=' . $forum_user['id'] . '&amp;type=' . $type . '&amp;pid=' . $cur_post['id'] . '" rel="nofollow" title="' . $lang['Forward'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/btn_forward.png" alt="' . $lang['Forward'] . '" /></a>';
                    }
                    if ($cur_topic['closed'] == '0')
                    {
                        if ($cur_post['poster_id'] == $forum_user['id'])
                        {
                            if ((($start_from + $post_count) == 1 && $forum_user['g_delete_topics'] == '1') || (($start_from + $post_count) > 1 && $forum_user['g_delete_posts'] == '1'))
                                $post_actions[] = '<li class="postdelete"><a href="delete.php?id=' . $cur_post['id'] . '" rel="nofollow" title="' . $lang['Delete'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/btn_delete.png" alt="' . $lang['Delete'] . '" /></a>';
                            if ($forum_user['g_edit_posts'] == '1')
                                $post_actions[] = '<li class="postedit"><a href="edit.php?id=' . $cur_post['id'] . '" rel="nofollow" title="' . $lang['Edit'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/btn_edit.png" alt="' . $lang['Edit'] . '" /></a>';
                        }
                        if (($cur_topic['post_replies'] == '' && $forum_user['g_post_replies'] == '1') || $cur_topic['post_replies'] == '1')
                        {
                            if ($forum_user['is_guest'] || !$quickpost)
                                $post_actions[] = '<li class="postquote"><a href="post.php?type=' . $type . '&amp;tid=' . $id . '&amp;qid=' . $cur_post['id'] . '" rel="nofollow" title="' . $lang['Quote'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/btn_quote.png" alt="' . $lang['Quote'] . '" /></a>';
                            else
                                $post_actions[] = '<li class="postquote"><a href="post.php?type=' . $type . '&amp;tid=' . $id . '&amp;qid=' . $cur_post['id'] . '" rel="nofollow" title="' . $lang['Quote'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/btn_qquote1.png" alt="' . $lang['Quote'] . '" /></a><a href="javascript:xBB_Toggle_Category(999, 0);xBB_Insert_Text(\'[quote=' . BB_Input::Htmlspecialchars($cur_post['username']) . ']' . $db->escape(BB_Input::Htmlspecialchars($cur_post['message'])) . '[/quote]\',\'\');" rel="nofollow" title="' . $lang['Multi quote'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/btn_qquote2.png" alt="' . $lang['Multi quote'] . '" /></a>';
                        }
                    }
                }
                else
                {
                    if (!$quickpost)
                        $post_actions[] = '<li class="postreport"><a href="misc.php?report=' . $cur_post['id'] . '&amp;type=' . $type . '" rel="nofollow" title="' . $lang['Report'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/btn_icon_report.png" alt="' . $lang['Report'] . '" /></a></li>&nbsp;<li class="postforward"><a href="misc.php?forward=' . $forum_user['id'] . '&amp;type=' . $type . '&amp;pid=' . $cur_post['id'] . '" rel="nofollow" title="' . $lang['Forward'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/btn_forward.png" alt="' . $lang['Forward'] . '" /></a></li>&nbsp;<li class="postdelete"><a href="delete.php?id=' . $cur_post['id'] . '" rel="nofollow" title="' . $lang['Delete'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/btn_delete.png" alt="' . $lang['Delete'] . '" /></a></li>&nbsp;<li class="postquote"><a href="move.php?id=' . $cur_post['id'] . '" rel="nofollow" title="' . $lang['Move'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/btn_move.png" alt="' . $lang['Move'] . '" /></a></li>&nbsp;<li class="postedit"><a href="edit.php?id=' . $cur_post['id'] . '" rel="nofollow" title="' . $lang['Edit'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/btn_edit.png" alt="' . $lang['Edit'] . '" /></a></li>&nbsp;<li class="postquote"><a href="post.php?type=' . $type . '&amp;tid=' . $id . '&amp;qid=' . $cur_post['id'] . '" rel="nofollow" title="' . $lang['Quote'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/btn_quote.png" alt="' . $lang['Quote'] . '" /></a>';
                    else
                        $post_actions[] = '<li class="postreport"><a href="misc.php?report=' . $cur_post['id'] . '&amp;type=' . $type . '" rel="nofollow" title="' . $lang['Report'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/btn_icon_report.png" alt="' . $lang['Report'] . '" /></a></li>&nbsp;<li class="postforward"><a href="misc.php?forward=' . $forum_user['id'] . '&amp;type=' . $type . '&amp;pid=' . $cur_post['id'] . '" rel="nofollow" title="' . $lang['Forward'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/btn_forward.png" alt="' . $lang['Forward'] . '" /></a></li>&nbsp;<li class="postdelete"><a href="delete.php?id=' . $cur_post['id'] . '" rel="nofollow" title="' . $lang['Delete'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/btn_delete.png" alt="' . $lang['Delete'] . '" /></a></li>&nbsp;<li class="postquote"><a href="move.php?id=' . $cur_post['id'] . '" rel="nofollow" title="' . $lang['Move'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/btn_move.png" alt="' . $lang['Move'] . '" /></a></li>&nbsp;<li class="postedit"><a href="edit.php?id=' . $cur_post['id'] . '" rel="nofollow" title="' . $lang['Edit'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/btn_edit.png" alt="' . $lang['Edit'] . '" /></a></li>&nbsp;<li class="postquote"><a href="post.php?type=' . $type . '&amp;tid=' . $id . '&amp;qid=' . $cur_post['id'] . '" rel="nofollow" title="' . $lang['Quote'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/btn_qquote1.png" alt="' . $lang['Quote'] . '" /></a><li class="postquote"><a href="javascript:xBB_Toggle_Category(999, 0);xBB_Insert_Text(\'[quote=' . BB_Input::Htmlspecialchars($cur_post['username']) . ']' . $db->escape(BB_Input::Htmlspecialchars($cur_post['message'])) . '[/quote]\',\'\');" rel="nofollow" title="' . $lang['Multi quote'] . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/btn_qquote2.png" alt="' . $lang['Multi quote'] . '" /></a></li>';
                }
                $bg_switch = ($bg_switch) ? $bg_switch = false : $bg_switch = true;
                $vtbg = ($bg_switch) ? ' roweven' : ' rowodd';
                $cur_post['message'] = BB_Parser::Parse_Message($cur_post['message'], $cur_post['hide_smilies']);
                if ($cur_post['signature'] != '' && $forum_user['show_sig'] != '0')
                {
                    if (isset($signature_cache[$cur_post['poster_id']]))
                        $signature = $signature_cache[$cur_post['poster_id']];
                    else
                    {
                        $signature = BB_Parser::Parse_Signature($cur_post['signature']);
                        $signature_cache[$cur_post['poster_id']] = $signature;
                    }
                }
                ?>
                <div id="p<?php echo $cur_post['id'] ?>" class="blockpost<?php echo $vtbg ?><?php if (($post_count + $start_from) == 1)
                    echo ' firstpost'; ?>">
                    <h2><span><span class="icons">
    <?php
    if (!$forum_user['is_guest'])
    {
        $temp_action = '';
        for ($i = 5; $i >= 0; $i--)
            $temp_action .= '<a href="topic.php?type=' . $type . '&amp;rate=' . $i . '&amp;id=' . $cur_post['topic_id'] . '&amp;do_rate=1"><img style="border:0px" src="' . BB_Template::Get_Image_Folder() . 'rating/rating_' . $i . '.png" alt="" /></a><br />';
        if ($cur_topic['rating_votes'] > 0 && $cur_topic['rating'] > 0)
        {
            $topic_rating = ceil($cur_topic['rating'] / $cur_topic['rating_votes']);
            $topic_icon = '<img src="' . BB_Template::Get_Image_Folder() . 'rating/rating_' . $topic_rating . '.png" id="rating" alt="" />';
        }
        else
            $topic_icon = '<img src="' . BB_Template::Get_Image_Folder() . 'rating/rating_0.png" id="rating" alt="" />';
    }
    if ($post_count == 1)
        echo '<a href="#" rel="nofollow" onclick="return xBB_Show_Tooltip(\'' . BB_Input::Htmlspecialchars($temp_action) . '\', REF, \'rating\', REFC,\'LR\', REFP,\'UR\', REFX, 0, FGCLASS, \'actions_popup_fg\', BGCLASS, \'actions_popup_bg\', BORDER, 1, STICKY, ABOVE, MOUSEOFF);">' . $topic_icon . '</a>';
    ?>

                            </span><a href="<?php echo BB_Input::Rewrite_URL("t", $cur_post['topic_id'], $cur_topic['subject']) . '#p' . $cur_post['id'] ?>"><?php echo BB_Input::Format_Time($cur_post['posted']) ?></a></span></h2>
                    <div class="box">
                        <div class="inbox">
                            <div class="postleft">
                                <dl>
                                    <dt><strong><?php echo $username ?></strong></dt>
                                    <dd class="usertitle"><strong><?php echo $user_title ?></strong></dd>
                                    <dd class="postavatar"><?php echo $user_avatar ?></dd>
                    <?php if (($cur_post['g_id'] != USER_GUEST) && (bb_ranks_enable))
                        echo "<dd class=\"info\">" . $rank_icons . "</dd>\n"; ?>
                    <?php
                    if ($cur_post['g_id'] != 3 && bb_enable_country)
                    {
                        if ($user_country != '')
                            echo '<dd class="info"><img src="' . bb_forum_url . 'img/general/flags/' . $user_country . '.png" alt="' . $user_country . '" title="' . $user_country . '" /></dd>';
                    }
                    if (count($user_info))
                        echo "\t\t\t\t\t" . implode('</dd>' . "\n\t\t\t\t\t", $user_info) . '</dd>' . "\n";
                    if ($cur_post['poster_id'] != 1 && $forum_user['g_rep_enable'] == 1 && bb_reputation_enabled == 1 && $cur_post['reputation_enable'] == 1 && $forum_user['reputation_enable_adm'] == 1 && $forum_user['reputation_enable'] == 1)
                    {
                        ?>
                                        <dd class="info">
        <?php
        echo '<a rel="nofollow" href="' . bb_website_url . '/include/functions/Reputation.php?uid=' . $cur_post['poster_id'] . '">' . $lang['Reputation'] . '</a>';
        ?> :  <?php
                                if ($forum_user['is_guest'] != true && $forum_user['username'] != $cur_post['username'])
                                {
                                    $repdata = '&amp;pid=' . $cur_post['id'] . '&amp;uid=' . $cur_post['poster_id'] . '&amp;method=';
                                    $repdataplus = $repdata . '1';
                                    $repdataminus = $repdata . '2';
                                    ?>
                                                <a rel="nofollow" href="<?php echo bb_website_url ?>/include/functions/Reputation.php?<?php echo $repdataplus; ?>"><img src="<?php echo BB_Template::Get_Image_Folder() ?>misc/plus.png" alt="+" border="0"></a>&nbsp;&nbsp;<strong><?php echo $cur_post['count_rep_plus'] - $cur_post['count_rep_minus']; ?>&nbsp;&nbsp;</strong><a rel="nofollow" href="<?php echo bb_website_url ?>/include/functions/Reputation.php?<?php echo $repdataminus; ?>"><img src="<?php echo BB_Template::Get_Image_Folder() ?>misc/minus.png" alt="-" border="0"></a><?php
                                }
                                else
                                {
            ?> &nbsp;&nbsp;<strong><?php echo $cur_post['count_rep_plus'] - $cur_post['count_rep_minus']; ?>&nbsp;</strong><?php
            }
        ?>
                                        </dd>
                        <?php
                    }
                    if (count($user_contacts))
                        echo "\t\t\t\t\t" . '<dd class="usercontacts">' . implode('&nbsp;&nbsp;', $user_contacts) . '</dd>' . "\n";
                    ?>
                                </dl>
                            </div>
                            <div class="postright">
                                <h3><?php if (($post_count + $start_from) > 1)
                        echo ' Re: '; ?><?php echo BB_Input::Htmlspecialchars($cur_topic['subject']) ?></h3>
                                <div class="postmsg" id="ipe<?php echo $cur_post['id'] ?>">
    <?php echo $cur_post['message'] . "\n" ?>
    <?php BB_Image_Upload::Show_Images($cur_post['id']) ?>
    <?php
    if ($cur_post['edited'] != '')
        echo "\t\t\t\t\t" . '<p class="postedit"><em>' . $lang['Last edit'] . ' ' . BB_Input::Htmlspecialchars($cur_post['edited_by']) . ' (' . BB_Input::Format_Time($cur_post['edited']) . ')</em></p>' . "\n";
    ?>
                                </div>
    <?php
    if ($signature != '')
        echo "\t\t\t\t" . '<div class="postsignature"><hr />' . $signature . '</div>' . "\n";
    if ($post_count == 1)
    {
        if ($cur_topic['tags'] != '')
        {
            $BoardID = "";
            $tags = $lang['Tags'];
            $words = split(",", $cur_topic['tags']);
            $tagurl = "http://www.boardtracker.com/tag";
            foreach ($words as $word)
            {
                $word = strtolower(trim($word));
                $tags .= "<a href=\"$tagurl" . "/$word/" . "$BoardID\" rel=\"tag\">$word</a> ";
            }
            echo "\t\t\t\t" . '<br /><div class="postsignature"><hr />' . $tags . '</div>' . "\n";
        }
    }
    ?>
                            </div>
                            <div class="clearer"></div>
                            <div class="postfootleft"><?php if ($cur_post['poster_id'] > 1)
        echo '<br /><p>' . $is_online . '</p>'; ?></div>
                            <div class="postfootright"><?php echo (count($post_actions)) ? '<ul>' . implode('</li> ', $post_actions) . '</li></ul></div>' . "\n" : '<div>&nbsp;</div></div>' . "\n" ?>
                            </div>
                        </div>
                    </div>
    <?php
    include('../include/functions/AdBot.php');
}
?>
                <div class="postlinksb">
                    <div class="inbox">
                        <p class="postlink conr"><?php echo $post_link ?></p>
                        <p class="pagelink conl"><?php echo $paging_links ?></p>
<?php
if ($cur_topic['parent_forum'])
    echo "\t\t" . '<ul><li><a href="index.php">' . $lang['Index'] . '</a>&nbsp;</li><li>&raquo;&nbsp;<a href="' . BB_Input::Rewrite_URL("f", $cur_topic['parent_forum_id'], $cur_topic['parent_forum_name']) . '">' . BB_Input::Htmlspecialchars($cur_topic['parent_forum']) . '</a>&nbsp;</li><li>&raquo;&nbsp;<a href="' . BB_Input::Rewrite_URL("f", $cur_topic['forum_id'], $cur_topic['forum_name']) . '">' . BB_Input::Htmlspecialchars($cur_topic['forum_name']) . '</a>&nbsp;</li><li>&raquo;&nbsp;' . BB_Input::Htmlspecialchars($cur_topic['subject']) . '</li></ul>';
else
    echo "\t\t" . '<ul><li><a href="index.php">' . $lang['Index'] . '</a></li><li>&nbsp;&raquo;&nbsp;<a href="' . BB_Input::Rewrite_URL("f", $cur_topic['forum_id'], $cur_topic['forum_name']) . '">' . BB_Input::Htmlspecialchars($cur_topic['forum_name']) . '</a></li><li>&nbsp;&raquo;&nbsp;' . BB_Input::Htmlspecialchars($cur_topic['subject']) . '</li></ul>';
?>
<?php echo $subscraction ?>
                    </div>
                </div>
<?php
if ($quickpost)
{
    $qpost_ids = (isset($_COOKIE['qpostprefs'])) ? $_COOKIE['qpostprefs'] . ',' : FALSE;
    if (strstr($qpost_ids, '999,'))
    {
        $div_ido = "none";
        $div_idx = "block";
    }
    else
    {
        $div_ido = "block";
        $div_idx = "none";
    }
    ?>
                    <div id="ido999" class="blockform" style="display:<?php echo $div_ido ?>">
                        <h2><span class="icons"><a href="javascript:xBB_Toggle_Category(999, 0);"><img src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/down.png" alt="+" /></a></span><span><?php echo $lang['Quick post'] ?></h2>
                    </div>
                    <div id="idx999" class="blockform" style="display:<?php echo $div_idx ?>">
                        <h2><span class="icons"><a href="javascript:xBB_Toggle_Category(999, 1);"><img src="<?php echo BB_Template::Get_Image_Folder() ?>arrows/up.png" alt="-" /></a></span><span><?php echo $lang['Quick post'] ?></h2>
                        <form id="post" method="post" action="post.php?tid=<?php echo $id ?>" onsubmit="this.submit.disabled=true;if(process_form(this)){return true;}else{this.submit.disabled=false;return false;}">
                            <div class="inform">
                                <div class="infldset txtarea">
                                    <input type="hidden" name="form_sent" value="1" />
                                    <input type="hidden" name="form_user" value="<?php echo (!$forum_user['is_guest']) ? BB_Input::Htmlspecialchars($forum_user['username']) : 'Guest'; ?>" />
    <?php
    require FORUM_ROOT . 'include/functions/BBCodes.php';
    ?>
                                    <label><div style="width:510px"><textarea id="req_message" name="req_message" rows="7" style="width:510px" tabindex="1"></textarea></div></label>
                                </div>
                            </div>
                            <div><input type="submit" class="b1" name="submit" tabindex="2" value="<?php echo $lang['Submit'] ?>" accesskey="s" /></div>
                        </form>
                    </div>
    <?php
}
$low_prio = ($db_type == 'mysql') ? 'LOW_PRIORITY ' : '';
$db->query('UPDATE ' . $low_prio . $db->prefix . 'topics SET num_views=num_views+1 WHERE id=' . $db->escape($id)) or BB_Functions::Error($lang['error_6'], __FILE__, __LINE__, $db->error());
$forum_id = $cur_topic['forum_id'];
$footer_style = 'view_' . $type;
require FORUM_ROOT . $forum_folder . '/footer.php';
?>
