<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
require dirname(__FILE__) . '/../include/init.php';
if ($forum_user['g_read_board'] == '0')
    BB_Functions::Message($lang['No permission'], true, 1);
$pollid = isset($_POST['poll_id']) ? intval($_POST['poll_id']) : 0;
if ($pollid < 1)
    BB_Functions::Message($lang['Bad request']);
$result = $db->query('SELECT f.id, f.forum_name, f.moderators, f.redirect_url, fp.post_replies, fp.post_topics, t.subject, t.closed, poll.ptype, poll.options, poll.voters, poll.votes FROM ' . $db->prefix . 'polls AS poll RIGHT JOIN ' . $db->prefix . 'topics AS t ON poll.pollid=t.id INNER JOIN ' . $db->prefix . 'forums AS f ON f.id=t.forum_id LEFT JOIN ' . $db->prefix . 'permissions AS fp ON (fp.forum_id=f.id AND fp.gid=' . $forum_user['g_id'] . ') WHERE (fp.read_forum IS NULL OR fp.read_forum=1) AND t.id=' . $db->escape($pollid)) or BB_Functions::Error($lang['error_1'], __FILE__, __LINE__, $db->error());
if (!$db->num_rows($result))
    BB_Functions::Message($lang['Bad request']);
$cur_poll = $db->fetch_assoc($result);
$mods_array = ($cur_poll['moderators'] != '') ? unserialize($cur_poll['moderators']) : array();
$is_admmod = ($forum_user['g_id'] == USER_ADMIN || ($forum_user['g_id'] == USER_MOD && array_key_exists($forum_user['username'], $mods_array))) ? true : false;
if ((((($cur_poll['post_replies'] == '' && $forum_user['g_post_replies'] == '0') || $cur_poll['post_replies'] == '0')) || (isset($cur_poll['closed']) && $cur_poll['closed'] == '1')) && !$is_admmod)
    BB_Functions::Message($lang['No permission'], true, 1);
if ($forum_user['is_guest'])
    BB_Functions::Message($lang['No permission']);
if (isset($_POST['form_sent']))
{
    if ($forum_user['is_guest'] || $_POST['form_user'] != $forum_user['username'])
        BB_Functions::Message($lang['Bad request']);
    $options = unserialize($cur_poll['options']);
    if (!empty($cur_poll['voters']))
        $voters = unserialize($cur_poll['voters']);
    else
        $voters = array();
    if (!empty($cur_poll['votes']))
        $votes = unserialize($cur_poll['votes']);
    else
        $votes = array();
    $ptype = $cur_poll['ptype'];
    if (in_array($forum_user['id'], $voters))
        BB_Functions::Message($lang['Already voted']);
    if (empty($_POST['null']))
    {
        if ($ptype == 1)
        {
            $myvote = intval(trim($_POST['vote']));
            if ((empty($myvote)) || (!array_key_exists($myvote, $options)))
                BB_Functions::Message($lang['Bad request']);
            if (isset($votes[$myvote]))
                $votes[$myvote]++;
            else
                $votes[$myvote] = 1;
        }
        else if ($ptype == 2)
        {
            while (list($key, $value) = each($_POST['options']))
            {
                if (!empty($value) && array_key_exists($key, $options))
                {
                    if (isset($votes[$key]))
                        $votes[$key]++;
                    else
                        $votes[$key] = 1;
                }
            }
        }
        else if ($ptype == 3)
        {
            while (list($key, $value) = each($_POST['options']))
            {
                if (!empty($value) && array_key_exists($key, $options))
                {
                    if ($value == "yes")
                    {
                        if (isset($votes[$key]['yes']))
                            $votes[$key]['yes']++;
                        else
                            $votes[$key]['yes'] = 1;
                    }
                    else
                    {
                        if (isset($votes[$key]['no']))
                            $votes[$key]['no']++;
                        else
                            $votes[$key]['no'] = 1;
                    }
                }
            }
        }
        else
            BB_Functions::Message($lang['Bad request']);
    }
    $voters[] = $forum_user['id'];
    $voters_serialized = serialize($voters);
    $votes_serialized = serialize($votes);
    $db->query('UPDATE ' . $db->prefix . 'polls SET votes=\'' . $votes_serialized . '\', voters=\'' . $voters_serialized . '\' WHERE pollid=' . $db->escape($pollid)) or BB_Functions::Error($lang['error_2'], __FILE__, __LINE__, $db->error());
    BB_Functions::Redirect(bb_forum_url . BB_Input::Rewrite_URL("l", $pollid, $cur_poll['subject']), $lang['Vote success']);
}
else
    BB_Functions::Message($lang['Bad request']);
?>
