<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
require '../../include/init.php';
if ($forum_user['g_read_board'] == '0')
    BB_Functions::Message($lang['No permission'], true, 1);
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html dir="<?php echo $lang['lang_direction']; ?>">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=<?php echo $lang['lang_encoding']; ?>" />
        <title>Color Picker</title>
        <style type="text/css">
            body {text-align: center;background-color:#FFFFFF}
            td {text-align: center;background-color:#FFFFFF}
            .table_black_border {border: 1px solid #000000}
        </style>
        <script type="text/javascript">
            var detail = 50, textarea = window.opener.document.getElementById('req_message'), strhex = "0123456789ABCDEF", i, is_mouse_down = false, is_mouse_over = false;
            function xBB_Change_Color(color)
            {
                document.forms['colpick_form'].elements['btn_choose_color'].style.backgroundColor = color;
            }
            function xBB_Decimal_To_Hex(n)
            {
                return strhex.charAt(Math.floor(n/16)) + strhex.charAt(n%16);
            }
            function xBB_Color(e)
            {
                x = e.offsetX ? e.offsetX : (e.target ? e.clientX-e.target.x : 0);
                y = e.offsetY ? e.offsetY : (e.target ? e.clientY-e.target.y : 0);
                var part_width = document.all ? document.all.color_picker.width/6 : document.getElementById('color_picker').width/6;
                var part_detail = detail/2;
                var im_height = document.all ? document.all.color_picker.height : document.getElementById('color_picker').height;
                var red = (x >= 0)*(x < part_width)*255 + (x >= part_width)*(x < 2*part_width)*(2*255 - x * 255 / part_width) + (x >= 4*part_width)*(x < 5*part_width)*(-4*255 + x * 255 / part_width) + (x >= 5*part_width)*(x < 6*part_width)*255;
                var blue = (x >= 2*part_width)*(x < 3*part_width)*(-2*255 + x * 255 / part_width) + (x >= 3*part_width)*(x < 5*part_width)*255 + (x >= 5*part_width)*(x < 6*part_width)*(6*255 - x * 255 / part_width);
                var green = (x >= 0)*(x < part_width)*(x * 255 / part_width) + (x >= part_width)*(x < 3*part_width)*255 + (x >= 3*part_width)*(x < 4*part_width)*(4*255 - x * 255 / part_width);
                var coef = (im_height-y)/im_height;
                red = 128+(red-128)*coef;
                green = 128+(green-128)*coef;
                blue = 128+(blue-128)*coef;
                xBB_Change_Color('#' + xBB_Decimal_To_Hex(red) + xBB_Decimal_To_Hex(green) + xBB_Decimal_To_Hex(blue));
                for(i = 0; i < detail; i++)
                {
                    if ((i >= 0) && (i < part_detail))
                    {
                        var final_coef = i/part_detail ;
                        var final_red = xBB_Decimal_To_Hex(255 - (255 - red) * final_coef);
                        var final_green = xBB_Decimal_To_Hex(255 - (255 - green) * final_coef);
                        var final_blue = xBB_Decimal_To_Hex(255 - (255 - blue) * final_coef);
                    }
                    else
                    {
                        var final_coef = 2 - i/part_detail ;
                        var final_red = xBB_Decimal_To_Hex(red * final_coef);
                        var final_green = xBB_Decimal_To_Hex(green * final_coef);
                        var final_blue = xBB_Decimal_To_Hex(blue * final_coef);
                    }
                    color = final_red + final_green + final_blue ;
                    document.all ? document.all('gs'+i).style.backgroundColor = '#'+color : document.getElementById('gs'+i).style.backgroundColor = '#'+color;
                }
            }
            function xBB_Get_Color()
            {
                function xBB_Color_Tag(prefix, suffix, fn)
                {
                    textarea.focus();
                    var start, end, sel, scrollPos, subst;
                    if (typeof(window.opener.document["selection"]) != "undefined")
                    {
                        sel = window.opener.document.selection.createRange().text;
                    }
                    else if (typeof(textarea["setSelectionRange"]) != "undefined")
                    {
                        start = textarea.selectionStart;
                        end = textarea.selectionEnd;
                        scrollPos = textarea.scrollTop;
                        sel = textarea.value.substring(start, end);
                    }
                    if (sel.match(/ $/))
                    {
                        sel = sel.substring(0, sel.length - 1);
                        suffix = suffix + " ";
                    }
                    if (typeof(fn) == 'function')
                    {
                        var res = (sel) ? fn(sel) : fn('');
                    }
                    else
                    {
                        var res = (sel) ? sel : '';
                    }
                    subst = prefix + res + suffix;
                    if (typeof(window.opener.document["selection"]) != "undefined")
                    {
                        var range = window.opener.document.selection.createRange().text = subst;
                        textarea.caretPos -= suffix.length;
                    }
                    else if (typeof(textarea["setSelectionRange"]) != "undefined")
                    {
                        textarea.value = textarea.value.substring(0, start) + subst +
                            textarea.value.substring(end);
                        if (sel)
                        {
                            textarea.setSelectionRange(start + subst.length, start + subst.length);
                        }
                        else
                        {
                            textarea.setSelectionRange(start + prefix.length, start + prefix.length);
                        }
                        textarea.scrollTop = scrollPos;
                    }
                }
                var new_color = document.forms['colpick_form'].elements['btn_choose_color'].style.backgroundColor;
                exp_rgb = new RegExp("rgb","g");
                if (exp_rgb.test(new_color))
                {
                    exp_extract = new RegExp("[0-9]+","g");
                    var tab_rgb = new_color.match(exp_extract);
                    new_color = '#'+xBB_Decimal_To_Hex(parseInt(tab_rgb[0]))+xBB_Decimal_To_Hex(parseInt(tab_rgb[1]))+xBB_Decimal_To_Hex(parseInt(tab_rgb[2]));
                }
                xBB_Color_Tag('', '', function(str) {return '[color='+new_color+']'+str+'[/color]'});
                window.opener.focus();
                window.close();
            }        
            window.focus();
        </script>
    </head>
    <body>
        <form name="colpick_form" action="#" method="post">
            <table border="0" cellspacing="0" cellpadding="0" align="center">
                <tr>
                    <td>
                        <table border="1" cellspacing="0" cellpadding="0" class="table_black_border">
                            <tr>
                                <td style="padding:0px; border-width:0px; border-style:none;"><img id="color_picker" src="<?php echo bb_forum_url ?>img/general/colpick.jpg" onclick=" xBB_Color(event)" onmousedown="is_mouse_down = true; return false;" onmouseup="is_mouse_down = false;" onmousemove="if (is_mouse_down && is_mouse_over) xBB_Color(event); return false;" onmouseover="is_mouse_over = true;" onmouseout="is_mouse_over = false;" style="cursor:crosshair;" /></td>
                            </tr>
                        </table>
                    </td>
                    <td style="background-color:#ffffff; width:20px; height:2px; padding:0px;"></td>
                    <td>
                        <table border="1" cellspacing="0" cellpadding="0" class="table_black_border" style="cursor:crosshair">
                            <script type="text/javascript">
                                for(i = 0; i < detail; i++)
                                {
                                    document.write('<tr><td id="gs'+i+'" style="background-color:#000000; width:20px; height:3px; border-style:none; border-width:0px;"' + ' onclick="xBB_Change_Color(this.style.backgroundColor)"' + ' onmousedown="is_mouse_down = true; return false;"' + ' onmouseup="is_mouse_down = false;"' + ' onmousemove="if (is_mouse_down && is_mouse_over) xBB_Change_Color(this.style.backgroundColor); return false;"' + ' onmouseover="is_mouse_over = true;"' + ' onmouseout="is_mouse_over = false;"' + '></td></tr>');
                                }
                            </script>
                        </table>
                    </td>
                </tr>
            </table>
            <br>
                <table align="center">
                    <tr valign="center">
                        <td><input type="button" name="btn_choose_color" value="&nbsp;" style="background: #000; border: 1px solid #000; width:100px; height:35px;"></td>
                        <td><input type="button" name="btn_ok" value="Ok" style="width:70px" onclick="xBB_Get_Color();"></td>
                    </tr>
                </table>
        </form>
    </body>
</html>
