<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
if (!defined('IN_FORUM'))
    exit('No direct script access allowed');

class BB_Core
{

    function Show_Rank($posts, $gid)
    {
        global $lang;
        if ($posts > 5000)
            $num_ranks = 10;
        elseif ($posts > 3000 && $posts < 5000)
            $num_ranks = 9;
        elseif ($posts > 2000 && $posts < 3000)
            $num_ranks = 8;
        elseif ($posts > 1000 && $posts < 2000)
            $num_ranks = 7;
        elseif ($posts > 500 && $posts < 1000)
            $num_ranks = 6;
        elseif ($posts > 300 && $posts < 500)
            $num_ranks = 5;
        elseif ($posts > 100 && $posts < 300)
            $num_ranks = 4;
        elseif ($posts > 50 && $posts < 100)
            $num_ranks = 3;
        elseif ($posts > 30 && $posts < 50)
            $num_ranks = 2;
        elseif ($posts > 10 && $posts < 50)
            $num_ranks = 1;
        else
            $num_ranks = 0;
        if ($gid == 1)
            return '<img style="border:0;" src="' . BB_Template::Get_Image_Folder() . 'ranks/rank_1.png" alt="' . $lang['Administrator'] . '" />';
        else if ($gid == 2)
            return '<img style="border:0;" src="' . BB_Template::Get_Image_Folder() . 'ranks/rank_2.png" alt="' . $lang['Moderator'] . '" />';
        else if ($img_size = @getimagesize(BB_Template::Get_Image_Folder(false) . 'ranks/rank_' . $gid . '.png'))
            return '<img style="border:0;" src="' . BB_Template::Get_Image_Folder() . 'ranks/rank_' . $gid . '.png" alt="" />';
        else
            return '<img style="border:0;" src="' . BB_Template::Get_Image_Folder() . '/ranks/stars_' . $num_ranks . '.png" alt="' . $lang['Ranks'] . '" />';
    }

    function Set_Default_User()
    {
        global $db, $forum_user;
        $result = $db->query('SELECT u.*, g.*, o.logged FROM ' . $db->prefix . 'users AS u INNER JOIN ' . $db->prefix . 'usergroups AS g ON u.gid=g.g_id LEFT JOIN ' . $db->prefix . 'online AS o ON o.ident=\'' . $db->escape(BB_Input::Get_Remote_Address()) . '\' WHERE u.id=1') or BB_Functions::Error('Unable to fetch guest information', __FILE__, __LINE__, $db->error());
        if (!$db->num_rows($result))
            exit('Unable to fetch guest information.');
        $forum_user = $db->fetch_assoc($result);
        if (!$forum_user['logged'])
            $db->query('INSERT INTO ' . $db->prefix . 'online (user_id, ident, logged, color) VALUES(1, \'' . $db->escape(BB_Input::Get_Remote_Address()) . '\', ' . time() . ', \'' . $forum_user['g_color'] . '\')') or BB_Functions::Error('Unable to insert into online list', __FILE__, __LINE__, $db->error());
        else
            $db->query('UPDATE ' . $db->prefix . 'online SET logged=' . time() . ' WHERE ident=\'' . $db->escape(BB_Input::Get_Remote_Address()) . '\'') or BB_Functions::Error('Unable to update online list', __FILE__, __LINE__, $db->error());
        $forum_user['disp_topics'] = bb_disp_topics_default;
        $forum_user['disp_posts'] = bb_disp_posts_default;
        $forum_user['timezone'] = bb_server_timezone;
        $forum_user['language'] = bb_default_lang;
        $forum_user['template'] = bb_default_style;
        $forum_user['is_guest'] = true;
    }

    function Set_Bans()
    {
        global $db, $lang, $forum_user, $forum_bans;
        if ($forum_user['g_id'] == USER_ADMIN || !$forum_bans)
            return;
        $user_ip = BB_Input::Get_Remote_Address() . '.';
        $bans_altered = false;
        foreach ($forum_bans as $cur_ban)
        {
            if ($cur_ban['expire'] != '' && $cur_ban['expire'] <= time())
            {
                $db->query('DELETE FROM ' . $db->prefix . 'bans WHERE id=' . $db->escape($cur_ban['id'])) or BB_Functions::Error('Unable to delete expired ban', __FILE__, __LINE__, $db->error());
                $bans_altered = true;
                continue;
            }
            if ($cur_ban['username'] != '' && !strcasecmp($forum_user['username'], $cur_ban['username']))
            {
                $db->query('DELETE FROM ' . $db->prefix . 'online WHERE ident=\'' . $db->escape($forum_user['username']) . '\'') or BB_Functions::Error('Unable to delete from online list', __FILE__, __LINE__, $db->error());
                BB_Functions::Message($lang['Ban message'] . ' ' . (($cur_ban['expire'] != '') ? $lang['Ban message 2'] . ' ' . strtolower(BB_Input::Format_Time($cur_ban['expire'], true)) . '. ' : '') . (($cur_ban['message'] != '') ? $lang['Ban message 3'] . '<br /><br /><strong>' . BB_Input::Htmlspecialchars($cur_ban['message']) . '</strong><br /><br />' : '<br /><br />') . $lang['Ban message 4'] . ' <a href="mailto:' . bb_admin_email . '">' . bb_admin_email . '</a>.', true);
            }
            if ($cur_ban['ip'] != '')
            {
                $cur_ban_ips = explode(' ', $cur_ban['ip']);
                for ($i = 0; $i < count($cur_ban_ips); ++$i)
                {
                    $cur_ban_ips[$i] = $cur_ban_ips[$i] . '.';
                    if (substr($user_ip, 0, strlen($cur_ban_ips[$i])) == $cur_ban_ips[$i])
                    {
                        $db->query('DELETE FROM ' . $db->prefix . 'online WHERE ident=\'' . $db->escape($forum_user['username']) . '\'') or BB_Functions::Error('Unable to delete from online list', __FILE__, __LINE__, $db->error());
                        BB_Functions::Message($lang['Ban message'] . ' ' . (($cur_ban['expire'] != '') ? $lang['Ban message 2'] . ' ' . strtolower(BB_Input::Format_Time($cur_ban['expire'], true)) . '. ' : '') . (($cur_ban['message'] != '') ? $lang['Ban message 3'] . '<br /><br /><strong>' . BB_Input::Htmlspecialchars($cur_ban['message']) . '</strong><br /><br />' : '<br /><br />') . $lang['Ban message 4'] . ' <a href="mailto:' . bb_admin_email . '">' . bb_admin_email . '</a>.', true);
                    }
                }
            }
        }
        if ($bans_altered)
            BB_Cache::Generate_Bans();
    }

    function Set_Online_Users()
    {
        global $db, $forum_user;
        $now = time();
        $pathinfo = pathinfo($_SERVER['PHP_SELF']);
        $current_page_full = $_SERVER['PHP_SELF'];
        $current_page = $pathinfo['basename'];
        $current_ip = BB_Input::Get_Remote_Address();
        if ($current_page == "forum.php" || $current_page == "topic.php" || $current_page == "member.php" || $current_page == "post.php" || $current_page == "edit.php")
        {
            if (isset($_GET['id']))
                $current_page_id = intval($_GET['id']);
            else if (isset($_GET['pid']))
            {
                $current_topic_id = $db->query('SELECT topic_id FROM ' . $db->prefix . 'posts WHERE id=\'' . $db->escape($_GET["pid"]) . '\'') or BB_Functions::Error('Unable to fetch topic info', __FILE__, __LINE__, $db->error());
                $tmp = $db->result($current_topic_id, 0);
                $current_page_id = ($tmp != '') ? $tmp : '0';
            }
            else if (isset($_GET['tid']))
                $current_page_id = intval($_GET['tid']);
            else if (isset($_GET['fid']))
                $current_page_id = intval($_GET['fid']);
        }
        else
            $current_page_id = 0;
        if ($forum_user['id'] > 1)
            $db->query('UPDATE ' . $db->prefix . 'online SET current_page=\'' . $db->escape($current_page_full) . '\', current_ip=\'' . $db->escape($current_ip) . '\', current_page_id=\'' . $db->escape($current_page_id) . '\' WHERE user_id=\'' . $forum_user['id'] . '\'') or BB_Functions::Error('Unable to update online list', __FILE__, __LINE__, $db->error());
        else
            $db->query('UPDATE ' . $db->prefix . 'online SET current_page=\'' . $db->escape($current_page_full) . '\', current_ip=\'' . $db->escape($current_ip) . '\', current_page_id=\'' . $db->escape($current_page_id) . '\' WHERE ident=\'' . $current_ip . '\'') or BB_Functions::Error('Unable to update online list', __FILE__, __LINE__, $db->error());
        $result = $db->query('SELECT * FROM ' . $db->prefix . 'online WHERE logged<' . ($now - bb_timeout_online)) or BB_Functions::Error('Unable to fetch old entries from online list', __FILE__, __LINE__, $db->error());
        while ($cur_user = $db->fetch_assoc($result))
        {
            if ($cur_user['user_id'] == '1')
                $db->query('DELETE FROM ' . $db->prefix . 'online WHERE ident=\'' . $db->escape($cur_user['ident']) . '\'') or BB_Functions::Error('Unable to delete from online list', __FILE__, __LINE__, $db->error());
            else
            {
                if ($cur_user['logged'] < ($now - bb_timeout_visit))
                {
                    $db->query('UPDATE ' . $db->prefix . 'users SET last_visit=' . $db->escape($cur_user['logged']) . ', read_topics=NULL WHERE id=' . $db->escape($cur_user['user_id'])) or BB_Functions::Error('Unable to update user visit data', __FILE__, __LINE__, $db->error());
                    $db->query('DELETE FROM ' . $db->prefix . 'online WHERE user_id=' . $db->escape($cur_user['user_id'])) or BB_Functions::Error('Unable to delete from online list', __FILE__, __LINE__, $db->error());
                }
                else if ($cur_user['idle'] == '0')
                    $db->query('UPDATE ' . $db->prefix . 'online SET idle=1 WHERE user_id=' . $db->escape($cur_user['user_id'])) or BB_Functions::Error('Unable to insert into online list', __FILE__, __LINE__, $db->error());
            }
        }
    }

    function Update_Forum($forum_id)
    {
        global $db;
        $result = $db->query('SELECT COUNT(id), SUM(num_replies) FROM ' . $db->prefix . 'topics WHERE moved_to IS NULL AND forum_id=' . $db->escape($forum_id)) or BB_Functions::Error('Unable to fetch forum topic count', __FILE__, __LINE__, $db->error());
        list($num_topics, $num_posts) = $db->fetch_row($result);
        $num_posts = $num_posts + $num_topics;
        $result = $db->query('SELECT last_post, last_post_id, last_poster FROM ' . $db->prefix . 'topics WHERE forum_id=' . $db->escape($forum_id) . ' AND moved_to IS NULL ORDER BY last_post DESC LIMIT 1') or BB_Functions::Error('Unable to fetch last_post/last_post_id/last_poster', __FILE__, __LINE__, $db->error());
        if ($db->num_rows($result))
        {
            list($last_post, $last_post_id, $last_poster) = $db->fetch_row($result);
            $db->query('UPDATE ' . $db->prefix . 'forums SET num_topics=' . $db->escape($num_topics) . ', num_posts=' . $db->escape($num_posts) . ', last_post=' . $db->escape($last_post) . ', last_post_id=' . $db->escape($last_post_id) . ', last_poster=\'' . $db->escape($last_poster) . '\' WHERE id=' . $db->escape($forum_id)) or BB_Functions::Error('Unable to update last_post/last_post_id/last_poster', __FILE__, __LINE__, $db->error());
        }
        else
            $db->query('UPDATE ' . $db->prefix . 'forums SET num_topics=0, num_posts=0, last_post=NULL, last_post_id=NULL, last_poster=NULL WHERE id=' . $db->escape($forum_id)) or BB_Functions::Error('Unable to update last_post/last_post_id/last_poster', __FILE__, __LINE__, $db->error());
    }

    function Update_Topic($topic_id)
    {
        global $db;
        $result = $db->query('SELECT COUNT(id) FROM ' . $db->prefix . 'posts WHERE topic_id=' . $db->escape($topic_id)) or BB_Functions::Error('Unable to fetch post count for topic', __FILE__, __LINE__, $db->error());
        $num_replies = $db->result($result, 0) - 1;
        $result = $db->query('SELECT poster, posted FROM ' . $db->prefix . 'posts WHERE topic_id=' . $db->escape($topic_id) . ' ORDER BY posted LIMIT 1') or BB_Functions::Error('Unable to fetch poster for topic', __FILE__, __LINE__, $db->error());
        list($poster, $posted ) = $db->fetch_row($result);
        $result = $db->query('SELECT posted, id, poster FROM ' . $db->prefix . 'posts WHERE topic_id=' . $db->escape($topic_id) . ' ORDER BY posted DESC LIMIT 1') or BB_Functions::Error('Unable to fetch last_post/last_post_id/last_poster for topic', __FILE__, __LINE__, $db->error());
        list($last_post, $last_post_id, $last_poster) = $db->fetch_row($result);
        $db->query('UPDATE ' . $db->prefix . 'topics SET num_replies=' . $db->escape($num_replies) . ', poster=\'' . $db->escape($poster) . '\', posted=' . $db->escape($posted) . ', last_post=' . $db->escape($last_post) . ', last_post_id=' . $db->escape($last_post_id) . ', last_poster=\'' . $db->escape($last_poster) . '\' WHERE id=' . $db->escape($topic_id)) or BB_Functions::Error('Unable to update last_post/last_post_id/last_poster', __FILE__, __LINE__, $db->error());
    }

    function Delete_Topic($topic_id)
    {
        global $db;
        $db->query('DELETE FROM ' . $db->prefix . 'topics WHERE id=' . $db->escape($topic_id) . ' OR moved_to=' . $db->escape($topic_id)) or BB_Functions::Error('Unable to delete topic', __FILE__, __LINE__, $db->error());
        $post_ids = '';
        $result = $db->query('SELECT id FROM ' . $db->prefix . 'posts WHERE topic_id=' . $db->escape($topic_id)) or BB_Functions::Error('Unable to fetch posts', __FILE__, __LINE__, $db->error());
        while ($row = $db->fetch_row($result))
        {
            $post_ids .= ( $post_ids != '') ? ',' . $row[0] : $row[0];
            BB_Image_Upload::Delete_Images($row[0]);
        }
        if ($post_ids != '')
        {
            BB_Core::Remove_Search_Index($post_ids);
            $db->query('DELETE FROM ' . $db->prefix . 'posts WHERE topic_id=' . $db->escape($topic_id)) or BB_Functions::Error('Unable to delete posts', __FILE__, __LINE__, $db->error());
        }
        $db->query('DELETE FROM ' . $db->prefix . 'subscriptions WHERE topic_id=' . $db->escape($topic_id)) or BB_Functions::Error('Unable to delete subscriptions', __FILE__, __LINE__, $db->error());
        $db->query('DELETE FROM ' . $db->prefix . 'polls WHERE pollid=' . $db->escape($topic_id)) or BB_Functions::Error('Unable to delete polls', __FILE__, __LINE__, $db->error());
    }

    function Delete_Post($post_id, $topic_id)
    {
        global $db;
        $result = $db->query('SELECT id, poster, posted FROM ' . $db->prefix . 'posts WHERE topic_id=' . $db->escape($topic_id) . ' ORDER BY id DESC LIMIT 2') or BB_Functions::Error('Unable to fetch post info', __FILE__, __LINE__, $db->error());
        list($last_id,, ) = $db->fetch_row($result);
        list($second_last_id, $second_poster, $second_posted) = $db->fetch_row($result);
        $db->query('DELETE FROM ' . $db->prefix . 'posts WHERE id=' . $db->escape($post_id)) or BB_Functions::Error('Unable to delete post', __FILE__, __LINE__, $db->error());
        BB_Image_Upload::Delete_Images($post_id);
        BB_Core::Remove_Search_Index($post_id);
        $result = $db->query('SELECT COUNT(id) FROM ' . $db->prefix . 'posts WHERE topic_id=' . $db->escape($topic_id)) or BB_Functions::Error('Unable to fetch post count for topic', __FILE__, __LINE__, $db->error());
        $num_replies = $db->result($result, 0) - 1;
        if ($last_id == $post_id)
        {
            if (!empty($second_last_id))
                $db->query('UPDATE ' . $db->prefix . 'topics SET last_post=' . $db->escape($second_posted) . ', last_post_id=' . $db->escape($second_last_id) . ', last_poster=\'' . $db->escape($second_poster) . '\', num_replies=' . $db->escape($num_replies) . ' WHERE id=' . $db->escape($topic_id)) or BB_Functions::Error('Unable to update topic', __FILE__, __LINE__, $db->error());
            else
                $db->query('UPDATE ' . $db->prefix . 'topics SET last_post=posted, last_post_id=id, last_poster=poster, num_replies=' . $num_replies . ' WHERE id=' . $db->escape($topic_id)) or BB_Functions::Error('Unable to update topic', __FILE__, __LINE__, $db->error());
        }
        else
            $db->query('UPDATE ' . $db->prefix . 'topics SET num_replies=' . $db->escape($num_replies) . ' WHERE id=' . $db->escape($topic_id)) or BB_Functions::Error('Unable to update topic', __FILE__, __LINE__, $db->error());
    }

    function Get_User_Title($user)
    {
        global $db, $forum_bans, $lang;
        static $ban_list, $forum_ranks;
        if (empty($ban_list))
        {
            $ban_list = array();
            foreach ($forum_bans as $cur_ban)
                $ban_list[] = strtolower($cur_ban['username']);
        }
        if (bb_ranks == '1' && empty($forum_ranks))
        {
            @include FORUM_ROOT . 'var/cache/cache_ranks.php';
            if (!defined('RANKS_LOADED'))
            {
                BB_Cache::Generate_Ranks();
                require FORUM_ROOT . 'var/cache/cache_ranks.php';
            }
        }
        if ($user['title'] != '')
            $user_title = BB_Input::Htmlspecialchars($user['title']);
        else if (in_array(strtolower($user['username']), $ban_list))
            $user_title = $lang['Banned'];
        else if ($user['g_user_title'] != '')
            $user_title = BB_Input::Htmlspecialchars($user['g_user_title']);
        else if ($user['g_id'] == USER_GUEST)
            $user_title = $lang['Guest'];
        else
        {
            if (bb_ranks == '1' && !empty($forum_ranks))
            {
                @reset($forum_ranks);
                while (list(, $cur_rank) = @each($forum_ranks))
                {
                    if (intval($user['num_posts']) >= $cur_rank['min_posts'])
                        $user_title = BB_Input::Htmlspecialchars($cur_rank['rank']);
                }
            }
            if (!isset($user_title))
                $user_title = $lang['Member'];
        }
        return $user_title;
    }

    function Paginate($num_pages, $cur_page, $link_to, $rewrite = false)
    {
        $pages = array();
        $link_to_all = false;
        $nav_links = true;
        if ($cur_page == -1)
        {
            $cur_page = 1;
            $link_to_all = true;
            $nav_links = false;
        }
        if ($num_pages <= 1)
            $pages = array('<strong class="pagination">1</strong>');
        else
        {
            if ($cur_page > 3)
            {
                if ($rewrite && bb_rewrite_urls == '1')
                    $pages[] = '<a class="pagination" href="' . $link_to . '_1.html">1</a>';
                else
                    $pages[] = '<a class="pagination" href="' . $link_to . '&amp;p=1">1</a>';
                if ($cur_page != 4)
                    $pages[] = '&hellip;';
            }
            for ($current = $cur_page - 2, $stop = $cur_page + 3; $current < $stop; ++$current)
            {
                if ($current < 1 || $current > $num_pages)
                    continue;
                else if ($current != $cur_page || $link_to_all)
                {
                    if ($rewrite && bb_rewrite_urls == '1')
                        $pages[] = '<a class="pagination" href="' . $link_to . '_' . $current . '.html">' . $current . '</a>';
                    else
                        $pages[] = '<a class="pagination" href="' . $link_to . '&amp;p=' . $current . '">' . $current . '</a>';
                }
                else
                    $pages[] = '<strong class="pagination">' . $current . '</strong>';
            }
            if ($cur_page <= ($num_pages - 3))
            {
                if ($cur_page != ($num_pages - 3))
                    $pages[] = '&hellip;';
                if ($rewrite && bb_rewrite_urls == '1')
                    $pages[] = '<a class="pagination" href="' . $link_to . '_' . $num_pages . '.html">' . $num_pages . '</a>';
                else
                    $pages[] = '<a class="pagination" href="' . $link_to . '&amp;p=' . $num_pages . '">' . $num_pages . '</a>';
            }
        }
        if ($nav_links)
        {
            if ($cur_page > 1)
            {
                $back_page_number = $cur_page - 1;
                if ($rewrite && bb_rewrite_urls == '1')
                    $back_page = '<a class="pagination" href="' . $link_to . '_' . $back_page_number . '.html">&laquo;</a>';
                else
                    $back_page = '<a class="pagination" href="' . $link_to . '&amp;p=' . $back_page_number . '">&laquo;</a>';
                array_splice($pages, 0, 0, $back_page);
            }
            if ($cur_page < $num_pages)
            {
                $next_page_number = $cur_page + 1;
                if ($rewrite && bb_rewrite_urls == '1')
                    $next_page = '<a class="pagination" href="' . $link_to . '_' . $next_page_number . '.html">&raquo;</a>';
                else
                    $next_page = '<a class="pagination" href="' . $link_to . '&amp;p=' . $next_page_number . '">&raquo;</a>';
                array_push($pages, $next_page);
            }
        }
        return implode('&nbsp;', $pages);
    }

    function Get_New_Topics()
    {
        global $db, $forum_user;
        $result = $db->query('SELECT forum_id, id, last_post FROM ' . $db->prefix . 'topics WHERE last_post>' . $forum_user['last_visit'] . ' AND moved_to IS NULL ORDER BY last_post DESC') or BB_Functions::Error('Unable to fetch new topics from forum', __FILE__, __LINE__, $db->error());
        $new_topics = array();
        while ($new_topics_row = $db->fetch_assoc($result))
            $new_topics[$new_topics_row['forum_id']][$new_topics_row['id']] = $new_topics_row['last_post'];
        return $new_topics;
    }

    function Is_New_Forum($forum_id, $last_post_time)
    {
        global $forum_user, $new_topics;
        if ($forum_user['last_visit'] >= $last_post_time)
            return false;
        else if (!empty($forum_user['read_topics']['f'][$forum_id]) && $forum_user['read_topics']['f'][$forum_id] >= $last_post_time)
            return false;
        else if (empty($forum_user['read_topics']['t']) && empty($forum_user['read_topics']['f']))
            return true;
        else
        {
            foreach ($new_topics[$forum_id] as $topic_id => $last_post)
            {
                if ((empty($forum_user['read_topics']['f'][$forum_id]) || $forum_user['read_topics']['f'][$forum_id] < $last_post) && (empty($forum_user['read_topics']['t'][$topic_id]) || $forum_user['read_topics']['t'][$topic_id] < $last_post))
                    return true;
            }
            return false;
        }
    }

    function Is_New_Topic($topic_id, $forum_id, $last_post_time)
    {
        global $forum_user;
        if ($forum_user['last_visit'] >= $last_post_time)
            return false;
        else if (!empty($forum_user['read_topics']['f'][$forum_id]) && $forum_user['read_topics']['f'][$forum_id] >= $last_post_time)
            return false;
        else if (!empty($forum_user['read_topics']['t'][$topic_id]) && $forum_user['read_topics']['t'][$topic_id] >= $last_post_time)
            return false;
        return true;
    }

    function Is_Bot_Online()
    {
        global $db;
        $botResult = '';
        $result = $db->query('SELECT * FROM ' . $db->prefix . 'botsconfig');
        $botConfig = $db->fetch_row($result);
        $botLifeSpan = $botConfig[1];
        $botUAStringSensitive = $botConfig[2];
        $botEnabled = $botConfig[3];
        if ($botEnabled == 0)
            return $botResult;
        $result = $db->query('SELECT * FROM ' . $db->prefix . 'bots') or BB_Functions::Error('Unable to retrieve bot data.', __FILE__, __LINE__, $db->error());
        while ($row = $db->fetch_row($result))
        {
            if ($botUAStringSensitive == 0)
                $userAgent = strtolower(getenv('HTTP_USER_AGENT'));
            else
                $userAgent = getenv('HTTP_USER_AGENT');
            if (strstr($userAgent, $row[2]))
            {
                $result = $db->query('UPDATE ' . $db->prefix . 'bots SET time_stamp=' . time() . ' WHERE id=' . $db->escape($row[0]));
                break;
            }
            elseif (date("Y-m-d", $row[3]) == date("Y-m-d") & date("G", $row[3]) == date("G") & date("i") - date("i", $row[3]) <= $botLifeSpan)
                $botResult .= ', ' . $row[1];
        }
        return $botResult;
    }

    function Set_Topic_Read($topic_id, $forum_id, $last_post)
    {
        global $db, $forum_user;
        if (BB_Core::Is_New_Topic($topic_id, $forum_id, $last_post))
        {
            $forum_user['read_topics']['t'][$topic_id] = time();
            $db->query('UPDATE ' . $db->prefix . 'users SET read_topics=\'' . $db->escape(serialize($forum_user['read_topics'])) . '\' WHERE id=' . $forum_user['id']) or BB_Functions::Error('Unable to update read-topic data', __FILE__, __LINE__, $db->error());
        }
    }

    function Set_Search_Index($mode, $post_id, $message, $subject = null)
    {
        global $db_type, $db;
        $words_message = BB_Input::Split_Words($message);
        $words_subject = ($subject) ? BB_Input::Split_Words($subject) : array();
        if ($mode == 'edit')
        {
            $result = $db->query('SELECT w.id, w.word, m.subject_match FROM ' . $db->prefix . 'search_words AS w INNER JOIN ' . $db->prefix . 'search_matches AS m ON w.id=m.word_id WHERE m.post_id=' . $db->escape($post_id), true) or BB_Functions::Error('Unable to fetch search index words', __FILE__, __LINE__, $db->error());
            $cur_words['post'] = array();
            $cur_words['subject'] = array();
            while ($row = $db->fetch_row($result))
            {
                $match_in = ($row[2]) ? 'subject' : 'post';
                $cur_words[$match_in][$row[1]] = $row[0];
            }
            $db->free_result($result);
            $words['add']['post'] = array_diff($words_message, array_keys($cur_words['post']));
            $words['add']['subject'] = array_diff($words_subject, array_keys($cur_words['subject']));
            $words['del']['post'] = array_diff(array_keys($cur_words['post']), $words_message);
            $words['del']['subject'] = array_diff(array_keys($cur_words['subject']), $words_subject);
        }
        else
        {
            $words['add']['post'] = $words_message;
            $words['add']['subject'] = $words_subject;
            $words['del']['post'] = array();
            $words['del']['subject'] = array();
        }
        unset($words_message);
        unset($words_subject);
        $unique_words = array_unique(array_merge($words['add']['post'], $words['add']['subject']));
        if (!empty($unique_words))
        {
            $result = $db->query('SELECT id, word FROM ' . $db->prefix . 'search_words WHERE word IN(' . implode(',', preg_replace('#^(.*)$#', '\'\1\'', $unique_words)) . ')', true) or BB_Functions::Error('Unable to fetch search index words', __FILE__, __LINE__, $db->error());
            $word_ids = array();
            while ($row = $db->fetch_row($result))
                $word_ids[$row[1]] = $row[0];
            $db->free_result($result);
            $new_words = array_diff($unique_words, array_keys($word_ids));
            unset($unique_words);
            if (!empty($new_words))
            {
                switch ($db_type)
                {
                    case 'mysql':
                    case 'mysqli':
                        $db->query('INSERT INTO ' . $db->prefix . 'search_words (word) VALUES' . implode(',', preg_replace('#^(.*)$#', '(\'\1\')', $new_words))) or BB_Functions::Error('Unable to insert search index words', __FILE__, __LINE__, $db->error());
                        break;
                    default:
                        while (list(, $word) = @each($new_words))
                            $db->query('INSERT INTO ' . $db->prefix . 'search_words (word) VALUES(\'' . $word . '\')') or BB_Functions::Error('Unable to insert search index words', __FILE__, __LINE__, $db->error());
                        break;
                }
            }
            unset($new_words);
        }
        while (list($match_in, $wordlist) = @each($words['del']))
        {
            $subject_match = ($match_in == 'subject') ? 1 : 0;
            if (!empty($wordlist))
            {
                $sql = '';
                while (list(, $word) = @each($wordlist))
                    $sql .= ( ($sql != '') ? ',' : '') . $cur_words[$match_in][$word];
                $db->query('DELETE FROM ' . $db->prefix . 'search_matches WHERE word_id IN(' . $sql . ') AND post_id=' . $db->escape($post_id) . ' AND subject_match=' . $db->escape($subject_match)) or BB_Functions::Error('Unable to delete search index word matches', __FILE__, __LINE__, $db->error());
            }
        }
        while (list($match_in, $wordlist) = @each($words['add']))
        {
            $subject_match = ($match_in == 'subject') ? 1 : 0;
            if (!empty($wordlist))
                $db->query('INSERT INTO ' . $db->prefix . 'search_matches (post_id, word_id, subject_match) SELECT ' . $post_id . ', id, ' . $subject_match . ' FROM ' . $db->prefix . 'search_words WHERE word IN(' . implode(',', preg_replace('#^(.*)$#', '\'\1\'', $wordlist)) . ')') or BB_Functions::Error('Unable to insert search index word matches', __FILE__, __LINE__, $db->error());
        }
        unset($words);
    }

    function Remove_Search_Index($post_ids)
    {
        global $db_type, $db;
        switch ($db_type)
        {
            case 'mysql':
            case 'mysqli': {
                    $result = $db->query('SELECT word_id FROM ' . $db->prefix . 'search_matches WHERE post_id IN(' . $post_ids . ') GROUP BY word_id') or BB_Functions::Error('Unable to fetch search index word match', __FILE__, __LINE__, $db->error());
                    if ($db->num_rows($result))
                    {
                        $word_ids = '';
                        while ($row = $db->fetch_row($result))
                            $word_ids .= ( $word_ids != '') ? ',' . $row[0] : $row[0];
                        $result = $db->query('SELECT word_id FROM ' . $db->prefix . 'search_matches WHERE word_id IN(' . $word_ids . ') GROUP BY word_id HAVING COUNT(word_id)=1') or BB_Functions::Error('Unable to fetch search index word match', __FILE__, __LINE__, $db->error());
                        if ($db->num_rows($result))
                        {
                            $word_ids = '';
                            while ($row = $db->fetch_row($result))
                                $word_ids .= ( $word_ids != '') ? ',' . $row[0] : $row[0];
                            $db->query('DELETE FROM ' . $db->prefix . 'search_words WHERE id IN(' . $word_ids . ')') or BB_Functions::Error('Unable to delete search index word', __FILE__, __LINE__, $db->error());
                        }
                    }
                    break;
                }
            default:
                $db->query('DELETE FROM ' . $db->prefix . 'search_words WHERE id IN(SELECT word_id FROM ' . $db->prefix . 'search_matches WHERE word_id IN(SELECT word_id FROM ' . $db->prefix . 'search_matches WHERE post_id IN(' . $post_ids . ') GROUP BY word_id) GROUP BY word_id HAVING COUNT(word_id)=1)') or BB_Functions::Error('Unable to delete from search index', __FILE__, __LINE__, $db->error());
                break;
        }
        $db->query('DELETE FROM ' . $db->prefix . 'search_matches WHERE post_id IN(' . $post_ids . ')') or BB_Functions::Error('Unable to delete search index word match', __FILE__, __LINE__, $db->error());
    }

}

?>
