<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
if (!defined('IN_FORUM'))
    exit('No direct script access allowed');

class BB_Extensions
{

    var $path;
    var $type;
    var $all_list = array();
    var $installed_list = array();
    var $uninstalled_list = array();
    var $activated_list = array();

    function BB_Extensions($path, $type = 'module')
    {
        if (is_dir($path))
            $this->path = $path;
        else
            $this->path = NULL;
        $this->type = $type;
        if ($type == 'module' || $type == 'block')
            return $this->Show();
        else
            return $this->Show('info.php');
    }

    function Active_Elements()
    {
        return $this->activated_list;
    }

    function Installed_Elements()
    {
        return $this->installed_list;
    }

    function Uninstalled_Elements()
    {
        return $this->uninstalled_list;
    }

    function All_Elements()
    {
        return $this->all_list;
    }

    function Show($file = 'index.php')
    {
        if ($this->path === NULL)
            return false;
        $this->all_list = array();
        $this->activated_list = array();
        $d = dir($this->path);
        while (($entry = $d->read()) !== false)
        {
            $config_name = 'bb_' . $this->type . '_' . $entry;
            if ($entry != '.' && $entry != '..' && is_dir($this->path . $entry) && file_exists($this->path . $entry . '/' . $file))
            {
                $this->all_list[] = $entry;
                if (defined($config_name))
                {
                    $this->installed_list[] = $entry;
                    if (constant($config_name) == 1)
                        $this->activated_list[] = $entry;
                }
                else
                    $this->uninstalled_list[] = $entry;
            }
        }
        natsort($this->all_list);
        natsort($this->installed_list);
        natsort($this->uninstalled_list);
        natsort($this->activated_list);
        return true;
    }

    function Install($url)
    {
        $dest = $this->path . '/' . basename($url);
        if (($err = BB_Files::Copy_Remote($url, $dest)) !== true)
            return $err;
        else
        {
            if (($content = @implode('', @gzfile($dest))) === false)
                return 'Cannot open file';
            else
            {
                if (($list = unserialize($content)) === false)
                    return 'Element not valid';
                else
                {
                    if (is_dir($this->path . '/' . $list['name']))
                    {
                        unlink($dest);
                        return 'This extension is already installed. Please remove it before installing it again.';
                    }
                    foreach ($list['dirs'] as $d)
                    {
                        mkdir($this->path . '/' . $d, fileperms($this->path));
                        chmod($this->path . '/' . $d, fileperms($this->path));
                    }
                    foreach ($list['files'] as $f => $v)
                    {
                        $v = base64_decode($v);
                        $fp = fopen($this->path . '/' . $f, 'w');
                        fwrite($fp, $v, strlen($v));
                        fclose($fp);
                        chmod($this->path . '/' . $f, fileperms($this->path) & ~0111);
                    }
                    unlink($dest);
                }
            }
        }
        return true;
    }

}

?>
