<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
if (!defined('IN_FORUM'))
    exit('No direct script access allowed');

class BB_Functions
{

    function Maintenance_Message()
    {
        global $db, $lang, $forum_user;
        $pattern = array("\t", '  ', '  ');
        $replace = array('&nbsp; &nbsp; ', '&nbsp; ', ' &nbsp;');
        $message = str_replace($pattern, $replace, bb_maintenance_message);
        if (is_file(FORUM_ROOT . 'include/templates/' . $forum_user['template'] . '/forum_maintenance.tpl'))
            $tpl_maint = BB_Input::Trim(file_get_contents(FORUM_ROOT . 'include/templates/' . $forum_user['template'] . '/forum_maintenance.tpl'));
        else
            $tpl_maint = BB_Input::Trim(file_get_contents(FORUM_ROOT . 'include/templates/Default/forum_maintenance.tpl'));
        $tpl_maint = str_replace('<forum_content_direction>', $lang['lang_direction'], $tpl_maint);
        $tpl_maint = str_replace('<forum_char_encoding>', $lang['lang_encoding'], $tpl_maint);
        ob_start();
        ?>
        <title><?php echo BB_Input::Htmlspecialchars(BB_Functions::Page_Title()) . ' - ' . $lang['In_Maintenance'] ?></title>
        <link rel="stylesheet" type="text/css" href="<?php echo BB_Template::Get_Templates_Folder() . 'stylesheet.css' ?>" />
        <?php
        $tpl_temp = trim(ob_get_contents());
        $tpl_maint = str_replace('<forum_head>', $tpl_temp, $tpl_maint);
        ob_end_clean();
        $tpl_maint = str_replace('<forum_maintenance_heading>', $lang['In_Maintenance'], $tpl_maint);
        $tpl_maint = str_replace('<forum_maintenance_message>', $message, $tpl_maint);
        $db->end_transaction();
        $db->close();
        exit($tpl_maint);
    }

    function Display_Saved_Queries()
    {
        global $db, $lang;
        $saved_queries = $db->get_saved_queries();
        ?>
        <br />
        <div id="debug" class="blocktable">
            <h2><span><?php echo $lang['Debug table'] ?></span></h2>
            <div class="box">
                <div class="inbox">
                    <table cellspacing="0">
                        <thead>
                            <tr>
                                <th class="tcl" scope="col"><?php echo $lang['Time'] ?></th>
                                <th class="tcr" scope="col"><?php echo $lang['Query'] ?></th>
                            </tr>
                        </thead>
                        <tbody>
        <?php
        $query_time_total = 0.0;
        while (list(, $cur_query) = @each($saved_queries))
        {
            $query_time_total += $cur_query[1];
            ?>
                                <tr>
                                    <td class="tcl"><?php echo ($cur_query[1] != 0) ? $cur_query[1] : '&nbsp;' ?></td>
                                    <td class="tcr"><?php echo BB_Input::Htmlspecialchars($cur_query[0]) ?></td>
                                </tr>
            <?php
        }
        ?>
                            <tr>
                                <td class="tcl" colspan="2"><?php echo $lang['Total query time:'] . $query_time_total . ' ' . $lang['sec'] ?></td>
                            </tr>
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
        <?php
    }

    function Error($message, $file, $line, $db_error = false)
    {
        global $db, $lang, $forum_user;
        @ob_end_clean();
        if (is_file(FORUM_ROOT . 'include/templates/' . $forum_user['template'] . '/forum_error.tpl'))
            $tpl_error = BB_Input::Trim(file_get_contents(FORUM_ROOT . 'include/templates/' . $forum_user['template'] . '/forum_error.tpl'));
        else
            $tpl_error = BB_Input::Trim(file_get_contents(FORUM_ROOT . 'include/templates/Default/forum_error.tpl'));
        $tpl_error = str_replace('<forum_content_direction>', $lang['lang_direction'], $tpl_error);
        $tpl_error = str_replace('<forum_char_encoding>', $lang['lang_encoding'], $tpl_error);
        ob_start();
        ?>
        <title><?php echo BB_Input::Htmlspecialchars($lang['Errors'] . ' (powered by XennoBB)') ?></title>
        <link rel="stylesheet" type="text/css" href="<?php echo BB_Template::Get_Templates_Folder() . 'stylesheet.css' ?>" />
        <?php
        $tpl_temp = trim(ob_get_contents());
        $tpl_error = str_replace('<forum_head>', $tpl_temp, $tpl_error);
        ob_end_clean();
        $tpl_error = str_replace('<forum_error_heading>', $lang['Errors'], $tpl_error);
        $tpl_temp = $message . '<br />';
        $tpl_error = str_replace('<forum_error_text>', $tpl_temp, $tpl_error);
        ob_start();
        $tpl_temp = trim(ob_get_contents());
        $tpl_error = str_replace('<forum_footer>', $tpl_temp, $tpl_error);
        ob_end_clean();
        if ($db_error)
            $GLOBALS['db']->close();
        exit($tpl_error);
    }

    function Redirect($destination_url, $message)
    {
        global $db, $lang, $forum_user;
        if ($destination_url == '')
            $destination_url = '/index.php';
        if (bb_redirect_delay == '0')
            header('Location: ' . str_replace('&amp;', '&', $destination_url));
        if (is_file(FORUM_ROOT . 'include/templates/' . $forum_user['template'] . '/forum_redirect.tpl'))
            $tpl_redir = BB_Input::Trim(file_get_contents(FORUM_ROOT . 'include/templates/' . $forum_user['template'] . '/forum_redirect.tpl'));
        else
            $tpl_redir = BB_Input::Trim(file_get_contents(FORUM_ROOT . 'include/templates/Default/forum_redirect.tpl'));
        $tpl_redir = str_replace('<forum_content_direction>', $lang['lang_direction'], $tpl_redir);
        $tpl_redir = str_replace('<forum_char_encoding>', $lang['lang_encoding'], $tpl_redir);
        ob_start();
        $redirect_url = str_replace(array('<', '>', '"'), array('&lt;', '&gt;', '&quot;'), $destination_url);
        ?>
        <meta http-equiv="refresh" content="<?php echo bb_redirect_delay ?>;URL=<?php echo $redirect_url ?>" />
        <title><?php echo BB_Input::Htmlspecialchars(BB_Functions::Page_Title()) . ' - ' . $lang['Redirecting'] ?></title>
        <link rel="stylesheet" type="text/css" href="<?php echo BB_Template::Get_Templates_Folder() ?>stylesheet.css" />
        <?php
        $tpl_temp = BB_Input::Trim(ob_get_contents());
        $tpl_redir = str_replace('<forum_head>', $tpl_temp, $tpl_redir);
        ob_end_clean();
        $tpl_redir = str_replace('<forum_redir_heading>', $lang['Redirecting'], $tpl_redir);
        $tpl_temp = $message . '<br /><br />' . '<a href="' . $destination_url . '">' . $lang['Click redirect'] . '</a>';
        $tpl_redir = str_replace('<forum_redir_text>', $tpl_temp, $tpl_redir);
        ob_start();
        $db->end_transaction();
        $tpl_temp = BB_Input::Trim(ob_get_contents());
        $tpl_redir = str_replace('<forum_footer>', $tpl_temp, $tpl_redir);
        ob_end_clean();
        $db->close();
        exit($tpl_redir);
    }

    function Page_Title()
    {
        if (isset($GLOBALS['cms_custom_title_page']) && !defined('IN_FORUM_ADMIN'))
            return BB_Input::Htmlspecialchars($GLOBALS['cms_custom_title_page'] . ' (powered by XennoBB)');
        else if (defined('IN_FORUM_ADMIN'))
            return BB_Input::Htmlspecialchars($GLOBALS['cms_custom_title_page']);
        else
            return BB_Input::Htmlspecialchars(bb_board_title . ' (powered by XennoBB)');
    }

    function Message($message, $no_back_link = false, $type = 0)
    {
        global $db, $lang, $forum_user, $cms_start, $cms_blocks;
        @ob_end_clean();
        switch ($type)
        {
            case 1:
                BB_Functions::Redirect(bb_website_url, $message);
                break;
            case 0:
            default:
                if (is_file(FORUM_ROOT . 'include/templates/' . $forum_user['template'] . '/forum_message.tpl'))
                    $tpl_message = BB_Input::Trim(file_get_contents(FORUM_ROOT . 'include/templates/' . $forum_user['template'] . '/forum_message.tpl'));
                else
                    $tpl_message = BB_Input::Trim(file_get_contents(FORUM_ROOT . 'include/templates/Default/forum_message.tpl'));
                break;
        }
        $cms_custom_title_page = $lang['Info'];
        $tpl_message = str_replace('<forum_content_direction>', $lang['lang_direction'], $tpl_message);
        $tpl_message = str_replace('<forum_char_encoding>', $lang['lang_encoding'], $tpl_message);
        ob_start();
        ?>
        <title><?php echo BB_Input::Htmlspecialchars(BB_Functions::Page_Title()) . ' - ' . $lang['Message'] ?></title>
        <link rel="stylesheet" type="text/css" href="<?php echo BB_Template::Get_Templates_Folder() . 'stylesheet.css' ?>" />
        <?php
        $tpl_temp = trim(ob_get_contents());
        $tpl_message = str_replace('<forum_head>', $tpl_temp, $tpl_message);
        ob_end_clean();
        $tpl_message = str_replace('<forum_message_heading>', $lang['Message'], $tpl_message);
        if (!$no_back_link)
            $tpl_temp = $message . '<br /><br /><br /><br /><input type="button" class="b1" onclick="javascript:history.go(-1)" value="' . $lang['Go back'] . '" />';
        else
            $tpl_temp = $message . '<br />';
        $tpl_message = str_replace('<forum_message_text>', $tpl_temp, $tpl_message);
        ob_start();
        $db->end_transaction();
        $tpl_temp = trim(ob_get_contents());
        $tpl_message = str_replace('<forum_footer>', $tpl_temp, $tpl_message);
        ob_end_clean();
        $db->close();
        exit($tpl_message);
    }

    function Set_Menu()
    {
        global $lang, $forum_user;
        $links[] = "\t\t\t" . '<li id="navigation_index"><a href="' . bb_forum_url . '">' . $lang['Message Board'] . '</a>';
        if ($forum_user['g_view_users'] == '1')
        {
            $links[] = "\t\t\t" . '<li id="navigation_userlist"><a class="navbar" href="' . bb_forum_url . 'members.php?Page=userlist">' . $lang['User list'] . '</a>';
            if (bb_um_enable == '1')
                $links[] = "\t\t\t" . '<li id="navigation_map"><a href="' . bb_forum_url . 'map.php">' . $lang['User map'] . '</a></li>';
        }
        if ($forum_user['is_guest'])
        {
            if ($forum_user['g_search'] == '1')
                $links[] = "\t\t\t" . '<li id="navigation_test"><a href="' . bb_forum_url . 'search.php">' . $lang['Search'] . '</a>';
            $links[] = "\t\t\t" . '<li id="navigation_register"><a href="' . bb_forum_url . 'register.php">' . $lang['Register'] . '</a>';
            $info = $lang['Not logged in'];
        }
        else
        {
            if ($forum_user['g_id'] > USER_MOD)
            {
                if ($forum_user['g_search'] == '1')
                    $links[] = "\t\t\t" . '<li id="navigation_test"><a href="' . bb_forum_url . 'search.php">' . $lang['Search'] . '</a>';
                if (bb_pms_enabled && $forum_user['g_pm'] == 1)
                    $links[] = "\t\t\t" . '<li id="navigation_message_list"><a href="' . bb_forum_url . 'messages.php?Page=List">' . $lang['Messages'] . '</a>';
                $links[] = "\t\t\t" . '<li id="navigation_member"><a href="' . bb_forum_url . BB_Input::Rewrite_URL("u", $forum_user['id'], $forum_user['username']) . '">' . $lang['MyProfile'] . '</a>';
            }
            else
            {
                $links[] = "\t\t\t" . '<li id="navigation_test"><a href="' . bb_forum_url . 'search.php">' . $lang['Search'] . '</a>';
                $links[] = "\t\t\t" . '<li id="navigation_member"><a href="' . bb_forum_url . BB_Input::Rewrite_URL("u", $forum_user['id'], $forum_user['username']) . '">' . $lang['MyProfile'] . '</a>';
            }
        }
        if (bb_additional_navlinks != '')
        {
            if (preg_match_all('#([0-9]+)\s*=\s*(.*?)\n#s', bb_additional_navlinks . "\n", $extra_links))
            {
                for ($i = 0; $i < count($extra_links[1]); ++$i)
                    array_splice($links, $extra_links[1][$i], 0, array('<li id="navigation_extra' . ($i + 1) . '">' . $extra_links[2][$i]));
            }
        }
        return "\n\t\t\t\t" . implode('</li>' . "\n\t\t\t\t", $links) . '</li>' . "\n\t\t\t";
    }

    function Set_Profile_Menu($page = '')
    {
        global $lang, $forum_user, $id;

        if ($id == $forum_user['id'] || $forum_user['g_id'] < 3)
        {
            ?>
            <div class="blockform">
                <h2><span style="float:left;">
            <?php
            if (($forum_user['g_id'] == USER_ADMIN) || ($forum_user['g_id'] == USER_MOD) || ($forum_user['id'] == $id) || ($forum_user['g_global_moderation']))
            {
                if (!isset($id) || $id == 0 || $_GET['Page'] == 'Delete')
                    $id = $forum_user['id'];
                ?>
                            <a rel="nofollow" href="<?php echo bb_forum_url ?>member.php?section=personal&amp;id=<?php echo $id ?>" <?php if ($page == 'personal')
                    echo 'style="text-decoration:underline"'; ?>><?php echo $lang['Section personal'] ?></a> -
                            <a rel="nofollow" href="<?php echo bb_forum_url ?>member.php?section=essentials&amp;id=<?php echo $id ?>" <?php if ($page == 'essentials')
                    echo 'style="text-decoration:underline"'; ?>><?php echo $lang['Section essentials'] ?></a> -
                            <a rel="nofollow" href="<?php bb_forum_url ?>member.php?section=personality&amp;id=<?php echo $id ?>" <?php if ($page == 'personality')
                    echo 'style="text-decoration:underline"'; ?>><?php echo $lang['Section personality'] ?></a> -
                            <a rel="nofollow" href="<?php echo bb_forum_url ?>member.php?section=display&amp;id=<?php echo $id ?>" <?php if ($page == 'display')
                    echo 'style="text-decoration:underline"'; ?>><?php echo $lang['Section display'] ?></a> -
                            <a rel="nofollow" href="<?php echo bb_forum_url ?>member.php?section=privacy&amp;id=<?php echo $id ?>" <?php if ($page == 'privacy')
                    echo 'style="text-decoration:underline"'; ?>><?php echo $lang['Section privacy'] ?></a> -
                <?php
                if ($forum_user['g_id'] == USER_ADMIN || $forum_user['g_global_moderation'] || ($forum_user['g_id'] == USER_MOD && bb_mod_ban_users == '1'))
                {
                    ?>
                                <a rel="nofollow" href="<?php echo bb_forum_url ?>member.php?section=admin&amp;id=<?php echo $id ?>" <?php if ($page == 'admin')
                        echo 'style="text-decoration:underline"'; ?>><?php echo $lang['Section admin'] ?></a> -
                    <?php
                }
            }
            ?>
                        <a href="<?php echo bb_forum_url ?>member.php?action=view&amp;id=<?php echo $id ?>" <?php if ($page == 'view')
                echo 'style="text-decoration:underline"'; ?>><?php echo $lang['View profile'] ?></a>
                    </span>
                    <span style="float:right;">
            <?php
            if (bb_pms_enabled && $forum_user['g_pm'] == 1)
            {
                ?>
                            <a href="<?php echo bb_forum_url ?>messages.php?Page=List" <?php if ($page == 'pms')
                    echo 'style="text-decoration:underline"'; ?>><?php echo $lang['Private Messages'] ?></a>
                <?php
            }
            ?>
                    </span></h2>
                <div class="clearer"></div>
            </div>
            <?php
        }
        else
            return '';
    }

    function Decode_URI_Segments()
    {
        if (!empty($_SERVER['QUERY_STRING']))
        {
            $uri_string = explode('&', $_SERVER['QUERY_STRING']);
            $segments = array();
            foreach ($uri_string as $keys)
            {
                $values = explode('=', $keys);
                if (empty($values[1]))
                    $values[1] = '0';
                $segments[] = $values[0] . '=' . $values[1];
            }
            return implode('&', $segments);
        }
        return '';
    }

    function quicklinks()
    {
        global $lang, $forum_user;
        ?>
        <div class="blockform" id="quicklinks">
            <div class="inbox">
                <div class="box">
                    <p style="float:left;">&nbsp;&nbsp;<a href="<?php echo bb_forum_url ?>search.php?action=show_new"><?php echo $lang['Show new posts'] ?></a><br />&nbsp;&nbsp;<a href="<?php echo bb_forum_url ?>search.php?action=show_24h"><?php echo $lang['Show recent posts'] ?></a></p>

                    <p style="float:right;text-align:right;"><a href="<?php echo bb_forum_url ?>search.php?action=show_subscriptions"><?php echo $lang['Show subscriptions'] ?></a>&nbsp;&nbsp;<br /><a href="<?php echo bb_forum_url ?>search.php?action=show_unanswered"><?php echo $lang['Show unanswered posts'] ?></a>&nbsp;&nbsp;</p>

                    <p style="text-align:center;"><a href="<?php echo bb_forum_url ?>/search.php?action=show_user&user_id=<?php echo $forum_user['id'] ?>"><?php echo $lang['Show your posts'] ?></a><br /><a href="<?php echo bb_forum_url ?>/misc.php?action=markread"><?php echo $lang['Mark all as read'] ?></a></p>

                    <div class="clearer"></div>
                </div>
            </div>
        </div>
        <?php
    }

}
?>
