<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
if (!defined('IN_FORUM'))
    exit('No direct script access allowed');

class BB_Admin_Functions
{

    function Log_Action($message = '', $log = 0)
    {
        global $db, $forum_user, $db_prefix;
        $result = $db->query("INSERT INTO " . $db_prefix . "logs (user_id, user_name, user_ip, date, log, code) VALUES ('" . $forum_user['id'] . "', '" . $forum_user['username'] . "', '" . $db->escape(BB_Input::Get_Remote_Address()) . "', '" . date('Y-m-d H:i:s') . "', '" . $db->escape($message) . "', '" . $db->escape($log) . "');") or BB_Functions::Error('Cannot create a new XennoBB log entry.', __FILE__, __LINE__, $db->error());
        return true;
    }

    function Set_Admin_Menu()
    {
        global $forum_user, $cms_modules, $cms_blocks, $lang;
        $is_admin = $forum_user['g_id'] == USER_ADMIN ? true : false;
        $admin_menu = '';
        $block = '<div class="blockform"><h2><span>%s</span></h2><div class="box">%s</div></div>';
        $tmp = '<ul>';
        $tmp .= '<li><a href="' . bb_website_url . '/admin/index.php?Page=Intro">' . $lang['Index'] . '</a></li>';
        if ($is_admin)
        {
            $tmp .= '<li><a href="' . bb_website_url . '/admin/notes.php?Page=ToDo">' . $lang['Notes'] . '</a></li>';
            $tmp .= '<li><a href="' . bb_website_url . '/admin/categories.php?Page=Edit">' . $lang['Categories'] . '</a></li>';
            $tmp .= '<li><a href="' . bb_website_url . '/admin/forums.php?Page=Edit">' . $lang['Forums'] . '</a></li>';
            $tmp .= '<li><a href="' . bb_website_url . '/admin/users.php?Page=Add">' . $lang['Users'] . '</a></li>';
            $tmp .= '<li><a href="' . bb_website_url . '/admin/usergroups.php?Page=Edit">' . $lang['UserGroups'] . '</a></li>';
            $tmp .= '<li><a href="' . bb_website_url . '/admin/options.php?Page=General">' . $lang['Basic options'] . '</a></li>';
            $tmp .= '<li><a href="' . bb_website_url . '/admin/options.php?Page=Reports">' . $lang['Advanced options'] . '</a></li>';
            $tmp .= '<li><a href="' . bb_website_url . '/admin/options.php?Page=Signatures">' . $lang['Extra options'] . '</a></li>';
            $tmp .= '<li><a href="' . bb_website_url . '/admin/ranks.php?Page=Configure">' . $lang['Ranks'] . '</a></li>';
            $tmp .= '<li><a href="' . bb_website_url . '/admin/cleaning.php?Page=RebuildIndex">' . $lang['Cleaning'] . '</a></li>';
            $tmp .= '<li><a href="' . bb_website_url . '/admin/maintenance.php?Page=RegenerateCache">' . $lang['Maintenance'] . '</a></li>';
            $tmp .= '<li><a href="' . bb_website_url . '/admin/reports.php?Page=New">' . $lang['Reports'] . '</a></li>';
        }
        $tmp .= '<li><a href="' . bb_website_url . '/admin/censoring.php?Page=Configure">' . $lang['Censoring'] . '</a></li>';
        $tmp .= '<li><a href="' . bb_website_url . '/admin/bans.php?Page=Edit">' . $lang['Bans'] . '</a></li>';
        $tmp .= '</ul>';
        $admin_menu = sprintf($block, $lang['Forum menu'], $tmp);
        $tmp = '<ul>';
        if ($is_admin)
        {
            $tmp .= '<li><a href="' . bb_website_url . '/admin/permissions.php">' . $lang['Permissions'] . '</a></li>';
            $tmp .= '<li><a href="' . bb_website_url . '/admin/modules.php">' . $lang['Modules'] . '</a></li>';
            $tmp .= '<li><a href="' . bb_website_url . '/admin/blocks.php">' . $lang['Blocks'] . '</a></li>';
            $tmp .= '<li><a href="' . bb_website_url . '/admin/themes.php">' . $lang['Themes'] . '</a></li>';
            $tmp .= '<li><a href="' . bb_website_url . '/admin/langs.php">' . $lang['Languages'] . '</a></li>';
            $tmp .= '<li><a href="' . bb_website_url . '/admin/logs.php">' . $lang['Logging'] . '</a></li>';
        }
        $tmp .= '</ul>';
        $admin_menu .= sprintf($block, $lang['CMS menu'], $tmp);
        $items = array();
        foreach ($cms_modules->Installed_Elements() as $m)
        {
            if (file_exists($cms_modules->path . $m . '/admin.php') && BB_Admin_Functions::Check_Permissions('module_' . $m))
                $items[] = '<li><a href="' . bb_website_url . '/admin/loader.php?module=' . $m . '">' . BB_Admin_Functions::Get_Name($m) . '</a></li>';
        }
        if (!empty($items))
            $admin_menu .= sprintf($block, $lang['Modules'], '<ul>' . implode("\n", $items) . '</ul>');
        $items = array();
        foreach ($cms_blocks->Installed_Elements() as $b)
        {
            if (file_exists($cms_blocks->path . $b . '/admin.php') && BB_Admin_Functions::Check_Permissions('block_' . $b))
                $items[] = '<li><a href="' . bb_website_url . '/admin/loader.php?block=' . $b . '">' . BB_Admin_Functions::Get_Name($b, 'block') . '</a></li>';
        }
        if (!empty($items))
            $admin_menu .= sprintf($block, $lang['Blocks'], '<ul>' . implode("\n", $items) . '</ul>');
        $items = array();
        $plugins = array();
        $d = dir(FORUM_ROOT . 'include/plugins');
        while (($entry = $d->read()) !== false)
        {
            $prefix = substr($entry, 0, strpos($entry, '_'));
            $suffix = substr($entry, strlen($entry) - 4);
            if ($suffix == '.php' && ((!$is_admin && $prefix == 'am') || ($is_admin && ($prefix == 'a' || $prefix == 'am'))))
                $plugins[] = array(substr(substr($entry, strpos($entry, '_') + 1), 0, -4), $entry);
        }
        $d->close();
        if (!empty($plugins))
        {
            while (list(, $cur_plugin) = @each($plugins))
                $items[] = '<li' . (($page == $cur_plugin[1]) ? ' class="isactive"' : '') . '><a href="' . bb_website_url . '/admin/plugin.php?plugin=' . $cur_plugin[1] . '">' . str_replace('_', ' ', $cur_plugin[0]) . '</a></li>';
        }
        if (!empty($plugins))
            $admin_menu .= sprintf($block, $lang['Plugins'], '<ul>' . implode("\n", $items) . '</ul>');
        return $admin_menu;
    }

    function Get_Name($extension_id, $extension_type = 'module')
    {
        $str = ($extension_type == 'module') ? 'lang_cms_main_module_' . $extension_id : 'lang_cms_main_block_' . $extension_id;
        if (isset($GLOBALS[$str][$extension_id]))
            return $GLOBALS[$str][$extension_id];
        else
            return $extension_id;
    }

    function Check_Extension($extension_id, $name, $element = 'module')
    {
        global $cms_blocks, $cms_themes, $cms_languages, $cms_modules, $lang;
        $config_link = '';
        $info_link = '';
        $enable_link = '';
        $install_link = '';
        $delete_link = '';
        $package_link = '';
        $type = $element;
        if ($type == 'module')
        {
            $config_name = 'bb_module_' . $extension_id;
            $url = bb_website_url . '/admin/modules.php';
            $path = $cms_modules->path;
            $del_message = $lang['sure_del_module'];
        }
        else if ($type == 'theme')
        {
            $url = bb_website_url . '/admin/themes.php';
            $path = $cms_themes->path;
            $del_message = $lang['sure_del_theme'];
        }
        else if ($type == 'lang')
        {
            $url = bb_website_url . '/admin/langs.php';
            $path = $cms_languages->path;
            $del_message = $lang['sure_del_lang'];
        }
        else
        {
            $config_name = 'bb_block_' . $extension_id;
            $url = bb_website_url . '/admin/blocks.php';
            $path = $cms_blocks->path;
            $del_message = $lang['sure_del_block'];
        }
        if ($type == 'module' || $type == 'block')
        {
            if (defined($config_name))
            {
                if (constant($config_name) == 1)
                    $enable_link = '<a href="' . $url . '?disable=' . $extension_id . '" title="' . $lang['disable'] . ' ' . $name . '"><img src="' . bb_forum_url . 'img/admin/disable.png" alt="' . $lang['disable'] . ' ' . $name . '" /></a>';
                else if (constant($config_name) == 0)
                    $enable_link = '<a href="' . $url . '?enable=' . $extension_id . '" title="' . $lang['enable'] . ' ' . $name . '"><img src="' . bb_forum_url . 'img/admin/enable.png" alt="' . $lang['enable'] . ' ' . $name . '" /></a>';
                else
                    $enable_link = '<img src="../img/admin/warning.png" alt="' . $lang['error'] . '" />';
                if (file_exists($path . $extension_id . '/install/uninstall.php'))
                    $install_link = '<a href="' . $url . '?uninstall=' . $extension_id . '" title="' . $lang['uninstall'] . ' ' . $name . '"><img src="' . bb_forum_url . 'img/admin/uninstall.png" alt="' . $lang['uninstall'] . ' ' . $name . '" /></a>';
                else
                    $install_link = '';
                if (file_exists($path . $extension_id . '/admin.php'))
                    $config_link = '<a href="' . bb_website_url . '/admin/loader.php?' . $type . '=' . $extension_id . '" title="' . $lang['manage'] . ' ' . $name . '"><img src="' . bb_forum_url . 'img/admin/preferences.png" alt="' . $lang['manage'] . ' ' . $name . '" /></a>';
            }
            else
            {
                if (file_exists($path . $extension_id . '/install/install.php'))
                    $install_link = '<a href="' . $url . '?install=' . $extension_id . '" title="' . $lang['install'] . ' ' . $name . '"><img src="' . bb_forum_url . 'img/admin/install.png" alt="' . $lang['install'] . ' ' . $name . '" /></a>';
                else
                    $install_link = '';
                $delete_link = '<a href="' . $url . '?delete=' . $extension_id . '" title="' . $lang['Delete'] . ' ' . $name . '" onclick="return window.confirm(\'' . addslashes($del_message) . '\')"><img src="' . bb_forum_url . 'img/admin/trash.png" alt="' . $lang['Delete'] . ' ' . $name . '" /></a>';
            }
            $info_link = '<a href="' . $url . '?info=' . $extension_id . '" title="' . $lang['info'] . ' ' . $name . '"><img src="' . bb_forum_url . 'img/admin/tooltip.png" alt="' . $lang['info'] . ' ' . $name . '" /></a>';
            $package_link = '<a href="' . $url . '?pack=' . $extension_id . '" title="' . $lang['export'] . ' ' . $name . '"><img src="' . bb_forum_url . 'img/admin/pack.png" alt="' . $lang['export'] . ' ' . $name . '" /></a>';
        }
        else if ($type == 'theme')
        {
            if (bb_default_style == $name)
                $enable_link = '<img src="' . bb_forum_url . 'img/admin/disable.png" alt="' . $lang['disable'] . ' ' . $name . '" />';
            else
                $enable_link = '<a href="' . $url . '?enable=' . $extension_id . '" title="' . $lang['enable'] . ' ' . $name . '"><img src="' . bb_forum_url . 'img/admin/enable.png" alt="' . $lang['enable'] . ' ' . $name . '" /></a>';
            $config_link = '<a href="' . $url . '?config=' . $extension_id . '" title="' . $lang['manage'] . ' ' . $name . '"><img src="' . bb_forum_url . 'img/admin/preferences.png" alt="' . $lang['manage'] . ' ' . $name . '" /></a>';
            $install_link = '';
            if ($extension_id == 'Default')
                $delete_link = '';
            else
                $delete_link = '<a href="' . $url . '?delete=' . $extension_id . '" title="' . $lang['Delete'] . ' ' . $name . '" onclick="return window.confirm(\'' . addslashes($del_message) . '\')"><img src="' . bb_forum_url . 'img/admin/trash.png" alt="' . $lang['Delete'] . ' ' . $name . '" /></a>';
            $info_link = '<a href="' . $url . '?info=' . $extension_id . '" title="' . $lang['info'] . ' ' . $name . '"><img src="' . bb_forum_url . 'img/admin/tooltip.png" alt="' . $lang['info'] . ' ' . $name . '" /></a>';
            if ($extension_id == 'Default')
                $package_link = '';
            else
                $package_link = '<a href="' . $url . '?pack=' . $extension_id . '" title="' . $lang['export'] . ' ' . $name . '"><img src="' . bb_forum_url . 'img/admin/pack.png" alt="' . $lang['export'] . ' ' . $name . '" /></a>';
        }
        else
        {
            if (bb_default_lang == $name)
                $enable_link = '<img src="' . bb_forum_url . 'img/admin/disable.png" alt="' . $lang['disable'] . ' ' . $name . '" />';
            else
                $enable_link = '<a href="' . $url . '?enable=' . $extension_id . '" title="' . $lang['enable'] . ' ' . $name . '"><img src="' . bb_forum_url . 'img/admin/enable.png" alt="' . $lang['enable'] . ' ' . $name . '" /></a>';
            $config_link = '<a href="' . $url . '?config=' . $extension_id . '" title="' . $lang['manage'] . ' ' . $name . '"><img src="' . bb_forum_url . 'img/admin/preferences.png" alt="' . $lang['manage'] . ' ' . $name . '" /></a>';
            $install_link = '';
            if ($extension_id == 'English')
                $delete_link = '';
            else
                $delete_link = '<a href="' . $url . '?delete=' . $extension_id . '" title="' . $lang['Delete'] . ' ' . $name . '" onclick="return window.confirm(\'' . addslashes($del_message) . '\')"><img src="' . bb_forum_url . 'img/admin/trash.png" alt="' . $lang['Delete'] . ' ' . $name . '" /></a>';
            $info_link = '<a href="' . $url . '?info=' . $extension_id . '" title="' . $lang['info'] . ' ' . $name . '"><img src="' . bb_forum_url . 'img/admin/tooltip.png" alt="' . $lang['info'] . ' ' . $name . '" /></a>';
            if ($extension_id == 'English')
                $package_link = '';
            else
                $package_link = '<a href="' . $url . '?pack=' . $extension_id . '" title="' . $lang['export'] . ' ' . $name . '"><img src="' . bb_forum_url . 'img/admin/pack.png" alt="' . $lang['export'] . ' ' . $name . '" /></a>';
        }
        return '<td>' . $info_link . '</td>' . "\n" . '<td>' . $config_link . '</td>' . "\n" . '<td>' . $enable_link . '</td>' . "\n" . '<td>' . $install_link . '</td>' . "\n" . '<td>' . $package_link . '</td>' . "\n" . '<td>' . $delete_link . '</td>' . "\n";
    }

    function Prune($forum_id, $prune_sticky, $prune_date)
    {
        global $db;
        $extra_sql = ($prune_date != -1) ? ' AND last_post<' . $prune_date : '';
        if (!$prune_sticky)
            $extra_sql .= ' AND sticky=\'0\'';
        $result = $db->query('SELECT id FROM ' . $db->prefix . 'topics WHERE forum_id=' . $forum_id . $extra_sql, true) or BB_Functions::Error($lang['error_37'], __FILE__, __LINE__, $db->error());
        $topic_ids = '';
        while ($row = $db->fetch_row($result))
            $topic_ids .= ( ($topic_ids != '') ? ',' : '') . $row[0];
        if ($topic_ids != '')
        {
            $result = $db->query('SELECT id FROM ' . $db->prefix . 'posts WHERE topic_id IN(' . $topic_ids . ')', true) or BB_Functions::Error($lang['error_101'], __FILE__, __LINE__, $db->error());
            $post_ids = '';
            while ($row = $db->fetch_row($result))
                $post_ids .= ( ($post_ids != '') ? ',' : '') . $row[0];
            if ($post_ids != '')
            {
                $db->query('DELETE FROM ' . $db->prefix . 'topics WHERE id IN(' . $topic_ids . ')') or BB_Functions::Error($lang['error_136'], __FILE__, __LINE__, $db->error());
                $db->query('DELETE FROM ' . $db->prefix . 'subscriptions WHERE topic_id IN(' . $topic_ids . ')') or BB_Functions::Error($lang['error_137'], __FILE__, __LINE__, $db->error());
                $db->query('DELETE FROM ' . $db->prefix . 'posts WHERE id IN(' . $post_ids . ')') or BB_Functions::Error($lang['error_138'], __FILE__, __LINE__, $db->error());
                BB_Core::Remove_Search_Index($post_ids);
            }
        }
    }

    function Check_Permissions($extension = '')
    {
        global $forum_user;
        if ($extension == '')
            return false;
        $perm_to_check = 'bb_perm_' . $extension;
        if ($forum_user['g_id'] == USER_ADMIN)
            return true;
        else if ($forum_user['g_id'] == USER_MOD && constant($perm_to_check) == 1)
            return true;
        else
            return false;
    }

}

?>
