<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
if (!defined('IN_FORUM'))
    exit('No direct script access allowed');

class BB_Input
{

    function Is_Alpha($str)
    {
        return (!preg_match("/^([-a-z])+$/i", $str)) ? FALSE : TRUE;
    }

    function Ia_Alpha_Numeric($str)
    {
        return (!preg_match("/^([-a-z0-9])+$/i", $str)) ? FALSE : TRUE;
    }

    function Is_Numeric($str)
    {
        return (!is_numeric($str)) ? FALSE : TRUE;
    }

    function Sanitize_Globals()
    {
        if (@ini_get('register_globals'))
        {
            if (isset($_REQUEST['GLOBALS']) || isset($_FILES['GLOBALS']))
                exit('Have a nice day.');
            $dnu = array('GLOBALS', '_GET', '_POST', '_COOKIE', '_REQUEST', '_SERVER', '_ENV', '_FILES');
            $lst = array_merge($_GET, $_POST, $_COOKIE, $_SERVER, $_ENV, $_FILES, isset($_SESSION) && is_array($_SESSION) ? $_SESSION : array());
            foreach ($lst as $k => $v)
            {
                if (!in_array($k, $dnu) && isset($GLOBALS[$k]))
                {
                    unset($GLOBALS[$k]);
                    unset($GLOBALS[$k]);
                }
            }
        }
        if (is_array($_POST) AND count($_POST) > 0)
        {
            foreach ($_POST as $key => $val)
            {
                if (is_array($val))
                {
                    foreach ($val as $k => $v)
                        $_POST[BB_Input::__Clean_Input_Keys($key)][BB_Input::__Clean_Input_Keys($k)] = BB_Input::__Clean_Input_Data($v);
                }
                else
                    $_POST[BB_Input::__Clean_Input_Keys($key)] = BB_Input::__Clean_Input_Data($val);
            }
        }
        if (is_array($_COOKIE) AND count($_COOKIE) > 0)
        {
            foreach ($_COOKIE as $key => $val)
                $_COOKIE[BB_Input::__Clean_Input_Keys($key)] = BB_Input::__Clean_Input_Data($val);
        }
    }

    function __Clean_Input_Data($str)
    {
        if (is_array($str))
        {
            $new_array = array();
            foreach ($str as $key => $val)
                $new_array[$key] = BB_Input::__Clean_Input_Data($val);
            return $new_array;
        }
        $str = BB_Input::XSS_Clean($str);
        return preg_replace("/\015\012|\015|\012/", "\n", $str);
    }

    function __Clean_Input_Keys($str)
    {
        if (!preg_match("/^[a-z0-9:_\/-]+$/i", $str))
            BB_Functions::Error('Disallowed Key Characters: ' . $str);
        if (!get_magic_quotes_gpc())
            return addslashes($str);
        return $str;
    }

    function XSS_Clean($str, $charset = 'ISO-8859-1')
    {
        $str = preg_replace('/\0+/', '', $str);
        $str = preg_replace('/(\\\\0)+/', '', $str);
        $str = preg_replace('#(&\#*\w+)[\x00-\x20]+;#u', "\\1;", $str);
        $str = preg_replace('#(&\#x*)([0-9A-F]+);*#iu', "\\1\\2;", $str);
        $str = preg_replace("/%u0([a-z0-9]{3})/i", "&#x\\1;", $str);
        $str = preg_replace("/%([a-z0-9]{2})/i", "&#x\\1;", $str);
        if (preg_match_all("/<(.+?)>/si", $str, $matches))
        {
            for ($i = 0; $i < count($matches['0']); $i++)
                $str = str_replace($matches['1'][$i], BB_Input::__Html_Entity_Decode($matches['1'][$i], $charset), $str);
        }
        $str = preg_replace("#\t+#", " ", $str);
        $str = str_replace(array('<?php', '<?PHP', '<?', '?>'), array('&lt;?php', '&lt;?PHP', '&lt;?', '?&gt;'), $str);
        $words = array('javascript', 'vbscript', 'script', 'applet', 'alert', 'document', 'write', 'cookie', 'window');
        foreach ($words as $word)
        {
            $temp = '';
            for ($i = 0; $i < strlen($word); $i++)
                $temp .= substr($word, $i, 1) . "\s*";
            $temp = substr($temp, 0, -3);
            $str = preg_replace('#' . $temp . '#is', $word, $str);
        }
        $str = preg_replace("#<a.+?href=.*?(alert\(|alert&\#40;|javascript\:|window\.|document\.|\.cookie|<script|<xss).*?\>.*?</a>#si", "", $str);
        $str = preg_replace("#<img.+?src=.*?(alert\(|alert&\#40;|javascript\:|window\.|document\.|\.cookie|<script|<xss).*?\>#si", "", $str);
//                $str = preg_replace("#<(script|xss).*?\>#si", "", $str);
        $str = preg_replace('#(<[^>]+.*?)(onblur|onchange|onclick|onfocus|onload|onmouseover|onmouseup|onmousedown|onselect|onsubmit|onunload|onkeypress|onkeydown|onkeyup|onresize)[^>]*>#iU', "\\1>", $str);
        $str = preg_replace('#<(/*\s*)(alert|applet|basefont|base|behavior|bgsound|blink|body|embed|expression|form|frameset|frame|head|html|ilayer|iframe|input|layer|link|meta|object|plaintext|style|script|textarea|title|xml|xss)([^>]*)>#is', "&lt;\\1\\2\\3&gt;", $str);
        $str = preg_replace('#(alert|cmd|passthru|eval|exec|system|fopen|fsockopen|file|file_get_contents|readfile|unlink)(\s*)\((.*?)\)#si', "\\1\\2&#40;\\3&#41;", $str);
        $bad = array('document.cookie' => '', 'document.write' => '', 'window.location' => '', "javascript\s*:" => '', "Redirect\s+302" => '', '<!--' => '&lt;!--', '-->' => '--&gt;');
        foreach ($bad as $key => $val)
            $str = preg_replace("#" . $key . "#i", $val, $str);
        return $str;
    }

    function __Html_Entity_Decode($str, $charset='ISO-8859-1')
    {
        if (stristr($str, '&') === FALSE)
            return $str;
        if (function_exists('html_entity_decode') && (strtolower($charset) != 'utf-8' OR version_compare(phpversion(), '5.0.0', '>=')))
        {
            $str = html_entity_decode($str, ENT_COMPAT, $charset);
            $str = preg_replace('~&#x([0-9a-f]{2,5})~ei', 'chr(hexdec("\\1"))', $str);
            return preg_replace('~&#([0-9]{2,4})~e', 'chr(\\1)', $str);
        }
        $str = preg_replace('~&#x([0-9a-f]{2,5});{0,1}~ei', 'chr(hexdec("\\1"))', $str);
        $str = preg_replace('~&#([0-9]{2,4});{0,1}~e', 'chr(\\1)', $str);
        if (stristr($str, '&') === FALSE)
            $str = strtr($str, array_flip(get_html_translation_table(HTML_ENTITIES)));
        return $str;
    }

    function Random_Pass($len)
    {
        $chars = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
        $password = '';
        for ($i = 0; $i < $len; ++$i)
            $password .= substr($chars, (mt_rand() % strlen($chars)), 1);
        return $password;
    }

    function Hash($str)
    {
        if (function_exists('sha1'))
            return sha1($str);
        else if (function_exists('mhash'))
            return bin2hex(mhash(MHASH_SHA1, $str));
        else
            return md5($str);
    }

    function Is_Valid_IP($ip)
    {
        return (!preg_match("/^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$/", $ip)) ? FALSE : TRUE;
    }

    function User_Agent()
    {
        return (!isset($_SERVER['HTTP_USER_AGENT'])) ? FALSE : $_SERVER['HTTP_USER_AGENT'];
    }

    function Get_Remote_Address()
    {
        $ip_address = '';
        $clientip = (isset($_SERVER['HTTP_CLIENT_IP']) AND $_SERVER['HTTP_CLIENT_IP'] != "") ? $_SERVER['HTTP_CLIENT_IP'] : FALSE;
        $remoteip = (isset($_SERVER['REMOTE_ADDR']) AND $_SERVER['REMOTE_ADDR'] != "") ? $_SERVER['REMOTE_ADDR'] : FALSE;
        $forwardip = (isset($_SERVER['HTTP_X_FORWARDED_FOR']) AND $_SERVER['HTTP_X_FORWARDED_FOR'] != "") ? $_SERVER['HTTP_X_FORWARDED_FOR'] : FALSE;
        if ($clientip && $remoteip)
            $ip_address = $clientip;
        elseif ($remoteip)
            $ip_address = $remoteip;
        elseif ($clientip)
            $ip_address = $clientip;
        elseif ($forwardip)
            $ip_address = $forwardip;
        if (strstr($ip_address, ','))
        {
            $x = explode(',', $ip_address);
            $ip_address = end($x);
        }
        if (!BB_Input::Is_Valid_IP($ip_address))
            $ip_address = '0.0.0.0';
        unset($clientip);
        unset($remoteip);
        unset($forwardip);
        return $ip_address;
    }

    function Entity_To_Decimal_Value($string)
    {
        static $entities_dec = false;
        if (!is_array($entities_dec))
        {
            $entities_named = array("&nbsp;", "&iexcl;", "&cent;", "&pound;", "&curren;", "&yen;", "&brvbar;", "&sect;", "&uml;", "&copy;", "&ordf;", "&laquo;", "&not;", "&shy;", "&reg;", "&macr;", "&deg;", "&plusmn;", "&sup2;", "&sup3;", "&acute;", "&micro;", "&para;", "&middot;", "&cedil;", "&sup1;", "&ordm;", "&raquo;", "&frac14;", "&frac12;", "&frac34;", "&iquest;", "&Agrave;", "&Aacute;", "&Acirc;", "&Atilde;", "&Auml;", "&Aring;", "&AElig;", "&Ccedil;", "&Egrave;", "&Eacute;", "&Ecirc;", "&Euml;", "&Igrave;", "&Iacute;", "&Icirc;", "&Iuml;", "&ETH;", "&Ntilde;", "&Ograve;", "&Oacute;", "&Ocirc;", "&Otilde;", "&Ouml;", "&times;", "&Oslash;", "&Ugrave;", "&Uacute;", "&Ucirc;", "&Uuml;", "&Yacute;", "&THORN;", "&szlig;", "&agrave;", "&aacute;", "&acirc;", "&atilde;", "&auml;", "&aring;", "&aelig;", "&ccedil;", "&egrave;", "&eacute;", "&ecirc;", "&euml;", "&igrave;", "&iacute;", "&icirc;", "&iuml;", "&eth;", "&ntilde;", "&ograve;", "&oacute;", "&ocirc;", "&otilde;", "&ouml;", "&divide;", "&oslash;", "&ugrave;", "&uacute;", "&ucirc;", "&uuml;", "&yacute;", "&thorn;", "&yuml;", "&fnof;", "&Alpha;", "&Beta;", "&Gamma;", "&Delta;", "&Epsilon;", "&Zeta;", "&Eta;", "&Theta;", "&Iota;", "&Kappa;", "&Lambda;", "&Mu;", "&Nu;", "&Xi;", "&Omicron;", "&Pi;", "&Rho;", "&Sigma;", "&Tau;", "&Upsilon;", "&Phi;", "&Chi;", "&Psi;", "&Omega;", "&alpha;", "&beta;", "&gamma;", "&delta;", "&epsilon;", "&zeta;", "&eta;", "&theta;", "&iota;", "&kappa;", "&lambda;", "&mu;", "&nu;", "&xi;", "&omicron;", "&pi;", "&rho;", "&sigmaf;", "&sigma;", "&tau;", "&upsilon;", "&phi;", "&chi;", "&psi;", "&omega;", "&thetasym;", "&upsih;", "&piv;", "&bull;", "&hellip;", "&prime;", "&Prime;", "&oline;", "&frasl;", "&weierp;", "&image;", "&real;", "&trade;", "&alefsym;", "&larr;", "&uarr;", "&rarr;", "&darr;", "&harr;", "&crarr;", "&lArr;", "&uArr;", "&rArr;", "&dArr;", "&hArr;", "&forall;", "&part;", "&exist;", "&empty;", "&nabla;", "&isin;", "&notin;", "&ni;", "&prod;", "&sum;", "&minus;", "&lowast;", "&radic;", "&prop;", "&infin;", "&ang;", "&and;", "&or;", "&cap;", "&cup;", "&int;", "&there4;", "&sim;", "&cong;", "&asymp;", "&ne;", "&equiv;", "&le;", "&ge;", "&sub;", "&sup;", "&nsub;", "&sube;", "&supe;", "&oplus;", "&otimes;", "&perp;", "&sdot;", "&lceil;", "&rceil;", "&lfloor;", "&rfloor;", "&lang;", "&rang;", "&loz;", "&spades;", "&clubs;", "&hearts;", "&diams;", "&quot;", "&amp;", "&lt;", "&gt;", "&OElig;", "&oelig;", "&Scaron;", "&scaron;", "&Yuml;", "&circ;", "&tilde;", "&ensp;", "&emsp;", "&thinsp;", "&zwnj;", "&zwj;", "&lrm;", "&rlm;", "&ndash;", "&mdash;", "&lsquo;", "&rsquo;", "&sbquo;", "&ldquo;", "&rdquo;", "&bdquo;", "&dagger;", "&Dagger;", "&permil;", "&lsaquo;", "&rsaquo;", "&euro;", "&apos;");
            $entities_decimal = array("&#160;", "&#161;", "&#162;", "&#163;", "&#164;", "&#165;", "&#166;", "&#167;", "&#168;", "&#169;", "&#170;", "&#171;", "&#172;", "&#173;", "&#174;", "&#175;", "&#176;", "&#177;", "&#178;", "&#179;", "&#180;", "&#181;", "&#182;", "&#183;", "&#184;", "&#185;", "&#186;", "&#187;", "&#188;", "&#189;", "&#190;", "&#191;", "&#192;", "&#193;", "&#194;", "&#195;", "&#196;", "&#197;", "&#198;", "&#199;", "&#200;", "&#201;", "&#202;", "&#203;", "&#204;", "&#205;", "&#206;", "&#207;", "&#208;", "&#209;", "&#210;", "&#211;", "&#212;", "&#213;", "&#214;", "&#215;", "&#216;", "&#217;", "&#218;", "&#219;", "&#220;", "&#221;", "&#222;", "&#223;", "&#224;", "&#225;", "&#226;", "&#227;", "&#228;", "&#229;", "&#230;", "&#231;", "&#232;", "&#233;", "&#234;", "&#235;", "&#236;", "&#237;", "&#238;", "&#239;", "&#240;", "&#241;", "&#242;", "&#243;", "&#244;", "&#245;", "&#246;", "&#247;", "&#248;", "&#249;", "&#250;", "&#251;", "&#252;", "&#253;", "&#254;", "&#255;", "&#402;", "&#913;", "&#914;", "&#915;", "&#916;", "&#917;", "&#918;", "&#919;", "&#920;", "&#921;", "&#922;", "&#923;", "&#924;", "&#925;", "&#926;", "&#927;", "&#928;", "&#929;", "&#931;", "&#932;", "&#933;", "&#934;", "&#935;", "&#936;", "&#937;", "&#945;", "&#946;", "&#947;", "&#948;", "&#949;", "&#950;", "&#951;", "&#952;", "&#953;", "&#954;", "&#955;", "&#956;", "&#957;", "&#958;", "&#959;", "&#960;", "&#961;", "&#962;", "&#963;", "&#964;", "&#965;", "&#966;", "&#967;", "&#968;", "&#969;", "&#977;", "&#978;", "&#982;", "&#8226;", "&#8230;", "&#8242;", "&#8243;", "&#8254;", "&#8260;", "&#8472;", "&#8465;", "&#8476;", "&#8482;", "&#8501;", "&#8592;", "&#8593;", "&#8594;", "&#8595;", "&#8596;", "&#8629;", "&#8656;", "&#8657;", "&#8658;", "&#8659;", "&#8660;", "&#8704;", "&#8706;", "&#8707;", "&#8709;", "&#8711;", "&#8712;", "&#8713;", "&#8715;", "&#8719;", "&#8721;", "&#8722;", "&#8727;", "&#8730;", "&#8733;", "&#8734;", "&#8736;", "&#8743;", "&#8744;", "&#8745;", "&#8746;", "&#8747;", "&#8756;", "&#8764;", "&#8773;", "&#8776;", "&#8800;", "&#8801;", "&#8804;", "&#8805;", "&#8834;", "&#8835;", "&#8836;", "&#8838;", "&#8839;", "&#8853;", "&#8855;", "&#8869;", "&#8901;", "&#8968;", "&#8969;", "&#8970;", "&#8971;", "&#9001;", "&#9002;", "&#9674;", "&#9824;", "&#9827;", "&#9829;", "&#9830;", "&#34;", "&#38;", "&#60;", "&#62;", "&#338;", "&#339;", "&#352;", "&#353;", "&#376;", "&#710;", "&#732;", "&#8194;", "&#8195;", "&#8201;", "&#8204;", "&#8205;", "&#8206;", "&#8207;", "&#8211;", "&#8212;", "&#8216;", "&#8217;", "&#8218;", "&#8220;", "&#8221;", "&#8222;", "&#8224;", "&#8225;", "&#8240;", "&#8249;", "&#8250;", "&#8364;", "&#39;");
            if (function_exists('array_combine'))
                $entities_dec = array_combine($entities_named, $entities_decimal);
            else
            {
                $i = 0;
                foreach ($entities_named as $_entities_named)
                    $entities_dec[$_entities_named] = $entities_decimal[$i++];
            }
        }
        return preg_replace("/&[A-Za-z]+;/", " ", strtr($string, $entities_dec));
    }

    function Confirm_Referrer($script)
    {
        global $lang;
        if (bb_rewrite_urls == 1)
        {
            static $rewrites = array('member.php' => 'u', 'topic.php' => 't', 'forum.php' => 'f');
            $referer = str_replace('www.', '', (isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : ''));
            $allowed_referer_base = preg_quote(str_replace('www.', '', bb_forum_url), '#');
            $allowed_referer = preg_quote($script, '#');
            if (!preg_match('#^' . $allowed_referer_base . $allowed_referer . '#i', $referer))
            {
                if (array_key_exists($script, $rewrites))
                {
                    $allowed_rewrites = $rewrites[$script] . '[0-9]+-[0-9|a-b|\-|\.]*';
//                                        if (!preg_match('#^'.$allowed_referer_base.$allowed_rewrites.'#i', $referer)) BB_Functions::Message($lang['Bad referrer']);
                }
//                                else BB_Functions::Message($lang['Bad referrer']);
            }
        }
        else
        {
//                        if (!preg_match('#^'.preg_quote(str_replace('www.', '', bb_forum_url).'/'.$script, '#').'#i', str_replace('www.', '', (isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : '')))) BB_Functions::Message($lang['Bad referrer']);
        }
    }

    function Encode_XML($data)
    {
        $data = str_replace('<br(.*?)>', "\n", $data);
        $data = preg_replace("/<\/(pre|ul|li|p|table|tr)>/", "\n", $data);
        $data = preg_replace("/<(.*?)>/", "", $data);
        $data = preg_replace("/\n\n+/", "\n\n", $data);
        return BB_Input::Entity_To_Decimal_Value($data);
    }

    function Rewrite_URL($type, $id, $name)
    {
        if (bb_rewrite_urls == 1)
        {
            $url = strtr($name, '�����������������������������������������������������/', 'AAAAAAaaaaaaOOOOOOooooooEEEEeeeeCcIIIIiiiiUUUUuuuuyNn-');
            $url = preg_replace('/ /', '-', $url);
            $url = trim(preg_replace('/[^a-z|A-Z|0-9|-]/', '', strtolower($url)), '-');
            $url = preg_replace('/\-+/', '-', $url);
            return urlencode($type . $id . '-' . $url . '.html');
        }
        else
        {
            switch ($type)
            {
                case 'u':
                    return 'member.php?id=' . $id;
                    break;
                case 't':
                    return 'topic.php?id=' . $id;
                    break;
                case 'l':
                    return 'topic.php?type=poll&amp;id=' . $id;
                    break;
                case 'p':
                    return 'topic.php?pid=' . $id;
                    break;
                case 'f':
                    return 'forum.php?id=' . $id;
                    break;
            }
        }
    }

    function Check_Cookie(&$forum_user)
    {
        global $db, $forum_user, $cookie_name, $cookie_seed;
        $now = time();
        $expire = $now + 31536000;
        $cookie = array('user_id' => 1, 'password_hash' => 'Guest');
        if (isset($_COOKIE[$cookie_name]))
            list($cookie['user_id'], $cookie['password_hash']) = @unserialize($_COOKIE[$cookie_name]);
        $cookie['user_id'] = BB_Input::Htmlspecialchars($cookie['user_id']);
        if ($cookie['user_id'] > 1)
        {
            $result = $db->query('SELECT u.*, g.*, o.logged, o.idle FROM ' . $db->prefix . 'users AS u INNER JOIN ' . $db->prefix . 'usergroups AS g ON u.gid=g.g_id LEFT JOIN ' . $db->prefix . 'online AS o ON o.user_id=u.id WHERE u.id=' . $db->escape(intval($cookie['user_id']))) or BB_Functions::Error('Unable to fetch user information', __FILE__, __LINE__, $db->error());
            $forum_user = $db->fetch_assoc($result);
            if (!isset($forum_user['id']) || md5($cookie_seed . $forum_user['password']) !== $cookie['password_hash'])
            {
                BB_Input::Set_Cookie(0, BB_Input::Random_Pass(8), $expire);
                BB_Core::Set_Default_User();
                return;
            }
            if (!@file_exists(FORUM_ROOT . 'include/languages/' . $forum_user['language']))
                $forum_user['language'] = bb_default_lang;
            if (!@file_exists(FORUM_ROOT . 'include/templates/' . $forum_user['template'] . '/stylesheet.css'))
                $forum_user['template'] = bb_default_style;
            if (!$forum_user['disp_topics'])
                $forum_user['disp_topics'] = bb_disp_topics_default;
            if (!$forum_user['disp_posts'])
                $forum_user['disp_posts'] = bb_disp_posts_default;
            if ($forum_user['save_pass'] == '0')
                $expire = 0;
            if ($forum_user['read_topics'])
                $forum_user['read_topics'] = unserialize($forum_user['read_topics']);
            else
                $forum_user['read_topics'] = array();
            if (!defined('QUIET_VISIT'))
            {
                if (!$forum_user['logged'])
                {
                    $db->query('INSERT INTO ' . $db->prefix . 'online (user_id, ident, logged, color) VALUES(' . $forum_user['id'] . ', \'' . $db->escape($forum_user['username']) . '\', ' . $now . ', \'' . $db->escape($forum_user['g_color']) . '\')') or BB_Functions::Error('Unable to insert into online list', __FILE__, __LINE__, $db->error());
                    if ($forum_user['invisible'] == '1')
                        $db->query('UPDATE ' . $db->prefix . 'online SET invisible=1 WHERE user_id=' . $forum_user['id']) or BB_Functions::Error('Unable to update user visit data', __FILE__, __LINE__, $db->error());
                }
                else
                {
                    if ($forum_user['logged'] < ($now - bb_timeout_visit))
                    {
                        $db->query('UPDATE ' . $db->prefix . 'users SET last_visit=' . $forum_user['logged'] . ', read_topics=NULL WHERE id=' . $forum_user['id']) or BB_Functions::Error('Unable to update user visit data', __FILE__, __LINE__, $db->error());
                        $forum_user['last_visit'] = $forum_user['logged'];
                    }
                    $idle_sql = ($forum_user['idle'] == '1') ? ', idle=0' : '';
                    $db->query('UPDATE ' . $db->prefix . 'online SET logged=' . $now . $idle_sql . ' WHERE user_id=' . $forum_user['id']) or BB_Functions::Error('Unable to update online list', __FILE__, __LINE__, $db->error());
                }
            }
            $forum_user['is_guest'] = false;
        }
        else
            BB_Core::Set_Default_User();
    }

    function Set_Cookie($user_id, $password_hash, $expire)
    {
        global $cookie_name, $cookie_path, $cookie_domain, $cookie_secure, $cookie_seed;
        setcookie($cookie_name, serialize(array($user_id, md5($cookie_seed . $password_hash))), $expire, $cookie_path, $cookie_domain, $cookie_secure);
    }

    function Spam_Protect($installed = TRUE, $ip = FALSE)
    {
        global $db, $forum_user;
        if ($installed === FALSE)
            return;
//                if (!in_array(basename($_SERVER['PHP_SELF']), explode(',', bb_spam_protect)) || !array_key_exists('o_spam_settings', $configuration) || !array_key_exists('o_spam_protect', $configuration)) return;
        $config = explode(',', bb_spam_settings);
        $config = array('server' => $config[0], 'expire' => intval($config[1]), 'max' => intval($config[2]), 'trust' => intval($config[3]), 'chk_admin' => intval($config[4]), 'chk_mods' => intval($config[5]));
        switch (TRUE)
        {
            case($forum_user['g_id'] == USER_ADMIN && $config['chk_admin'] === 0):
            case($forum_user['g_id'] == USER_MOD && $config['chk_mods'] === 0):
            case($forum_user['num_posts'] >= $config['trust'] && $config['trust'] !== 0):
                return;
            default:
                break;
        }
        if ($ip === FALSE)
            $ip = BB_Input::Get_Remote_Address();
        $result = $db->query('SELECT ip, time, blocked, total FROM ' . $db->prefix . 'spam_protect WHERE ip=\'' . $db->escape($ip) . '\' LIMIT 1') or BB_Functions::Error($lang['error_145'], __FILE__, __LINE__, $db->error());
        $cur_status = $db->fetch_assoc($result);
        if ($cur_status['total'] >= $config['max'] && $config['max'] != 0)
            BB_Functions::Message($lang['error_149'], true);
        elseif ($cur_status['blocked'] == 1 && time() - $cur_status['time'] < $config['expire'])
            BB_Functions::Message($lang['error_148'], true);
        elseif (time() - $cur_status['time'] > $config['expire'] || !isset($cur_status['ip']))
        {
            $rev = array_reverse(explode('.', $ip));
            $lookup = implode('.', $rev) . '.' . $config['server'];
            $isbanned = '0';
            if (!isset($cur_status['total']))
                $cur_status['total'] = '0';
            if ($lookup != gethostbyname($lookup))
            {
                $isbanned = '1';
                $cur_status['total']++;
            }
            if (isset($cur_status['ip']) && isset($cur_status['blocked']))
                $db->query('UPDATE ' . $db->prefix . 'spam_protect SET ip=\'' . $db->escape($ip) . '\', time=\'' . time() . '\', blocked=\'' . $db->escape($isbanned) . '\', total=\'' . $db->escape($cur_status['total']) . '\' WHERE ip=\'' . $db->escape($ip) . '\'') or BB_Functions::Error($lang['error_146'], __FILE__, __LINE__, $db->error());
            if (!isset($cur_status['ip']))
                $result = $db->query('INSERT INTO ' . $db->prefix . 'spam_protect (ip, time, blocked, total) VALUES (\'' . $db->escape($ip) . '\', \'' . time() . '\', \'' . $db->escape($isbanned) . '\', \'' . $db->escape($cur_status['total']) . '\')') or BB_Functions::Error($lang['error_147'], __FILE__, __LINE__, $db->error());
            if ($isbanned == 1)
                BB_Functions::Message($lang['error_148'], true);
        }
    }

    function Censor_Words($text)
    {
        global $db;
        static $search_for, $replace_with;
        if (!isset($search_for))
        {
            $result = $db->query('SELECT search_for, replace_with FROM ' . $db->prefix . 'censoring') or BB_Functions::Error('Unable to fetch censor word list', __FILE__, __LINE__, $db->error());
            $num_words = $db->num_rows($result);
            $search_for = array();
            for ($i = 0; $i < $num_words; ++$i)
            {
                list($search_for[$i], $replace_with[$i]) = $db->fetch_row($result);
                $search_for[$i] = '/\b(' . str_replace('\*', '\w*?', preg_quote($search_for[$i], '/')) . ')\b/i';
            }
        }
        if (!empty($search_for))
            $text = substr(preg_replace($search_for, $replace_with, ' ' . $text . ' '), 1, -1);
        return $text;
    }

    function Suggest($keywords)
    {
        global $db, $lang;
        if (isset($_GET['suggest']) || empty($keywords))
            BB_Functions::Message($lang['No hits']);
        $suggest = array();
        $bold = array();
        foreach ($keywords as $cur_word)
        {
            $len = strlen($cur_word);
            if ($len < 3 || $cur_word == 'and' || $cur_word == 'or' || $cur_word == 'not')
                continue;
            $size = round($len / 3);
            $cur_word1 = substr($cur_word, 0, $size);
            $cur_word2 = substr($cur_word, $size, $size);
            $cur_word3 = substr($cur_word, 2 * $size);
            $result = $db->query('SELECT w.word, COUNT(m.post_id) AS c FROM ' . $db->prefix . 'search_words AS w INNER JOIN ' . $db->prefix . 'search_matches AS m ON m.word_id = w.id WHERE CHAR_LENGTH(w.word) >= ' . ($len - 2) . ' and CHAR_LENGTH(w.word) <= ' . ($len + 2) . ' and (w.word like \'' . $cur_word1 . '%\' or w.word like \'%' . $cur_word2 . '%\' or w.word like \'%' . $cur_word3 . '\') GROUP BY w.word ORDER BY c DESC LIMIT 50', true) or BB_Functions::Error('Unable to search for posts', __FILE__, __LINE__, $db->error());
            while ($temp = $db->fetch_row($result))
            {
                if (levenshtein($temp[0], $cur_word) <= 2)
                {
                    $suggest[$cur_word] = $temp[0];
                    $bold[$cur_word] = '<b><i>' . $temp[0] . '</i></b>';
                    break;
                }
            }
        }
        if (empty($suggest))
            BB_Functions::Message($lang['No hits']);
        $_GET['keywords'] = strtolower(trim($_GET['keywords']));
        $suggestion = str_replace(array_keys($bold), array_values($bold), $_GET['keywords']);
        $_GET['keywords'] = str_replace(array_keys($suggest), array_values($suggest), $_GET['keywords']);
        $q = '';
        foreach ($_GET as $k => $v)
            $q .= $k . '=' . $v . '&';
        BB_Functions::Message('Did you mean: <a href="search.php?' . $q . 'suggest=1">' . $suggestion . '</a> ?</p><p>' . $lang['No hits']);
    }

    function Format_Time($timestamp, $date_only = false)
    {
        global $lang, $forum_user;
        if ($timestamp == '')
            return $lang['Never'];
        $diff = ($forum_user['timezone'] - bb_server_timezone) * 3600;
        $timestamp += $diff;
        $now = time();
        $date = date(bb_date_format, $timestamp);
        $today = date(bb_date_format, $now + $diff);
        $yesterday = date(bb_date_format, $now + $diff - 86400);
        if ($date == $today)
            $date = $lang['Today'];
        else if ($date == $yesterday)
            $date = $lang['Yesterday'];
        if (!$date_only)
            return $date . ' ' . date(bb_time_format, $timestamp);
        else
            return $date;
    }

    function Split_Words($text)
    {
        global $forum_user;
        static $noise_match, $noise_replace, $stopwords;
        if (empty($noise_match))
        {
            $noise_match = array('[quote', '[code', '[url', '[img', '[email', '[color', '[colour', 'quote]', 'code]', 'url]', 'img]', 'email]', 'color]', 'colour]', '^', '$', '&', '(', ')', '<', '>', '`', '\'', '"', '|', ',', '@', '_', '?', '%', '~', '+', '[', ']', '{', '}', ':', '\\', '/', '=', '#', ';', '!', '*');
            $noise_replace = array('', '', '', '', '', '', '', '', '', '', '', '', '', '', ' ', ' ', ' ', ' ', ' ', ' ', ' ', '', '', ' ', ' ', ' ', ' ', '', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', '', ' ', ' ', ' ', ' ', ' ', ' ');
            $stopwords = (array) @file(FORUM_ROOT . 'include/languages/' . $forum_user['language'] . '/stopwords.txt');
            $stopwords = array_map('trim', $stopwords);
        }
        $patterns[] = '#&[\#a-z0-9]+?;#i';
        $patterns[] = '#\b[\w]+:\/\/[a-z0-9\.\-]+(\/[a-z0-9\?\.%_\-\+=&\/~]+)?#';
        $patterns[] = '#\[\/?[a-z\*=\+\-]+(\:?[0-9a-z]+)?:[a-z0-9]{10,}(\:[a-z0-9]+)?=?.*?\]#';
        $text = preg_replace($patterns, ' ', ' ' . strtolower($text) . ' ');
        $text = str_replace($noise_match, $noise_replace, $text);
        $text = trim(preg_replace('#\s+#', ' ', $text));
        $words = explode(' ', $text);
        if (!empty($words))
        {
            while (list($i, $word) = @each($words))
            {
                $words[$i] = trim($word, '.');
                $num_chars = BB_Input::Strlen($word);
                if ($num_chars < 3 || $num_chars > 20 || in_array($word, $stopwords))
                    unset($words[$i]);
            }
        }
        return array_unique($words);
    }

    function Htmlspecialchars($str)
    {
        $str = preg_replace('/&(?!#[0-9]+;)/s', '&amp;', $str);
        $str = str_replace(array('<', '>', '"'), array('&lt;', '&gt;', '&quot;'), $str);
        return $str;
    }

    function O_Htmlspecialchars($str)
    {
        $str = str_replace(array('<', '>', '"'), array('&lt;', '&gt;', '&quot;'), $str);
        return $str;
    }

    function Strlen($str)
    {
        return strlen(preg_replace('/&#([0-9]+);/', '!', $str));
    }

    function Linebreaks($str)
    {
        return str_replace("\r", "\n", str_replace("\r\n", "\n", $str));
    }

    function Trim($str)
    {
        global $lang;
        if (strpos($lang['lang_encoding'], '8859') !== false)
        {
            $not_allowed_chars = array(chr(0x81), chr(0x8D), chr(0x8F), chr(0x90), chr(0x9D), chr(0xA0));
            return trim(str_replace($not_allowed_chars, ' ', $str));
        }
        else
            return trim($str);
    }

}

?>
