<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
if (!defined('IN_FORUM'))
    exit('No direct script access allowed');

class BB_Cache
{

    function Generate_Bans()
    {
        global $db;
        $result = $db->query('SELECT * FROM ' . $db->prefix . 'bans', true) or BB_Functions::Error($lang['error_67'], __FILE__, __LINE__, $db->error());
        $output = array();
        while ($cur_ban = $db->fetch_assoc($result))
            $output[] = $cur_ban;
        $fh = @fopen(FORUM_ROOT . 'var/cache/cache_bans.php', 'wb');
        if (!$fh)
            BB_Functions::Error($lang['error_141'], __FILE__, __LINE__);
        fwrite($fh, '<?php' . "\n\n" . 'define(\'BANS_LOADED\', 1);' . "\n\n" . '$forum_bans = ' . var_export($output, true) . ';' . "\n\n" . '?>');
        fclose($fh);
    }

    function Generate_Ranks()
    {
        global $db;
        $result = $db->query('SELECT * FROM ' . $db->prefix . 'ranks ORDER BY min_posts', true) or BB_Functions::Error($lang['error_22'], __FILE__, __LINE__, $db->error());
        $output = array();
        while ($cur_rank = $db->fetch_assoc($result))
            $output[] = $cur_rank;
        $fh = @fopen(FORUM_ROOT . 'var/cache/cache_ranks.php', 'wb');
        if (!$fh)
            BB_Functions::Error($lang['error_141'], __FILE__, __LINE__);
        fwrite($fh, '<?php' . "\n\n" . 'define(\'RANKS_LOADED\', 1);' . "\n\n" . '$forum_ranks = ' . var_export($output, true) . ';' . "\n\n" . '?>');
        fclose($fh);
    }

    function Add_Language($extension, $type = 'module')
    {
        $type = ($type == 'module') ? 'module' : 'block';
        if ($type == 'module')
            $dir = $GLOBALS['cms_modules']->path . '/' . $extension;
        else
            $dir = $GLOBALS['cms_blocks']->path . '/' . $extension;
        if (is_dir($dir . '/lang_admin'))
        {
            $d = dir($dir . '/lang_admin');
            while (($entry = $d->read()) !== false)
            {
                if ($entry != '.' && $entry != '..' && substr($entry, strlen($entry) - 4) == '.php')
                {
                    $cache = FORUM_ROOT . 'var/cache/lang_admin_' . $entry;
                    if (file_exists($cache))
                    {
                        $str1 = file_get_contents($cache);
                        $str1 = BB_Cache::__Clean($str1, 0);
                    }
                    else
                        $str1 = '';
                    $str2 = file_get_contents($dir . '/lang_admin/' . $entry);
                    $str2 = BB_Cache::__Clean($str2, 1);
                    $str2 = '###start lang_' . $type . '_' . $extension . '###' . "\n" . $str2 . "\n" . '###end lang_' . $type . '_' . $extension . '###' . "\n";
                    if (!file_put_contents($cache, '<?php' . "\n" . $str1 . "\n" . $str2 . "\n" . '?>'))
                        return false;
                }
            }
            $d->close();
        }
        if (is_dir($dir . '/lang'))
        {
            $d = dir($dir . '/lang');
            while (($entry = $d->read()) !== false)
            {
                if ($entry != '.' && $entry != '..' && substr($entry, strlen($entry) - 4) == '.php')
                {
                    $cache = FORUM_ROOT . 'var/cache/lang_' . $entry;
                    if (file_exists($cache))
                    {
                        $str1 = file_get_contents($cache);
                        $str1 = BB_Cache::__Clean($str1, 0);
                    }
                    else
                        $str1 = '';
                    $str2 = file_get_contents($dir . '/lang/' . $entry);
                    $str2 = BB_Cache::__Clean($str2, 1);
                    $str2 = '###start lang_' . $type . '_' . $extension . '###' . "\n" . $str2 . "\n" . '###end lang_' . $type . '_' . $extension . '###' . "\n";
                    if (!file_put_contents($cache, '<?php' . "\n" . $str1 . "\n" . $str2 . "\n" . '?>'))
                        return false;
                }
            }
            $d->close();
        }
        return true;
    }

    function Remove_Language($extension, $type = 'module')
    {
        $type = ($type == 'module') ? 'module' : 'block';
        $dir = FORUM_ROOT . 'var/cache';
        $d = dir($dir);
        while (($entry = $d->read()) !== false)
        {
            if ($entry != '.' && $entry != '..' && substr($entry, strlen($entry) - 4) == '.php' && substr($entry, 0, 5) == 'lang_')
            {
                $str = file_get_contents($dir . '/' . $entry);
                $str = preg_replace('%###start lang_' . $type . '_' . $extension . '###(.*?)###end lang_' . $type . '_' . $extension . '###%s', '', $str);
                $str = BB_Cache::__Clean($str, 0);
                if (!file_put_contents($dir . '/' . $entry, '<?php' . "\n" . $str . "\n" . '?>'))
                    return false;
            }
        }
        $d->close();
        return true;
    }

    function Generate_Advertising_Config()
    {
        global $db;
        $result = $db->query('SELECT * FROM ' . $db->prefix . 'advertising_config', true) or BB_Functions::Error($lang['error_139'], __FILE__, __LINE__, $db->error());
        while ($cur_config_item = $db->fetch_row($result))
            $output[$cur_config_item[0]] = $cur_config_item[1];
        $fh = @fopen(FORUM_ROOT . 'var/cache/cache_ads_config.php', 'wb');
        if (!$fh)
            BB_Functions::Error($lang['error_141'], __FILE__, __LINE__);
        fwrite($fh, '<?php' . "\n\n" . 'define(\'ADS_CONFIG_LOADED\', 1);' . "\n\n" . '$ads_config = ' . var_export($output, true) . ';' . "\n\n" . '?>');
        fclose($fh);
    }

    function __Clean($str, $type)
    {
        $str = str_replace('<?php', '', $str);
        $str = str_replace('?>', '', $str);
        $str = preg_replace('#/\\*(.*?)\\*/#s', '', $str);
        if ($type == 1)
        {
            $str = preg_replace('#\s\s+#', " ", $str);
            $str = preg_replace('#\n\n+#', "\n", $str);
        }
        $str = trim($str);
        return $str;
    }

    function Generate_Smiley()
    {
        global $db;
        $smiley_text = array();
        $smiley_img = array();
        $result = $db->query('SELECT image, text FROM ' . $db->prefix . 'smilies ORDER BY disp_position') or BB_Functions::Error($lang['error_140'], __FILE__, __LINE__, $db->error());
        while ($db_smilies = $db->fetch_assoc($result))
        {
            $smiley_text[] = $db_smilies['text'];
            $smiley_img[] = $db_smilies['image'];
        }
        $smiley_text = array_map('addslashes', $smiley_text);
        $smiley_text = array_map('Htmlspecialchars', $smiley_text);
        $str = '';
        $str .= '<?php' . "\n\n";
        $str .= '$smiley_text = array(' . "\n";
        foreach ($smiley_text as $t)
            $str .= "'" . $t . "'," . "\n";
        $str .= ');' . "\n\n";
        $str .= '$smiley_img = array(' . "\n";
        foreach ($smiley_img as $i)
            $str .= "'" . $i . "'," . "\n";
        $str .= ');' . "\n\n";
        $str .= 'define(\'SMILEY_LOADED\', 1);' . "\n\n";
        $str .= '?>';
        $fh = @fopen(FORUM_ROOT . 'var/cache/cache_smilies.php', 'wb');
        if (!$fh)
            BB_Functions::Error($lang['error_141'], __FILE__, __LINE__);
        fwrite($fh, $str);
        fclose($fh);
    }

}

?>
