<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
require '../../include/init.php';
if ($forum_user['g_rep_enable'] == 0)
    BB_Functions::Message($lang['Group Disabled']);
if ($forum_user['reputation_enable_adm'] == 0)
    BB_Functions::Message($lang['Individual Disabled']);
if (bb_reputation_enabled == 0)
    BB_Functions::Message($lang['Disabled']);
if ($forum_user['reputation_enable'] == 0)
    BB_Functions::Message($lang['Your Disabled']);
require_once FORUM_ROOT . 'include/functions/Parser.php';
$page_title = BB_Input::Htmlspecialchars($lang['Reputation']);
if (isset($_POST['form_sent']))
{
    if (isset($_POST['delete_rep_id']))
    {
        if ($forum_user['g_id'] == USER_ADMIN || $forum_user['g_id'] == USER_MOD)
        {
            $uid = intval($_GET['uid']);
            $p = intval($_GET['p']);
            if ($uid < 2)
                BB_Functions::Message($lang['Bad request']);
            $idlist = implode(',', array_values($_POST['delete_rep_id']));
            BB_Input::Confirm_Referrer('Reputation.php');
            $db->query('DELETE FROM ' . $db->prefix . 'reputation WHERE id IN(' . $idlist . ')') or BB_Functions::Error($lang['error_998'], __FILE__, __LINE__, $db->error());
            BB_Functions::Redirect(bb_website_url . '/include/functions/Reputation.php?uid=' . $uid . '&p=' . $p, $lang['Deleted redirect']);
        }
        else
            BB_Functions::Message($lang['No permission'], true, 1);
    }
    if ($forum_user['is_guest'])
        BB_Functions::Message($lang['No permission'], true, 1);
    $pid = isset($_POST['pid']) ? intval($_POST['pid']) : BB_Functions::Message($lang['Bad request']);
    $poster = isset($_POST['poster']) ? $_POST['poster'] : BB_Functions::Message($lang['Bad request']);
    $method = isset($_POST['method']) ? intval($_POST['method']) : BB_Functions::Message($lang['Bad request']);
    if ($method != 2 && $method != 1)
        BB_Functions::Message($lang['Bad request']);
    $result = $db->query('SELECT p.poster, p.poster_id, p.posted, p.id, p.topic_id, t.subject, u.reputation_enable, r.time FROM ' . $db->prefix . 'posts AS p INNER JOIN ' . $db->prefix . 'topics AS t ON p.topic_id=t.id INNER JOIN ' . $db->prefix . 'users AS u ON p.poster_id = u.id LEFT JOIN ' . $db->prefix . 'reputation AS r ON (r.from_user_id =' . $forum_user["id"] . ' AND r.user_id = u.id) WHERE p.id=' . $db->escape($pid) . ' AND p.poster="' . $db->escape($poster) . '" ORDER BY r.time DESC LIMIT 0 , 1') or BB_Functions::Error($lang['error_998'], __FILE__, __LINE__, $db->error());
    if (!$db->num_rows($result))
        BB_Functions::Message($lang['Bad request']);
    $target = $db->fetch_assoc($result);
    if ($target['time'])
    {
        if (bb_reputation_timeout * 60 > (time() - $target['time']))
            BB_Functions::Message($lang['Timeout 1'] . bb_reputation_timeout . $lang['Timeout 2']);
    }
    if ($target['reputation_enable'] != 1)
        BB_Functions::Message($lang['User Disable']);
    if ($forum_user["id"] == $target["poster_id"])
        BB_Functions::Message($lang['Silly user']);
    if ((($forum_user['g_rep_minus_min'] > $forum_user['num_posts']) && ($method = 2) ) || (($forum_user['g_rep_plus_min'] > $forum_user['num_posts']) && ($method = 1) ))
        BB_Functions::Message($lang['Small Number of post']);
    $message = BB_Input::Linebreaks(BB_Input::Trim($_POST['req_message']));
    if ($message == '')
        BB_Functions::Message($lang['No message']);
    else if (strlen($message) > 400)
        BB_Functions::Message($lang['Too long message']);
    else if (bb_message_all_caps == '0' && strtoupper($message) == $message && $forum_user['g_id'] > USER_GUEST)
        $message = ucwords(strtolower($message));
    if (bb_message_bbcode == '1' && strpos($message, '[') !== false && strpos($message, ']') !== false)
        $message = BB_Parser::Preparse_BBCode($message, $errors);
    $message = addslashes($message);
    if (isset($errors))
        BB_Functions::Message($errors[0]);
    if ($method == 1)
        $rep_column = "rep_plus";
    else
        $rep_column="rep_minus";
    $db->query("INSERT INTO " . $db->prefix . "reputation (user_id, from_user_id, time, post_id, reason, topics_id, " . $rep_column . ") Values ('" . $db->escape($target['poster_id']) . "', '" . $db->escape($forum_user["id"]) . "', '" . mktime() . "', '" . $db->escape($target['id']) . "', '" . $db->escape($message) . "', '" . $db->escape($target['topic_id']) . "', '1')") or BB_Functions::Error($lang['error_998'], __FILE__, __LINE__, $db->error());
    BB_Functions::Redirect(bb_forum_url . 'topic.php?&pid=' . $pid . '#p' . $pid, $lang['Redirect Message']);
}
if (isset($_GET['uid']) && !isset($_GET['method']))
{
    require FORUM_ROOT . $forum_folder . '/header.php';
    $uid = intval($_GET['uid']);
    if ($uid < 2)
        BB_Functions::Message($lang['Bad request']);
    $result = $db->query('SELECT u.username, SUM(r.rep_plus) AS count_rep_plus, SUM(r.rep_minus) AS count_rep_minus FROM ' . $db->prefix . 'users AS u LEFT JOIN ' . $db->prefix . 'reputation as r ON r.user_id=u.id WHERE u.id=' . $db->escape($uid) . ' GROUP by u.id') or BB_Functions::Error($lang['error_998'], __FILE__, __LINE__, $db->error());
    if (!$db->num_rows($result))
        BB_Functions::Message($lang['Bad request']);
    $user_rep = $db->fetch_assoc($result);
    $result = $db->query('SELECT COUNT(*) FROM ' . $db->prefix . 'reputation WHERE user_id=' . $db->escape($uid)) or BB_Functions::Error($lang['error_998'], __FILE__, __LINE__, $db->error());
    list($num_rows) = $db->fetch_row($result);
    if ($num_rows > 0)
    {
        $num_pages = ceil(($num_rows + 1) / $forum_user['disp_posts']);
        $p = (!isset($_GET['p']) || $_GET['p'] <= 1 || $_GET['p'] > $num_pages) ? 1 : $_GET['p'];
        $start_from = $forum_user['disp_posts'] * ($p - 1);
        $paging_links = '<strong class="pagination">' . $lang['Pages'] . '</strong> ' . BB_Core::Paginate($num_pages, $p, 'Reputation.php?uid=' . $uid);
        $result = $db->query('SELECT r.id, r.time, r.reason, r.post_id, r.rep_plus, r.rep_minus, r.user_id, t.subject, u2.username as from_user_name, u2.id as from_user_id FROM ' . $db->prefix . 'reputation AS r LEFT JOIN ' . $db->prefix . 'users AS u ON r.user_id = u.id LEFT JOIN ' . $db->prefix . 'topics AS t ON t.id=r.topics_id LEFT JOIN ' . $db->prefix . 'users AS u2 ON r.from_user_id = u2.id WHERE u.id=' . $db->escape($uid) . ' ORDER BY r.time DESC LIMIT ' . $db->escape($start_from) . ',' . $forum_user['disp_posts']) or BB_Functions::Error($lang['error_998'], __FILE__, __LINE__, $db->error());
        $is_admmod = ($forum_user['g_id'] == USER_ADMIN || $forum_user['g_id'] == USER_MOD) ? true : false;
        $form_del = "\t\t\t\t" . '<form action="Reputation.php?p=' . $p . '&uid=' . $uid . '" method="post" name="multiselect">';
        $form_end = "\t\t\t\t" . '</form>';
        if ($is_admmod)
            echo $form_del . "\n" . "\t\t\t\t" . '<input type="hidden" name="form_sent" value="1" />' . "\n";
        ?>
        <div class="postlinksb">
            <div class="inbox">
                <p class="pagelink conl"><?php echo $paging_links ?></p>
                <div class="clearer"></div>
            </div>
        </div>
        <div class="blockform">
            <h2><span><?php echo $lang['User reputation'] . BB_Input::Htmlspecialchars($user_rep['username']) . '&nbsp;&nbsp;<strong>[+' . $user_rep['count_rep_plus'] . ' / -' . $user_rep['count_rep_minus'] . '] &nbsp;</strong>' ?></span></h2>
            <div class="box">
                <div class="inbox">
                    <table cellspacing="0">
                        <thead>
                            <tr>
                                <th class="tcl"><?php echo $lang['From user'] ?></th>
                                <th class="tc2" style="width:<?php if ($is_admmod)
                    {
                        echo '35';
                    }
                    else
                    {
                        echo '45';
                    } ?>%"><?php echo $lang['Reason'] ?></th>
                                <th class="tc3">&nbsp;</th>
                                <th class="tcr"><?php echo $lang['Date'] ?></th>
                                            <?php if ($is_admmod)
                                                echo '<th class="tcmod" style="text-align:left"><input name="allbox" type="checkbox" value="Check All" onclick="InboxCheckAll();" /></th>'; ?>
                            </tr>
                        <tbody>
        <?php
        while ($cur_rep = $db->fetch_assoc($result))
        {
            $cur_rep['reason'] = BB_Parser::Parse_Message($cur_rep['reason'], 0);
            ?>
                                <tr>                                        
                                    <td class="tcl"><?php echo $cur_rep['from_user_name'] ? '<a href="Reputation.php?uid=' . $cur_rep['from_user_id'] . '">' . BB_Input::Htmlspecialchars($cur_rep['from_user_name']) . '</a>' : $lang['Profile deleted'] ?></td>
                                    <td class="tc2"><?php echo $cur_rep['reason'] ?></td>
                                    <td class="tc3"><?php echo $cur_rep['rep_plus'] == 1 ? '<img src="' . BB_Template::Get_Image_Folder() . 'misc/plus.png" alt="+" border="0">' : '<img src="' . BB_Template::Get_Image_Folder() . 'misc/minus.png" alt="-" border="0">'; ?></td>
                                    <td class="tcr"><?php echo BB_Input::Format_Time($cur_rep['time']) ?></td>
                                    <?php if ($is_admmod)
                                        echo '<td class="tcmod" style="text-align:left"><input type="checkbox" onclick="cca(this);" name="delete_rep_id[]" value="' . $cur_rep['id'] . '"></td>'; ?>                                                
                                </tr>
                                    <?php
                                }
                            }
                            else
                            {
                                ?>
                        <div class="blockform">
                            <h2><span><?php echo $lang['User reputation'] . BB_Input::Htmlspecialchars($user_rep['username']) . '&nbsp;&nbsp;<strong>[+' . $user_rep['count_rep_plus'] . ' / -' . $user_rep['count_rep_minus'] . '] &nbsp;</strong>' ?></span></h2>
                            <div class="box">
                                <div class="inbox">
                                    <table cellspacing="0" style="table-layout:fixed">
                                        <tbody>
                                            <tr><td ><?php echo $lang['No reputation'] ?></td></tr>        
                        <?php
                    }
                    ?>
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>
                    <div class="clearer"></div>
                    <?php
                    if ($paging_links != '' || $is_admmod)
                    {
                        ?>
                        <div class="postlinksb">
                            <div class="inbox">
                                <p class="pagelink conl"><?php echo $paging_links ?></p>
                        <?php
                        if ($is_admmod)
                        {
                            ?>
                                    <p class="postlink conr"><input type="submit" class="b1" name="del_rep" value="Delete" onclick="return confirm('<?php echo $lang['Are you sure']; ?>')" /></p>
                            <?php
                        }
                        ?>                
                                <div class="clearer"></div>
                            </div>
                        </div>
        <?php
    }
    require FORUM_ROOT . $forum_folder . '/footer.php';
}
else
{
    if (empty($_GET['pid']) || empty($_GET['method']) || empty($_GET['uid']))
        BB_Functions::Message($lang['Bad request']);
    if ($forum_user['is_guest'])
        BB_Functions::Message($lang['No permission'], true, 1);
    $pid = intval($_GET['pid']);
    $method = intval($_GET['method']);
    $uid = intval($_GET['uid']);
    if ($forum_user["id"] == $uid)
        BB_Functions::Message($lang['Silly user']);
    if (($method != 1) && ($method != 2))
        BB_Functions::Message($lang['Bad request']);
    $result = $db->query('SELECT r.time, u.username FROM ' . $db->prefix . 'users AS u LEFT JOIN ' . $db->prefix . 'reputation AS r ON ( r.user_id=' . $db->escape($uid) . ' AND r.from_user_id=' . $forum_user["id"] . ' ) WHERE u.id=' . $db->escape($uid) . ' ORDER BY r.time DESC LIMIT 0 , 1') or BB_Functions::Error($lang['error_998'], __FILE__, __LINE__, $db->error());
    if (!$db->num_rows($result))
        BB_Functions::Message($lang['Bad request']);
    $target = $db->fetch_assoc($result);
    if ($target['time'])
    {
        if (bb_reputation_timeout * 60 > (time() - $target['time']))
            BB_Functions::Message($lang['Timeout 1'] . bb_reputation_timeout . $lang['Timeout 2']);
    }
    if ($forum_user["id"] == $uid)
        BB_Functions::Message($lang['Silly user']);
    if ((($forum_user['g_rep_minus_min'] > $forum_user['num_posts']) && ($method = 2) ) || (($forum_user['g_rep_plus_min'] > $forum_user['num_posts']) && ($method = 1) ))
        BB_Functions::Message($lang['Small Number of post']);
    $poster = BB_Input::Htmlspecialchars($target['username']);
    require FORUM_ROOT . $forum_folder . '/header.php';
    $form = '<form action="Reputation.php?" method="post" name="Reput" onsubmit="return Validate()">';
    ?>
                    <script language="javascript">
                        <!--
                        function Validate()
                        {
                            var Max = 100;
                            Length = document.Reput.req_message.value.length;
                            if ((Length > Max) && (Max > 0))
                            {
                                alert("<?php echo $lang['Max length of message'] ?> " + Max + " <?php echo $lang['You already of use'] ?> " + Length + " <?php echo $lang['Of symbol'] ?>");
                                return false;
                            }
                            else
                            {
                                document.Reput.submit.disabled = true;
                                return true;
                            }
                        }
                        // -->
                    </script>
                    <?php
                    echo $form . "\n"
                    ?>
                    <div class="blockform">
                        <h2><span><?php echo $lang['Form header'] ?></span></h2>
                        <div class="box">
                            <div class="inbox">
                                <input type="hidden" name="form_sent" value="1" />
                                <input type="hidden" name="pid" value="<?php echo $pid ?>" />        
                                <input type="hidden" name="poster" value="<?php echo $poster ?>" />        
                                <input type="hidden" name="method" value="<?php echo $method ?>" />                
                                <table cellspacing="0">
                                    <tr>
                                        <td  class="tc0" width="30%"><?php echo $lang['Form your name'] ?>:</td>
                                        <td  class="tc0" width="70%"><?php echo BB_Input::Htmlspecialchars($forum_user['username']) ?></td>
                                    </tr>
                                    <tr>
                                        <td class="tc0" width="30%"><?php echo $lang['Form to name'] ?>:</td>
                                        <td class="tc0" width="70%"><?php echo Htmlspecialchars($poster) ?></td>
                                    </tr>
                                    <tr>
                                        <td class="tc0" width="30%"><?php echo $lang['Form reason'] ?>:</td>
                                        <td class="tc0" width="70%"><textarea cols='60' rows='10' wrap='soft' name="req_message" class='textinput'></textarea></td>
                                    </tr>                                
                                    <tr>
                                        <td class="tc0" width="30%"><?php echo $lang['Form method'] ?>:</td>
                                        <td class="tc0" width="70%"><?php echo $method == 1 ? $lang['Plus'] : $lang['Minus']; ?></td>
                                    </tr>
                                </table>
                                <table cellspacing="0">
                                    <tr>
                                        <td  class="tc0" style="text-align:center;"><input type="button" class="b1" onclick="javascript:history.go(-1)" value="<?php echo $lang['Go back'] ?>"> <input type="submit" class="b1" name="submit" value="<?php echo $lang['Submit'] ?>"></td>
                                    </tr>
                                </table>
                            </div>
                        </div>
                    </div>
                    </form>
    <?php
    require FORUM_ROOT . $forum_folder . '/footer.php';
}
?>
