<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
if (!defined('IN_FORUM'))
    exit('No direct script access allowed');

class BB_Template
{

    function Get_Image_Folder($web = true)
    {
        global $forum_user;
        if ($web)
            return bb_website_url . '/include/templates/' . $forum_user['template'] . '/img/';
        else
            return FORUM_ROOT . 'include/templates/' . $forum_user['template'] . '/img/';
    }

    function Get_Templates_Folder($web = true)
    {
        global $forum_user;
        if ($web)
            return bb_website_url . '/include/templates/' . $forum_user['template'] . '/';
        else
            return FORUM_ROOT . 'include/templates/' . $forum_user['template'] . '/';
    }

    function Is_Template($theme_name)
    {
        if (is_dir(FORUM_ROOT . 'include/templates/' . $theme_name . '/') && is_file(FORUM_ROOT . 'include/templates/' . $theme_name . '/cms_main.tpl'))
            return true;
        else
            return false;
    }

    function Get_Module_Image_Folder($module_name, $web = true)
    {
        global $forum_user;
        if ($web)
            return bb_website_url . '/include/templates/' . $forum_user['template'] . '/modules/' . $module_name . '/img/';
        else
            return FORUM_ROOT . 'include/templates/' . $forum_user['template'] . '/modules/' . $module_name . '/img/';
    }

    function Get_Block_Image_Folder($block_name, $web = true)
    {
        global $forum_user;
        if ($web)
            return bb_website_url . '/include/templates/' . $forum_user['template'] . '/blocks/' . $block_name . '/img/';
        else
            return FORUM_ROOT . 'include/templates/' . $forum_user['template'] . '/blocks/' . $block_name . '/img/';
    }

    function Load_Main_Template($template_name)
    {
        global $forum_user;
        if (is_file(FORUM_ROOT . 'include/templates/' . $forum_user['template'] . '/' . $template_name . '.tpl'))
            return BB_Input::Trim(file_get_contents(FORUM_ROOT . 'include/templates/' . $forum_user['template'] . '/' . $template_name . '.tpl'));
        return BB_Input::Trim(file_get_contents(FORUM_ROOT . 'include/templates/Default/' . $template_name . '.tpl'));
    }

    function Load_Block_Template($template_name, $block_name)
    {
        global $forum_user;
        if (is_file(FORUM_ROOT . 'include/templates/' . $forum_user['template'] . '/blocks/' . $block_name . '/' . $template_name . '.tpl'))
            return BB_Input::Trim(file_get_contents(FORUM_ROOT . 'include/templates/' . $forum_user['template'] . '/blocks/' . $block_name . '/' . $template_name . '.tpl'));
        return BB_Input::Trim(file_get_contents(FORUM_ROOT . 'include/templates/Default/' . $block_name . '/' . $template_name . '.tpl'));
    }

    function Load_Module_Template($template_name, $module_name)
    {
        global $forum_user;
        if (is_file(FORUM_ROOT . 'include/templates/' . $forum_user['template'] . '/modules/' . $module_name . '/' . $template_name . '.tpl'))
            return BB_Input::Trim(file_get_contents(FORUM_ROOT . 'include/templates/' . $forum_user['template'] . '/modules/' . $module_name . '/' . $template_name . '.tpl'));
        return BB_Input::Trim(file_get_contents(FORUM_ROOT . 'include/templates/Default/modules/' . $module_name . '/' . $template_name . '.tpl'));
    }

    function Get_Template_Path($template_name)
    {
        global $forum_user;
        if (is_file(FORUM_ROOT . 'include/templates/' . $forum_user['template'] . '/' . $template_name . '.tpl'))
            return FORUM_ROOT . 'include/templates/' . $forum_user['template'] . '/' . $template_name . '.tpl';
        else
            return FORUM_ROOT . 'include/templates/Default/' . $template_name . '.tpl';
    }

    function Print_Script_Tag($file_name)
    {
        if (is_file(FORUM_ROOT . 'include/js/' . $file_name . '.js'))
            echo "\t" . '<script type="text/javascript" src="' . bb_website_url . '/include/js/' . $file_name . '.js"></script>' . "\n";
    }

    function Print_Meta_Data()
    {
        global $page_meta_description, $redirect_to;
        if (!defined('ALLOW_INDEX'))
            echo '<meta name="robots" content="noindex, follow" />' . "\n";
        if ($page_meta_description == '')
            echo "\t" . '<meta name="description" content="' . bb_board_meta . '" />' . "\n";
        else
            echo "\t" . '<meta name="description" content="' . $page_meta_description . '" />' . "\n";
        if (bb_board_meta_author)
            echo "\t" . '<meta name="author" content="Generated by XennoBB (C) 2005-2011 UserDot" />' . "\n";
        echo "\t" . '<meta name="keywords" content="' . bb_board_meta_keywords . '" />' . "\n";
        if (isset($redirect_to))
            echo '<meta http-equiv="refresh" content="' . $redirect_to['content'] . ';URL=' . $redirect_to['url'] . '" />';
    }

    function Show_Announcement()
    {
        global $lang;
        return '<div id="announce" class="xenno_block"><h2><span>' . $lang['Announcement'] . '</span></h2><div class="box"><div class="inbox"><div>' . bb_announcement_message . '</div></div></div></div>';
    }

    function Show_Advertisement()
    {
        global $lang;
        return '<div id="advertisement" class="xenno_block"><h2><span>' . $lang['Advertisement'] . '</span></h2><div class="box"><div class="inbox"><div>' . bb_advertisement_message . '</div></div></div></div>';
    }

    function Show_Information()
    {
        global $lang;
        return '<div id="information" class="xenno_block"><h2><span>' . $lang['Information'] . '</span></h2><div class="box"><div class="inbox"><div>' . bb_information_message . '</div></div></div></div>';
    }

    function Show_Guest_Information()
    {
        global $lang;
        return '<div id="guestinformation" class="xenno_block"><h2><span>' . $lang['Guest_information'] . '</span></h2><div class="box"><div class="inbox"><div>' . bb_guest_information_message . '</div></div></div></div>';
    }

    function Print_Page_Header()
    {
        global $page_title;
        if (isset($page_title))
            echo "\t" . '<title>' . BB_Input::Htmlspecialchars($page_title) . '</title>' . "\n";
        else
            echo "\t" . '<title>' . BB_Input::Htmlspecialchars(BB_Functions::Page_Title()) . '</title>' . "\n";
        echo "\t" . '<link rel="shortcut icon" href="' . bb_forum_url . 'img/general/favicon.ico" />' . "\n";
        BB_Template::Print_Meta_Data();
        echo "\t" . '<link rel="stylesheet" type="text/css" href="' . BB_Template::Get_Templates_Folder() . 'stylesheet.css" />' . "\n";
        BB_Template::Print_Script_Tag('lib');
        BB_Template::Print_Script_Tag('main');
        if (strpos(strtolower(BB_Input::User_Agent()), 'msie') !== false && strpos(strtolower(BB_Input::User_Agent()), 'windows') !== false && strpos(strtolower(BB_Input::User_Agent()), 'opera') === false)
            BB_Template::Print_Script_Tag('fixes');
        if (!defined('IN_FORUM_ADMIN'))
            echo "\t" . '<link rel="alternate" type="application/rss+xml" title="New topics feed." href="' . bb_website_url . '/syndicate.php?type=rss20"/>' . "\n";
    }

    function Print_Tooltip($tip)
    {
        echo '<img src="' . bb_forum_url . 'img/admin/tooltip.png" onmouseover="return xBB_Show_Tooltip(\'' . $tip . '\');" onmouseout="return nd();" />';
    }

    function Generate_Menu($items)
    {
        $out = '<div class="blockform">' . "\n\t" . '<h2>' . "\n";
        while (list($key, $value) = @each($items))
            $out .= '<a href="' . $value . '">' . $key . '</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
        $out .= '</h2>' . "\n" . '</div>' . "\n";
        return $out;
    }

}

?>
