<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
if (!defined('IN_FORUM'))
    exit('No direct script access allowed');

class ini_syntax extends plain_code_syntax
{

    function highlight($code)
    {
        $ch = "";
        $next_ch = "";
        $l = strlen($code);
        $out = '';
        $i = 0;
        while ($i < $l)
        {
            if ($this->state == S_NONE)
            {
                $ch = $code{$i};
                if ($i + 1 < $l)
                    $next_ch = $code{$i + 1};
                else
                    $next_ch = '';
                if ($ch == '#' or $ch == ';')
                {
                    $this->state = S_COMMENT1;
                    $out = $ch;
                    $i++;
                }
                else if ($ch == '=')
                {
                    $this->state = S_VALUE;
                    $out = $ch;
                    $i++;
                }
                else if ($ch == '\'')
                {
                    $this->state = S_STRING;
                    $out = $ch;
                    $i++;
                }
                else if ($ch == '"')
                {
                    $this->state = S_STRING2;
                    $out = $ch;
                    $i++;
                }
                else if ($ch == '[')
                {
                    $this->state = S_OBJECT;
                    $out = $ch;
                    $i++;
                }
                else
                {
                    $out = $ch;
                }
                $this->open_state = $this->state;
                $this->close_state = S_NONE;
            }
            if ($this->state != S_NONE)
            {
                switch ($this->state)
                {
                    case S_COMMENT1:
                        $j = strpos($code, "\n", $i);
                        if ($j === false)
                            $j = $l - 1;
                        else
                            $this->close_state = $this->state;
                        $out.=substr($code, $i, $j - $i + 1);
                        $i = $j;
                        break;
                    case S_KEYWORD: {
                            $j = $i;
                            while ($j < $l)
                            {
                                if ($code{$j} == '=')
                                    break;
                                $j++;
                            }
                            $this->close_state = $this->state;
                            $out.=substr($code, $i, $j - $i);
                            $i = $j - 1;
                            break;
                        }
                    case S_VALUE: {
                            $j = $i;
                            while ($j < $l)
                            {
                                if ($code{$j} == '#' or $code{$j} == ';' or $code{$j} == "\n")
                                    break;
                                $j++;
                            }
                            $this->close_state = $this->state;
                            $out.=substr($code, $i, $j - $i);
                            $i = $j - 1;
                            break;
                        }
                    case S_OBJECT: {
                            $j = $i;
                            while ($j < $l)
                            {
                                if ($code{$j} == ']' or $code{$j} == "\n")
                                {
                                    $this->close_state = $this->state;
                                    break;
                                }
                                $j++;
                            }
                            $out.=substr($code, $i, $j - $i + 1);
                            $i = $j;
                            break;
                        }
                    case S_STRING: {
                            $j = $i;
                            while ($j < $l)
                            {
                                if ($code{$j} == '\'' or $code{$j} == "\n")
                                {
                                    $this->close_state = $this->state;
                                    break;
                                }
                                $j++;
                            }
                            $out.=substr($code, $i, $j - $i + 1);
                            $i = $j;
                            break;
                        }
                    case S_STRING2: {
                            $j = $i;
                            while ($j < $l)
                            {
                                if ($code{$j} == '"' or $code{$j} == "\n")
                                {
                                    $this->close_state = $this->state;
                                    break;
                                }
                                $j++;
                            }
                            $out.=substr($code, $i, $j - $i + 1);
                            $i = $j;
                            break;
                        }
                }
            }
            $this->text_out($out);
            $i++;
        }
    }

}

?>