<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
if (!defined('IN_FORUM'))
    exit('No direct script access allowed');
if ($forum_user['id'] != $id)
{
    if ($forum_user['g_id'] > USER_MOD)
        BB_Functions::Message($lang['No permission'], true, 1);
    else if ($forum_user['g_id'] == USER_MOD)
    {
        $result = $db->query('SELECT gid FROM ' . $db->prefix . 'users WHERE id=' . $db->escape($id)) or BB_Functions::Error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
        if (!$db->num_rows($result))
            BB_Functions::Message($lang['Bad request']);
        if (bb_mod_edit_users == '0' || $db->result($result) < USER_GUEST)
            BB_Functions::Message($lang['No permission'], true, 1);
    }
}
if (isset($_GET['key']))
{
    $key = BB_Input::Htmlspecialchars($_GET['key']);
    $result = $db->query('SELECT activate_string, activate_key FROM ' . $db->prefix . 'users WHERE id=' . $db->escape($id)) or BB_Functions::Error('Unable to fetch activation data', __FILE__, __LINE__, $db->error());
    list($new_email, $new_email_key) = $db->fetch_row($result);
    if ($key != $new_email_key)
        BB_Functions::Message($lang['E-mail key bad'] . ' <a href="mailto:' . bb_admin_email . '">' . bb_admin_email . '</a>.');
    else
    {
        $db->query('UPDATE ' . $db->prefix . 'users SET email=activate_string, activate_string=NULL, activate_key=NULL WHERE id=' . $id) or BB_Functions::Error('Unable to update e-mail address', __FILE__, __LINE__, $db->error());
        BB_Functions::Message($lang['E-mail updated'], true);
    }
}
else if (isset($_POST['form_sent']))
{
    if (BB_Input::Hash($_POST['req_password']) !== $forum_user['password'])
        BB_Functions::Message($lang['Wrong pass']);
    $new_email = strtolower(trim($_POST['req_new_email']));
    if (!BB_Email::Is_Valid_Email($new_email))
        BB_Functions::Message($lang['Invalid e-mail']);
    if (BB_Email::Is_Banned_Email($new_email))
    {
        if (bb_allow_banned_email == '0')
            BB_Functions::Message($lang['Banned e-mail']);
        else if (bb_mailing_list != '')
        {
            $mail_subject = 'Alert - Banned e-mail detected';
            $mail_message = 'User \'' . $forum_user['username'] . '\' changed to banned e-mail address: ' . $new_email . "\n\n" . 'User profile: ' . bb_forum_url . '/member.php?id=' . $id . "\n\n" . '-- ' . "\n" . 'Forum Mailer' . "\n" . '(Do not reply to this message)';
            BB_Email::Mail(bb_mailing_list, $mail_subject, $mail_message);
        }
    }
    $result = $db->query('SELECT id, username FROM ' . $db->prefix . 'users WHERE email=\'' . $db->escape($new_email) . '\'') or BB_Functions::Error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
    if ($db->num_rows($result))
    {
        if (bb_allow_dupe_email == '0')
            BB_Functions::Message($lang['Dupe e-mail']);
        else if (bb_mailing_list != '')
        {
            while ($cur_dupe = $db->fetch_assoc($result))
                $dupe_list[] = $cur_dupe['username'];
            $mail_subject = 'Alert - Duplicate e-mail detected';
            $mail_message = 'User \'' . $forum_user['username'] . '\' changed to an e-mail address that also belongs to: ' . implode(', ', $dupe_list) . "\n\n" . 'User profile: ' . bb_forum_url . '/member.php?id=' . $id . "\n\n" . '-- ' . "\n" . 'Forum Mailer' . "\n" . '(Do not reply to this message)';
            BB_Email::Mail(bb_mailing_list, $mail_subject, $mail_message);
        }
    }
    $new_email_key = BB_Input::Random_Pass(8);
    $db->query('UPDATE ' . $db->prefix . 'users SET activate_string=\'' . $db->escape($new_email) . '\', activate_key=\'' . $new_email_key . '\' WHERE id=' . $db->escape($id)) or BB_Functions::Error('Unable to update activation data', __FILE__, __LINE__, $db->error());
    $mail_tpl = trim(file_get_contents(FORUM_ROOT . 'include/languages/' . $forum_user['language'] . '/mail_templates/activate_email.tpl'));
    $first_crlf = strpos($mail_tpl, "\n");
    $mail_subject = trim(substr($mail_tpl, 8, $first_crlf - 8));
    $mail_message = trim(substr($mail_tpl, $first_crlf));
    $mail_message = str_replace('<username>', $forum_user['username'], $mail_message);
    $mail_message = str_replace('<base_url>', bb_forum_url, $mail_message);
    $mail_message = str_replace('<activation_url>', bb_forum_url . '/member.php?action=change_email&id=' . $id . '&key=' . $new_email_key, $mail_message);
    $mail_message = str_replace('<board_mailer>', bb_board_title . ' ' . $lang['Mailer'], $mail_message);
    BB_Email::Mail($new_email, $mail_subject, $mail_message);
    BB_Functions::Message($lang['Activate e-mail sent'] . ' <a href="mailto:' . bb_admin_email . '">' . bb_admin_email . '</a>.', true);
}
$page_title = BB_Input::Htmlspecialchars($lang['Profile']);
$required_fields = array('req_new_email' => $lang['New e-mail'], 'req_password' => $lang['Password']);
$focus_element = array('change_email', 'req_new_email');
require FORUM_ROOT . $forum_folder . '/header.php';
BB_Functions::Set_Profile_Menu('essentials');
?>
<div class="blockform">
    <h2><span><?php echo $lang['Change e-mail'] ?></span></h2>
    <div class="box">
        <form id="change_email" method="post" action="member.php?action=change_email&amp;id=<?php echo $id ?>" id="change_email" onsubmit="return process_form(this)">
            <div class="inform">
                <div class="infldset file" style="padding:6px">
                    <p><?php echo $lang['E-mail instructions'] ?></p>
                </div>
            </div>
            <div class="inform">
                <input type="hidden" name="form_sent" value="1" />
                <div class="infldset file" style="padding:6px">
                    <table class="aligntop" cellspacing="0">
                        <tr>
                            <th style="width:150px"><b><?php echo $lang['New e-mail'] ?></b></th>
                            <td><input type="text" class="textbox" name="req_new_email" size="50" maxlength="50" /></td>
                        </tr>
                        <tr>
                            <th><b><?php echo $lang['Password'] ?></b></th>
                            <td><input type="password" class="textbox" name="req_password" size="30" maxlength="16" /></td>
                        </tr>
                    </table>
                </div>
            </div>
            <div><input type="button" name="new_email" class="b1" onclick="javascript:history.go(-1);" value="<?php echo $lang['Go back'] ?>"> <input type="submit" class="b1" name="update" value="<?php echo $lang['Save'] ?>" /></div>
        </form>
    </div>
</div>
<div class="clearer"></div>

<?php require FORUM_ROOT . $forum_folder . '/footer.php'; ?>
