<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
if (!defined('IN_FORUM'))
    exit('No direct script access allowed');
if (isset($_GET['key']))
{
    if (!$forum_user['is_guest'])
    {
        header('Location: index.php');
        exit;
    }
    $key = BB_Input::Htmlspecialchars($_GET['key']);
    $result = $db->query('SELECT activate_string, activate_key FROM ' . $db->prefix . 'users WHERE id=' . $db->escape($id)) or BB_Functions::Error('Unable to fetch new password', __FILE__, __LINE__, $db->error());
    list($new_password_hash, $new_password_key) = $db->fetch_row($result);
    if ($key == '' || $key != $new_password_key)
        BB_Functions::Message($lang['Pass key bad'] . ' <a href="mailto:' . bb_admin_email . '">' . bb_admin_email . '</a>.');
    else
    {
        $db->query('UPDATE ' . $db->prefix . 'users SET password=\'' . $new_password_hash . '\', activate_string=NULL, activate_key=NULL WHERE id=' . $db->escape($id)) or BB_Functions::Error('Unable to update password', __FILE__, __LINE__, $db->error());
        BB_Functions::Message($lang['Pass updated'], true);
    }
}
if ($forum_user['id'] != $id)
{
    if ($forum_user['g_id'] > USER_MOD)
        BB_Functions::Message($lang['No permission'], true, 1);
    else if ($forum_user['g_id'] == USER_MOD)
    {
        $result = $db->query('SELECT gid FROM ' . $db->prefix . 'users WHERE id=' . $$db->escape(id)) or BB_Functions::Error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
        if (!$db->num_rows($result))
            BB_Functions::Message($lang['Bad request']);
        if (bb_mod_edit_users == '0' || bb_mod_change_passwords == '0' || $db->result($result) < USER_GUEST)
            BB_Functions::Message($lang['No permission'], true, 1);
    }
}
if (isset($_POST['form_sent']))
{
    $old_password = isset($_POST['req_old_password']) ? trim($_POST['req_old_password']) : '';
    $new_password1 = trim($_POST['req_new_password1']);
    $new_password2 = trim($_POST['req_new_password2']);
    if ($new_password1 != $new_password2)
        BB_Functions::Message($lang['Pass not match']);
    if (strlen($new_password1) < 4)
        BB_Functions::Message($lang['Pass too short']);
    $result = $db->query('SELECT password, save_pass FROM ' . $db->prefix . 'users WHERE id=' . $db->escape($id)) or BB_Functions::Error('Unable to fetch password', __FILE__, __LINE__, $db->error());
    list($db_password_hash, $save_pass) = $db->fetch_row($result);
    $authorized = false;
    if (!empty($db_password_hash))
    {
        $sha1_in_db = (strlen($db_password_hash) == 40) ? true : false;
        $sha1_available = (function_exists('sha1') || function_exists('mhash')) ? true : false;
        $old_password_hash = BB_Input::Hash($old_password);
        if (($sha1_in_db && $sha1_available && $db_password_hash == $old_password_hash) || (!$sha1_in_db && $db_password_hash == md5($old_password)) || $forum_user['g_id'] < USER_GUEST)
            $authorized = true;
    }
    if (!$authorized)
        BB_Functions::Message($lang['Wrong pass']);
    $new_password_hash = BB_Input::Hash($new_password1);
    $db->query('UPDATE ' . $db->prefix . 'users SET password=\'' . $new_password_hash . '\' WHERE id=' . $db->escape($id)) or BB_Functions::Error('Unable to update password', __FILE__, __LINE__, $db->error());
    if ($forum_user['id'] == $id)
    {
        $expire = ($save_pass == '1') ? time() + 31536000 : 0;
        BB_Input::Set_Cookie($forum_user['id'], $new_password_hash, $expire);
    }
    BB_Functions::Redirect(bb_forum_url . 'member.php?section=essentials&amp;id=' . $id, $lang['Pass updated redirect']);
}
$page_title = BB_Input::Htmlspecialchars($lang['Profile']);
$required_fields = array('req_old_password' => $lang['Old pass'], 'req_new_password1' => $lang['New pass'], 'req_new_password2' => $lang['Confirm new pass']);
$focus_element = array('change_pass', (($forum_user['g_id'] > USER_MOD) ? 'req_old_password' : 'req_new_password1'));
require FORUM_ROOT . $forum_folder . '/header.php';
BB_Functions::Set_Profile_Menu('essentials');
?>
<div class="blockform">
    <h2><span><?php echo $lang['Change pass'] ?></span></h2>
    <div class="box">
        <form id="change_pass" method="post" action="member.php?action=change_pass&amp;id=<?php echo $id ?>" onsubmit="return process_form(this)">
            <div class="inform">
                <input type="hidden" name="form_sent" value="1" />
                <div class="infldset file" style="padding:6px">
                    <table class="aligntop" cellspacing="0">
                        <?php
                        if ($forum_user['g_id'] > USER_MOD)
                        {
                            ?>
                            <tr>
                                <th style="width:160px"><b><?php echo $lang['Old pass'] ?></b></th>
                                <td><input class="textbox" type="password" name="req_old_password" size="25" maxlength="16" /></td>
                            </tr>
    <?php
}
?>                      <tr>
                            <th style="width:160px"><b><?php echo $lang['New pass'] ?></b></th>
                            <td><input class="textbox" type="password" name="req_new_password1" size="25" maxlength="16" /></td>
                        </tr>
                        <tr>
                            <th><b><?php echo $lang['Confirm new pass'] ?></b></th>
                            <td><input class="textbox" type="password" name="req_new_password2" size="25" maxlength="16" /></td>
                        </tr>
                    </table>
                </div>
            </div>
            <div><input type="button" class="b1" onclick="javascript:history.go(-1);" value="<?php echo $lang['Go back'] ?>"> <input type="submit" class="b1" name="update" value="<?php echo $lang['Save'] ?>" /></div>
        </form>
    </div>
</div>

<div class="clearer"></div>

<?php require FORUM_ROOT . $forum_folder . '/footer.php'; ?>
