<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
if (!defined('IN_FORUM'))
    exit('No direct script access allowed');
$result = $db->query('SELECT gid FROM ' . $db->prefix . 'users WHERE id=' . $db->escape($id)) or BB_Functions::Error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
if (!$db->num_rows($result))
    BB_Functions::Message($lang['Bad request']);
$gid = $db->result($result);
if ($forum_user['id'] != $id && ($forum_user['g_id'] > USER_MOD || ($forum_user['g_id'] == USER_MOD && bb_mod_edit_users == '0') || ($forum_user['g_id'] == USER_MOD && $gid < USER_GUEST)))
    BB_Functions::Message($lang['No permission'], true, 1);
if ($forum_user['g_id'] < USER_GUEST)
    BB_Input::Confirm_Referrer('member.php');

function extract_elements($allowed_elements)
{
    $form = array();
    while (list($key, $value) = @each($_POST['form']))
    {
        if (in_array($key, $allowed_elements))
            $form[$key] = $value;
    }
    return $form;
}

$username_updated = false;
switch ($section)
{
    case 'essentials': {
            $form = extract_elements(array('timezone', 'language'));
            if ($forum_user['g_id'] < USER_GUEST)
            {
                $form['admin_note'] = trim($_POST['admin_note']);
                if ($forum_user['g_id'] == USER_ADMIN || ($forum_user['g_id'] == USER_MOD && bb_mod_rename_users == '1') || $forum_user['g_global_moderation'])
                {
                    $form['username'] = trim($_POST['req_username']);
                    $old_username = trim($_POST['old_username']);
                    if (strlen($form['username']) < 2)
                        BB_Functions::Message($lang['Username too short']);
                    else if (BB_Input::Strlen($form['username']) > 25)
                        BB_Functions::Message($lang['Bad request']);
                    else if (!strcasecmp($form['username'], 'Guest') || !strcasecmp($form['username'], $lang['Guest']))
                        BB_Functions::Message($lang['Username guest']);
                    else if (preg_match('/[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}/', $form['username']))
                        BB_Functions::Message($lang['Username IP']);
                    else if (preg_match('#\[b\]|\[/b\]|\[u\]|\[/u\]|\[i\]|\[/i\]|\[color|\[/color\]|\[quote\]|\[quote=|\[/quote\]|\[code\]|\[/code\]|\[img\]|\[/img\]|\[url|\[/url\]|\[email|\[/email\]#i', $form['username']))
                        BB_Functions::Message($lang['Username BBCode']);
                    $result = $db->query('SELECT 1 FROM ' . $db->prefix . 'users WHERE username=\'' . $db->escape($form['username']) . '\' AND id!=' . $db->escape($id)) or BB_Functions::Error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
                    if ($db->num_rows($result))
                        BB_Functions::Message($lang['Duplicate username']);
                    if ($form['username'] != $old_username)
                        $username_updated = true;
                }
                if ($forum_user['g_id'] == USER_ADMIN)
                    $form['num_posts'] = intval($_POST['num_posts']);
            }
            if (bb_regs_verify == '0' || $forum_user['g_id'] < USER_GUEST)
            {
                $form['email'] = strtolower(trim($_POST['req_email']));
                if (!BB_Email::Is_Valid_Email($form['email']))
                    BB_Functions::Message($lang['Invalid e-mail']);
            }
            if (isset($form['language']))
            {
                $form['language'] = preg_replace('#[\.\\\/]#', '', $form['language']);
                if (!file_exists(FORUM_ROOT . 'include/languages/' . $form['language'] . '/main.php'))
                    BB_Functions::Message($lang['Bad request']);
            }
            break;
        }
    case 'personal': {
            $form = extract_elements(array('realname', 'url', 'location', 'sex', 'country', 'absent', 'absence_message', 'jabber', 'icq', 'msn', 'aim', 'yahoo', 'gtalk', 'skype', 'xfire'));
            if ($form['icq'] != '' && preg_match('/[^0-9]/', $form['icq']))
                BB_Functions::Message($lang['Bad ICQ']);
            if ($forum_user['g_id'] == USER_ADMIN)
                $form['title'] = trim($_POST['title']);
            else if ($forum_user['g_set_title'] == '1')
            {
                $form['title'] = trim($_POST['title']);
                if ($form['title'] != '')
                {
                    $forbidden = array('Member', 'Moderator', 'Administrator', 'Banned', 'Guest', $lang['Member'], $lang['Moderator'], $lang['Administrator'], $lang['Banned'], $lang['Guest']);
                    if (in_array($form['title'], $forbidden))
                        BB_Functions::Message($lang['Forbidden title']);
                }
            }
            if ($form['url'] != '' && !stristr($form['url'], 'http://'))
                $form['url'] = 'http://' . $form['url'];
            $form['country'] = BB_Input::Htmlspecialchars($form['country']);
            break;
        }
    case 'personality': {
            $form = extract_elements(array('use_avatar'));
            $form['signature'] = BB_Input::Linebreaks(trim($_POST['signature']));
            if (BB_Input::Strlen($form['signature']) > bb_sig_length)
                BB_Functions::Message($lang['Sig too long'] . ' ' . bb_sig_length . ' ' . $lang['characters'] . '.');
            else if (substr_count($form['signature'], "\n") > (bb_sig_lines - 1))
                BB_Functions::Message($lang['Sig too many lines'] . ' ' . bb_sig_lines . ' ' . $lang['lines'] . '.');
            else if ($form['signature'] && bb_sig_all_caps == '0' && strtoupper($form['signature']) == $form['signature'] && $forum_user['g_id'] > USER_MOD)
                $form['signature'] = ucwords(strtolower($form['signature']));
            if (bb_sig_bbcode == '1' && strpos($form['signature'], '[') !== false && strpos($form['signature'], ']') !== false)
            {
                require_once FORUM_ROOT . 'include/functions/Parser.php';
                $form['signature'] = BB_Parser::Preparse_BBCode($form['signature'], $foo, true);
            }
            if (!isset($form['use_avatar']) || $form['use_avatar'] != '1')
                $form['use_avatar'] = '0';
            break;
        }
    case 'display': {
            $form = extract_elements(array('quicklinks', 'disp_topics', 'disp_posts', 'show_smilies', 'show_img', 'show_img_sig', 'reverse_posts', 'show_avatars', 'show_sig', 'new_window_link', 'template'));
            $form['reputation_enable'] = BB_Input::Linebreaks(trim($_POST['reputation_enable']));
            if (!isset($form['reputation_enable']) || $form['reputation_enable'] != '1')
                $form['reputation_enable'] = '0';
            if ($form['disp_topics'] != '' && intval($form['disp_topics']) < 3)
                $form['disp_topics'] = 3;
            if ($form['disp_topics'] != '' && intval($form['disp_topics']) > 75)
                $form['disp_topics'] = 75;
            if ($form['disp_posts'] != '' && intval($form['disp_posts']) < 3)
                $form['disp_posts'] = 3;
            if ($form['disp_posts'] != '' && intval($form['disp_posts']) > 75)
                $form['disp_posts'] = 75;
            if (!isset($form['show_smilies']) || $form['show_smilies'] != '1')
                $form['show_smilies'] = '0';
            if (!isset($form['show_img']) || $form['show_img'] != '1')
                $form['show_img'] = '0';
            if (!isset($form['show_img_sig']) || $form['show_img_sig'] != '1')
                $form['show_img_sig'] = '0';
            if (!isset($form['reverse_posts']) || $form['reverse_posts'] != '1')
                $form['reverse_posts'] = '0';
            if (!isset($form['show_avatars']) || $form['show_avatars'] != '1')
                $form['show_avatars'] = '0';
            if (!isset($form['show_sig']) || $form['show_sig'] != '1')
                $form['show_sig'] = '0';
            if (!isset($form['new_window_link']) || $form['new_window_link'] != '1')
                $form['new_window_link'] = '0';
            if (!isset($form['quicklinks']))
                $form['quicklinks'] = 'top';
            break;
        }
    case 'privacy': {
            $form = extract_elements(array('email_setting', 'save_pass', 'notify_with_post', 'email_alert'));
            $form['email_setting'] = intval($form['email_setting']);
            if ($form['email_setting'] < 0 && $form['email_setting'] > 2)
                $form['email_setting'] = 1;
            if (!isset($form['save_pass']) || $form['save_pass'] != '1')
                $form['save_pass'] = '0';
            if (!isset($form['notify_with_post']) || $form['notify_with_post'] != '1')
                $form['notify_with_post'] = '0';
            if (!isset($form['email_alert']) || $form['email_alert'] != '1')
                $form['email_alert'] = '0';
            if ($forum_user['id'] == $id && $form['save_pass'] != $forum_user['save_pass'])
            {
                $result = $db->query('SELECT password FROM ' . $db->prefix . 'users WHERE id=' . $db->escape($id)) or BB_Functions::Error('Unable to fetch user password hash', __FILE__, __LINE__, $db->error());
                BB_Input::Set_Cookie($id, $db->result($result), ($form['save_pass'] == '1') ? time() + 31536000 : 0);
            }
            break;
        }
    default: BB_Functions::Message($lang['Bad request']);
}
$temp = array();
while (list($key, $input) = @each($form))
{
    $value = ($input !== '') ? '\'' . $db->escape($input) . '\'' : 'NULL';
    $temp[] = $key . '=' . $value;
}
if (isset($_POST['bday_year']) && isset($_POST['bday_month']) && isset($_POST['bday_day']))
    $birthday = $db->escape($_POST['bday_year']) . "-" . $db->escape($_POST['bday_month']) . "-" . $db->escape($_POST['bday_day']);
$bday_query = (isset($birthday)) ? 'birthday="' . BB_Input::Htmlspecialchars($birthday) . '", ' : NULL;
if (empty($temp))
    BB_Functions::Message($lang['Bad request']);
$db->query('UPDATE ' . $db->prefix . 'users SET ' . $bday_query . implode(',', $temp) . ' WHERE id=' . $db->escape($id)) or BB_Functions::Error('Unable to update profile', __FILE__, __LINE__, $db->error());
if ($username_updated)
{
    $db->query('UPDATE ' . $db->prefix . 'posts SET poster=\'' . $db->escape($form['username']) . '\' WHERE poster_id=' . $db->escape($id)) or BB_Functions::Error('Unable to update posts', __FILE__, __LINE__, $db->error());
    $db->query('UPDATE ' . $db->prefix . 'topics SET poster=\'' . $db->escape($form['username']) . '\' WHERE poster=\'' . $db->escape($old_username) . '\'') or BB_Functions::Error('Unable to update topics', __FILE__, __LINE__, $db->error());
    $db->query('UPDATE ' . $db->prefix . 'topics SET last_poster=\'' . $db->escape($form['username']) . '\' WHERE last_poster=\'' . $db->escape($old_username) . '\'') or BB_Functions::Error('Unable to update topics', __FILE__, __LINE__, $db->error());
    $db->query('UPDATE ' . $db->prefix . 'forums SET last_poster=\'' . $db->escape($form['username']) . '\' WHERE last_poster=\'' . $db->escape($old_username) . '\'') or BB_Functions::Error('Unable to update forums', __FILE__, __LINE__, $db->error());
    $db->query('UPDATE ' . $db->prefix . 'online SET ident=\'' . $db->escape($form['username']) . '\' WHERE ident=\'' . $db->escape($old_username) . '\'') or BB_Functions::Error('Unable to update online list', __FILE__, __LINE__, $db->error());
    $result = $db->query('SELECT gid FROM ' . $db->prefix . 'users WHERE id=' . $db->escape($id)) or BB_Functions::Error('Unable to fetch user info', __FILE__, __LINE__, $db->error());
    $gid = $db->result($result);
    if ($gid < USER_GUEST)
    {
        $result = $db->query('SELECT id, moderators FROM ' . $db->prefix . 'forums') or BB_Functions::Error('Unable to fetch forum list', __FILE__, __LINE__, $db->error());
        while ($cur_forum = $db->fetch_assoc($result))
        {
            $cur_moderators = ($cur_forum['moderators'] != '') ? unserialize($cur_forum['moderators']) : array();
            if (in_array($id, $cur_moderators))
            {
                unset($cur_moderators[$old_username]);
                $cur_moderators[$form['username']] = $id;
                ksort($cur_moderators);
                $db->query('UPDATE ' . $db->prefix . 'forums SET moderators=\'' . $db->escape(serialize($cur_moderators)) . '\' WHERE id=' . $cur_forum['id']) or BB_Functions::Error('Unable to update forum', __FILE__, __LINE__, $db->error());
            }
        }
    }
}
if (isset($_POST['fields']))
{
    $fields = $_POST['fields'];
    foreach ($fields as $key => $value)
    {
        $value = BB_Input::Htmlspecialchars($db->escape($value));
        $key = intval($key);
        if ($db->result($db->query("SELECT f_id FROM " . $db->prefix . "profile_field_entries WHERE f_id=" . $db->escape($key) . " AND u_id=" . $forum_user['id'])))
            $db->query("UPDATE " . $db->prefix . "profile_field_entries SET value='" . $db->escape($value) . "' WHERE f_id=" . $db->escape($key) . " AND u_id=" . $forum_user['id']) or BB_Functions::Error($lang['error_998'], __FILE__, __LINE__, $db->error());
        else
            $db->query("INSERT INTO " . $db->prefix . "profile_field_entries (value, f_id, u_id) VALUES ('" . $db->escape($value) . "', '" . $db->escape($key) . "', '" . $forum_user['id'] . "')") or BB_Functions::Error($lang['error_998'], __FILE__, __LINE__, $db->error());
    }
}
BB_Functions::Redirect(bb_forum_url . 'member.php?section=' . $section . '&amp;id=' . $id, $lang['Profile redirect']);
?>
