<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
if (!defined('IN_FORUM'))
    exit('No direct script access allowed');
if (bb_avatars == '0')
    BB_Functions::Message($lang['Avatars disabled']);
if ($forum_user['id'] != $id && $forum_user['g_id'] > USER_MOD)
    BB_Functions::Message($lang['No permission'], true, 1);
if (isset($_POST['form_sent']))
{
    if (!isset($_FILES['req_file']))
        BB_Functions::Message($lang['No file']);
    $uploaded_file = $_FILES['req_file'];
    if (isset($uploaded_file['error']))
    {
        switch ($uploaded_file['error'])
        {
            case 1:
            case 2:
                BB_Functions::Message($lang['Too large ini']);
                break;

            case 3:
                BB_Functions::Message($lang['Partial upload']);
                break;

            case 4:
                BB_Functions::Message($lang['No file']);
                break;

            case 6:
                BB_Functions::Message($lang['No tmp directory']);
                break;

            default:
                if ($uploaded_file['size'] == 0)
                    BB_Functions::Message($lang['No file']);
                break;
        }
    }
    if (is_uploaded_file($uploaded_file['tmp_name']))
    {
        $allowed_types = array('image/gif', 'image/jpeg', 'image/pjpeg', 'image/png', 'image/x-png');
        if (!in_array($uploaded_file['type'], $allowed_types))
            BB_Functions::Message($lang['Bad type']);
        if ($uploaded_file['size'] > bb_avatars_size)
            BB_Functions::Message($lang['Too large'] . ' ' . bb_avatars_size . ' ' . $lang['bytes'] . '.');
        $extensions = null;
        if ($uploaded_file['type'] == 'image/gif')
            $extensions = array('.gif', '.jpg', '.png');
        else if ($uploaded_file['type'] == 'image/jpeg' || $uploaded_file['type'] == 'image/pjpeg')
            $extensions = array('.jpg', '.gif', '.png');
        else
            $extensions = array('.png', '.gif', '.jpg');
        if (!@move_uploaded_file($uploaded_file['tmp_name'], bb_avatars_dir . '/' . $id . '.tmp'))
            BB_Functions::Message($lang['Move failed'] . ' <a href="mailto:' . bb_admin_email . '">' . bb_admin_email . '</a>.');
        list($width, $height, $type, ) = getimagesize(bb_avatars_dir . '/' . $id . '.tmp');
        if (empty($width) || empty($height) || $width > bb_avatars_width || $height > bb_avatars_height)
        {
            @unlink(bb_avatars_dir . '/' . $id . '.tmp');
            BB_Functions::Message($lang['Too wide or high'] . ' ' . bb_avatars_width . 'x' . bb_avatars_height . ' ' . $lang['pixels'] . '.');
        }
        else if ($type == 1 && $uploaded_file['type'] != 'image/gif')
        {
            @unlink(bb_avatars_dir . '/' . $id . '.tmp');
            BB_Functions::Message($lang['Bad type']);
        }
        @unlink(bb_avatars_dir . '/' . $id . $extensions[0]);
        @unlink(bb_avatars_dir . '/' . $id . $extensions[1]);
        @unlink(bb_avatars_dir . '/' . $id . $extensions[2]);
        @rename(bb_avatars_dir . '/' . $id . '.tmp', bb_avatars_dir . '/' . $id . $extensions[0]);
        @chmod(bb_avatars_dir . '/' . $id . $extensions[0], 0644);
    }
    else
        BB_Functions::Message($lang['Unknown failure']);
    $db->query('UPDATE ' . $db->prefix . 'users SET use_avatar=1 WHERE id=' . $db->escape($id)) or BB_Functions::Error('Unable to update avatar state', __FILE__, __LINE__, $db->error());
    BB_Functions::Redirect(bb_forum_url . 'member.php?section=personality&amp;id=' . $id, $lang['Avatar upload redirect']);
}
$page_title = BB_Input::Htmlspecialchars($lang['Profile']);
$required_fields = array('req_file' => $lang['File']);
$focus_element = array('upload_avatar', 'req_file');
require FORUM_ROOT . $forum_folder . '/header.php';
BB_Functions::Set_Profile_Menu('personality');
?>
<div class="blockform">
    <h2><span><?php echo $lang['Upload avatar'] ?></span></h2>
    <div class="box">
        <form id="upload_avatar" method="post" enctype="multipart/form-data" action="member.php?action=upload_avatar2&amp;id=<?php echo $id ?>" onsubmit="return process_form(this)">
            <div class="inform">
                <div class="infldset file" style="padding:6px">
<?php echo $lang['Avatar desc'] . ' ' . bb_avatars_width . ' x ' . bb_avatars_height . ' ' . $lang['pixels'] . ' ' . $lang['and'] . ' ' . bb_avatars_size . ' ' . $lang['bytes'] . ' (' . ceil(bb_avatars_size / 1024) ?> KB).
                </div>
            </div>
            <div class="inform">
                <div class="infldset file" style="padding:6px">
                    <input type="hidden" name="form_sent" value="1" />
                    <input type="hidden" name="MAX_FILE_SIZE" value="<?php echo bb_avatars_size ?>" />
                    <label><strong><?php echo $lang['File'] ?></strong>&nbsp;&nbsp;<input class="textbox" name="req_file" type="file" size="40" /><br /></label>
                </div>
            </div>
            <div><input type="button" class="b1" onclick="javascript:history.go(-1);" value="<?php echo $lang['Go back'] ?>"> <input type="submit" class="b1" name="upload" value="<?php echo $lang['Upload'] ?>" /></div>
        </form>
    </div>
</div>
<div class="clearer"></div>
<?php
require FORUM_ROOT . $forum_folder . '/footer.php';
?>
