<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
@include dirname(__FILE__) . '/config.php';
if (!defined('IN_FORUM') || $db_name == '')
{
    header('Location: install/index.php');
    exit;
}
list($usec, $sec) = explode(' ', microtime());
$forum_start = ((float) $usec + (float) $sec);
define('ALLOW_INDEX', 1);
require FORUM_ROOT . 'include/functions/Preloader.php';
BB_Input::Sanitize_Globals();
error_reporting(E_ALL ^ E_NOTICE);
set_magic_quotes_runtime(0);
if (get_magic_quotes_gpc())
{

    function stripslashes_array($array)
    {
        return is_array($array) ? array_map('stripslashes_array', $array) : stripslashes($array);
    }

    $_GET = stripslashes_array($_GET);
    $_POST = stripslashes_array($_POST);
    $_COOKIE = stripslashes_array($_COOKIE);
}
mt_srand((double) microtime() * 1000000);
if (empty($cookie_name))
{
    $cookie_name = 'forum_cookie';
}
define('USER_UNVERIFIED', 999);
define('USER_ADMIN', 1);
define('USER_MOD', 2);
define('USER_GUEST', 3);
define('USER_MEMBER', 4);
require FORUM_ROOT . 'include/functions/drivers/common_db.php';
$db->start_transaction();
$cms_settings = new BB_Settings($db, $db->prefix . 'configuration');
$cms_settings->Export();
if (!defined('DISABLE_BUFFERING'))
{
    $_SERVER['HTTP_ACCEPT_ENCODING'] = isset($_SERVER['HTTP_ACCEPT_ENCODING']) ? $_SERVER['HTTP_ACCEPT_ENCODING'] : '';
    if (bb_gzip && extension_loaded('zlib') && (strpos($_SERVER['HTTP_ACCEPT_ENCODING'], 'gzip') !== false || strpos($_SERVER['HTTP_ACCEPT_ENCODING'], 'deflate') !== false))
    {
        ob_start('ob_gzhandler');
    }
    else
    {
        ob_start();
    }
}
$forum_user = array();
BB_Input::Check_Cookie($forum_user);
@include FORUM_ROOT . 'include/languages/' . $forum_user['language'] . '/main.php';
@include FORUM_ROOT . 'var/cache/lang_' . $forum_user['language'] . '.php';
if (!isset($lang))
{
    exit('There is no valid language pack \'' . BB_Input::Htmlspecialchars($forum_user['language']) . '\' installed. Please reinstall a language pack of that name.');
}
if ($lang['lang_encoding'] == strtolower('utf-8'))
{
    ini_set("default_charset", "utf-8");
}
if (bb_maintenance && $forum_user['g_id'] > USER_ADMIN && !defined('TURN_OFF_MAINT'))
{
    BB_Functions::Maintenance_Message();
}
@include FORUM_ROOT . 'var/cache/cache_bans.php';
if (!defined('BANS_LOADED'))
{
    BB_Cache::Generate_Bans();
    require FORUM_ROOT . 'var/cache/cache_bans.php';
}
BB_Core::Set_Bans();
@include FORUM_ROOT . 'var/cache/cache_ads_config.php';
if (!defined('ADS_CONFIG_LOADED'))
{
    BB_Cache::Generate_Advertising_Config();
    require FORUM_ROOT . 'var/cache/cache_ads_config.php';
}
//if(function_exists(Spam_Protect)) BB_Input::Spam_Protect();
BB_Core::Set_Online_Users();
if (!isset($_SERVER['REQUEST_URI']))
{
    $_SERVER['REQUEST_URI'] = $_SERVER['PHP_SELF'];
    if (isset($_SERVER['QUERY_STRING']) && !empty($_SERVER['QUERY_STRING']))
    {
        $_SERVER['REQUEST_URI'] .= '?' . $_SERVER['QUERY_STRING'];
    }
}
$cms_blocks = new BB_Extensions(FORUM_ROOT . 'include/blocks/', 'block');
$cms_themes = new BB_Extensions(FORUM_ROOT . 'include/templates/', 'theme');
$cms_modules = new BB_Extensions(FORUM_ROOT . 'include/modules/', 'module');
$cms_languages = new BB_Extensions(FORUM_ROOT . 'include/languages/', 'lang');
if (defined('IN_FORUM_ADMIN'))
{
    require FORUM_ROOT . 'var/cache/lang_admin_' . $forum_user['language'] . '.php';
    require FORUM_ROOT . 'include/functions/FunctionsAdmin.php';
    foreach ($cms_modules->Uninstalled_Elements() as $module)
    {
        if (file_exists($cms_modules->path . $module . '/lang_admin/' . $forum_user['language'] . '.php'))
        {
            require $cms_modules->path . $module . '/lang_admin/' . $forum_user['language'] . '.php';
        }
    }
    foreach ($cms_blocks->Uninstalled_Elements() as $block)
    {
        if (file_exists($cms_blocks->path . $block . '/lang_admin/' . $forum_user['language'] . '.php'))
        {
            require $cms_blocks->path . $block . '/lang_admin/' . $forum_user['language'] . '.php';
        }
    }
}
else
{
    $args = '';
    if (!empty($_SERVER['QUERY_STRING']))
    {
        parse_str(BB_Functions::Decode_URI_Segments(), $qs);
        $qs = array_keys($qs);
        if ($_GET[$qs[0]] == '')
        {
            $args = $qs[0];
            unset($_GET[$qs[0]]);
            unset($_REQUEST[$qs[0]]);
        }
    }
    else
    {
        $args = '';
    }
    $uri_segments = array();
    $uri_segments = explode("/", $args);
    $bb_current_module = (isset($uri_segments[1]) && in_array($uri_segments[1], $cms_modules->Installed_Elements())) ? $uri_segments[1] : bb_default_module;
}