<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
if (!defined('IN_FORUM'))
    exit('No direct script access allowed');
$path_module = $cms_modules->path . 'articles';
if (bb_rewrite_urls == 1)
    $web_path_module = bb_website_url . '/articles/';
else
    $web_path_module = bb_website_url . '/index.php?/articles/';

function xBB_Show_Articles_Index()
{
    global $db, $lang_cms_main_module_articles, $web_path_module;
    $result = $db->query('SELECT id, title, url, cat_id FROM ' . $db->prefix . 'module_articles ORDER BY title') or BB_Functions::Error('Cannot retrieve articles list', __FILE__, __LINE__, $db->error());
    $num_pages = $db->num_rows($result);
    $pages_list = array();
    for ($i = 0; $i < $num_pages; ++$i)
        $pages_list[] = $db->fetch_assoc($result);
    $result = $db->query('SELECT id, name, url FROM ' . $db->prefix . 'module_articles_categories ORDER BY position') or BB_Functions::Error('Cannot retrieve category list', __FILE__, __LINE__, $db->error());
    $num_cats = $db->num_rows($result);
    if ($num_cats > 0)
    {
        $cat_list = array();
        for ($i = 0; $i < $num_cats; ++$i)
            $cat_list[] = $db->fetch_assoc($result);
        ?>
        <div class="blockform" id="IndexPages">
            <h2><span><?php echo $lang_cms_main_module_articles['articles']; ?></span></h2>
            <div class="fakeform">
                <div class="inbox">
                    <?php
                    if ($num_pages)
                    {
                        echo "\t\t\t\t" . '<ul>' . "\n";
                        foreach ($pages_list as $p)
                        {
                            if ($p['cat_id'] == 0)
                                echo "\t\t\t\t\t" . '<li><a href="' . $web_path_module . $p['id'] . '-' . $p['url'] . '">' . $p['title'] . '</a></li>' . "\n";
                        }
                        echo "\t\t\t\t" . '</ul>' . "\n";
                    }
                    if ($num_cats)
                    {
                        foreach ($cat_list as $c)
                        {
                            echo "\t\t\t\t" . '<h4><span><a href="' . $web_path_module . $c['url'] . '">' . $c['name'] . '</a></span></h4>' . "\n";
                            echo "\t\t\t\t" . '<ul>' . "\n";
                            foreach ($pages_list as $p)
                            {
                                if ($p['cat_id'] == $c['id'])
                                    echo "\t\t\t\t\t" . '<li><a href="' . $web_path_module . $p['id'] . '-' . $p['url'] . '">' . $p['title'] . '</a></li>' . "\n";
                            }
                            echo "\t\t\t\t" . '</ul>' . "\n";
                        }
                    }
                    ?>
                </div>
            </div>
        </div>
        <?php
    }
}

if (isset($uri_segments[2]) && preg_match('!^([A-Z][A-Za-z0-9_-]*)!', $uri_segments[2], $match))
{
    $result = $db->query('SELECT id, name FROM ' . $db->prefix . 'module_articles_categories WHERE url=\'' . $db->escape($match[1]) . '\'') or BB_Functions::Error('Cannot retrieve category list', __FILE__, __LINE__, $db->error());
    $cat = array();
    $cat = $db->fetch_assoc($result);
    if (!empty($cat))
    {
        $result = $db->query('SELECT id, title, url FROM ' . $db->prefix . 'module_articles WHERE cat_id=' . $db->escape($cat['id']) . ' ORDER BY title') or BB_Functions::Error('Cannot retrieve articles list', __FILE__, __LINE__, $db->error());
        $num_pages = $db->num_rows($result);
        $pages_list = array();
        for ($i = 0; $i < $num_pages; ++$i)
            $pages_list[] = $db->fetch_assoc($result);
        $cms_custom_title_page = $cat['name'];
        require FORUM_ROOT . 'include/header.php';
        ?>
        <div class="blockform" id="IndexPages">
            <h2><span><?php echo $cat['name']; ?></span></h2>
            <div class="fakeform">
                <div class="inbox">
        <?php
        if ($num_pages)
        {
            echo "\t\t\t\t" . '<ul>' . "\n";
            foreach ($pages_list as $p)
                echo "\t\t\t\t\t" . '<li><a href="' . $web_path_module . $p['id'] . '-' . $p['url'] . '">' . $p['title'] . '</a></li>' . "\n";
            echo "\t\t\t\t" . '</ul>' . "\n";
        }
        ?>
                </div>
            </div>
        </div>
        <?php
        require FORUM_ROOT . 'include/footer.php';
    }
    else
    {
        $cms_custom_title_page = $lang_cms_main_module_articles['articles'];
        require FORUM_ROOT . 'include/header.php';
        xBB_Show_Articles_Index();
        require FORUM_ROOT . 'include/footer.php';
    }
}
elseif (isset($uri_segments[2]) && preg_match('!^([0-9]+)!', $uri_segments[2], $match) && file_exists(FORUM_ROOT . 'var/articles/html/' . $match[1] . '.html'))
{
    $page_tpl = BB_Input::Trim(file_get_contents(FORUM_ROOT . 'var/articles/html/' . $match[1] . '.html'));
    $first_crlf = strpos($page_tpl, "\n");
    $cms_custom_title_page = BB_Input::Trim(substr($page_tpl, 6, $first_crlf - 6));
    require FORUM_ROOT . 'include/header.php';
    echo BB_Input::Trim(substr($page_tpl, $first_crlf));
    require FORUM_ROOT . 'include/footer.php';
}
else
{
    $cms_custom_title_page = $lang_cms_main_module_articles['articles'];
    require FORUM_ROOT . 'include/header.php';
    xBB_Show_Articles_Index();
    require FORUM_ROOT . 'include/footer.php';
}
?>
