<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
if (!defined('IN_FORUM_ADMIN'))
    exit('No direct script access allowed');

function BB_Install_Module()
{
    global $db_type, $db_prefix, $db, $cms_settings;
    $error = '';
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "module_articles (
                                id INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
                                title VARCHAR(255) NOT NULL,
                                content TEXT NOT NULL,
                                format VARCHAR(4) NOT NULL default 'html',
                                url VARCHAR(255) NOT NULL,
                                cat_id INT(10) default NULL,
                                PRIMARY KEY  (id)
                                ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "module_articles (
                                id SERIAL,
                                title VARCHAR(255) NOT NULL,
                                content TEXT NOT NULL,
                                format VARCHAR(200) NOT NULL DEFAULT 'html',
                                url VARCHAR(255) NOT NULL,
                                cat_id INT DEFAULT NULL,
                                PRIMARY KEY  (id)
                                )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "module_articles (
                                id INTEGER NOT NULL,
                                title VARCHAR(255) NOT NULL,
                                content TEXT NOT NULL,
                                format VARCHAR(4) NOT NULL DEFAULT 'html',
                                url VARCHAR(255) NOT NULL,
                                cat_id INTEGER DEFAULT NULL,
                                PRIMARY KEY  (id)
                                )";
            break;
    }
    if (!$db->query($sql))
        $error = 'Cannot create table ' . $db_prefix . 'module_articles. You must create it manually.';
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "module_articles_categories (
                                id INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
                                name VARCHAR(80) NOT NULL DEFAULT '',
                                url VARCHAR(80) NOT NULL DEFAULT '',
                                position INT(10) NOT NULL DEFAULT 0,
                                PRIMARY KEY (id)
                                ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "module_articles_categories (
                                id SERIAL,
                                name VARCHAR(80) NOT NULL DEFAULT '',
                                url VARCHAR(80) NOT NULL DEFAULT '',
                                position INT NOT NULL DEFAULT 0,
                                PRIMARY KEY (id)
                                )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "module_articles_categories (
                                id INTEGER NOT NULL,
                                name VARCHAR(80) NOT NULL DEFAULT '',
                                url VARCHAR(80) NOT NULL DEFAULT '',
                                position INTEGER NOT NULL DEFAULT 0,
                                PRIMARY KEY (id)
                                )";
            break;
    }
    if (!$db->query($sql))
        $error = 'Cannot create table ' . $db_prefix . 'module_articles_categories. You must create it manually.';
    $res = true;
    $cms_settings->Set_Namespace('module_articles');
    $res &= $cms_settings->Save('bb_module_articles', 0);
    $cms_settings->Set_Namespace('permissions');
    $res &= $cms_settings->Save('bb_perm_module_articles', 0);
    $cms_settings->Set_Namespace('');
    if (!$res)
        return false;
    elseif ($error != '')
        return $error;
    else
        return true;
}

?>
