<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
if (!defined('IN_FORUM_ADMIN'))
    exit('No direct script access allowed');
if (!BB_Admin_Functions::Check_Permissions('module_downloads'))
    BB_Functions::Message($lang['No permission']);
require dirname(__FILE__) . '/install/info.php';
define('MODULE_URL', bb_website_url . '/modules/downloads');
define('MODULE_ADMIN_URL', 'loader.php?module=downloads');
$do = isset($_GET['do']) ? $_GET['do'] : 'dl';
$submenu = array($lang['Downloads'] => MODULE_ADMIN_URL . '&amp;do=dl', $lang['Categories'] => MODULE_ADMIN_URL . '&amp;do=cat', $lang['Files'] => MODULE_ADMIN_URL . '&amp;do=files', $lang['Configure'] => MODULE_ADMIN_URL . '&amp;do=config');
switch ($do)
{
    default:
    case 'config':
        if (isset($_POST['config_module_dl']))
        {
            $form = array_map('trim', $_POST['form']);
            if (intval($form['module_downloads_time']) <= 0 || intval($form['module_downloads_time']) > 30)
                $form['module_downloads_time'] = 1;
            if (substr($form['module_downloads_path'], -1) == '/')
                $form['module_downloads_path'] = substr($form['module_downloads_path'], 0, -1);
            if ($form['module_downloads_path']{0} != '/')
                $form['module_downloads_path'] = '/' . $form['module_downloads_path'];
            $extensions = explode('|', $form['module_downloads_exts']);
            $form['module_downloads_exts'] = implode('|', array_map('trim', $extensions));
            $cms_settings->Set_Namespace('module_downloads');
            $res = true;
            $res &= $cms_settings->Save('bb_module_downloads', $form['module_downloads']);
            $res &= $cms_settings->Save('bb_module_downloads_path', $form['module_downloads_path']);
            $res &= $cms_settings->Save('bb_module_downloads_exts', $form['module_downloads_exts']);
            $res &= $cms_settings->Save('bb_module_downloads_time', $form['module_downloads_time']);
            $res &= $cms_settings->Save('bb_module_downloads_leech', $form['module_downloads_leech']);
            $res &= $cms_settings->Save('bb_module_downloads_mode', $form['module_downloads_mode']);
            $res &= $cms_settings->Save('bb_module_downloads_dwl', $form['module_downloads_dwl']);
            $res &= $cms_settings->Save('bb_module_downloads_guest', $form['module_downloads_guest']);
            $cms_settings->Set_Namespace('');
            if ($res)
            {
                BB_Admin_Functions::Log_Action('Module downloads : edit config ', 1);
                BB_Functions::Redirect(MODULE_ADMIN_URL . '&amp;do=config', $lang['config_updated']);
            }
            else
                BB_Functions::Message($lang['unable_update_config']);
        }
        else
        {
            echo BB_Template::Generate_Menu($submenu);
            ?>
            <div class="blockform">
                <form method="post" action="<?php echo MODULE_ADMIN_URL ?>&amp;do=config">
                    <input type="hidden" name="config_module_dl" value="1" />
                    <div class="inform">
                        <div class="infldset file" style="padding:10px">
                            <table class="aligntop" cellspacing="0">
                                <tr>
                                    <th class="header"><?php echo $lang_cms_main_module_downloads['enable_module']; ?></th>
                                    <td class="tips">&nbsp;</td>
                                    <td><input type="radio" name="form[module_downloads]" value="1"<?php if (bb_module_downloads == '1')
                echo ' checked="checked"' ?> />&#160;<?php echo $lang['Yes']; ?>&#160;&#160;&#160;<input type="radio" name="form[module_downloads]" value="0"<?php if (bb_module_downloads == '0')
                                       echo ' checked="checked"' ?> />&#160;<?php echo $lang['No']; ?></td>
                                </tr>                        
                                <tr>
                                    <th class="header"><?php echo $lang_cms_main_module_downloads['dl_dir']; ?></th>
                                    <td class="tips"><?php BB_Template::Print_Tooltip($lang_cms_main_module_downloads['dl_dir_info']) ?></td>
                                    <td><input class="textbox" type="text" name="form[module_downloads_path]" size="40" maxlength="255"  value="<?php echo bb_module_downloads_path ?>" /></td>
                                </tr>                                
                                <tr>
                                    <th class="header"><?php echo $lang_cms_main_module_downloads['exts']; ?></th>
                                    <td class="tips"><?php BB_Template::Print_Tooltip($lang_cms_main_module_downloads['exts_info']) ?></td>
                                    <td><input class="textbox" type="text" name="form[module_downloads_exts]" size="40" maxlength="255"  value="<?php echo bb_module_downloads_exts ?>" /></td>
                                </tr>
                                <tr>
                                    <th class="header"><?php echo $lang_cms_main_module_downloads['guest']; ?></th>
                                    <td class="tips"><?php BB_Template::Print_Tooltip($lang_cms_main_module_downloads['guest_info']) ?></td>
                                    <td><input type="radio" name="form[module_downloads_guest]" value="1"<?php if (bb_module_downloads_guest == '1')
                                       echo ' checked="checked"' ?> />&#160;<?php echo $lang['Yes']; ?>&#160;&#160;&#160;<input type="radio" name="form[module_downloads_guest]" value="0"<?php if (bb_module_downloads_guest == '0')
                                       echo ' checked="checked"' ?> />&#160;<?php echo $lang['No']; ?></td>
                                </tr>
                                <tr>
                                    <th class="header"><?php echo $lang_cms_main_module_downloads['extern']; ?></th>
                                    <td class="tips"><?php BB_Template::Print_Tooltip($lang_cms_main_module_downloads['extern_info']) ?></td>
                                    <td><input type="radio" name="form[module_downloads_leech]" value="1"<?php if (bb_module_downloads_leech == '1')
                                       echo ' checked="checked"' ?> />&#160;<?php echo $lang['Yes']; ?>&#160;&#160;&#160;<input type="radio" name="form[module_downloads_leech]" value="0"<?php if (bb_module_downloads_leech == '0')
                                       echo ' checked="checked"' ?> />&#160;<?php echo $lang['No']; ?></td>
                                </tr>
                                <tr>
                                    <th class="header"><?php echo $lang_cms_main_module_downloads['mode']; ?></th>
                                    <td class="tips"><?php BB_Template::Print_Tooltip($lang_cms_main_module_downloads['mode_info']) ?></td>
                                    <td><input type="radio" name="form[module_downloads_mode]" value="redir"<?php if (bb_module_downloads_mode == 'redir')
                                       echo ' checked="checked"' ?> />&#160;<?php echo $lang_cms_main_module_downloads['mode_redir']; ?>&#160;&#160;&#160;<input type="radio" name="form[module_downloads_mode]" value="send"<?php if (bb_module_downloads_mode == 'send')
                                       echo ' checked="checked"' ?> />&#160;<?php echo $lang_cms_main_module_downloads['mode_send']; ?></td>
                                </tr>
                                <tr>
                                    <th class="header"><?php echo $lang_cms_main_module_downloads['redir_time']; ?></th>
                                    <td class="tips"><?php BB_Template::Print_Tooltip($lang_cms_main_module_downloads['redir_time_info']) ?></td>
                                    <td><input class="textbox" type="text" name="form[module_downloads_time]" size="5" maxlength="3" value="<?php echo bb_module_downloads_time ?>" /></td>
                                </tr>
                                <tr>
                                    <th class="header"><?php echo $lang_cms_main_module_downloads['direct_link']; ?></th>
                                    <td class="tips"><?php BB_Template::Print_Tooltip($lang_cms_main_module_downloads['direct_link_info']) ?></td>
                                    <td><input type="radio" name="form[module_downloads_dwl]" value="1"<?php if (bb_module_downloads_dwl == '1')
                                       echo ' checked="checked"' ?> />&#160;<?php echo $lang['Yes']; ?>&#160;&#160;&#160;<input type="radio" name="form[module_downloads_dwl]" value="0"<?php if (bb_module_downloads_dwl == '0')
                                       echo ' checked="checked"' ?> />&#160;<?php echo $lang['No']; ?></td>
                                </tr>
                            </table>
                        </div>
                    </div>
                    <div><input type="submit" class="b1" value="<?php echo $lang['Save']; ?>" /></div>
                </form>
            </div>
            <?php
        }
        break;
    case 'cat':
        if (isset($_POST['add_cat']))
        {
            $new_cat_name = BB_Input::Trim($_POST['new_cat_name']);
            if ($new_cat_name == '')
                BB_Functions::Message($lang_cms_main_module_downloads['must_give_cat_name']);
            $db->query('INSERT INTO ' . $db->prefix . 'module_downloads_categories (cat_name) VALUES(\'' . $db->escape($new_cat_name) . '\')') or BB_Functions::Error($lang_cms_main_module_downloads['cannot_create_cat'], __FILE__, __LINE__, $db->error());
            BB_Admin_Functions::Log_Action('Module downloads : add category ' . $new_cat_name, 0);
            BB_Functions::Redirect(MODULE_ADMIN_URL . '&amp;do=cat', $lang_cms_main_module_downloads['cat_added']);
        }
        else if (isset($_POST['del_cat']) || isset($_POST['del_cat_comply']))
        {
            $cat_to_delete = isset($_POST['cat_to_delete']) ? intval($_POST['cat_to_delete']) : null;
            if ($cat_to_delete < 1)
                BB_Functions::Message($lang['Bad request']);
            if (isset($_POST['del_cat_comply']))
            {
                @set_time_limit(0);
                $result = $db->query('SELECT id FROM ' . $db->prefix . 'module_downloads WHERE cat_id=' . $db->escape($cat_to_delete)) or BB_Functions::Error($lang_cms_main_module_downloads['unable_get_dls'], __FILE__, __LINE__, $db->error());
                $num_files = $db->num_rows($result);
                for ($i = 0; $i < $num_files; ++$i)
                {
                    $cur_file = $db->result($result, $i);
                    $db->query('DELETE FROM ' . $db->prefix . 'module_downloads WHERE id=' . $db->escape($cur_file)) or BB_Functions::Error($lang_cms_main_module_downloads['unable_del_dl'], __FILE__, __LINE__, $db->error());
                }
                $db->query('DELETE FROM ' . $db->prefix . 'module_downloads_categories WHERE id=' . $db->escape($cat_to_delete)) or BB_Functions::Error($lang_cms_main_module_downloads['unable_del_cat'], __FILE__, __LINE__, $db->error());
                BB_Admin_Functions::Log_Action('Module downloads : delete category ' . $cat_to_delete, 3);
                BB_Functions::Redirect(MODULE_ADMIN_URL . '&amp;do=cat', $lang_cms_main_module_downloads['cat_deleted']);
            }
            else
            {
                $result = $db->query('SELECT cat_name FROM ' . $db->prefix . 'module_downloads_categories WHERE id=' . $db->escape($cat_to_delete)) or BB_Functions::Error($lang_cms_main_module_downloads['unable_get_cat_info'], __FILE__, __LINE__, $db->error());
                $cat_name = $db->result($result);
                ?>
                <div class="blockform">
                    <h2><span><?php echo $lang_cms_main_module_downloads['del_dl_cat']; ?></span></h2>
                    <form method="post" action="<?php echo MODULE_ADMIN_URL ?>&amp;do=cat&amp;del_cat">
                        <input type="hidden" name="cat_to_delete" value="<?php echo $cat_to_delete ?>" />
                        <div class="inform">
                            <div class="infldset file" style="padding:10px">
                                <p><?php printf($lang_cms_main_module_downloads['confirm_del_cat_id'], $cat_name); ?></p>
                                <p><?php echo $lang_cms_main_module_downloads['warn_del_cat']; ?></p>
                            </div>
                        </div>
                        <div><input type="button" class="b1" onclick="javascript:history.go(-1);" value="<?php echo $lang['Go back']; ?>" />&nbsp;&nbsp;&nbsp;<input type="submit" name="del_cat_comply" class="b1" value="<?php echo $lang['Delete']; ?>" /></div>
                    </form>
                </div>
                <?php
            }
        }
        else if (isset($_POST['update']))
        {
            $cat_order = $_POST['cat_order'];
            $cat_name = $_POST['cat_name'];
            $result = $db->query('SELECT id, disp_position FROM ' . $db->prefix . 'module_downloads_categories ORDER BY disp_position') or BB_Functions::Error($lang_cms_main_module_downloads['unable_to_get_cat'], __FILE__, __LINE__, $db->error());
            $num_cats = $db->num_rows($result);
            for ($i = 0; $i < $num_cats; ++$i)
            {
                if ($cat_name[$i] == '')
                    BB_Functions::Message($lang_cms_main_module_downloads['must_give_cat_name']);
                if (!preg_match('#^\d+$#', $cat_order[$i]))
                    BB_Functions::Message($lang_cms_main_module_downloads['posit_must_int']);
                list($cat_id, $position) = $db->fetch_row($result);
                $db->query('UPDATE ' . $db->prefix . 'module_downloads_categories SET cat_name=\'' . $db->escape($cat_name[$i]) . '\', disp_position=' . $db->escape($cat_order[$i]) . ' WHERE id=' . $db->escape($cat_id)) or BB_Functions::Error($lang_cms_main_module_downloads['unable_update_cat'], __FILE__, __LINE__, $db->error());
            }
            BB_Admin_Functions::Log_Action('Module downloads : edit categories ', 1);
            BB_Functions::Redirect(MODULE_ADMIN_URL . '&amp;do=cat', $lang_cms_main_module_downloads['cats_updated']);
        }
        else
        {
            $result = $db->query('SELECT id, cat_name, disp_position FROM ' . $db->prefix . 'module_downloads_categories ORDER BY disp_position') or BB_Functions::Error($lang_cms_main_module_downloads['unable_to_get_cat'], __FILE__, __LINE__, $db->error());
            $num_cats = $db->num_rows($result);
            for ($i = 0; $i < $num_cats; ++$i)
                $cat_list[] = $db->fetch_row($result);
            echo BB_Template::Generate_Menu($submenu);
            ?>
            <div class="blockform">
                <form method="post" action="<?php echo MODULE_ADMIN_URL ?>&amp;do=cat">
                    <div class="inform">
                        <div class="infldset file" style="padding:10px">
                            <table class="aligntop" cellspacing="0">
                                <tr>
                                    <th style="width:150px" scope="row"><?php echo $lang_cms_main_module_downloads['add_new_cat']; ?></th>
                                    <td><input class="textbox" type="text" name="new_cat_name" size="30" maxlength="80" tabindex="1" /></td>
                                    <td><input type="submit" class="b1" name="add_cat" value="<?php echo $lang['Add']; ?>" tabindex="2" /></td>
                                </tr>
                                <?php
                                if ($num_cats)
                                {
                                    ?>
                                    <tr>
                                        <th scope="row"><?php echo $lang_cms_main_module_downloads['del_cat']; ?></th>
                                        <td>
                                            <select name="cat_to_delete" tabindex="3">
                                                <?php
                                                while (list(, list($cat_id, $cat_name,, )) = @each($cat_list))
                                                    echo "\t\t\t\t\t\t\t\t\t\t" . '<option value="' . $cat_id . '">' . BB_Input::Htmlspecialchars($cat_name) . '</option>' . "\n";
                                                ?>
                                            </select>
                                        </td>
                                        <td><input type="submit" class="b1" name="del_cat" value="<?php echo $lang['Delete']; ?>" tabindex="4" /></td>
                                    </tr>
                                    <?php
                                }
                                ?>
                            </table>
                        </div>
                    </div>
                    <?php
                    if ($num_cats)
                    {
                        ?>
                        <div class="inform">
                            <h2><?php echo $lang_cms_main_module_downloads['edit_cat']; ?></h2>
                            <div class="inform">
                                <div class="infldset file" style="padding:0px">
                                    <table>
                                        <thead>
                                            <tr>
                                                <th style="width:80%" class="tcl" scope="col"><?php echo $lang_cms_main_module_downloads['name']; ?></th>
                                                <th scope="col"><?php echo $lang_cms_main_module_downloads['position']; ?></th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            <?php
                                            @reset($cat_list);
                                            for ($i = 0; $i < $num_cats; ++$i)
                                            {
                                                list(, list($cat_id, $cat_name, $position)) = @each($cat_list);
                                                ?>
                                                <tr><td><input type="text" class="textbox" name="cat_name[<?php echo $i ?>]" value="<?php echo BB_Input::Htmlspecialchars($cat_name) ?>" size="30" maxlength="80" /></td><td><input type="text" class="textbox" name="cat_order[<?php echo $i ?>]" value="<?php echo $position ?>" size="3" maxlength="3" /></td></tr>
                                                <?php
                                            }
                                            ?>
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                            <div><input class="b1" type="submit" name="update" value="<?php echo $lang['Update']; ?>" /></div>
                        </div>
                        <?php
                    }
                    ?>
                </form>
            </div>
            <?php
        }
        break;
    case 'dl':
        if (isset($_POST['add_file']))
        {
            $add_to_cat = isset($_POST['add_to_cat']) ? intval($_POST['add_to_cat']) : null;
            if ($add_to_cat < 1)
                BB_Functions::Message($lang['Bad request']);
            $db->query('INSERT INTO ' . $db->prefix . 'module_downloads (cat_id) VALUES(' . $db->escape($add_to_cat) . ')') or BB_Functions::Error($lang_cms_main_module_downloads['unable_add_dl'], __FILE__, __LINE__, $db->error());
            $new_id = $db->insert_id();
            BB_Admin_Functions::Log_Action('Module downloads : add download', 0);
            BB_Functions::Redirect(MODULE_ADMIN_URL . '&amp;do=dl&amp;edit=' . $new_id, $lang_cms_main_module_downloads['dl_added']);
        }
        else if (isset($_POST['update_positions']))
        {
            while (list($file_id, $disp_position) = @each($_POST['position']))
            {
                if (!preg_match('#^\d+$#', $disp_position))
                    BB_Functions::Message($lang_cms_main_module_downloads['posit_must_int']);
                $db->query('UPDATE ' . $db->prefix . 'module_downloads SET disp_position=' . $db->escape($disp_position) . ' WHERE id=' . $db->escape($file_id)) or BB_Functions::Error($lang_cms_main_module_downloads['unable_update_dl'], __FILE__, __LINE__, $db->error());
            }
            BB_Admin_Functions::Log_Action('Module downloads : edit downloads', 1);
            BB_Functions::Redirect(MODULE_ADMIN_URL . '&amp;do=dl', $lang_cms_main_module_downloads['dls_updated']);
        }
        else if (isset($_GET['del']))
        {
            $file_id = isset($_GET['del']) ? intval($_GET['del']) : null;
            if ($file_id < 1)
                BB_Functions::Message($lang['Bad request']);
            if (isset($_POST['del_file_comply']))
            {
                @set_time_limit(0);
                $db->query('DELETE FROM ' . $db->prefix . 'module_downloads WHERE id=' . $db->escape($file_id)) or BB_Functions::Error($lang_cms_main_module_downloads['unable_del_dl'], __FILE__, __LINE__, $db->error());
                BB_Admin_Functions::Log_Action('Module downloads : delete download ' . $file_id, 3);
                BB_Functions::Redirect(MODULE_ADMIN_URL . '&amp;do=dl', $lang_cms_main_module_downloads['dl_deleted']);
            }
            else
            {
                $result = $db->query('SELECT name FROM ' . $db->prefix . 'module_downloads WHERE id=' . $db->escape($file_id)) or BB_Functions::Error($lang_cms_main_module_downloads['unable_get_dl_info'], __FILE__, __LINE__, $db->error());
                $file_name = BB_Input::Htmlspecialchars($db->result($result));
                ?>
                <div class="blockform">
                    <h2><span><?php echo $lang_cms_main_module_downloads['confim_del_dl']; ?></span></h2>
                    <form method="post" action="<?php echo MODULE_ADMIN_URL ?>&amp;do=dl&amp;del=<?php echo $file_id ?>">
                        <div class="inform">
                            <div class="infldset file" style="padding:10px">
                                <p><?php printf($lang_cms_main_module_downloads['confirm_del_dl_id'], $file_name); ?></p>
                            </div>
                        </div>
                        <div><input type="button" class="b1" onclick="javascript:history.go(-1);" value="<?php echo $lang['Go back']; ?>" />&nbsp;&nbsp;&nbsp;<input type="submit" name="del_file_comply" class="b1" value="<?php echo $lang['Delete']; ?>" /></div>
                    </form>
                </div>
                <?php
            }
        }
        elseif (isset($_GET['edit']))
        {
            $file_id = isset($_GET['edit']) ? intval($_GET['edit']) : null;
            if ($file_id < 1)
                BB_Functions::Message($lang['Bad request']);
            if (isset($_POST['save']))
            {
                $name = BB_Input::Trim($_POST['name']);
                $filename = BB_Input::Trim($_POST['filename']);
                $description = BB_Input::Linebreaks(BB_Input::Trim($_POST['description']));
                $cat_id = intval($_POST['cat_id']);
                $date = BB_Input::Trim($_POST['date']);
                $counter = intval($_POST['counter']);
                $home = intval($_POST['home']);
                $on_block = intval($_POST['on_block']);
                if ($name == '')
                    BB_Functions::Message($lang_cms_main_module_downloads['must_give_dl_title']);
                if ($filename == '')
                    BB_Functions::Message($lang_cms_main_module_downloads['must_give_dl_filename']);
                if ($cat_id < 1)
                    BB_Functions::Message($lang['Bad request']);
                $description = ($description != '') ? '\'' . $db->escape($description) . '\'' : 'NULL';
                $date = ($date != '') ? '\'' . $db->escape($date) . '\'' : 'NULL';
                $db->query('UPDATE ' . $db->prefix . 'module_downloads SET name=\'' . $db->escape($name) . '\', filename=\'' . $db->escape($filename) . '\', description=' . $description . ', counter=' . $db->escape($counter) . ', date=' . $date . ', cat_id=' . $db->escape($cat_id) . ', home=' . $db->escape($home) . ', on_block=' . $db->escape($on_block) . '  WHERE id=' . $db->escape($file_id)) or BB_Functions::Error($lang_cms_main_module_downloads['unable_update_the_dl'], __FILE__, __LINE__, $db->error());
                BB_Admin_Functions::Log_Action('Module downloads : edit download ' . $file_id, 1);
                BB_Functions::Redirect(MODULE_ADMIN_URL . '&amp;do=dl', $lang_cms_main_module_downloads['dl_updated']);
            }
            $result = $db->query('SELECT id, name, filename, description, counter, date, cat_id, home, on_block FROM ' . $db->prefix . 'module_downloads WHERE id=' . $db->escape($file_id)) or BB_Functions::Error($lang_cms_main_module_downloads['unable_get_dl_info'], __FILE__, __LINE__, $db->error());
            if (!$db->num_rows($result))
                BB_Functions::Message($lang['Bad request']);
            $cur_file = $db->fetch_assoc($result);
            ?>
            <div class="blockform">
                <h2><span><?php echo $lang_cms_main_module_downloads['edit_dl']; ?></span></h2>
                <form id="edit_file" method="post" action="<?php echo MODULE_ADMIN_URL ?>&amp;do=dl&amp;edit=<?php echo $cur_file['id'] ?>">
                    <div class="inform">
                        <div class="infldset file" style="padding:10px">
                            <table class="aligntop" cellspacing="0">
                                <tr>
                                    <th style="width:150px" scope="row"><?php echo $lang_cms_main_module_downloads['title']; ?></th>
                                    <td><input type="text" class="textbox" name="name" size="35" maxlength="80" value="<?php echo BB_Input::Htmlspecialchars($cur_file['name']) ?>" tabindex="1" /></td>
                                </tr>
                                <tr>
                                    <th scope="row"><?php echo $lang_cms_main_module_downloads['filename']; ?></th>
                                    <td><input type="text" class="textbox" name="filename" size="35" maxlength="80" value="<?php echo BB_Input::Htmlspecialchars($cur_file['filename']) ?>" tabindex="2" /></td>
                                </tr>
                                <tr>
                                    <th scope="row"><?php echo $lang_cms_main_module_downloads['desc_dl']; ?></th>
                                    <td><textarea name="description" rows="5" cols="50" tabindex="3"><?php echo BB_Input::Htmlspecialchars($cur_file['description']) ?></textarea></td>
                                </tr>
                                <tr>
                                    <th scope="row"><?php echo $lang_cms_main_module_downloads['cat']; ?></th>
                                    <td><select name="cat_id" tabindex="4">
                                            <?php
                                            $result = $db->query('SELECT id, cat_name FROM ' . $db->prefix . 'module_downloads_categories ORDER BY disp_position') or BB_Functions::Error($lang_cms_main_module_downloads['unable_to_get_cat'], __FILE__, __LINE__, $db->error());
                                            while ($cur_cat = $db->fetch_assoc($result))
                                            {
                                                $selected = ($cur_cat['id'] == $cur_file['cat_id']) ? ' selected="selected"' : '';
                                                echo "\t\t\t\t\t\t\t\t\t\t\t" . '<option value="' . $cur_cat['id'] . '"' . $selected . '>' . BB_Input::Htmlspecialchars($cur_cat['cat_name']) . '</option>' . "\n";
                                            }
                                            ?>
                                        </select></td>
                                </tr>
                                <tr>
                                    <th scope="row"><?php echo $lang_cms_main_module_downloads['date']; ?></th>
                                    <td><input type="text" class="textbox" name="date" size="15" maxlength="80" value="<?php echo BB_Input::Htmlspecialchars($cur_file['date']) ?>" tabindex="5" /></td>
                                </tr>
                                <tr>
                                    <th scope="row"><?php echo $lang_cms_main_module_downloads['count']; ?></th>
                                    <td><input type="text" class="textbox" name="counter" size="10" maxlength="7" value="<?php echo $cur_file['counter'] ?>" tabindex="6" /></td>
                                </tr>
                                <tr>
                                    <th scope="row"><?php echo $lang_cms_main_module_downloads['module_home']; ?></th>
                                    <td><input type="radio" name="home" value="1"<?php if ($cur_file['home'] == '1')
                                    echo ' checked="checked"' ?> />&#160;<?php echo $lang['Yes']; ?>&#160;&#160;&#160;<input type="radio" name="home" value="0"<?php if ($cur_file['home'] == '0')
                                       echo ' checked="checked"' ?> />&#160;<?php echo $lang['No']; ?></td>
                                </tr>
                                <tr>
                                    <th scope="row"><?php echo $lang_cms_main_module_downloads['block']; ?></th>
                                    <td><input type="radio" name="on_block" value="1"<?php if ($cur_file['on_block'] == '1')
                                       echo ' checked="checked"' ?> />&#160;<?php echo $lang['Yes']; ?>&#160;&#160;&#160;<input type="radio" name="on_block" value="0"<?php if ($cur_file['on_block'] == '0')
                                       echo ' checked="checked"' ?> />&#160;<?php echo $lang['No']; ?></td>
                                </tr>
                            </table>
                        </div>
                    </div>
                    <div><input type="button" class="b1" onclick="javascript:history.go(-1);" value="<?php echo $lang['Go back']; ?>" />&nbsp;&nbsp;&nbsp;<input class="b1" type="submit" name="save" value="<?php echo $lang['Save']; ?>" /></div>
                </form>
            </div>
            <?php
        }
        else
        {
            echo BB_Template::Generate_Menu($submenu);
            ?>
            <div class="blockform">
                <form method="post" action="<?php echo MODULE_ADMIN_URL ?>&amp;do=dl">
                    <div class="inform">
                        <div class="infldset file" style="padding:10px">
                            <table class="aligntop" cellspacing="0">
                                <tr>
                                    <th style="width:150px" scope="row"><?php echo $lang_cms_main_module_downloads['add_dl_to_cat']; ?></th>
                                    <td><select name="add_to_cat" tabindex="1">
                                            <?php
                                            $result = $db->query('SELECT id, cat_name FROM ' . $db->prefix . 'module_downloads_categories ORDER BY disp_position') or xBB_Eeror($lang_cms_main_module_downloads['unable_to_get_cat'], __FILE__, __LINE__, $db->error());
                                            while ($cur_cat = $db->fetch_assoc($result))
                                                echo "\t\t\t\t\t\t\t\t\t" . '<option value="' . $cur_cat['id'] . '">' . BB_Input::Htmlspecialchars($cur_cat['cat_name']) . '</option>' . "\n";
                                            ?>
                                        </select></td>
                                    <td><input type="submit" class="b1" name="add_file" value=" <?php echo $lang['Add']; ?> " tabindex="2" /></td>
                                </tr>
                            </table>
                        </div>
                    </div>
                </form>
            </div>
            <?php
            $tabindex_count = 4;
            $result = $db->query('SELECT c.id AS cid, c.cat_name, f.id AS fid, f.name, f.filename,  f.home, f.on_block, f.disp_position FROM ' . $db->prefix . 'module_downloads_categories AS c INNER JOIN ' . $db->prefix . 'module_downloads AS f ON c.id=f.cat_id ORDER BY c.disp_position, c.id, f.disp_position') or BB_Functions::Error($lang_cms_main_module_downloads['unable_to_get_cat_and_files'], __FILE__, __LINE__, $db->error());
            $cur_category = 0;
            $countfiles = 0;
            if ($db->num_rows($result) > 0)
            {
                ?>
                <div class="blockform">
                    <h2><span><?php echo $lang_cms_main_module_downloads['edit_dls']; ?></span></h2>
                    <form id="edforum" method="post" action="<?php echo MODULE_ADMIN_URL ?>&amp;do=dl">
                        <?php
                        while ($cur_file = $db->fetch_assoc($result))
                        {
                            if ($cur_file['cid'] != $cur_category)
                            {
                                if ($cur_category != 0)
                                    echo "\t\t\t\t\t\t\t" . '</table>' . "\n\t\t\t\t\t\t" . '</div>' . "\n\t\t\t\t\t" . '</fieldset>' . "\n\t\t\t\t" . '</div>' . "\n";
                                ?>
                                <div class="inform">
                                    <h2><?php echo $lang_cms_main_module_downloads['cat'] . ' ' . BB_Input::Htmlspecialchars($cur_file['cat_name']) ?></h2>
                                    <div class="infldset file" style="padding:10px">
                                        <table cellspacing="0">
                                            <?php
                                            $cur_category = $cur_file['cid'];
                                        }
                                        $file_links_tmp = '';
                                        foreach (explode('|', bb_module_downloads_exts) as $ext)
                                        {
                                            if (file_exists('var' . bb_module_downloads_path . '/' . $ext . '/' . $cur_file['filename'] . '.' . $ext))
                                                $file_links_tmp .= '[' . $ext . '] ';
                                        }
                                        ?>
                                        <tr>
                                            <th style="width:150px"><a href="<?php echo MODULE_ADMIN_URL ?>&amp;do=dl&amp;edit=<?php echo $cur_file['fid'] ?>"><?php echo $lang['Edit']; ?></a> - <a href="<?php echo MODULE_ADMIN_URL ?>&amp;do=dl&amp;del=<?php echo $cur_file['fid'] ?>"><?php echo $lang['Delete']; ?></a></th>
                                            <td><?php echo $lang_cms_main_module_downloads['position']; ?>&#160;&#160;<input type="text" class="textbox" name="position[<?php echo $cur_file['fid'] ?>]" size="3" maxlength="3" value="<?php echo $cur_file['disp_position'] ?>" tabindex="<?php echo $tabindex_count ?>" />&#160;&#160;<strong><?php echo BB_Input::Htmlspecialchars($cur_file['name']) ?></strong></td>
                                        </tr>
                                        <?php
                                        $tabindex_count += 2;
                                        $countfiles++;
                                    }
                                    if ($countfiles > 0)
                                    {
                                        ?>
                                    </table>
                                </div>
                            </div>
                            <?php
                        }
                        ?>
                        <div><input type="submit" class="b1" name="update_positions" value="<?php echo $lang['Update']; ?>" tabindex="<?php echo $tabindex_count ?>" /></div>
                    </form>
                </div>
                <?php
            }
        }
        break;
    case 'files':

        class xBB_File_Manager extends BB_File_Manager
        {

            var $url;
            var $p_img;

            function xBB_File_Manager($root_path, $base_path, $url, $p_img)
            {
                parent::BB_File_Manager($root_path, $base_path);
                $this->url = $url;
                $this->p_img = $p_img;
            }

            function Get_Nav_Bar()
            {
                $f = '';
                $res = '&#187; <a href="' . $this->url . '">' . bb_module_downloads_path . '</a>';
                if (file_exists($this->root . $this->base_path))
                {
                    $r = explode('/', $this->base_path);
                    for ($i = 1; $i < count($r); $i++)
                    {
                        $f .= '/' . $r[$i];
                        $res .= '/<a href="' . $this->url . '&amp;f=' . $f . '">' . $r[$i] . '</a>';
                    }
                }
                return $res;
            }

            function Get_Line($k, $v, $c)
            {
                global $lang_cms_main_module_downloads, $lang;
                $color[0] = 'background:#fff;';
                $color[1] = 'background:#f3f3f3;';
                $common_style = 'padding: 1px 0.5em;';
                $name_style = $common_style;
                $common_style .= 'width:1px;white-space:nowrap;';
                $common_style = 'style="' . $common_style . $color[$c] . '"';
                $name_style = 'style="' . $name_style . $color[$c] . '"';
                $res = '<tr>';
                $res .= '<td ' . $common_style . '>';
                if ($v['d'] && $v['w'])
                    $res .= '<img src="' . $this->p_img . 'folder.png" alt="' . $lang_cms_main_module_downloads['folder'] . '" /> ';
                elseif ($v['d'])
                    $res .= '<img src="' . $this->p_img . 'folder-ro.png" alt="' . $lang_cms_main_module_downloads['folder'] . '" /> ';
                elseif ($v['f'] && $v['w'])
                {
                    if ($v['type'] == 'img')
                        $res .= '<img src="' . $this->p_img . 'image.png" alt="' . $lang_cms_main_module_downloads['file'] . '" /> ';
                    else
                        $res .= '<img src="' . $this->p_img . 'file.png" alt="' . $lang_cms_main_module_downloads['file'] . '" /> ';
                }
                else
                {
                    if ($v['type'] == 'img')
                        $res .= '<img src="' . $this->p_img . 'image-ro.png" alt="' . $lang_cms_main_module_downloads['file'] . '" /> ';
                    else
                        $res .= '<img src="' . $this->p_img . 'file-ro.png" alt="' . $lang_cms_main_module_downloads['file'] . '" /> ';
                }
                $res .= '</td>';
                $res .= '<td ' . $name_style . '>';
                if ($v['jail'] && $v['r'] && ($v['f'] || $v['d'] && $v['x']))
                    $res .= '<a href="' . $this->url . '&amp;f=' . $v['l'] . '">' . $k . '</a>';
                else
                    $res .= $k;
                $res .= '</td>';
                $res .= '<td ' . $common_style . '>' . BB_Files::Size(filesize($v['fname'])) . '</td>';
                $res .= '<td ' . $common_style . '>' . strftime('%Y-%m-%d %H:%M:%S', $v['mtime']) . '</td>';
                $res .= '<td ' . $common_style . '>';
                if ($v['del'])
                {
                    $del_msg = $v['d'] ? $lang_cms_main_module_downloads['confirm_del_dir'] : $lang_cms_main_module_downloads['confirm_del_file'];
                    $res .= '<a href="' . $this->url . '&amp;f=' . $v['l'] . '&amp;del=1" onclick="return window.confirm(\'' . $del_msg . '\')" title="' . $lang['Delete'] . '"><img src="' . $this->p_img . 'trash.png" alt="' . $lang['Delete'] . '" /></a> ';
                }
                if ($v['jail'] && $v['r'] && $v['f'])
                    $res .= '<a href="' . $this->url . '&amp;f=' . $v['l'] . '&amp;dl=1" title="' . $lang_cms_main_module_downloads['dl'] . '"><img src="' . $this->p_img . 'download.png" alt="' . $lang_cms_main_module_downloads['dl'] . '" /></a> ';
                $res .= ' </td>';
                $res .= '</tr>';
                return $res;
            }

        }

        $fm_cf_chroot = '../var' . bb_module_downloads_path;
        $fm_cf_exclusion = array();
        $base_path = (!empty($_REQUEST['f'])) ? $_REQUEST['f'] : '';
        $cms_FM = new xBB_File_Manager($fm_cf_chroot, $base_path, 'loader.php?module=downloads&do=files', '../' . $forum_folder . '/img/admin/');
        $cms_FM->Add_Exclusion($fm_cf_exclusion);
        if (!empty($_GET['dl']) && $cms_FM->Is_File() && !$cms_FM->Is_Excluded())
        {
            if (strpos(basename($cms_FM->base_path), '.') === false)
                $mime_type = 'text/plain';
            elseif (preg_match('/.png$/', $cms_FM->base_path))
                $mime_type = 'image/png';
            elseif (preg_match('/.gif$/', $cms_FM->base_path))
                $mime_type = 'image/gif';
            elseif (preg_match('/.(jpg|jpeg)$/', $cms_FM->base_path))
                $mime_type = 'image/jpeg';
            elseif (preg_match('/(' . $cms_FM->_types['txt'] . ')$/', $cms_FM->base_path))
                $mime_type = 'text/plain';
            else
                $mime_type = 'application/download';
            header('Content-Type: ' . $mime_type);
            if ($mime_type == 'application/download')
                header('Content-Disposition: attachment; filename=' . basename($cms_FM->base_path));
            echo $cms_FM->Get_Content();
            BB_Admin_Functions::Log_Action('Module downloads : get file "' . basename($cms_FM->base_path) . '"', 0);
            exit;
        }
        if (!empty($_GET['new_dir']) && $cms_FM->Is_Writable() && !$cms_FM->Is_Excluded())
        {
            if ($cms_FM->New_Directory($_GET['new_dir']) !== false)
            {
                BB_Admin_Functions::Log_Action('Module downloads : create directory "' . $_GET['new_dir'] . '"', 0);
                header('Location: loader.php?module=downloads&do=files&f=' . $cms_FM->base_path);
                exit;
            }
            else
                BB_Functions::Message($lang_cms_main_module_downloads['cannot_create_dir']);
        }
        if (!empty($_FILES['up_file']) && !$cms_FM->Is_Excluded())
        {
            $up_name = BB_Input::Trim(str_replace('/', '', $_POST['up_name']));
            $tmp_file = $_FILES['up_file']['tmp_name'];
            $file_name = $_FILES['up_file']['name'];
            $dest_file = $cms_FM->root . $cms_FM->base_path . '/' . $file_name;
            if ($up_name != '')
                $dest_file = $cms_FM->root . $cms_FM->base_path . '/' . $up_name;
            $uerr = array();
            if (version_compare(phpversion(), '4.2.0', '>='))
                $upd_error = $_FILES['up_file']['error'];
            else
                $upd_error = 0;
            if ($upd_error != 0)
            {
                switch ($upd_error)
                {
                    case 1:
                    case 2:
                        BB_Functions::Message($lang_cms_main_module_downloads['file_too_big']);
                        break;
                    case 3:
                        BB_Functions::Message($lang_cms_main_module_downloads['file_partially']);
                        break;
                    case 4:
                        BB_Functions::Message($lang_cms_main_module_downloads['no_file']);
                        break;
                }
            }
            elseif (file_exists($dest_file))
                BB_Functions::Message($lang_cms_main_module_downloads['file_allready_exists']);
            elseif (@move_uploaded_file($tmp_file, $dest_file) !== false)
            {
                BB_Admin_Functions::Log_Action('Module downloads : add file "' . $dest_file . '"', 0);
                chmod($dest_file, fileperms(dirname($dest_file)) & ~0111);
                header('Location: loader.php?module=downloads&do=files&f=' . $cms_FM->base_path);
                exit;
            }
            else
                BB_Functions::Message($lang_cms_main_module_downloads['cannot_upload']);
        }
        if ($cms_FM->base_path != '' && !$cms_FM->Is_Excluded())
        {
            if (!empty($_POST['f_content']) && $cms_FM->Is_Writable())
            {
                $f_content = str_replace("\r", '', $_POST['f_content']);
                if ($cms_FM->Put_Content($f_content) !== false)
                {
                    BB_Admin_Functions::Log_Action('Module downloads : edit file "' . $cms_FM->base_path . '"', 1);
                    header('Location: loader.php?module=downloads&do=files&f=' . $cms_FM->base_path);
                    exit;
                }
                else
                    BB_Functions::Message($lang_cms_main_module_downloads['cannot_write_file']);
            }
            if (!empty($_GET['new_name']) && $cms_FM->Is_Parent_Writable())
            {
                if ($cms_FM->Rename($_GET['new_name']) !== false)
                {
                    BB_Admin_Functions::Log_Action('Module downloads : rename "' . $_GET['f'] . '" in "' . $_GET['new_name'] . '"', 1);
                    header('Location: loader.php?module=downloads&do=files&f=' . dirname($cms_FM->base_path));
                    exit;
                }
                else
                    BB_Functions::Message($lang_cms_main_module_downloads['cannot_rename']);
            }
            if (!empty($_GET['del']) && $cms_FM->Is_Deletable())
            {
                if ($cms_FM->Delete() === true)
                {
                    BB_Admin_Functions::Log_Action('Module downloads : delete "' . $cms_FM->base_path . '"', 3);
                    header('Location: loader.php?module=downloads&do=files&f=' . dirname($cms_FM->base_path));
                    exit;
                }
                else
                    BB_Functions::Message($lang_cms_main_module_downloads['cannot_delete']);
            }
        }
        echo BB_Template::Generate_Menu($submenu);
        ?>
        <div class="blockform">
            <div class="fakeform">
                <div class="inbox">
                    <p><?php echo $cms_FM->Get_Nav_Bar(); ?></p>
                    <?php
                    if (!$cms_FM->Is_Excluded() && ($f_list = $cms_FM->Get_Directory()) !== false)
                    {
                        ?>
                        <table style="width:98%;border-collapse:separate;border-spacing:1px;">
                            <tr>
                                <th>&nbsp;</th>
                                <th><strong><?php echo $lang_cms_main_module_downloads['name']; ?></strong></th>
                                <th><strong><?php echo $lang_cms_main_module_downloads['size']; ?></strong></th>
                                <th><strong><?php echo $lang_cms_main_module_downloads['date']; ?></strong></th>
                                <th>&nbsp;</th>
                            </tr>
                            <?php
                            $i = 0;
                            foreach ($f_list['dirs'] as $k => $v)
                            {
                                echo $cms_FM->Get_Line($k, $v, ($i % 2));
                                $i++;
                            }
                            foreach ($f_list['files'] as $k => $v)
                            {
                                echo $cms_FM->Get_Line($k, $v, ($i % 2));
                                $i++;
                            }
                            echo '</table>';
                        }
                        ?>
                </div>
            </div>
            <?php
            $title_box = $lang_cms_main_module_downloads['options'];
            $content_box = '';
            if ($cms_FM->Is_File() && !$cms_FM->Is_Excluded())
            {
                if (!$cms_FM->Is_Readable())
                    $title_box = $lang_cms_main_module_downloads['file_not_readable'];
                else
                {
                    if ($cms_FM->Is_Image())
                        $content_box .= '<img style="border:1px dashed #fc0;" src="loader.php?module=downloads&amp;do=files&amp;f=' . $cms_FM->base_path . '&amp;dl=1" alt="" />';
                    else
                    {
                        if ($cms_FM->Is_Writable())
                        {
                            $title_box = $lang_cms_main_module_downloads['file_writable'];
                            $content_box .= '<form action="loader.php?module=downloads&amp;do=files" method="post"><div class="inform"><textarea id="f_content" name="f_content" rows="26" cols="60" style="width:100%;font-family:courier,monospace;">' . BB_Input::Htmlspecialchars($cms_FM->Get_Content()) . '</textarea><p><input type="submit" class="b1" value="save" /><input type="hidden" name="f" value="' . BB_Input::Htmlspecialchars($cms_FM->base_path) . '" /><input type="hidden" name="p" value="filemanager" /></p></div></form>';
                        }
                        else
                        {
                            $title_box = $lang_cms_main_module_downloads['file_not_writable'];
                            $content_box .= '<div style="overflow:auto; height:26em; background:#eee;"><pre style="padding:0.5em">' . htmlspecialchars($cms_FM->Get_Content()) . '</pre></div>';
                        }
                    }
                }
            }
            if ($cms_FM->base_path != '' and $cms_FM->Is_Parent_Writable() && !$cms_FM->Is_Excluded())
                $content_box .= '<form action="loader.php?module=downloads&amp;do=files" method="get"><div class="inform"><h2>' . ($cms_FM->Is_File() ? $lang_cms_main_module_downloads['rename_file'] : $lang_cms_main_module_downloads['rename_dir']) . '</h2><div class="infldset file" style="padding:15px;"><label for="new_name">' . $lang_cms_main_module_downloads['new_name'] . '&nbsp;:<br /><input size="20" class="textbox" name="new_name" id="new_name" value="' . BB_Input::Htmlspecialchars(basename($cms_FM->base_path)) . '" type="text" />&nbsp;&nbsp;<input type="submit" class="b1" value="' . $lang_cms_main_module_downloads['rename'] . '" /></label><input type="hidden" name="module" value="downloads" /><input type="hidden" name="do" value="files" /><input type="hidden" name="f" value="<?php echo BB_Input::Htmlspecialchars($cms_FM->base_path); ?>" /></p></div></div></form>';
            if ($cms_FM->Is_Writable() && $cms_FM->Is_Directory() && !$cms_FM->Is_Excluded())
                $content_box .= '<form action="loader.php?module=downloads&amp;do=files" method="get"><div class="inform"><h2>' . $lang_cms_main_module_downloads['new_dir'] . '</h2><div class="infldset file" style="padding:15px"><label>' . $lang_cms_main_module_downloads['name'] . '&nbsp;:<br /><input size="20" class="textbox" name="new_dir" id="new_dir" value="" type="text" />&nbsp;&nbsp;<input type="submit" class="b1" value="' . $lang['Save'] . '" /></label><input type="hidden" name="module" value="downloads" /><input type="hidden" name="do" value="files" /><input type="hidden" name="f" value="' . BB_Input::Htmlspecialchars($cms_FM->base_path) . '" /></p></div></div></form><form enctype="multipart/form-data" action="loader.php?module=downloads&amp;do=files" method="post"><div class="inform"><h2>' . $lang_cms_main_module_downloads['add_file'] . '</h2><div class="infldset file" style="padding:15px"><label>' . $lang_cms_main_module_downloads['choose_file'] . '&nbsp;:<br /><input name="up_file" id="up_file" type="file" /></label><label>' . $lang_cms_main_module_downloads['opt_new_name'] . '&nbsp;:<br /><input size="20" name="up_name" id="up_name" value="" type="text" />&nbsp;&nbsp;<input type="submit" class="b1" value="' . $lang_cms_main_module_downloads['send'] . '" /></label><input type="hidden" name="module" value="downloads" /><input type="hidden" name="do" value="files" /><input type="hidden" name="f" value="' . BB_Input::Htmlspecialchars($cms_FM->base_path) . '" /></div></div></form>';
            ?>
            <?php echo $content_box; ?>
        </div>
        <?php
        break;
}
?>
