<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
if (!defined('IN_FORUM'))
    exit('No direct script access allowed');

class BB_Download_Module
{

    var $url;
    var $path;
    var $mode;
    var $request;
    var $extensions = array();
    var $cat_list = array();
    var $cat_id_list = array();
    var $cat_id = '';
    var $current_file = '';
    var $file_list = array();
    var $file_id = '';
    var $title = '';
    var $submenu = '';
    var $content = '';
    var $error;

    function BB_Download_Module()
    {
        global $cms_modules, $lang_cms_main_module_downloads, $uri_segments;
        if (bb_rewrite_urls == 1)
            $this->url = bb_website_url . '/downloads';
        else
            $this->url = bb_website_url . '/index.php?/downloads';
        $this->path = $cms_modules->path . '/downloads';
        $this->mode = bb_module_downloads_mode;
        $this->error = null;
        $this->request = null;
        $this->cat_id = '';
        $this->extensions = explode('|', bb_module_downloads_exts);
        $this->title = $lang_cms_main_module_downloads['downloads'];
        if (bb_module_downloads == '1')
        {
            if (isset($uri_segments[3]) && isset($uri_segments[4]))
            {
                $this->Download_File($uri_segments[3], $uri_segments[4]);
                $this->request = true;
            }
            else
            {
                if ($this->__List_Categories())
                {
                    if (!$this->__Get_Files())
                        $this->error = $lang_cms_main_module_downloads['no_file'];
                }
                else
                    $this->error = $lang_cms_main_module_downloads['no_cat'];
            }
        }
        else
            $this->error = $lang_cms_main_module_downloads['not_active'];
    }

    function __List_Categories()
    {
        global $db;
        $result = $db->query('SELECT id, cat_name FROM ' . $db->prefix . 'module_downloads_categories ORDER BY disp_position') or BB_Functions::Error('Cannot retrieve category info', __FILE__, __LINE__, $db->error());
        $num_cats = $db->num_rows($result);
        if ($num_cats > 0)
        {
            for ($i = 0; $i < $num_cats; ++$i)
                $this->cat_list[] = $db->fetch_row($result);
            while (list(, list($cat_id, $cat_name,, )) = @each($this->cat_list))
                $this->cat_id_list[] = $cat_id;
            return true;
        }
        else
            return false;
    }

    function __Get_Files()
    {
        global $uri_segments, $db;
        if (isset($uri_segments[2]) && isset($uri_segments[3]))
        {
            if (in_array($uri_segments[2], $this->cat_id_list))
                $this->cat_id = $uri_segments[2];
            $this->file_id = $uri_segments[3];
            $result = $db->query('SELECT c.id AS cid, f.id, f.name, f.filename, f.description, f.counter, f.date, f.disp_position, f.cat_id, c.cat_name FROM ' . $db->prefix . 'module_downloads AS f INNER JOIN ' . $db->prefix . 'module_downloads_categories AS c ON c.id=f.cat_id WHERE f.id=' . $db->escape($this->file_id) . ' ORDER BY disp_position') or BB_Functions::Error('Cannot retrieve file list', __FILE__, __LINE__, $db->error());
        }
        elseif (isset($uri_segments[2]) && in_array($uri_segments[2], $this->cat_id_list))
        {
            $this->cat_id = $uri_segments[2];
            $result = $db->query('SELECT id, name, filename, description, date, counter FROM ' . $db->prefix . 'module_downloads WHERE cat_id=' . $db->escape($this->cat_id) . ' ORDER BY disp_position') or BB_Functions::Error('Cannot retrieve files list', __FILE__, __LINE__, $db->error());
        }
        else
            $result = $db->query('SELECT c.id AS cid, c.cat_name, f.id, f.name, f.filename, f.description, f.date, f.counter FROM ' . $db->prefix . 'module_downloads_categories AS c INNER JOIN ' . $db->prefix . 'module_downloads AS f ON c.id=f.cat_id  WHERE f.home=1 ORDER BY c.disp_position, f.disp_position') or BB_Functions::Error('Cannot retrieve file list', __FILE__, __LINE__, $db->error());
        $num_files = $db->num_rows($result);
        if ($num_files > 0)
        {
            for ($i = 0; $i < $num_files; ++$i)
                $this->file_list[] = $db->fetch_assoc($result);
            return true;
        }
        else
            return false;
    }

    function Show_Menu($block = '<div id="submenu" class="xenno_block"><div class="inbox"><ul>%s</ul></div></div>', $item = '<li>%s</li>')
    {
        global $lang_cms_main_module_downloads;
        $items = '';
        @reset($this->cat_list);
        while (list(, list($cat_id, $cat_name,, )) = @each($this->cat_list))
        {
            if ($cat_id == $this->cat_id)
            {
                $items .= sprintf($item, '<a href="' . $this->url . '/' . $cat_id . '"><strong>' . BB_Input::Htmlspecialchars($cat_name) . '</strong></a>');
            }
            else
                $items .= sprintf($item, '<a href="' . $this->url . '/' . $cat_id . '">' . BB_Input::Htmlspecialchars($cat_name) . '</a>');
        }
        if ($items != '')
            printf($block, $items);
    }

    function Download_File($id, $ext)
    {
        global $db, $lang_cms_main_module_downloads;
        $ext = str_replace('_', '.', $ext);
        if (bb_module_downloads_leech == '0')
        {
            $referer = getenv("HTTP_REFERER");
            $host = parse_url($referer);
            if ($host['host'] != '' && $host['host'] != $_SERVER['HTTP_HOST'])
            {
                $this->error = $lang_cms_main_module_downloads['anti_leech'];
                return false;
            }
        }
        if (!in_array($ext, $this->extensions))
        {
            $this->error = $lang_cms_main_module_downloads['not_exists'];
            return false;
        }
        $result = $db->query('SELECT name, filename, counter FROM ' . $db->prefix . 'module_downloads WHERE id=' . $db->escape($id)) or BB_Functions::Error('Cannot retrieve file info', __FILE__, __LINE__, $db->error());
        if (!$db->num_rows($result))
        {
            $this->error = $lang_cms_main_module_downloads['not_exists'];
            return false;
        }
        $this->current_file = $db->fetch_assoc($result);
        $file_path = bb_website_url . '/var' . bb_module_downloads_path . '/' . $ext . '/' . $this->current_file['filename'] . '.' . $ext;
        $db->query('UPDATE ' . $db->prefix . 'module_downloads SET counter=' . ++$this->current_file['counter'] . ' WHERE id=' . $db->escape($id)) or BB_Functions::Error('Cannot update file download count', __FILE__, __LINE__, $db->error());
        if (bb_module_downloads_mode == 'redir')
            $this->Download_Redirect($file_path);
        else
            $this->Download_Send($ext, $file_path);
    }

    function Download_Redirect($file_path)
    {
        global $forum_user, $lang_cms_main_module_downloads;
        $tpl_file = BB_Template::Load_Module_Template('cms_download', 'downloads');
        $tpl_file = str_replace('<dl_file>', $lang_cms_main_module_downloads['do_dl'], $tpl_file);
        $tpl_file = str_replace('<will_start>', sprintf($lang_cms_main_module_downloads['will_start'], '<em>' . $this->current_file['name'] . '</em>'), $tpl_file);
        if (bb_module_downloads_dwl == '1')
            $dontwaitlink = sprintf($lang_cms_main_module_downloads['dont_wait'], '<a href="' . $file_path . '">' . $lang_cms_main_module_downloads['downloads_it'] . ' <em>' . $this->current_file['name'] . '</em></a>');
        else
            $dontwaitlink = '';
        $tpl_file = str_replace('<dont_wait>', $dontwaitlink, $tpl_file);
        $this->content .= $tpl_file;
        $GLOBALS['redirect_to'] = array('content' => bb_module_downloads_time, 'url' => $file_path);
    }

    function Download_Send($ext, $file_path)
    {
        ob_end_clean();
        if (strpos(basename($file_path), '.') === false)
            $mime_type = 'text/plain';
        elseif (preg_match('/.png$/', $file_path))
            $mime_type = 'image/png';
        elseif (preg_match('/.gif$/', $file_path))
            $mime_type = 'image/gif';
        elseif (preg_match('/.(jpg|jpeg)$/', $file_path))
            $mime_type = 'image/jpeg';
        elseif (preg_match('/(.htm|.html|.php|.php3|.inc|.xml|.txt|.xhtml|.css)$/', $file_path))
            $mime_type = 'text/plain';
        else
            $mime_type = 'application/download';
        header('Content-Type: ' . $mime_type);
        if ($mime_type == 'application/download')
            header('Content-Disposition: attachment; filename=' . basename($file_path));
        echo file_get_contents($file_path);
        exit;
    }

    function Show_Download_Page()
    {
        global $forum_user, $lang_cms_main_module_downloads;
        foreach ($this->file_list as $current_file)
        {
            $tpl_file = BB_Template::Load_Module_Template('cms_file', 'downloads');
            $file_links_tmp = array();
            foreach ($this->extensions as $ext)
            {
                if (file_exists('var' . bb_module_downloads_path . '/' . $ext . '/' . $current_file['filename'] . '.' . $ext))
                {
                    $fsize = BB_Files::Size(filesize('var' . bb_module_downloads_path . '/' . $ext . '/' . $current_file['filename'] . '.' . $ext));
                    $file_links_tmp[] = '<a href="' . $this->url . '/' . ($this->cat_id != '' ? $this->cat_id : $current_file['cid']) . '/' . $current_file['id'] . '/' . $ext . '" title="File size: ' . $fsize . '"><img src="' . BB_Template::Get_Image_Folder() . 'buttons/download_' . $ext . '.png" alt="Download now" /></a>';
                }
            }
            if (empty($file_links_tmp) || ($forum_user['is_guest'] && bb_module_downloads_guest == '0'))
                $file_links = '';
            else
                $file_links = implode(' ', $file_links_tmp);
            if ($this->cat_id != '')
                $tpl_file = str_replace('<file_name>', '<a href="' . $this->url . '/' . $this->cat_id . '/' . $current_file['id'] . '">' . $current_file['name'] . '</a>', $tpl_file);
            elseif ($this->cat_id != '' && $this->file_id != '')
                $tpl_file = str_replace('<file_name>', $current_file['name'] . ' - <a href="' . $this->url . '/' . $this->cat_id . '/' . $current_file['cid'] . '">' . $current_file['cat_name'] . '</a>', $tpl_file);
            else
                $tpl_file = str_replace('<file_name>', '<a href="' . $this->url . '/' . $current_file['cid'] . '/' . $current_file['id'] . '">' . $current_file['name'] . '</a> - <a href="' . $this->url . '/' . $current_file['cid'] . '">' . $current_file['cat_name'] . '</a>', $tpl_file);
            $tpl_file = str_replace('<file_description>', $current_file['description'], $tpl_file);
            $tpl_file = str_replace('<file_date>', $lang_cms_main_module_downloads['last_release'] . ' <strong>' . $current_file['date'] . '</strong>', $tpl_file);
            $tpl_file = str_replace('<file_counter>', sprintf($lang_cms_main_module_downloads['downloaded_x_time'], '<strong>' . $current_file['counter'] . '</strong>'), $tpl_file);
            $tpl_file = str_replace('<file_links>', $file_links, $tpl_file);
            echo $tpl_file;
        }
    }

}

$download_page = new BB_Download_Module();
$cms_custom_title_page = $download_page->title;
require FORUM_ROOT . 'include/header.php';
$download_page->Show_Menu();
if ($download_page->error !== null)
{
    ?>
    <div id="error" class="block">
        <div class="inbox">        
            <span style="color:red;"><?php echo $download_page->error; ?></span>        
        </div>
    </div>
    <?php
}
elseif ($download_page->request !== null)
    echo $download_page->content;
else
    $download_page->Show_Download_Page();
require FORUM_ROOT . 'include/footer.php';
?>
