<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
if (!defined('IN_FORUM_ADMIN'))
    exit('No direct script access allowed');

function BB_Install_Module()
{
    global $db_type, $db_prefix, $db, $cms_settings;
    $error = array();
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "module_downloads (
                                id INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
                                name VARCHAR(200) NOT NULL DEFAULT 'New file',
                                filename VARCHAR(200) NOT NULL DEFAULT '',
                                description TEXT NOT NULL,
                                counter INT(10) UNSIGNED NOT NULL DEFAULT 0,
                                date VARCHAR(200) NOT NULL default 'dd/mm/yyyy',
                                cat_id INT(10) UNSIGNED NOT NULL DEFAULT 0,
                                disp_position INT(10) NOT NULL DEFAULT 0,
                                home TINYINT(1) NOT NULL DEFAULT 1,
                                on_block TINYINT(1) NOT NULL DEFAULT 0,
                                PRIMARY KEY  (id)
                                ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "module_downloads (
                                id SERIAL,
                                name VARCHAR(200) NOT NULL DEFAULT 'New file',
                                filename VARCHAR(200) NOT NULL DEFAULT '',
                                description TEXT NOT NULL,
                                counter INT NOT NULL DEFAULT 0,
                                date VARCHAR(200) NOT NULL DEFAULT 'dd/mm/yyyy',
                                cat_id INT NOT NULL DEFAULT 0,
                                disp_position INT NOT NULL DEFAULT 0,
                                home SMALLINT NOT NULL DEFAULT 1,
                                on_block SMALLINT NOT NULL DEFAULT 0,
                                PRIMARY KEY  (id)
                                )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "module_downloads (
                                id INTEGER NOT NULL,
                                name VARCHAR(200) NOT NULL DEFAULT 'New file',
                                filename VARCHAR(200) NOT NULL DEFAULT '',
                                description TEXT NOT NULL,
                                counter INTEGER NOT NULL DEFAULT 0,
                                date VARCHAR(200) NOT NULL DEFAULT 'dd/mm/yyyy',
                                cat_id INTEGER NOT NULL DEFAULT 0,
                                disp_position INTEGER NOT NULL DEFAULT 0,
                                home INTEGER NOT NULL DEFAULT 1,
                                on_block INTEGER NOT NULL DEFAULT 0,
                                PRIMARY KEY  (id)
                                )";
            break;
    }
    if (!$db->query($sql))
        $error[] = 'Cannot create table ' . $db_prefix . 'module_downloads. You must create it manually.';
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "module_downloads_categories (
                                id INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
                                cat_name VARCHAR(80) NOT NULL DEFAULT 'New category',
                                disp_position INT(10) UNSIGNED NOT NULL DEFAULT 0,
                                PRIMARY KEY  (id)
                                ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "module_downloads_categories (
                                id SERIAL,
                                cat_name VARCHAR(80) NOT NULL DEFAULT 'New category',
                                disp_position INT NOT NULL DEFAULT 0
                                PRIMARY KEY  (id)
                                )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "module_downloads_categories (
                                id INTEGER NOT NULL,
                                cat_name VARCHAR(80) NOT NULL DEFAULT 'New category',
                                disp_position INTEGER NOT NULL DEFAULT 0
                                PRIMARY KEY  (id)
                                )";
            break;
    }
    if (!$db->query($sql))
        $error[] = 'Cannot create table ' . $db_prefix . 'module_downloads_categories. You must create it manually.';
    $res = true;
    $cms_settings->Set_Namespace('module_downloads');
    $res &= $cms_settings->Save('bb_module_downloads', 0);
    $res &= $cms_settings->Save('bb_module_downloads_path', '/files');
    $res &= $cms_settings->Save('bb_module_downloads_exts', 'zip|rar|tgz|bz2');
    $res &= $cms_settings->Save('bb_module_downloads_time', '2');
    $res &= $cms_settings->Save('bb_module_downloads_leech', 0);
    $res &= $cms_settings->Save('bb_module_downloads_mode', 'redir');
    $res &= $cms_settings->Save('bb_module_downloads_dwl', 1);
    $res &= $cms_settings->Save('bb_module_downloads_guest', 1);
    $cms_settings->Set_Namespace('permissions');
    $res &= $cms_settings->Save('bb_perm_module_downloads', 0);
    $cms_settings->Set_Namespace('');
    if (!$res)
        return false;
    elseif (!empty($error))
        return implode("<br />", $error);
    else
        return true;
}

?>
