<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
if (!defined('IN_FORUM_ADMIN'))
    exit('No direct script access allowed');
if (!BB_Admin_Functions::Check_Permissions('module_news'))
    BB_Functions::Message($lang['No permission']);
define('MODULE_ADMIN_URL', 'loader.php?module=news');
if (isset($_POST['gen_news']))
{
    require_once FORUM_ROOT . 'include/functions/Parser.php';
    $result = $db->query('SELECT id, subject, question FROM ' . $db->prefix . 'topics WHERE forum_id=' . $db->escape(bb_module_news_forum_id) . ' AND moved_to IS NULL ORDER BY sticky DESC, posted DESC LIMIT 0, ' . $db->escape(bb_module_news_num_posts)) or BB_Functions::Error($lang_cms_main_module_news['unable_get_topics'], __FILE__, __LINE__, $db->error());
    if (!$db->num_rows($result))
        BB_FunctionsMessage(sprintf($lang_cms_main_module_news['no_topics_to_generate'], bb_module_news_forum_id));
    if (is_file(FORUM_ROOT . 'include/templates/' . $forum_user['template'] . '/modules/news/cms_news_static.tpl'))
        $news_tpl = file_get_contents(FORUM_ROOT . 'include/templates/' . $forum_user['template'] . '/modules/news/cms_news_static.tpl');
    else
        $news_tpl = file_get_contents(FORUM_ROOT . 'include/templates/Default/modules/news/cms_news_static.tpl');
    $fh = @fopen(FORUM_ROOT . 'var/news/html/' . 'news.html', 'wb');
    if (!$fh)
        BB_Functions::Error($lang_cms_main_module_news['unable_to_write_news'], __FILE__, __LINE__);
    while ($cur_topic = $db->fetch_assoc($result))
    {
        $title_news = '';
        $url_news = '';
        $date_news = '';
        $author_news = '';
        $author_profile = '';
        $avatar_author = '';
        $message_news = '';
        $result2 = $db->query('SELECT u.use_avatar, p.posted, p.poster, p.poster_id, p.message, p.hide_smilies FROM ' . $db->prefix . 'posts AS p INNER JOIN ' . $db->prefix . 'users AS u ON u.id=p.poster_id WHERE topic_id=' . $db->escape($cur_topic['id']) . ' ORDER BY posted ASC LIMIT 1') or BB_Functions::Error($lang_cms_main_module_news['unable_get_posts'], __FILE__, __LINE__, $db->error());
        $cur_post = $db->fetch_assoc($result2);
        if (bb_censoring == '1')
            $cur_topic['subject'] = BB_Input::Censor_Words($cur_topic['subject']);
        if (bb_module_news_truncat_news > 0)
        {
            $paragraph = preg_split("/\s*\n+/", $cur_post['message']);
            if (isset($paragraph[bb_module_news_truncat_news]))
            {
                $cur_post['message'] = '';
                for ($i = 0; $i < bb_module_news_truncat_news; $i++)
                    $cur_post['message'] .= $paragraph[$i] . "\n\n";
                if ($cur_topic['question'] != '')
                    $cur_post['message'] = BB_Parser::Parse_Message($cur_post['message'], $cur_post['hide_smilies']) . '<p><a href="' . bb_forum_url . BB_Input::Rewrite_URL("l", $cur_topic['id'], $cur_topic['subject']) . '" title="' . $lang_cms_main_module_news['read_more_of'] . ' ' . $cur_topic['subject'] . '"><img src="' . bb_website_url . '/include/templates/' . $forum_user['template'] . '/img/buttons/readmore.png" alt="' . $lang_cms_main_module_news['read_more'] . '" /></a></p>';
                else
                    $cur_post['message'] = BB_Parser::Parse_Message($cur_post['message'], $cur_post['hide_smilies']) . '<p><a href="' . bb_forum_url . BB_Input::Rewrite_URL("t", $cur_topic['id'], $cur_topic['subject']) . '" title="' . $lang_cms_main_module_news['read_more_of'] . ' ' . $cur_topic['subject'] . '"><img src="' . bb_website_url . '/include/templates/' . $forum_user['template'] . '/img/buttons/readmore.png" alt="' . $lang_cms_main_module_news['read_more'] . '" /></a></p>';
            }
            else
                $cur_post['message'] = BB_Parser::Parse_Message($cur_post['message'], $cur_post['hide_smilies']);
        }
        else
            $cur_post['message'] = BB_Parser::Parse_Message($cur_post['message'], $cur_post['hide_smilies']);
        if (bb_avatars == '1' && $cur_post['use_avatar'] == '1')
        {
            if ($img_size = @getimagesize(FORUM_ROOT . $forum_folder . '/' . bb_avatars_dir . '/' . $cur_post['poster_id'] . '.gif'))
                $user_avatar = '<img src="' . bb_forum_url . bb_avatars_dir . '/' . $cur_post['poster_id'] . '.gif" ' . $img_size[3] . ' alt="" />';
            else if ($img_size = @getimagesize(FORUM_ROOT . $forum_folder . '/' . bb_avatars_dir . '/' . $cur_post['poster_id'] . '.jpg'))
                $user_avatar = '<img src="' . bb_forum_url . bb_avatars_dir . '/' . $cur_post['poster_id'] . '.jpg" ' . $img_size[3] . ' alt="" />';
            else if ($img_size = @getimagesize(FORUM_ROOT . $forum_folder . '/' . bb_avatars_dir . '/' . $cur_post['poster_id'] . '.png'))
                $user_avatar = '<img src="' . bb_forum_url . bb_avatars_dir . '/' . $cur_post['poster_id'] . '.png" ' . $img_size[3] . ' alt="" />';
            else
                $user_avatar = '<img src="' . bb_forum_url . bb_avatars_dir . '/noavatar.png" alt="" />';
        }
        else
            $user_avatar = '<img src="' . bb_forum_url . bb_avatars_dir . '/noavatar.png" alt="" />';
        $title_news = BB_Input::Htmlspecialchars($cur_topic['subject']);
        if ($cur_topic['question'] != '')
            $url_news = bb_forum_url . BB_Input::Rewrite_URL("l", $cur_topic['id'], $cur_topic['subject']);
        else
            $url_news = bb_forum_url . BB_Input::Rewrite_URL("t", $cur_topic['id'], $cur_topic['subject']);
        $date_news = date(bb_module_news_date_format, $cur_post['posted']);
        $author_news = BB_Input::Htmlspecialchars($cur_post['poster']);
        $author_profile = bb_forum_url . BB_Input::Rewrite_URL("u", $cur_post['poster_id'], $cur_post['poster']);
        $avatar_author = $user_avatar;
        $message_news = $cur_post['message'];
        $search = array(
            '<title_news>',
            '<url_news>',
            '<date_news>',
            '<author_news>',
            '<author_profile>',
            '<author_avatar>',
            '<message_news>'
        );
        $replace = array(
            $title_news,
            $url_news,
            $date_news,
            $author_news,
            $author_profile,
            $avatar_author,
            $message_news
        );
        fwrite($fh, str_replace($search, $replace, $news_tpl));
    }
    fclose($fh);
    $year_end = intval(date('Y'));
    $month_end = intval(date('n'));
    $year_start = ($month_end != 1) ? $year_end : $year_end - 1;
    $month_start = ($month_end != 1) ? $month_end - 1 : 12;
    $result = $db->query('SELECT MIN(posted) FROM ' . $db->prefix . 'topics WHERE forum_id=' . $db->escape(bb_module_news_forum_id)) or BB_Functions::Error($lang_cms_main_module_news['unable_get_posts'], __FILE__, __LINE__, $db->error());
    $history_limit = $db->result($result);
    $year_limit = intval(date('Y', $history_limit));
    $month_limit = intval(date('n', $history_limit));
    while ($year_end > $year_limit || $month_end > $month_limit)
    {
        $title_news = '';
        $url_news = '';
        $date_news = '';
        $author_news = '';
        $author_profile = '';
        $avatar_author = '';
        $message_news = '';
        $result = $db->query('SELECT id, subject FROM ' . $db->prefix . 'topics WHERE forum_id=' . $db->escape(bb_module_news_forum_id) . ' AND posted>=UNIX_TIMESTAMP(\'' . $db->escape($year_start) . '-' . $db->escape($month_start) . '-01\') AND posted<UNIX_TIMESTAMP(\'' . $db->escape($year_end) . '-' . $db->escape($month_end) . '-01\') AND moved_to IS NULL ORDER BY posted DESC') or BB_Functions::Error($lang_cms_main_module_news['unable_get_topics'], __FILE__, __LINE__, $db->error());
        if ($db->num_rows($result))
        {
            if (is_file(FORUM_ROOT . 'include/templates/' . $forum_user['template'] . '/modules/news/cms_news_static.tpl'))
                $news_tpl = file_get_contents(FORUM_ROOT . 'include/templates/' . $forum_user['template'] . '/modules/news/cms_news_static.tpl');
            else
                $news_tpl = file_get_contents(FORUM_ROOT . 'include/templates/Default/modules/news/cms_news_static.tpl');
            $fh = @fopen(FORUM_ROOT . 'var/news/html/archives/' . $year_start . '-' . ($month_start > 9 ? $month_start : '0' . $month_start) . '.html', 'wb');
            if (!$fh)
                BB_Functions::Error(sprintf($lang_cms_main_module_news['unable_to_write_archives'], $year_start . '-' . ($month_start > 9 ? $month_start : '0' . $month_start)), __FILE__, __LINE__);
            while ($cur_topic = $db->fetch_assoc($result))
            {
                $title_news = '';
                $url_news = '';
                $date_news = '';
                $author_news = '';
                $author_profile = '';
                $avatar_author = '';
                $message_news = '';
                $result2 = $db->query('SELECT u.use_avatar, p.posted, p.poster, p.poster_id, p.message, p.hide_smilies FROM ' . $db->prefix . 'posts AS p INNER JOIN ' . $db->prefix . 'users AS u ON u.id=p.poster_id WHERE topic_id=' . $db->escape($cur_topic['id']) . ' ORDER BY posted ASC LIMIT 1') or BB_Functions::Error($lang_cms_main_module_news['unable_get_posts'], __FILE__, __LINE__, $db->error());
                $cur_post = $db->fetch_assoc($result2);
                if (bb_censoring == '1')
                    $cur_topic['subject'] = BB_Input::Censor_Words($cur_topic['subject']);
                if (bb_module_news_truncat_news > 0)
                {
                    $paragraph = preg_split("/\s*\n+/", $cur_post['message']);
                    if (isset($paragraph[bb_module_news_truncat_news]))
                    {
                        $cur_post['message'] = '';
                        for ($i = 0; $i < bb_module_news_truncat_news; $i++)
                            $cur_post['message'] .= $paragraph[$i] . "\n\n";
                        if ($cur_topic['question'] != '')
                            $cur_post['message'] = BB_Parser::Parse_Message($cur_post['message'], $cur_post['hide_smilies']) . '<p><a href="' . bb_forum_url . BB_Input::Rewrite_URL("l", $cur_topic['id'], $cur_topic['subject']) . '" title="' . $lang_cms_main_module_news['read_more_of'] . ' ' . $cur_topic['subject'] . '"><img src="' . bb_website_url . '/include/templates/' . $forum_user['template'] . '/img/buttons/readmore.png" alt="' . $lang_cms_main_module_news['read_more'] . '" /></a></p>';
                        else
                            $cur_post['message'] = BB_Parser::Parse_Message($cur_post['message'], $cur_post['hide_smilies']) . '<p><a href="' . bb_forum_url . BB_Input::Rewrite_URL("t", $cur_topic['id'], $cur_topic['subject']) . '" title="' . $lang_cms_main_module_news['read_more_of'] . ' ' . $cur_topic['subject'] . '"><img src="' . bb_website_url . '/include/templates/' . $forum_user['template'] . '/img/buttons/readmore.png" alt="' . $lang_cms_main_module_news['read_more'] . '" /></a></p>';
                    }
                    else
                        $cur_post['message'] = BB_Parser::Parse_Message($cur_post['message'], $cur_post['hide_smilies']);
                }
                else
                    $cur_post['message'] = BB_Parser::Parse_Message($cur_post['message'], $cur_post['hide_smilies']);
                if (bb_avatars == '1' && $cur_post['use_avatar'] == '1')
                {
                    if ($img_size = @getimagesize(FORUM_ROOT . bb_avatars_dir . '/' . $cur_post['poster_id'] . '.gif'))
                        $user_avatar = '<img src="' . bb_forum_url . bb_avatars_dir . '/' . $cur_post['poster_id'] . '.gif" ' . $img_size[3] . ' alt="" />';
                    else if ($img_size = @getimagesize(FORUM_ROOT . bb_avatars_dir . '/' . $cur_post['poster_id'] . '.jpg'))
                        $user_avatar = '<img src="' . bb_forum_url . bb_avatars_dir . '/' . $cur_post['poster_id'] . '.jpg" ' . $img_size[3] . ' alt="" />';
                    else if ($img_size = @getimagesize(FORUM_ROOT . bb_avatars_dir . '/' . $cur_post['poster_id'] . '.png'))
                        $user_avatar = '<img src="' . bb_forum_url . bb_avatars_dir . '/' . $cur_post['poster_id'] . '.png" ' . $img_size[3] . ' alt="" />';
                    else
                        $user_avatar = '<img src="' . bb_forum_url . bb_avatars_dir . '/noavatar.png" alt="" />';
                }
                else
                    $user_avatar = '<img src="' . bb_forum_url . bb_avatars_dir . '/noavatar.png" alt="" />';
                $title_news = BB_Input::Htmlspecialchars($cur_topic['subject']);
                if ($cur_topic['question'] != '')
                    $url_news = bb_forum_url . BB_Input::Rewrite_URL("l", $cur_topic['id'], $cur_topic['subject']);
                else
                    $url_news = bb_forum_url . BB_Input::Rewrite_URL("t", $cur_topic['id'], $cur_topic['subject']);
                $date_news = date(bb_module_news_date_format, $cur_post['posted']);
                $author_news = BB_Input::Htmlspecialchars($cur_post['poster']);
                $author_profile = bb_forum_url . BB_Input::Rewrite_URL("u", $cur_post['poster_id'], $cur_post['poster']);
                $avatar_author = $user_avatar;
                $message_news = $cur_post['message'];
                $search = array(
                    '<title_news>',
                    '<url_news>',
                    '<date_news>',
                    '<author_news>',
                    '<author_profile>',
                    '<author_avatar>',
                    '<message_news>'
                );
                $replace = array(
                    $title_news,
                    $url_news,
                    $date_news,
                    $author_news,
                    $author_profile,
                    $avatar_author,
                    $message_news
                );
                fwrite($fh, str_replace($search, $replace, $news_tpl));
            }
            fclose($fh);
        }
        $year_end = $year_start;
        $month_end = $month_start;
        $year_start = ($month_end != 1) ? $year_end : $year_end - 1;
        $month_start = ($month_end != 1) ? $month_end - 1 : 12;
    }
    BB_Admin_Functions::Log_Action("News module : generate news");
    BB_Functions::Redirect(MODULE_ADMIN_URL, $lang_cms_main_module_news['generated']);
}
elseif (!empty($_POST['config_news']))
{
    $form = array_map('trim', $_POST['form']);
    $cms_settings->Set_Namespace('module_news');
    $res = true;
    $res &= $cms_settings->Save('bb_module_news', $form['module_news']);
    $res &= $cms_settings->Save('bb_module_news_mode', intval($form['module_news_mode']));
    $res &= $cms_settings->Save('bb_module_news_forum_id', intval($form['module_news_forum_id']));
    $res &= $cms_settings->Save('bb_module_news_num_posts', intval($form['module_news_num_posts']));
    $res &= $cms_settings->Save('bb_module_news_truncat_news', intval($form['module_news_truncat_news']));
    $res &= $cms_settings->Save('bb_module_news_date_format', $form['date_format']);
    $cms_settings->Set_Namespace('');
    if ($res)
    {
        BB_Admin_Functions::Log_Action('News module : edit config', 1);
        BB_Functions::Redirect(MODULE_ADMIN_URL, $lang['config_updated']);
    }
    else
        BB_Functions::Message($lang['unable_update_config']);
}
else
{
    if (bb_module_news_mode == 0)
    {
        ?>
        <div class="blockform">
            <h2><span style="padding-left:10px"><?php echo $lang_cms_main_module_news['news']; ?></span></h2>
            <form id="newsgenerator" method="post" action="<?php echo MODULE_ADMIN_URL; ?>">
                <div class="inform">
                    <input type="hidden" name="gen_news" value="1" />
                    <div class="infldset file" style="padding:10px">
                        <p><?php echo $lang_cms_main_module_news['info']; ?></p>
                    </div>
                </div>
                <div><input class="b1" type="submit" value="<?php echo $lang_cms_main_module_news['generate']; ?>" /></div>
            </form>
        </div>
        <?php
    }
    ?>
    <div class="blockform">
        <h2><span style="padding-left:10px"><?php echo $lang_cms_main_module_news['config'] ?></span></h2>
        <form id="newsconfig" method="post" action="<?php echo MODULE_ADMIN_URL; ?>">
            <input type="hidden" name="config_news" value="1" />
            <div class="inform">
                <div class="infldset file" style="padding:10px">
                    <table class="aligntop" cellspacing="0">
                        <tr>
                            <th style="width:150px"><?php echo $lang_cms_main_module_news['enable_mods']; ?></th>
                            <td style="width:25px">&nbsp;</td>
                            <td><input type="radio" name="form[module_news]" value="1"<?php if (bb_module_news == 1)
        echo ' checked="checked"'; ?> />&#160;<?php echo $lang['Yes']; ?>&#160;&#160;&#160;<input type="radio" name="form[module_news]" value="0"<?php if (bb_module_news == 0)
        echo ' checked="checked"'; ?> />&#160;<?php echo $lang['No']; ?></td>
                        </tr>
                        <tr>
                            <th><?php echo $lang_cms_main_module_news['mode']; ?></th>
                            <td style="width:25px">&nbsp;&nbsp;<img src="<?php echo bb_forum_url ?>img/admin/tooltip.png" onmouseover="return xBB_Show_Tooltip('<?php echo $lang_cms_main_module_news['mode_info'] ?>');" onmouseout="return nd();" alt="" /></td>
                            <td><input type="radio" name="form[module_news_mode]" value="1"<?php if (bb_module_news_mode == 1)
        echo ' checked="checked"'; ?> />&#160;<?php echo $lang_cms_main_module_news['dyna']; ?>&#160;&#160;&#160;<input type="radio" name="form[module_news_mode]" value="0"<?php if (bb_module_news_mode == 0)
        echo ' checked="checked"'; ?> />&#160;<?php echo $lang_cms_main_module_news['static']; ?></td>
                        </tr>
                        <tr>
                            <th><?php echo $lang_cms_main_module_news['forumid']; ?></th>
                            <td style="width:25px">&nbsp;&nbsp;<img src="<?php echo bb_forum_url ?>img/admin/tooltip.png" onmouseover="return xBB_Show_Tooltip('<?php echo $lang_cms_main_module_news['forumidinfo'];
    if (bb_module_news_mode == 0)
        echo '<br />' . $lang_cms_main_module_news['notes']; ?>');" onmouseout="return nd();" alt="" /></td>
                            <td><input class="textbox" type="text" name="form[module_news_forum_id]" size="5" maxlength="10"  value="<?php echo bb_module_news_forum_id; ?>" /></td>
                        </tr>
                        <tr>
                            <th><?php echo $lang_cms_main_module_news['nbmessages']; ?></th>
                            <td style="width:25px">&nbsp;&nbsp;<img src="<?php echo bb_forum_url ?>img/admin/tooltip.png" onmouseover="return xBB_Show_Tooltip('<?php echo $lang_cms_main_module_news['nbmessagesinfo'];
    if (bb_module_news_mode == 0)
        echo '<br />' . $lang_cms_main_module_news['notes']; ?>');" onmouseout="return nd();" alt="" /></td>
                            <td><input class="textbox" type="text" name="form[module_news_num_posts]" size="5" maxlength="10" value="<?php echo bb_module_news_num_posts; ?>" /></td>
                        </tr>
                        <tr>
                            <th><?php echo $lang_cms_main_module_news['truncat']; ?></th>
                            <td style="width:25px">&nbsp;&nbsp;<img src="<?php echo bb_forum_url ?>img/admin/tooltip.png" onmouseover="return xBB_Show_Tooltip('<?php echo $lang_cms_main_module_news['truncatinfo'];
    if (bb_module_news_mode == 0)
        echo '<br />' . $lang_cms_main_module_news['notes']; ?>');" onmouseout="return nd();" alt="" /></td>
                            <td><input class="textbox" type="text" name="form[module_news_truncat_news]" size="5" maxlength="10" value="<?php echo bb_module_news_truncat_news; ?>" /></td>
                        </tr>
                        <tr>
                            <th><?php echo $lang_cms_main_module_news['date_format']; ?></th>
                            <td style="width:25px">&nbsp;&nbsp;<img src="<?php echo bb_forum_url ?>img/admin/tooltip.png" onmouseover="return xBB_Show_Tooltip('<?php printf($lang_cms_main_module_news['date_format_info'], date(bb_module_news_date_format));
    if (bb_module_news_mode == 0)
        echo '<br />' . $lang_cms_main_module_news['notes']; ?>');" onmouseout="return nd();" alt="" /></td>
                            <td><input class="textbox" type="text" name="form[date_format]" size="25" maxlength="25" value="<?php echo BB_Input::Htmlspecialchars(bb_module_news_date_format) ?>" /></td>
                        </tr>
                    </table>
                </div>
            </div>
            <div><input type="submit" class="b1" value=" <?php echo $lang['Save']; ?> " /></div>
        </form>
    </div>
    <?php
}
?>
