<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
if (!defined('IN_FORUM'))
    exit('No direct script access allowed');
$path_module = $cms_modules->path . 'news';
require FORUM_ROOT . 'include/header.php';
$cms_archives = (isset($uri_segments[2]) && isset($uri_segments[3])) ? true : false;
if (bb_module_news_mode == 0)
{
    if ($cms_archives)
    {
        if (file_exists(FORUM_ROOT . 'var/news/html/archives/' . $uri_segments[2] . '-' . $uri_segments[3] . '.html'))
            require(FORUM_ROOT . 'var/news/html/archives/' . $uri_segments[2] . '-' . $uri_segments[3] . '.html');
        else
            $cms_archives = false;
    }
    if (!$cms_archives)
    {
        if (file_exists(FORUM_ROOT . 'var/news/html/news.html'))
            require(FORUM_ROOT . 'var/news/html/news.html');
        else
            echo '<p>' . $lang_cms_main['No news'] . '</p>';
    }
}
else
{
    require_once FORUM_ROOT . 'include/functions/Parser.php';
    if ($cms_archives)
    {
        $cms_year_start = $uri_segments[2];
        $cms_month_start = ($uri_segments[3]{0} == '0') ? substr($uri_segments[3], 1, 2) : $uri_segments[3];
        if ($cms_month_start == '12')
        {
            $cms_year_end = $cms_year_start + 1;
            $cms_month_end = '1';
        }
        else
        {
            $cms_year_end = $cms_year_start;
            $cms_month_end = $cms_month_start + 1;
        }
        $result = $db->query('SELECT id, subject, num_views, question, num_replies FROM ' . $db->prefix . 'topics WHERE forum_id=' . $db->escape(bb_module_news_forum_id) . ' AND moved_to IS NULL AND posted>=UNIX_TIMESTAMP(\'' . $db->escape($cms_year_start) . '-' . $db->escape($cms_month_start) . '-01\') AND posted<UNIX_TIMESTAMP(\'' . $db->escape($cms_year_end) . '-' . $db->escape($cms_month_end) . '-01\') ORDER BY posted DESC');
        if (!$db->num_rows($result))
            $cms_archives = false;
    }
    if (!$cms_archives)
    {
        $result = $db->query('SELECT id, subject, num_views, question, num_replies FROM ' . $db->prefix . 'topics WHERE forum_id=' . $db->escape(bb_module_news_forum_id) . ' AND moved_to IS NULL ORDER BY sticky DESC, posted DESC LIMIT 0, ' . $db->escape(bb_module_news_num_posts)) or BB_Functions::Error($lang_cms_main_module_news['unable_get_topics'], __FILE__, __LINE__, $db->error());
    }
    if ($db->num_rows($result))
    {
        if (is_file(FORUM_ROOT . 'include/templates/' . $forum_user['template'] . '/modules/news/cms_news_dynamic.tpl'))
            $news_tpl = file_get_contents(FORUM_ROOT . 'include/templates/' . $forum_user['template'] . '/modules/news/cms_news_dynamic.tpl');
        else
            $news_tpl = file_get_contents(FORUM_ROOT . 'include/templates/Default/modules/news/cms_news_dynamic.tpl');
        while ($cur_topic = $db->fetch_assoc($result))
        {
            $cms_title_news = '';
            $cms_url_news = '';
            $cms_date_news = '';
            $cms_author_news = '';
            $cms_author_profile = '';
            $cms_avatar_author = '';
            $cms_message_news = '';
            $cms_nb_reads = '';
            $cms_nb_comments = '';
            $result2 = $db->query('SELECT u.use_avatar, p.posted, p.poster, p.poster_id, p.message, p.hide_smilies FROM ' . $db->prefix . 'posts AS p INNER JOIN ' . $db->prefix . 'users AS u ON u.id=p.poster_id WHERE topic_id=' . $db->escape($cur_topic['id']) . ' ORDER BY posted ASC LIMIT 1') or BB_Functions::Error($lang_cms_main_module_news['unable_get_posts'], __FILE__, __LINE__, $db->error());
            $cur_post = $db->fetch_assoc($result2);
            if (bb_censoring == '1')
                $cur_topic['subject'] = BB_Input::Censor_Words($cur_topic['subject']);
            if (bb_module_news_truncat_news > 0)
            {
                $paragraph = preg_split("/\s*\n+/", $cur_post['message']);
                if (isset($paragraph[bb_module_news_truncat_news]))
                {
                    $cur_post['message'] = '';
                    for ($i = 0; $i < bb_module_news_truncat_news; $i++)
                        $cur_post['message'] .= $paragraph[$i] . "\n\n";
                    if ($cur_topic['question'] != '')
                        $cur_post['message'] = BB_Parser::Parse_Message($cur_post['message'], $cur_post['hide_smilies']) . '<p><a href="' . bb_forum_url . BB_Input::Rewrite_URL("l", $cur_topic['id'], $cur_topic['subject']) . '" title="' . $lang_cms_main_module_news['read_more_of'] . ' ' . $cur_topic['subject'] . '"><img src="' . bb_website_url . '/include/templates/' . $forum_user['template'] . '/img/buttons/readmore.png" alt="' . $lang_cms_main_module_news['read_more'] . '" /></a></p>';
                    else
                        $cur_post['message'] = BB_Parser::Parse_Message($cur_post['message'], $cur_post['hide_smilies']) . '<p><a href="' . bb_forum_url . BB_Input::Rewrite_URL("t", $cur_topic['id'], $cur_topic['subject']) . '" title="' . $lang_cms_main_module_news['read_more_of'] . ' ' . $cur_topic['subject'] . '"><img src="' . bb_website_url . '/include/templates/' . $forum_user['template'] . '/img/buttons/readmore.png" alt="' . $lang_cms_main_module_news['read_more'] . '" /></a></p>';
                }
                else
                    $cur_post['message'] = BB_Parser::Parse_Message($cur_post['message'], $cur_post['hide_smilies']);
            }
            else
                $cur_post['message'] = BB_Parser::Parse_Message($cur_post['message'], $cur_post['hide_smilies']);
            if (bb_avatars == '1' && $cur_post['use_avatar'] == '1')
            {
                if ($img_size = @getimagesize(FORUM_ROOT . $forum_folder . '/' . bb_avatars_dir . '/' . $cur_post['poster_id'] . '.gif'))
                    $user_avatar = '<img src="' . bb_forum_url . bb_avatars_dir . '/' . $cur_post['poster_id'] . '.gif" ' . $img_size[3] . ' alt="" />';
                else if ($img_size = @getimagesize(FORUM_ROOT . $forum_folder . '/' . bb_avatars_dir . '/' . $cur_post['poster_id'] . '.jpg'))
                    $user_avatar = '<img src="' . bb_forum_url . bb_avatars_dir . '/' . $cur_post['poster_id'] . '.jpg" ' . $img_size[3] . ' alt="" />';
                else if ($img_size = @getimagesize(FORUM_ROOT . $forum_folder . '/' . bb_avatars_dir . '/' . $cur_post['poster_id'] . '.png'))
                    $user_avatar = '<img src="' . bb_forum_url . bb_avatars_dir . '/' . $cur_post['poster_id'] . '.png" ' . $img_size[3] . ' alt="" />';
                else
                    $user_avatar = '<img src="' . bb_forum_url . $forum_folder . '/' . bb_avatars_dir . '/noavatar.png" alt="" />';
            }
            else
                $user_avatar = '<img src="' . bb_forum_url . bb_avatars_dir . '/noavatar.png" alt="" />';
            $cms_title_news = BB_Input::Htmlspecialchars($cur_topic['subject']);
            if ($cur_topic['question'] != '')
                $cms_url_news = bb_forum_url . BB_Input::Rewrite_URL("l", $cur_topic['id'], $cur_topic['subject']);
            else
                $cms_url_news = bb_forum_url . BB_Input::Rewrite_URL("t", $cur_topic['id'], $cur_topic['subject']);
            $cms_date_news = date(bb_module_news_date_format, $cur_post['posted']);
            $cms_author_news = BB_Input::Htmlspecialchars($cur_post['poster']);
            $cms_author_profile = bb_forum_url . BB_Input::Rewrite_URL("u", $cur_post['poster_id'], $cur_post['poster']);
            $cms_avatar_author = $user_avatar;
            $cms_message_news = $cur_post['message'];
            $cms_nb_reads = $cur_topic['num_views'];
            $cms_nb_comments = $cur_topic['num_replies'];
            $search = array(
                '<title_news>',
                '<url_news>',
                '<date_news>',
                '<author_news>',
                '<author_profile>',
                '<author_avatar>',
                '<message_news>',
                '<nb_reads>',
                '<nb_comments>'
            );
            $replace = array(
                $cms_title_news,
                $cms_url_news,
                $cms_date_news,
                $cms_author_news,
                $cms_author_profile,
                $cms_avatar_author,
                $cms_message_news,
                $cms_nb_reads,
                $cms_nb_comments
            );
            echo str_replace($search, $replace, $news_tpl);
        }
    }
    else
        echo '<p>' . $lang_cms_main['No news'] . '</p>';
}
$footer_style = 'frontpage';
require FORUM_ROOT . 'include/footer.php';
?>
