<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
if (!defined('IN_FORUM'))
    exit('No direct script access allowed');
define('PLUGIN_LOADED', 1);
define('PLUGIN_URL', 'plugin.php?plugin=a_BotDetect.php');
$result = $db->query('SELECT * FROM ' . $db->prefix . 'botsconfig') or BB_Functions::Error($lang['error_152'], __FILE__, __LINE__, $db->error());
$botConfig = $db->fetch_row($result);
$botLifeSpan = $botConfig[1];
$botUAStringSensitive = $botConfig[2];
$botEnabled = $botConfig[3];
if (isset($_POST['delete_bot']))
{
    if (!isset($_POST['toremove']))
        BB_Functions::Message($lang['select_bot']);
    else
    {
        $toremove = intval($_POST['toremove']);
        $db->query('DELETE FROM ' . $db->prefix . 'bots WHERE id=' . $toremove) or BB_Functions::Error($lang['error_153'], __FILE__, __LINE__, $db->error());
        BB_Functions::Redirect(PLUGIN_URL, $lang['redit_bot_removed']);
    }
}
else if (isset($_POST['update_config']))
{
    $newConfig = array((int) $_POST['bot_lifespan'], (int) isset($_POST['bot_caseSensitive']), (int) isset($_POST['bot_enabled']));
    if ($newConfig[0] != $botLifeSpan | $newConfig[1] != $botUAStringSensitive | $newConfig[3] != $botEnabled)
    {
        $result = $db->query('UPDATE ' . $db->prefix . 'botsconfig SET display_time=' . $db->escape($newConfig[0]) . ', isCaseSensitive=' . $db->escape($newConfig[1]) . ', isEnabled=' . $db->escape($newConfig[2]) . ' WHERE id=1') or BB_Functions::Error($lang['error_152'], __FILE__, __LINE__, $db->error());
        BB_Functions::Redirect(PLUGIN_URL, $lang['redir_bot_updated']);
    }
}
else if (isset($_POST['submit_bot']))
{
    if (trim($_POST['bot_alias']) == '')
        BB_Functions::Message($lang['no_bot_alias']);
    if (trim($_POST['bot_string']) == '')
        BB_Functions::Message($lang['no_bot_agent']);
    $bot_alias = CMS_Input::Htmlspecialchars($_POST['bot_alias']);
    $bot_string = CMS_Input::Htmlspecialchars($_POST['bot_string']);
    $result = $db->query('INSERT INTO ' . $db->prefix . "bots (id, bot_alias, bot_string, time_stamp) VALUES('', '$db->escape($bot_alias)', '$db->escape($bot_string)', '')") or BB_Functions::Error($lang['error_151'], __FILE__, __LINE__, $db->error());
    BB_Functions::Redirect(PLUGIN_URL, $lang['redit_bot_added']);
}
else
{
    ?>
    <div class="blockform">
        <h2><span><?php echo $lang['Configure'] ?></span></h2>
        <form id="example" method="post" action="<?php echo PLUGIN_URL; ?>">
            <div class="inform">
                <div class="infldset file" style="padding:15px">
                    <table class="aligntop" cellspacing="0">
                        <tr>
                            <th style="width:150px" scope="row"><?php echo $lang['Bot online time'] ?></th>
                            <td style="width:25px">&nbsp;&nbsp;<img src="<?php echo bb_forum_url ?>img/admin/tooltip.png" onmouseover="return xBB_Show_Tooltip('<?php echo $lang['tip_194'] ?>');" onmouseout="return nd();" /></td>
                            <td><input type="text" class="textbox" value="<?php echo $botLifeSpan ?>" name="bot_lifespan" size="3" tabindex="1" /><?php echo $lang['bot_lifespan_min'] ?></td>
                        </tr>
                        <tr>
                            <th scope="row"><?php echo $lang['User agent string'] ?></th>
                            <td style="width:25px">&nbsp;</td>
                            <td><input type="checkbox" name="bot_caseSensitive" <?php if ($botUAStringSensitive == 1)
        echo ' checked' ?> tabindex="1" /><?php echo $lang['bot_agent_case'] ?></td>
                        </tr>
                        <tr>
                            <th scope="row"><?php echo $lang['Bot detection'] ?></th>
                            <td style="width:25px">&nbsp;</td>
                            <td><input type="checkbox" name="bot_enabled" <?php if ($botEnabled == 1)
        echo ' checked' ?> tabindex="1" /><?php echo $lang['bot_detection_enabled'] ?></td>
                        </tr>
                    </table>
                </div>
            </div>
            <div><input type="submit" name="update_config" class="b1" value="<?php echo $lang['Update'] ?>" tabindex="2" /></div>
        </form>
        <h2><span><?php echo $lang['Add new bot'] ?></span></h2>
        <form id="example" method="post" action="<?php echo PLUGIN_URL; ?>">
            <div class="inform">
                <div class="infldset file" style="padding:15px">
                    <table class="aligntop" cellspacing="0">
                        <tr>
                            <th style="width:150px" scope="row"><?php echo $lang['Bot alias'] ?></th>
                            <td style="width:25px">&nbsp;&nbsp;<img src="<?php echo bb_forum_url ?>img/admin/tooltip.png" onmouseover="return xBB_Show_Tooltip('<?php echo $lang['tip_192'] ?>');" onmouseout="return nd();" /></td>
                            <td><input type="text" class="textbox" name="bot_alias" size="25" tabindex="1" /></td>
                        </tr>
                        <tr>
                            <th scope="row"><?php echo $lang['Bot user agent string'] ?></th>
                            <td style="width:25px">&nbsp;&nbsp;<img src="<?php echo bb_forum_url ?>img/admin/tooltip.png" onmouseover="return xBB_Show_Tooltip('<?php echo $lang['tip_193'] ?>');" onmouseout="return nd();" /></td>
                            <td><input type="text" class="textbox" name="bot_string" size="25" tabindex="1" /></td>
                        </tr>
                    </table>
                </div>
            </div>
            <div><input type="submit" class="b1" name="submit_bot" value="<?php echo $lang['Save'] ?>" tabindex="2" /></div>
        </form>
        <h2><span><?php echo $lang['Edit bots'] ?></span></h2>
        <form>
            <div class="inform">
                <div class="infldset file" style="padding:0px">
                    <table>
                        <tr>
                            <th height="30" scope="row"><?php echo $lang['Bot alias'] ?></th>
                            <th scope="row"><?php echo $lang['Bot user agent string'] ?></th>
                            <th scope="row">&nbsp;</th>
                        </tr>
                        <?php
                        $result = $db->query('SELECT * FROM ' . $db->prefix . 'bots') or BB_Functions::Error($lang['error_150'], __FILE__, __LINE__, $db->error());
                        $num_definitions = 0;
                        while ($row = $db->fetch_row($result))
                        {
                            $num_definitions++;
                            $cur_ident = $row[0];
                            ?>
                            <tr>
                                <td><?php echo $row[1] ?></td>
                                <td><?php echo $row[2] ?></td>
                            <form id="example" method="post" action="<?php echo PLUGIN_URL; ?>&delbot=yes">
                                <td><input type="hidden" name="toremove" value="<?php echo $cur_ident ?>"><input type="submit" name="delete_bot" class="b1" value="<?php echo $lang['Delete'] ?>" tabindex="2"></td>
                            </form>
                            </tr>
        <?php
    }
    ?>
                        <tr>
                            <th height="30" colspan="3" scope="row"><?php echo $lang['bots_total'] ?><strong><?php echo $num_definitions ?></strong></th>
                        </tr>
                    </table>
                </div>
            </div>
        </form>
        <div class="clearer"></div>
    </div>
    <?php
}
?>