<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
if (!defined('IN_FORUM'))
    exit('No direct script access allowed');
define('PLUGIN_LOADED', 1);
define('PLUGIN_URL', 'plugin.php?plugin=a_Smilies.php');
$smilies_config_image_size = 10240; // max upload image size in bytes
$smilies_config_image_width = 20; // max upload image width in pixels
$smilies_config_image_height = 20; // max upload image height in pixels
@include_once FORUM_ROOT . 'var/cache/cache_smilies.php';
if (!defined('SMILEY_LOADED'))
{
    BB_Cache::Generate_Smiley();
    require FORUM_ROOT . 'var/cache/cache_smilies.php';
}
if (isset($_POST['reord']))
{
    $smilies_order = $_POST['smilies_order'];
    $result = $db->query('SELECT id FROM ' . $db->prefix . 'smilies ORDER BY disp_position') or BB_Functions::Error('Unable to retrieve smilies', __FILE__, __LINE__, $db->error());
    while ($db_smilies = $db->fetch_assoc($result))
    {
        if (!preg_match('#^\d+$#', $smilies_order[$db_smilies['id']]))
            BB_Functions::Message($lang['Must int']);
        $db->query('UPDATE ' . $db->prefix . 'smilies SET disp_position=' . $db->escape($smilies_order[$db_smilies['id']]) . ' WHERE id=' . $db->escape($db_smilies['id'])) or BB_Functions::Error('Unable to change smilies positions', __FILE__, __LINE__, $db->error());
    }
    BB_Cache::Generate_Smiley();
    BB_Functions::Redirect(PLUGIN_URL, $lang['Positions changed']);
}
elseif (isset($_POST['remove']))
{
    $rem_smilies = array_map('trim', $_POST['rem_smilies']);
    foreach (array_keys($rem_smilies) as $id)
        $db->query('DELETE FROM ' . $db->prefix . "smilies WHERE id = '" . $db->escape($id) . "'") or BB_Functions::Error('Unable to delete smiley', __FILE__, __LINE__, $db->error());
    BB_Cache::Generate_Smiley();
    BB_Functions::Redirect(PLUGIN_URL, $lang['Delete Smiley Redirect']);
}
elseif (isset($_POST['delete']))
{
    $del_smilies = array_map('trim', $_POST['del_smilies']);
    $to_delete = array();
    $images_affected = array();
    $not_deleted = array();
    foreach (array_keys($del_smilies) as $img)
    {
        if (!in_array($img, $smiley_img))
            $to_delete[] = $img;
        else
            $images_affected[] = $img;
    }
    if (!empty($images_affected))
        BB_Functions::Message(sprintf($lang['Images affected'], implode(', ', $images_affected)));
    else
    {
        foreach ($to_delete as $img)
        {
            if (!@unlink(FORUM_ROOT . $forum_folder . '/img/smilies/' . $img))
                $not_deleted[] = $img;
        }
    }
    if (!empty($not_deleted))
        $message = sprintf($lang['Images not deleted'], implode(', ', $not_deleted));
    else
        $message = $lang['Images deleted'];
    BB_Functions::Redirect(PLUGIN_URL, $message);
}
elseif (isset($_POST['add_image']))
{
    if (!isset($_FILES['req_file']))
        BB_Functions::Message($lang['No file']);
    $uploaded_file = $_FILES['req_file'];
    if (isset($uploaded_file['error']))
    {
        switch ($uploaded_file['error'])
        {
            case 1:
            case 2:
                BB_Functions::Message($lang['Too large ini']);
                break;
            case 3:
                BB_Functions::Message($lang['Partial upload']);
                break;
            case 4:
                BB_Functions::Message($lang['No file']);
                break;
            case 6:
                BB_Functions::Message($lang['No tmp directory']);
                break;
            default:
                if ($uploaded_file['size'] == 0)
                    BB_Functions::Message($lang['No file']);
                break;
        }
    }
    if (is_uploaded_file($uploaded_file['tmp_name']))
    {
        $filename = substr($uploaded_file['name'], 0, strpos($uploaded_file['name'], '.'));
        $allowed_types = array('image/gif', 'image/jpeg', 'image/pjpeg', 'image/png', 'image/x-png');
        if (!in_array($uploaded_file['type'], $allowed_types))
            BB_Functions::Message($lang['Bad type']);
        if ($uploaded_file['size'] > $smilies_config_image_size)
            BB_Functions::Message($lang['Too large'] . ' ' . $smilies_config_image_size . ' ' . $lang['bytes'] . '.');
        $extensions = null;
        if ($uploaded_file['type'] == 'image/gif')
            $extensions = array('.gif', '.jpg', '.png');
        else if ($uploaded_file['type'] == 'image/jpeg' || $uploaded_file['type'] == 'image/pjpeg')
            $extensions = array('.jpg', '.gif', '.png');
        else
            $extensions = array('.png', '.gif', '.jpg');
        if (!@move_uploaded_file($uploaded_file['tmp_name'], FORUM_ROOT . $forum_folder . '/img/smilies/' . $filename . '.tmp'))
            BB_Functions::Message($lang['Move failed']);
        list($width, $height, $type, ) = getimagesize(FORUM_ROOT . $forum_folder . '/img/smilies/' . $filename . '.tmp');
        if (empty($width) || empty($height) || $width > $smilies_config_image_width || $height > $smilies_config_image_height)
        {
            @unlink(FORUM_ROOT . $forum_folder . '/img/smilies/' . $filename . '.tmp');
            BB_Functions::Message($lang['Too wide or high'] . ' ' . $smilies_config_image_width . 'x' . $smilies_config_image_height . ' ' . $lang['pixels'] . '.');
        }
        else if ($type == 1 && $uploaded_file['type'] != 'image/gif')
        {
            @unlink(FORUM_ROOT . $forum_folder . '/img/smilies/' . $filename . '.tmp');
            BB_Functions::Message($lang['Bad type']);
        }
        @unlink(FORUM_ROOT . $forum_folder . '/img/smilies/' . $filename . $extensions[0]);
        @unlink(FORUM_ROOT . $forum_folder . '/img/smilies/' . $filename . $extensions[1]);
        @unlink(FORUM_ROOT . $forum_folder . '/img/smilies/' . $filename . $extensions[2]);
        @rename(FORUM_ROOT . $forum_folder . '/img/smilies/' . $filename . '.tmp', FORUM_ROOT . 'img/smilies/' . $filename . $extensions[0]);
        @chmod(FORUM_ROOT . $forum_folder . '/img/smilies/' . $filename . $extensions[0], 0644);
    }
    else
        BB_Functions::Message($lang['Unknown failure']);
    BB_Functions::Redirect(PLUGIN_URL, $lang['Successful Upload']);
}
elseif (isset($_POST['add_smiley']))
{
    $smiley_code = trim($_POST['smiley_code']);
    $smiley_image = trim($_POST['smiley_image']);
    if ($smiley_code == '')
        BB_Functions::Message($lang['Create Smiley Code None']);
    if ($smiley_image == '')
        BB_Functions::Message($lang['Create Smiley Image None']);
    if (in_array($smiley_code, $smiley_text))
        BB_Functions::Message($lang['Code already exists']);
    $db->query('INSERT INTO ' . $db->prefix . "smilies (image, text) VALUES ('" . $db->escape($smiley_image) . "', '" . $db->escape($smiley_code) . "')") or BB_Functions::Error('Unable to add smiley', __FILE__, __LINE__, $db->error());
    BB_Cache::Generate_Smiley();
    BB_Functions::Redirect(PLUGIN_URL, $lang['Successful Creation']);
}
else
{
    ?>
    <div class="blockform">
        <h2><?php echo $lang['Installed smilies'] ?></h2>
                            <?php
                            $result = $db->query('SELECT * FROM ' . $db->prefix . 'smilies ORDER BY disp_position') or BB_Functions::Error('Unable to retrieve smilies', __FILE__, __LINE__, $db->error());
                            $num_db_smilies = $db->num_rows($result);
                            if ($num_db_smilies > 0)
                            {
                                ?>
            <form method="post" action="<?php echo PLUGIN_URL; ?>">
                <div class="inform">
                    <div class="infldset file" style="padding:0px">
                        <table>
                            <thead>
                                <tr>
                                    <th height="30" scope="row"><strong><?php echo $lang['Position']; ?></strong></th>
                                    <th scope="row"><strong><?php echo $lang['Image Filename']; ?></strong></th>
                                    <th scope="row"><strong><?php echo $lang['Code']; ?></strong></th>
                                    <th scope="row"><strong><?php echo $lang['Image']; ?></strong></th>
                                    <th scope="row"><strong><?php echo $lang['Remove']; ?></strong></th>
                                </tr>
                            </thead>
                            <tbody>
            <?php
            while ($db_smilies = $db->fetch_assoc($result))
            {
                ?>
                                    <tr>
                                        <td><input type="text" class="textbox" name="smilies_order[<?php echo $db_smilies['id']; ?>]" value="<?php echo $db_smilies['disp_position']; ?>" size="3" maxlength="3" /></td>
                                        <td><?php echo $db_smilies['image']; ?></td>
                                        <td><?php echo $db_smilies['text']; ?></td>
                                        <td><img src="<?php echo bb_forum_url ?>img/smilies/<?php echo $db_smilies['image']; ?>" alt="<?php echo $db_smilies['text']; ?>" /></td>
                                        <td><input name="rem_smilies[<?php echo $db_smilies['id']; ?>]" type="checkbox" value="1" /></td>
                                    </tr>
            <?php
        }
        ?>
                            </tbody>
                        </table>
                    </div>
                </div>
                <div><input name="reord" class="b1" type="submit" value="<?php echo $lang['Change position']; ?>" /> <input name="remove" class="b1" type="submit" value="<?php echo $lang['Remove Selected']; ?>" /></div>
            </form>
        <?php
    }
    else
    {
        ?>
            <div class="fakeform">
                <div class="inbox">
                    <p><?php echo $lang['No smiley']; ?></p>
                </div>
            </div>
        <?php
    }
    ?>
        <h2><?php echo $lang['Submit New Smiley'] ?></h2>
        <form method="post" action="<?php echo PLUGIN_URL; ?>">
            <div class="inform">
                <div class="infldset file" style="padding:10px">
                    <table class="aligntop" cellspacing="0">
                        <tr>
                            <th style="width:150px" scope="row"><?php echo $lang['Smiley Code'] ?></th>
                            <td style="width:25px">&nbsp;&nbsp;<img src="<?php echo bb_forum_url ?>img/admin/tooltip.png" onmouseover="return xBB_Show_Tooltip('<?php echo $lang['Smiley Code Description'] ?>');" onmouseout="return nd();" /></td>
                            <td><input class="textbox" type="text" name="smiley_code" size="25" tabindex="1" /></td>
                        </tr>
                        <tr>
                            <th scope="row"><?php echo $lang['Smiley Image'] ?></th>
                            <td style="width:25px">&nbsp;&nbsp;<img src="<?php echo bb_forum_url ?>img/admin/tooltip.png" onmouseover="return xBB_Show_Tooltip('<?php echo $lang['Smiley Image Description'] ?>');" onmouseout="return nd();" /></td>
                            <td><input class="textbox" type="text" name="smiley_image" size="25" tabindex="1" /></td>
                        </tr>
                    </table>
                </div>
            </div>
            <div><input type="submit" class="b1" name="add_smiley" value="<?php echo $lang['Submit Smiley'] ?>" /></div>
        </form>
        <h2><?php echo $lang['Smilies available'] ?></h2>
        <form method="post" action="<?php echo PLUGIN_URL; ?>">
            <div class="inform">
                <div class="infldset file" style="padding:0px">
                            <?php
                            $img_smilies = array();
                            $d = dir(FORUM_ROOT . $forum_folder . '/img/smilies');
                            while (($entry = $d->read()) !== false)
                            {
                                if (!is_dir($entry) && $entry != '.' && $entry != '..' && $entry != 'index.html')
                                    $img_smilies[] = $entry;
                            }
                            $d->close();
                            @natsort($img_smilies);
                            ?>
                    <table>
                        <thead>
                            <tr>
                                <th height="30" scope="row"><strong><?php echo $lang['Image Filename']; ?></strong></th>
                                <th scope="row"><strong><?php echo $lang['Image']; ?></strong></th>
                                <th scope="row"><strong><?php echo $lang['Delete']; ?></strong></th>
                            </tr>
                        </thead>
                        <tbody>
    <?php
    $i = 0;
    foreach ($img_smilies as $img) :
        ?>
                                <tr>
                                    <td><?php echo $img; ?></td>
                                    <td><img src="<?php echo bb_forum_url ?>img/smilies/<?php echo $img; ?>" alt="" /></td>
                                    <td><input name="del_smilies[<?php echo $img; ?>]" type="checkbox" value="1" /></td>
                                </tr>
        <?php
        $i++;
    endforeach;
    ?>
                        </tbody>
                    </table>
                </div>
            </div>
            <div><input name="delete" class="b1" type="submit" value="<?php echo $lang['Delete Selected']; ?>" /></div>
        </form>
        <h2><?php echo $lang['Add smiley'] ?></h2>
        <form method="post" enctype="multipart/form-data"  action="<?php echo PLUGIN_URL; ?>">
            <div class="inform">
                <div class="infldset file" style="padding:10px">
                    <table class="aligntop" cellspacing="0">
                        <tr>
                            <th style="width:150px" scope="row"><?php echo $lang['Image file'] ?></th>
                            <td style="width:25px">&nbsp;&nbsp;<img src="<?php echo bb_forum_url ?>img/admin/tooltip.png" onmouseover="return xBB_Show_Tooltip('<?php echo $lang['upload_image_file'] ?>');" onmouseout="return nd();" /></td>
                            <td><input name="req_file" type="file" size="30" /></td>
                        </tr>
                    </table>
                </div>
            </div>
            <div><input name="add_image" class="b1" type="submit" value="<?php echo $lang['Upload']; ?>" /></div>
        </form>
        <div class="clearer"></div>
    </div>
    <?php
}
?>