<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
if (!defined('IN_FORUM'))
    exit('No direct script access allowed');
define('PLUGIN_LOADED', 1);
define('PLUGIN_URL', 'plugin.php?plugin=a_Spam_Protect.php');
$current = explode(',', bb_spam_protect);
$current_config = explode(',', bb_spam_settings);
if (isset($_POST['submitform']))
{
    foreach ($_POST as $input)
    {
        if (preg_match('/^.*\\.php\\w*|^.*\\.htm\\w*/i', $input))
            $insert[] = $input;
    }
    $cms_settings->Set_Namespace('xennobb');
    $res = true;
    $res &= $cms_settings->Save(bb_spam_protect, implode(',', $insert));
    if ($res)
        BB_Admin_Functions::Log_Action('Change XennoBB configuration (spam protect)', 2);
    $cms_settings->Set_Namespace('');
    BB_Functions::Redirect(PLUGIN_URL, 'eXtinguisher list of protected file updated. Redirecting &hellip;');
}
else if (isset($_POST['submitform2']))
{
    $insert = array($_POST['server'],
        intval($_POST['expire']),
        intval($_POST['max']),
        intval($_POST['trust']),
        intval($_POST['admin']),
        intval($_POST['mod'])
    );
    if (preg_match('/^www\\.|^http:|^ftp:/i', $insert['0']) || str_replace(' ', '', $insert['0']) == '' || strlen($insert['0']) < 4)
        BB_Functions::Message('Empty or incorrect values detected. Please go back and correct your settings.');
    $cms_settings->Set_Namespace('xennobb');
    $res = true;
    $res &= $cms_settings->Save(bb_spam_settings, implode(',', str_replace(array(' ', ','), '', $insert)));
    if ($res)
        BB_Admin_Functions::Log_Action('Change XennoBB configuration (spam protect)', 2);
    $cms_settings->Set_Namespace('');
    BB_Functions::Redirect(PLUGIN_URL, 'eXtinguisher settings updated. Redirecting &hellip;');
}
?>
<div class="blockform">
    <h2 class="block2"><span>Please select the files you want to protect</span></h2>
    <form id="days" method="post" action="<?php echo PLUGIN_URL ?>">
        <div class="inform">
            <div class="infldset file" style="padding:10px">
                <p>By default, eXtinguisher protects the following files:</p>
                <div id="posterror">
                    <ul>
                        <li><strong>edit.php</strong></li>
                        <li><strong>misc.php</strong></li>
                        <li><strong>post.php</strong></li>
                        <li><strong>member.php</strong></li>
                    </ul>
                </div>
                <p>If you want to protect any additional files, you will need to select
					them in the form below. It only makes sense to protect files which will
					be run directly, and not those which will be included through other scripts.
					Because of this, files like config.php, header.php, footer.php &amp; any
					installation files is not displayed.</p>
            </div>
        </div>
        <div class="inform">
            <div class="infldset file" style="padding:15px">
                <?php
                $dh = opendir(FORUM_ROOT . $forum_folder . '/');
                $i = 0;
                echo '' . "\t" . '<ul>' . "\n\t\t\t\t\t\t\t" . '';
                while (false !== ($file = readdir($dh)))
                {
                    if (!is_dir($file) && preg_match('/^.*\\.php\\w*|^.*\\.htm\\w*/i', $file) && !preg_match('/^config\\.php|^install.*.php|^header\\.php|^footer\\.php/i', $file))
                    {
                        if (in_array($file, $current))
                            $checked = 'checked="checked"';
                        else
                            $checked = '';
                        echo '' . "\t" . '<li><label><input type="checkbox" name="file' . $i . '" value="' . $file . '" ' . $checked . ' /> ' . $file . '</label></li>' . "\n\t\t\t\t\t\t\t" . '';
                        $i++;
                    }
                }
                echo '</ul>' . "\n" . '';
                ?>
            </div>
        </div>
        <div><input type="submit" class="b1" name="submitform" value="<?php echo $lang['Update'] ?>" tabindex="2" /></div>
    </form>
    <h2 class="block2"><span>Settings</span></h2>
    <form id="settings" method="post" action="<?php echo PLUGIN_URL ?>">
        <div class="inform">
            <div class="infldset file" style="padding:15px">
                <ul>
                    <li><label><strong>SBL/XBL Server</strong></label><input class="textbox" type="text" size="50" id="server" name="server" value="<?php echo $current_config['0'] ?>" /><p>Only change this setting if you really know what you're doing (default setting: sbl-xbl.spamhaus.org)</p></li>
                    <li><label><strong>Frequency to check IP</strong></label><input class="textbox" type="text" size="10" id="expire" name="expire" value="<?php echo $current_config['1'] ?>" /><p>Enter value is seconds. Not recommended to set lower then 3600</p></li>
                    <li><label><strong>Max hits before permanent block</strong></label><input class="textbox" type="text" size="10" id="max" name="max" value="<?php echo $current_config['2'] ?>" /><p>Hits before permanenty block occurs. Enter 0 to disable this function</p></li>
                    <li><label><strong>Number of posts to gain 'trusted' status</strong></label><input class="textbox" type="text" size="10" id="trust" name="trust" value="<?php echo $current_config['3'] ?>" /><p>Number of posts before we trust this user, and consequently disable the SPAM check. Enter 0 to disable this function (NOTE: Do <span class="bbu">not</span> protect login.php if you wish to use this feature!)</p></li>
                    <li><label><input type="checkbox" id="admin" name="admin" value="1" <?php if ($current_config['4'] == 1)
                    echo 'checked="checked"'; ?> /> Mark this to check administrator accounts (ignored if admins posts >= trusted setting)</label></li>
                    <li><label><input type="checkbox" id="mod" name="mod" value="1" <?php if ($current_config['5'] == 1)
                    echo 'checked="checked"'; ?> /> Mark this to check moderator accounts (ignored if mods posts >= trusted setting)</label></li>
                </ul>
            </div>
        </div>
        <div><input type="submit" id="submit" class="b1" name="submitform2" value="<?php echo $lang['Update'] ?>" tabindex="2" /></div>
    </form>
</div>