<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
function xBB_Convert_Path($t1)
{
    if (strstr($_SERVER['SERVER_SOFTWARE'], 'Win32') || strstr($_SERVER['SERVER_SOFTWARE'], 'win32'))
        return str_replace('/', '\\', $t1);
    else
        return $t1;
}

$action = isset($_GET['action']) ? $_GET['action'] : NULL;
$WorkingDirectory = getcwd();
$errors = array();
if ($action == 'Permissions')
{
    if (!is_writable(realpath($WorkingDirectory . xBB_Convert_Path("/../community/img/avatars"))))
        $errors[] = "The folder <u>" . realpath($WorkingDirectory . xBB_Convert_Path('/../community/img/avatars')) . "</u> is not writable!";
    if (!is_writable(realpath($WorkingDirectory . xBB_Convert_Path("/../var/files"))))
        $errors[] = "The folder <u>" . realpath($WorkingDirectory . xBB_Convert_Path('/../var/files')) . "</u> is not writable!";
    if (!is_writable(realpath($WorkingDirectory . xBB_Convert_Path("/../var/news/html"))))
        $errors[] = "The folder <u>" . realpath($WorkingDirectory . xBB_Convert_Path('/../var/news/html')) . "</u> is not writable!";
    if (!is_writable(realpath($WorkingDirectory . xBB_Convert_Path("/../var/news/html/archives"))))
        $errors[] = "The folder <u>" . realpath($WorkingDirectory . xBB_Convert_Path('/../var/news/html/archives')) . "</u> is not writable!";
    if (!is_writable(realpath($WorkingDirectory . xBB_Convert_Path("/../var/articles/html"))))
        $errors[] = "The folder <u>" . realpath($WorkingDirectory . xBB_Convert_Path('/../var/articles/html')) . "</u> is not writable!";
    if (!is_writable(realpath($WorkingDirectory . xBB_Convert_Path("/../var/cache"))))
        $errors[] = "The folder <u>" . realpath($WorkingDirectory . xBB_Convert_Path('/../var/cache')) . "</u> is not writable!";
    if (!is_writable(realpath($WorkingDirectory . xBB_Convert_Path("/../var/uploads"))))
        $errors[] = "The folder <u>" . realpath($WorkingDirectory . xBB_Convert_Path('/../var/uploads')) . "</u> is not writable!";
    if (!file_exists($WorkingDirectory . "/../include/config.php"))
        $errors[] = "The file <u>include/config.php</u> does not exist.!";
    else
    {
        if (!is_writable(realpath($WorkingDirectory . xBB_Convert_Path("/../include/config.php"))))
            $errors[] = "The file <u>" . realpath($WorkingDirectory . xBB_Convert_Path('/../include/config.php')) . "</u> is not writable!";
    }
    if (!is_writable(realpath($WorkingDirectory . xBB_Convert_Path("/../var/cache/lang_English.php"))))
        $errors[] = "The file <u>" . realpath($WorkingDirectory . xBB_Convert_Path('/../var/cache/lang_English.php')) . "</u> is not writable!";
    if (!is_writable(realpath($WorkingDirectory . xBB_Convert_Path("/../var/cache/lang_admin_English.php"))))
        $errors[] = "The file <u>" . realpath($WorkingDirectory . xBB_Convert_Path('/../var/cache/lang_admin_English.php')) . "</u> is not writable!";
    ?>
    <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
    <html dir="ltr">
        <head>
            <link rel="shortcut icon" href="../community/img/general/favicon.ico" />
            <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
            <title>XennoBB - Install</title>
            <link rel="stylesheet" type="text/css" href="../include/templates/Default/stylesheet.css" />
        </head>
        <body>
            <div id="wrap">
                <div id="wrap-inner">
                    <div id="main-body">
                        <div id="xenno_wrapper_type1">
                            <div id="xenno_install" class="xenno_main">
                                <div id="xenno_header" class="xenno_block">
                                    <div class="box">
                                        <div id="xenno_title" class="inbox">
                                            <h1><span>&nbsp;</span></h1>
                                        </div>
                                    </div>
                                </div>
                                <div class="blockform">
                                    <h2><span style="padding-left:10px">XennoBB Installation Wizard - Permissions</span></h2>
                                    <div class="box">
                                        <div class="inform" style="padding:20px">
                                            <p align="justify">Before we can do much of anything, we need to make sure that you've got your directory &amp; file permissions set up properly.</p>
                                            <?php
                                            if (count($errors) > 0)
                                            {
                                                ?>
                                                <div class="Warnings"><br />
                                                    <strong>Oops. We came across some problems while checking your permissions...</strong><br /><br />
                                                <?php
                                                echo implode('<br />', $errors);
                                                ?>
                                                    <br /><br />
                                                </div>
                                                <p align="justify">Let's try this again...</p>
                                                <div style="border:1px solid #DDDDDD;padding:5px;text-align:center;"><a href="install_step1.php">Click here to go back</a></div>
        <?php
    }
    else
    {
        ?>
                                                <p align="justify">All permissions have been set correctly. You can proceed now to the next step.</p><br /><br />
                                                <div style="border:1px solid #DDDDDD;padding:5px;text-align:center;"><a href="install_step2.php">Click here to proceed to the next step</a></div>
        <?php
    }
    ?>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div id="footer">
<p>powered by <a href="http://www.userdot.net/projects/xennobb"><b>XennoBB</b></a><br />&copy; 2005-2011 <a href="http://www.userdot.net"><b>UserDot</b></a>. All rights reserved.</p>
                    </div>
                </div>
            </div>
        </body>
    </html>
    <?php
}
else
{
    ?>
    <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
    <html dir="ltr">
        <head>
            <link rel="shortcut icon" href="../community/img/general/favicon.ico" />
            <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
            <title>XennoBB - Install</title>
            <link rel="stylesheet" type="text/css" href="../include/templates/Default/stylesheet.css" />
        </head>
        <body>
            <div id="wrap">
                <div id="wrap-inner">
                    <div id="main-body">
                        <div id="xenno_wrapper_type1">
                            <div id="xenno_install" class="xenno_main">
                                <div id="xenno_header" class="xenno_block">
                                    <div class="box">
                                        <div id="xenno_title" class="inbox">
                                            <h1><span>&nbsp;</span></h1>
                                        </div>
                                    </div>
                                </div>
                                <div class="blockform">
                                    <h2><span style="padding-left:10px">XennoBB Installation Wizard - Permissions</span></h2>
                                    <div class="box">
                                        <div class="inform" style="padding:20px">
                                            <p align="justify">Before we can do much of anything, we need to make sure that you've got your directory &amp; file permissions set up properly.</p>
                                            <p align="justify">XennoBB is going to need read AND write access to the following folders:</p>
                                            <blockquote><pre>
                                                    <?php echo realpath($WorkingDirectory . xBB_Convert_Path("/../var/files")) . "\n"; ?>
                                                    <?php echo realpath($WorkingDirectory . xBB_Convert_Path("/../var/news/html")) . "\n"; ?>
                                                    <?php echo realpath($WorkingDirectory . xBB_Convert_Path("/../var/news/html/archives")) . "\n"; ?>
                                                    <?php echo realpath($WorkingDirectory . xBB_Convert_Path("/../var/articles/html")) . "\n"; ?>
                                                    <?php echo realpath($WorkingDirectory . xBB_Convert_Path("/../community/img/avatars")) . "\n"; ?>
                                                    <?php echo realpath($WorkingDirectory . xBB_Convert_Path("/../var/cache")) . "\n"; ?>
                                                    <?php echo realpath($WorkingDirectory . xBB_Convert_Path("/../var/uploads")) . "\n"; ?></pre>
                                            </blockquote>
                                            <p align="justify">XennoBB is also going to need read and write access to the following file:</p>
                                            <blockquote><pre>
    <?php echo realpath($WorkingDirectory . xBB_Convert_Path("/../include/config.php")) . "\n"; ?>
    <?php echo realpath($WorkingDirectory . xBB_Convert_Path("/../var/cache/lang_English.php")) . "\n"; ?>
    <?php echo realpath($WorkingDirectory . xBB_Convert_Path("/../var/cache/lang_admin_English.php")) . "\n"; ?></pre></blockquote>
                                            <p align="justify">If you are running a *nix server and you have command line access, you can achieve these permissions by navigating to the main XennoBB folder. Once you are sitting in that folder, run the following commands:</p>
                                            <blockquote><pre>chmod 755 include/config.php
    chmod 755 var/cache/lang_English.php
    chmod 755 var/cache/lang_admin_English.php
    chmod 755 var/files
    chmod 755 var/news/html
    chmod 755 var/news/html/archives
    chmod 755 var/articles/html
    chmod 755 community/img/avatars
    chmod 755 var/cache
    chmod 755 var/uploads</pre>
                                            </blockquote>
                                            <p align="justify"><b>NOTE!</b> Sometimes chmodding the files and folder to 755 does not work, so you can chmod them to 777.</p>
                                            <p align="justify">Once you've got your permissions set up properly...</p>
                                            <br /><br />
                                            <div style="border:1px solid #DDDDDD;padding:5px;text-align:center;"><a href="install_step1.php?action=Permissions">Click here to check your permissions and proceed to the next step</a></div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div id="footer">
                        <p>powered by <a href="http://www.userdot.net/projects/xennobb"><b>XennoBB</b></a><br />&copy; 2005-2011 <a href="http://www.userdot.net"><b>UserDot</b></a>. All rights reserved.</p>
                    </div>
                </div>
            </div>
        </body>
    </html>
    <?php
}
?>