<?php
/*

  Copyright (C) 2005-2011 UserDot
  Visit XennoBB at www.userdot.net/projects/xennobb
  Originally based on PunBB www.punbb.org

  XennoBB is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  XennoBB is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301 USA

 */
define('IN_FORUM', 1);
define('FORUM_ROOT', '../community/');
error_reporting(E_ALL);
@set_time_limit(0);
$WorkingDirectory = getcwd() . "/";
if (isset($_POST['form_sent']))
{

    class BB_Settings
    {

        var $db;
        var $table;
        var $ns;
        var $settings = array();

        function BB_Settings(&$bbdb, $table)
        {
            $this->db = $bbdb;
            $this->table = $table;
            $this->ns = '';
            $this->__Get_Settings();
        }

        function Export()
        {
            foreach ($this->settings as $k => $v)
            {
                if (!defined($k))
                    define($k, $v['value']);
            }
        }

        function Set_Namespace($ns)
        {
            if (preg_match('/^[a-z_]+$/', $ns))
                $this->ns = $ns;
        }

        function Save($id, $value, $type=null, $label=null)
        {
            if ($this->ns == '')
                return false;
            if ($type == 'double')
                $type = 'float';
            elseif ($type === null)
            {
                if ($this->__Is_Setting($id))
                    $type = gettype($this->settings[$id]['value']);
                else
                    $type = 'string';
            }
            elseif ($type != 'boolean' && $type != 'integer' && $type != 'float')
                $type = 'string';
            if ($label == null && $this->__Is_Setting($id))
                $label = $this->settings[$id]['label'];
            if (!preg_match('/^bb_[a-zA-Z0-9_]+$/', $id))
                return false;
            settype($value, $type);
            if ($this->__Is_Setting($id) && $this->ns == $this->settings[$id]['ns'])
                $strReq = "UPDATE " . $this->table . " SET value = '" . $this->db->escape($value) . "', type = '" . $this->db->escape($type) . "', label = '" . $this->db->escape($label) . "' WHERE id = '" . $this->db->escape($id) . "' ";
            else
            {
                $strReq = 'INSERT INTO ' . $this->table . ' ' .
                        '(id,namespace,value,type,label) VALUES ' . "\n" . ' (' .
                        "'" . $this->db->escape($id) . "'," .
                        "'" . $this->db->escape($this->ns) . "'," .
                        "'" . $this->db->escape($value) . "'," .
                        "'" . $this->db->escape($type) . "'," .
                        "'" . $this->db->escape($label) . "'" .
                        ') ';
            }
            if ($this->db->query($strReq))
                return true;
            else
                BB_Functions::Error('Cannot update XennoBB configuration.', __FILE__, __LINE__, $this->db->error());
        }

        function Remove($id)
        {
            $strReq = 'DELETE FROM ' . $this->table . ' ' . "WHERE id = '" . $this->db->escape($id) . "' ";
            if ($this->db->query($strReq))
                return true;
            else
                BB_Functions::Error('Cannot update XennoBB configuration.', __FILE__, __LINE__, $this->db->error());
        }

        function __Get_Settings()
        {
            $result = $this->db->query('SELECT id, namespace, value, type, label FROM ' . $this->table . ' ORDER BY namespace, id DESC ') or BB_Functions::Error('Cannot get XennoCMS configuration from database.', __FILE__, __LINE__, $this->db->error());
            $cur_setting = array();
            while ($cur_setting = $this->db->fetch_assoc($result))
            {
                $id = trim($cur_setting['id']);
                $value = $cur_setting['value'];
                $type = $cur_setting['type'];
                if ($type == 'float' || $type == 'double')
                    $type = (version_compare(PHP_VERSION, '4.2.0', 'lt')) ? 'double' : 'float';
                elseif ($type != 'boolean' && $type != 'integer')
                    $type = 'string';
                settype($value, $type);
                $this->settings[$id] = array(
                    'ns' => $cur_setting['namespace'],
                    'value' => $value,
                    'label' => (string) $cur_setting['label']
                );
            }
            return false;
        }

        function __Is_Setting($id)
        {
            return isset($this->settings[$id]);
        }

    }

    function unescape($str)
    {
        return (get_magic_quotes_gpc() == 1) ? stripslashes($str) : $str;
    }

    function xBB_Hash($str)
    {
        if (function_exists('sha1'))
            return sha1($str);
        else if (function_exists('mhash'))
            return bin2hex(mhash(MHASH_SHA1, $str));
        else
            return md5($str);
    }

    class BB_Functions
    {

        function Error($message, $file = false, $line = false, $db_error = false)
        {
            ?>
            <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
            <html dir="ltr">
                <head>
                    <link rel="shortcut icon" href="../community/img/general/favicon.ico" />
                    <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
                    <title>XennoBB - Install</title>
                    <link rel="stylesheet" type="text/css" href="../include/templates/Default/stylesheet.css" />
                </head>
                <body>
                    <div id="wrap">
                        <div id="wrap-inner">
                            <div id="main-body">
                                <div id="xenno_wrapper_type1">
                                    <div id="xenno_index" class="xenno_main">
                                        <div id="xenno_header" class="xenno_block">
                                            <div class="box">
                                                <div id="xenno_title" class="inbox">
                                                    <h1><span>&nbsp;</span></h1>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="blocktable">
                                            <h2><span style="padding-left:10px">XennoBB Installation Wizard -  Database Setup</span></h2>
                                            <div class="box">
                                                <div class="inform" style="padding:20px">
                                                    <p align="justify">Below you can provide the connection parameters for the database server where you want to install XennoBB. If you haven't done it yet, now would be a good time to create the database where you want XennoBB installed.</p>
                                                    <div class="Warnings">
                                                        <br /><br />
                                                        <strong>Oops. We came across some problems prepairing the database for XennoBB ...</strong>
            <?php
            if ($file !== false && $line !== false)
                echo '<strong style="color: A00000">An BB_Functions::Error occured on line ' . $line . ' in file ' . $file . '.</strong><br /><br />';
            else
                echo '<strong style="color: A00000">An BB_Functions::Error occured.</strong><br />';
            echo '<strong>Forum reported:</strong> ' . htmlspecialchars($message) . '<br /><br />';
            if ($db_error !== false)
                echo '<strong>Database reported:</strong> ' . htmlspecialchars($db_error['error_msg']) . (($db_error['error_no']) ? ' (Errno: ' . $db_error['error_no'] . ')' : '');
            ?>
                                                    </div>
                                                    <p align="justify">Let's try this again...</p>
                                                    <br /><br />
                                                    <div style="border:1px solid #DDDDDD;padding:5px;text-align:center;"><a href="javascript:history.go(-1)">Click here to go back and correct the BB_Functions::Errors.</a></div>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div id="footer">
                        <p>powered by <a href="http://www.userdot.net/projects/xennobb"><b>XennoBB</b></a><br />&copy; 2005-2011 <a href="http://www.userdot.net"><b>UserDot</b></a>. All rights reserved.</p>
                            </div>
                        </div>
                    </div>
                </body>
            </html>
            <?php
            exit;
        }

    }

    $db_type = $_POST['req_db_type'];
    $db_host = trim($_POST['req_db_host']);
    $db_name = trim($_POST['req_db_name']);
    $db_username = unescape(trim($_POST['db_username']));
    $db_password = unescape(trim($_POST['db_password']));
    $db_prefix = trim($_POST['db_prefix']);
    if ($db_prefix == '')
        $db_prefix = substr(strtolower(md5(uniqid(rand(), 1))), 0, 7) . '_';
    $username = unescape(trim($_POST['req_username']));
    $email = strtolower(trim($_POST['req_email']));
    $password1 = unescape(trim($_POST['req_password1']));
    $password2 = unescape(trim($_POST['req_password2']));
    if (substr($_POST['req_base_url'], -1) == '/')
        $base_url = substr($_POST['req_base_url'], 0, -1);
    else
        $base_url = $_POST['req_base_url'];
    $base_url_tmp = $base_url . '/';
    $forum_url = $base_url . '/community/';
    $forum_path = unescape(trim($_POST['req_forum_path']));
    $upload_url = getcwd() . '/../var/uploads';
    $add_links = '0=<a href=' . $base_url_tmp . '>Home</a>';
    if (strlen($username) < 2)
        BB_Functions::Error('Usernames must be at least 2 characters long. Please go back and correct.');
    if (strlen($password1) < 4)
        BB_Functions::Error('Passwords must be at least 4 characters long. Please go back and correct.');
    if ($password1 != $password2)
        BB_Functions::Error('Passwords do not match. Please go back and correct.');
    if (!strcasecmp($username, 'Guest'))
        BB_Functions::Error('The username guest is reserved. Please go back and correct.');
    if (preg_match('/[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}/', $username))
        BB_Functions::Error('Usernames may not be in the form of an IP address. Please go back and correct.');
    if (preg_match('#\[b\]|\[/b\]|\[u\]|\[/u\]|\[i\]|\[/i\]|\[color|\[/color\]|\[quote\]|\[/quote\]|\[code\]|\[/code\]|\[img\]|\[/img\]|\[url|\[/url\]|\[email|\[/email\]#i', $username))
        BB_Functions::Error('Usernames may not contain any of the text formatting tags (BBCode) that the forum uses. Please go back and correct.');
    if (strlen($email) > 50 || !preg_match('/^(([^<>()[\]\\.,;:\s@"\']+(\.[^<>()[\]\\.,;:\s@"\']+)*)|("[^"\']+"))@((\[\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}\])|(([a-zA-Z\d\-]+\.)+[a-zA-Z]{2,}))$/', $email))
        BB_Functions::Error('The administrator e-mail address you entered is invalid. Please go back and correct.');
    switch ($db_type)
    {
        case 'mysql':
            require FORUM_ROOT . '../include/functions/drivers/mysql.php';
            break;
        case 'mysqli':
            require FORUM_ROOT . '../include/functions/drivers/mysqli.php';
            break;
        case 'pgsql':
            require FORUM_ROOT . '../include/functions/drivers/pgsql.php';
            break;
        case 'sqlite':
            require FORUM_ROOT . '../include/functions/drivers/sqlite.php';
            break;
        default:
            BB_Functions::Error('\'' . $db_type . '\' is not a valid database type.');
    }
    $db = new xBB_DB_Layer($db_host, $db_username, $db_password, $db_name, $db_prefix, false);
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            break;
        case 'pgsql':
            if (version_compare(PHP_VERSION, '4.3.0', '<'))
                BB_Functions::Error('You are running PHP version ' . PHP_VERSION . '. XennoBB requires at least PHP 4.3.0 to run properly when using PostgreSQL. You must upgrade your PHP installation or use a different database before you can continue.');
            break;
        case 'sqlite':
            if (strtolower($db_prefix) == 'sqlite_')
                BB_Functions::Error('The table prefix \'sqlite_\' is reserved for use by the SQLite engine. Please choose a different prefix.');
            break;
    }
    $result = $db->query('SELECT 1 FROM ' . $db_prefix . 'users WHERE id=1');
    if ($db->num_rows($result))
        BB_Functions::Error('A table called "' . $db_prefix . 'users" is already present in the database "' . $db_name . '". This could mean that XennoBB is already installed or that another piece of software is installed and is occupying one or more of the table names XennoBB requires. If you want to install multiple copies of XennoBB in the same database, you must choose a different table prefix.');
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "advertising_config (
                                conf_name VARCHAR(255) NOT NULL DEFAULT '',
                                conf_value TEXT,
                                PRIMARY KEY (conf_name)
                        ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $db->start_transaction();
            $sql = 'CREATE TABLE ' . $db_prefix . "advertising_config (
                                conf_name VARCHAR(255) NOT NULL DEFAULT '',
                                conf_value TEXT,
                                PRIMARY KEY (conf_name)
                        )";
            break;
        case 'sqlite':
            $db->start_transaction();
            $sql = 'CREATE TABLE ' . $db_prefix . "advertising_config (
                                conf_name VARCHAR(255) NOT NULL DEFAULT '',
                                conf_value TEXT,
                                PRIMARY KEY (conf_name)
                        )";
            break;
    }
    $db->query($sql) or BB_Functions::Error('Unable to create table ' . $db_prefix . 'advertising_config. Please check your settings and try again.', __FILE__, __LINE__, $db->error());
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "bans (
                                id INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
                                username VARCHAR(200),
                                ip VARCHAR(255),
                                email VARCHAR(50),
                                message VARCHAR(255),
                                expire INT(10) UNSIGNED,
                                PRIMARY KEY (id)
                        ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "bans (
                                id SERIAL,
                                username VARCHAR(200),
                                ip VARCHAR(255),
                                email VARCHAR(50),
                                message VARCHAR(255),
                                expire INT,
                                PRIMARY KEY (id)
                        )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "bans (
                                id INTEGER NOT NULL,
                                username VARCHAR(200),
                                ip VARCHAR(255),
                                email VARCHAR(50),
                                message VARCHAR(255),
                                expire INTEGER,
                                PRIMARY KEY (id)
                        )";
            break;
    }
    $db->query($sql) or BB_Functions::Error('Unable to create table ' . $db_prefix . 'bans. Please check your settings and try again.', __FILE__, __LINE__, $db->error());
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "bots (
                                id int(7) unsigned NOT NULL auto_increment,
                                bot_alias varchar(60) NOT NULL DEFAULT '',
                                bot_string varchar(60) NOT NULL DEFAULT '',
                                  time_stamp int(10) NOT NULL DEFAULT 0,
                                  PRIMARY KEY (id)
                        ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "bots (
                                id SERIAL,
                                bot_alias varchar(60) NOT NULL DEFAULT '',
                                bot_string varchar(60) NOT NULL DEFAULT '',
                                  time_stamp int(10) NOT NULL DEFAULT 0,
                                  PRIMARY KEY (id)
                        )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "bots (
                                id INTEGER NOT NULL,
                                bot_alias varchar(60) NOT NULL DEFAULT '',
                                bot_string varchar(60) NOT NULL DEFAULT '',
                                  time_stamp INTEGER NOT NULL DEFAULT 0,
                                  PRIMARY KEY (id)
                        )";
            break;
    }
    $db->query($sql) or BB_Functions::Error('Unable to create table ' . $db_prefix . 'bots. Please check your settings and try again.', __FILE__, __LINE__, $db->error());
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "botsconfig (
                                id int(7) unsigned NOT NULL auto_increment,
                                display_time int(4) NOT NULL DEFAULT 5,
                                isCaseSensitive int(1) NOT NULL DEFAULT 0,
                                isEnabled int(1) NOT NULL DEFAULT 1,
                                PRIMARY KEY (id)
                        ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "botsconfig (
                                id SERIAL,
                                display_time INT(4) NOT NULL DEFAULT 5,
                                isCaseSensitive INT(1) NOT NULL DEFAULT 0,
                                isEnabled INT(1) NOT NULL DEFAULT 1,
                                PRIMARY KEY (id)
                        )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "botsconfig (
                                id INTEGER NOT NULL,
                                display_time INTEGER NOT NULL DEFAULT 5,
                                isCaseSensitive INTEGER NOT NULL DEFAULT 0,
                                isEnabled INTEGER NOT NULL DEFAULT 1,
                                PRIMARY KEY (id)
                        )";
            break;
    }
    $db->query($sql) or BB_Functions::Error('Unable to create table ' . $db_prefix . 'botsconfig. Please check your settings and try again.', __FILE__, __LINE__, $db->error());
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = "CREATE TABLE " . $db_prefix . "configuration (
                                id VARCHAR(255) NOT NULL DEFAULT '',
                                namespace VARCHAR(32) NOT NULL DEFAULT 'system',
                                value TEXT,
                                type VARCHAR(8) NOT NULL DEFAULT 'string',
                                label TEXT,
                                PRIMARY KEY (id)
                        ) TYPE=MyISAM";
            break;
        case 'pgsql':
            $db->start_transaction();
            $sql = "CREATE TABLE " . $db_prefix . "configuration (
                                id VARCHAR(255) NOT NULL DEFAULT '',
                                namespace VARCHAR(32) NOT NULL DEFAULT 'system',
                                value TEXT,
                                type VARCHAR(8) NOT NULL DEFAULT 'string',
                                label TEXT,
                                PRIMARY KEY (id)
                        )";
            break;
        case 'sqlite':
            $db->start_transaction();
            $sql = "CREATE TABLE " . $db_prefix . "configuration (
                                id VARCHAR(255) NOT NULL DEFAULT '',
                                namespace VARCHAR(32) NOT NULL DEFAULT 'system',
                                value TEXT,
                                type VARCHAR(8) NOT NULL DEFAULT 'string',
                                label TEXT,
                                PRIMARY KEY (id)
                        )";
            break;
    }
    $db->query($sql) or BB_Functions::Error('Unable to create table ' . $db_prefix . 'configuration. Please check your settings and try again.', __FILE__, __LINE__, $db->error());
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = "CREATE TABLE " . $db_prefix . "logs (
                                user_id INT NOT NULL ,
                                user_name VARCHAR(200) ,
                                user_ip VARCHAR(15) ,
                                date DATETIME NOT NULL ,
                                log VARCHAR(255) NOT NULL,
                                code INT(2) NOT NULL
                        ) TYPE=MyISAM";
            break;
        case 'pgsql':
            $db->start_transaction();
            $sql = "CREATE TABLE " . $db_prefix . "logs (
                                user_id INT NOT NULL ,
                                user_name VARCHAR(200) ,
                                user_ip VARCHAR(15) ,
                                date VARCHAR(200) NOT NULL ,
                                log VARCHAR(255) NOT NULL,
                                code INT(2) NOT NULL
                        )";
            break;
        case 'sqlite':
            $db->start_transaction();
            $sql = "CREATE TABLE " . $db_prefix . "logs (
                                user_id INTEGER NOT NULL ,
                                user_name VARCHAR(200) ,
                                user_ip VARCHAR(15) ,
                                date VARCHAR(200) NOT NULL ,
                                log VARCHAR(255) NOT NULL,
                                code INTEGER(2) NOT NULL
                        )";
            break;
    }
    $db->query($sql) or BB_Functions::Error('Unable to create table ' . $db_prefix . 'logs. Please check your settings and try again.', __FILE__, __LINE__, $db->error());
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "categories (
                                id INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
                                cat_name VARCHAR(80) NOT NULL DEFAULT 'New Category',
                                disp_position INT(10) NOT NULL DEFAULT 0,
                                PRIMARY KEY (id)
                        ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "categories (
                                id SERIAL,
                                cat_name VARCHAR(80) NOT NULL DEFAULT 'New Category',
                                disp_position INT NOT NULL DEFAULT 0,
                                PRIMARY KEY (id)
                        )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "categories (
                                id INTEGER NOT NULL,
                                cat_name VARCHAR(80) NOT NULL DEFAULT 'New Category',
                                disp_position INTEGER NOT NULL DEFAULT 0,
                                PRIMARY KEY (id)
                        )";
            break;
    }
    $db->query($sql) or BB_Functions::Error('Unable to create table ' . $db_prefix . 'categories. Please check your settings and try again.', __FILE__, __LINE__, $db->error());
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "censoring (
                                id INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
                                search_for VARCHAR(60) NOT NULL DEFAULT '',
                                replace_with VARCHAR(60) NOT NULL DEFAULT '',
                                PRIMARY KEY (id)
                        ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "censoring (
                                id SERIAL,
                                search_for VARCHAR(60) NOT NULL DEFAULT '',
                                replace_with VARCHAR(60) NOT NULL DEFAULT '',
                                PRIMARY KEY (id)
                        )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "censoring (
                                id INTEGER NOT NULL,
                                search_for VARCHAR(60) NOT NULL DEFAULT '',
                                replace_with VARCHAR(60) NOT NULL DEFAULT '',
                                PRIMARY KEY (id)
                        )";
            break;
    }
    $db->query($sql) or BB_Functions::Error('Unable to create table ' . $db_prefix . 'censoring. Please check your settings and try again.', __FILE__, __LINE__, $db->error());
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "permissions (
                                gid int(10) NOT NULL DEFAULT 0,
                                forum_id int(10) NOT NULL DEFAULT 0,
                                read_forum tinyint(1) NOT NULL DEFAULT 1,
                                post_replies tinyint(1) NOT NULL DEFAULT 1,
                                post_topics tinyint(1) NOT NULL DEFAULT 1,
                                image_upload tinyint(1) NOT NULL DEFAULT 0,
                                PRIMARY KEY  (gid,forum_id)
                        ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "permissions (
                                gid INT NOT NULL DEFAULT 0,
                                forum_id INT NOT NULL DEFAULT 0,
                                read_forum SMALLINT NOT NULL DEFAULT 1,
                                post_replies SMALLINT NOT NULL DEFAULT 1,
                                post_topics SMALLINT NOT NULL DEFAULT 1,
                                image_upload INT NOT NULL DEFAULT 0,
                                PRIMARY KEY (gid, forum_id)
                        )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "permissions (
                                gid INTEGER NOT NULL DEFAULT 0,
                                forum_id INTEGER NOT NULL DEFAULT 0,
                                read_forum INTEGER NOT NULL DEFAULT 1,
                                post_replies INTEGER NOT NULL DEFAULT 1,
                                post_topics INTEGER NOT NULL DEFAULT 1,
                                image_upload INTEGER NOT NULL DEFAULT 0,
                                PRIMARY KEY (gid, forum_id)
                        )";
            break;
    }
    $db->query($sql) or BB_Functions::Error('Unable to create table ' . $db_prefix . 'permissions. Please check your settings and try again.', __FILE__, __LINE__, $db->error());
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "forums (
                                id int(10) unsigned NOT NULL AUTO_INCREMENT,
                                forum_name varchar(80) NOT NULL DEFAULT '...',
                                forum_desc text,
                                redirect_url varchar(100) DEFAULT NULL,
                                moderators text,
                                num_topics mediumint(8) unsigned NOT NULL DEFAULT 0,
                                num_posts mediumint(8) unsigned NOT NULL DEFAULT 0,
                                last_post int(10) unsigned DEFAULT NULL,
                                last_post_id int(10) unsigned DEFAULT NULL,
                                last_poster varchar(200) DEFAULT NULL,
                                sort_by tinyint(1) NOT NULL DEFAULT 0,
                                disp_position int(10) NOT NULL DEFAULT 0,
                                cat_id int(10) unsigned NOT NULL DEFAULT 0,
                                parent_forum_id int(10) unsigned DEFAULT 0,
                                protected int(11) NOT NULL DEFAULT 0,
                                password varchar(255) NOT NULL DEFAULT '',
                                PRIMARY KEY  (id)
                        ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "forums (
                                id SERIAL,
                                forum_name VARCHAR(80) NOT NULL DEFAULT '...',
                                forum_desc TEXT,
                                redirect_url VARCHAR(100),
                                moderators TEXT,
                                num_topics INT NOT NULL DEFAULT 0,
                                num_posts INT NOT NULL DEFAULT 0,
                                last_post INT,
                                last_post_id INT,
                                last_poster VARCHAR(200),
                                sort_by SMALLINT NOT NULL DEFAULT 0,
                                disp_position INT NOT NULL DEFAULT 0,
                                cat_id INT NOT NULL DEFAULT 0,
                                parent_forum_id INT(10) DEFAULT 0,
                                protected INT(11) NOT NULL DEFAULT 0,
                                password VARCHAR(255) NOT NULL DEFAULT '',
                                PRIMARY KEY (id)
                        )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "forums (
                                id INTEGER NOT NULL,
                                forum_name VARCHAR(80) NOT NULL DEFAULT '...',
                                forum_desc TEXT,
                                redirect_url VARCHAR(100),
                                moderators TEXT,
                                num_topics INTEGER NOT NULL DEFAULT 0,
                                num_posts INTEGER NOT NULL DEFAULT 0,
                                last_post INTEGER,
                                last_post_id INTEGER,
                                last_poster VARCHAR(200),
                                sort_by INTEGER NOT NULL DEFAULT 0,
                                disp_position INTEGER NOT NULL DEFAULT 0,
                                cat_id INTEGER NOT NULL DEFAULT 0,
                                parent_forum_id INTEGER(10) DEFAULT 0,
                                protected INTEGER NOT NULL DEFAULT 0,
                                password VARCHAR(255) NOT NULL DEFAULT '',
                                PRIMARY KEY (id)
                        )";
            break;
    }
    $db->query($sql) or BB_Functions::Error('Unable to create table ' . $db_prefix . 'forums. Please check your settings and try again.', __FILE__, __LINE__, $db->error());
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "messages (
                                id INT(10) unsigned NOT NULL auto_increment,
                                owner INT(10) NOT NULL default 0,
                                subject VARCHAR(120) NOT NULL default '',
                                message TEXT,
                                sender VARCHAR(120) NOT NULL default '',
                                sender_id INT(10) NOT NULL default 0,
                                posted INT(10) NOT NULL default 0,
                                sender_ip VARCHAR(120) default NULL,
                                smileys tinyint(4) default 1,
                                status tinyint(4) default 0,
                                showed tinyint(4) default 0,
                                PRIMARY KEY (id)
                        ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "messages (
                                id SERIAL,
                                owner INT(10) NOT NULL default 0,
                                subject VARCHAR(120) NOT NULL default '',
                                message TEXT,
                                sender VARCHAR(120) NOT NULL default '',
                                sender_id INT(10) NOT NULL default 0,
                                posted INT(10) NOT NULL default 0,
                                sender_ip VARCHAR(120) default NULL,
                                smileys SMALLINT(4) default 1,
                                status SMALLINT(4) default 0,
                                showed SMALLINT(4) default 0,
                                PRIMARY KEY (id)
                        )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "messages (
                                id INTEGER NOT NULL,
                                owner INTEGER NOT NULL default 0,
                                subject VARCHAR(120) NOT NULL default '',
                                message TEXT,
                                sender VARCHAR(120) NOT NULL default '',
                                sender_id INTEGER NOT NULL default 0,
                                posted INTEGER NOT NULL default 0,
                                sender_ip VARCHAR(120) default NULL,
                                smileys INTEGER default 1,
                                status INTEGER default 0,
                                showed INTEGER default 0,
                                PRIMARY KEY (id)
                        )";
            break;
    }
    $db->query($sql) or BB_Functions::Error('Unable to create table ' . $db_prefix . 'messages. Please check your settings and try again.', __FILE__, __LINE__, $db->error());
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "online (
                                user_id INT(10) UNSIGNED NOT NULL DEFAULT 1,
                                ident VARCHAR(200) NOT NULL DEFAULT '',
                                logged INT(10) UNSIGNED NOT NULL DEFAULT 0,
                                idle TINYINT(1) NOT NULL DEFAULT 0,
                                color varchar(10) NOT NULL default '',
                                current_page varchar(100) default NULL,
                                current_page_id int(10) default NULL,
                                current_ip varchar(20) default NULL,
                                invisible tinyint(1) NOT NULL default 0
                        ) TYPE=HEAP;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "online (
                                user_id INT NOT NULL DEFAULT 1,
                                ident VARCHAR(200) NOT NULL DEFAULT '',
                                logged INT NOT NULL DEFAULT 0,
                                idle SMALLINT NOT NULL DEFAULT 0,
                                color VARCHAR(10) NOT NULL default '',
                                current_page VARCHAR(100) default NULL,
                                current_page_id INT(10) default NULL,
                                current_ip VARCHAR(20) default NULL,
                                invisible SMALLINT NOT NULL DEFAULT 0
                        )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "online (
                                user_id INTEGER NOT NULL DEFAULT 1,
                                ident VARCHAR(200) NOT NULL DEFAULT '',
                                logged INTEGER NOT NULL DEFAULT 0,
                                idle INTEGER NOT NULL DEFAULT 0,
                                color VARCHAR(10) NOT NULL default '',
                                current_page VARCHAR(100) default NULL,
                                current_page_id INTEGER default NULL,
                                current_ip VARCHAR(20) default NULL,
                                invisible INTEGER NOT NULL default '0'
                        )";
            break;
    }
    $db->query($sql) or BB_Functions::Error('Unable to create table ' . $db_prefix . 'online. Please check your settings and try again.', __FILE__, __LINE__, $db->error());
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "module_news (
                                id INT(11) NOT NULL auto_increment,
                                position INT(11) NOT NULL default 0,
                                title varchar(150) NOT NULL,
                                body longtext NOT NULL,
                                PRIMARY KEY (id)
                        ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "module_news (
                                id SERIAL,
                                position INT(11) NOT NULL default 0,
                                title TEXT NOT NULL,
                                body TEXT NOT NULL,
                                PRIMARY KEY (id)
                        )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "module_news (
                                id INTEGER NOT NULL,
                                position INTEGER  NOT NULL default 0,
                                title TEXT NOT NULL,
                                body TEXT NOT NULL,
                                PRIMARY KEY (id)
                        )";
            break;
    }
    $db->query($sql) or BB_Functions::Error('Unable to create table ' . $db_prefix . 'module_news. Please check your settings and try again.', __FILE__, __LINE__, $db->error());
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "polls (
                                id INT(11) NOT NULL auto_increment,
                                pollid INT(11) NOT NULL default 0,
                                options longtext NOT NULL,
                                voters longtext NOT NULL,
                                ptype tinyint(4) NOT NULL default 0,
                                votes longtext NOT NULL,
                                PRIMARY KEY (id)
                        ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "polls (
                                id SERIAL,
                                pollid INT(11) NOT NULL default 0,
                                options TEXT NOT NULL,
                                voters TEXT NOT NULL,
                                ptype SMALLINT(4) NOT NULL default 0,
                                votes TEXT NOT NULL,
                                PRIMARY KEY (id)
                        )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "polls (
                                id INTEGER NOT NULL,
                                pollid INTEGER  NOT NULL default 0,
                                options TEXT NOT NULL,
                                voters TEXT NOT NULL,
                                ptype INTEGER NOT NULL default 0,
                                votes TEXT NOT NULL,
                                PRIMARY KEY (id)
                        )";
            break;
    }
    $db->query($sql) or BB_Functions::Error('Unable to create table ' . $db_prefix . 'polls. Please check your settings and try again.', __FILE__, __LINE__, $db->error());
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "posts (
                                id INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
                                poster VARCHAR(200) NOT NULL DEFAULT '',
                                poster_id INT(10) UNSIGNED NOT NULL DEFAULT 1,
                                poster_ip VARCHAR(15),
                                poster_email VARCHAR(50),
                                message TEXT NOT NULL DEFAULT '',
                                hide_smilies TINYINT(1) NOT NULL DEFAULT 0,
                                posted INT(10) UNSIGNED NOT NULL DEFAULT 0,
                                edited INT(10) UNSIGNED,
                                edited_by VARCHAR(200),
                                topic_id INT(10) UNSIGNED NOT NULL DEFAULT 0,
                                PRIMARY KEY  (id)
                        ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "posts (
                                id SERIAL,
                                poster VARCHAR(200) NOT NULL DEFAULT '',
                                poster_id INT NOT NULL DEFAULT 1,
                                poster_ip VARCHAR(15),
                                poster_email VARCHAR(50),
                                message TEXT NOT NULL DEFAULT '',
                                hide_smilies SMALLINT NOT NULL DEFAULT 0,
                                posted INT NOT NULL DEFAULT 0,
                                edited INT,
                                edited_by VARCHAR(200),
                                topic_id INT NOT NULL DEFAULT 0,
                                PRIMARY KEY  (id)
                        )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "posts (
                                id INTEGER NOT NULL,
                                poster VARCHAR(200) NOT NULL DEFAULT '',
                                poster_id INTEGER NOT NULL DEFAULT 1,
                                poster_ip VARCHAR(15),
                                poster_email VARCHAR(50),
                                message TEXT NOT NULL DEFAULT '',
                                hide_smilies INTEGER NOT NULL DEFAULT 0,
                                posted INTEGER NOT NULL DEFAULT 0,
                                edited INTEGER,
                                edited_by VARCHAR(200),
                                topic_id INTEGER NOT NULL DEFAULT 0,
                                PRIMARY KEY  (id)
                        )";
            break;
    }
    $db->query($sql) or BB_Functions::Error('Unable to create table ' . $db_prefix . 'posts. Please check your settings and try again.', __FILE__, __LINE__, $db->error());
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "profile_fields (
                                id int(6) unsigned NOT NULL auto_increment,
                                name VARCHAR(255) NOT NULL,
                                lang_entry VARCHAR(255) default NULL,
                                PRIMARY KEY(id)
                        ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "profile_fields (
                                id SERIAL,
                                name VARCHAR(255) NOT NULL,
                                lang_entry varchar(255) default NULL,
                                PRIMARY KEY(id)
                        )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "profile_fields (
                                id INTEGER NOT NULL,
                                name VARCHAR(255) NOT NULL,
                                lang_entry VARCHAR(255) default NULL,
                                PRIMARY KEY(id)
                        )";
            break;
    }
    $db->query($sql) or BB_Functions::Error('Unable to create table ' . $db_prefix . 'profile_fields. Please check your settings and try again.', __FILE__, __LINE__, $db->error());
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "profile_field_entries (
                                e_id INT(6) NOT NULL auto_increment,
                                f_id INT(6) NOT NULL,
                                value VARCHAR(255) default NULL,
                                u_id INT(6) NOT NULL,
                                PRIMARY KEY(e_id)
                        ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "profile_field_entries (
                                e_id SERIAL,
                                f_id INT NOT NULL,
                                value VARCHAR(255) default NULL,
                                u_id INT NOT NULL,
                                PRIMARY KEY(e_id)
                        )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "profile_field_entries (
                                e_id INTEGER NOT NULL,
                                f_id INTEGER NOT NULL,
                                value VARCHAR(255) default NULL,
                                u_id INTEGER NOT NULL,
                                PRIMARY KEY(e_id)
                        )";
            break;
    }
    $db->query($sql) or BB_Functions::Error('Unable to create table ' . $db_prefix . 'profile_field_entries. Please check your settings and try again.', __FILE__, __LINE__, $db->error());
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "ranks (
                                id INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
                                rank VARCHAR(50) NOT NULL DEFAULT '',
                                min_posts MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT 0,
                                PRIMARY KEY (id)
                        ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "ranks (
                                id SERIAL,
                                rank VARCHAR(50) NOT NULL DEFAULT '',
                                min_posts INT NOT NULL DEFAULT 0,
                                PRIMARY KEY (id)
                        )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "ranks (
                                id INTEGER NOT NULL,
                                rank VARCHAR(50) NOT NULL DEFAULT '',
                                min_posts INTEGER NOT NULL DEFAULT 0,
                                PRIMARY KEY (id)
                        )";
            break;
    }
    $db->query($sql) or BB_Functions::Error('Unable to create table ' . $db_prefix . 'titles. Please check your settings and try again.', __FILE__, __LINE__, $db->error());
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "reports (
                                id INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
                                post_id INT(10) UNSIGNED NOT NULL DEFAULT 0,
                                topic_id INT(10) UNSIGNED NOT NULL DEFAULT 0,
                                forum_id INT(10) UNSIGNED NOT NULL DEFAULT 0,
                                reported_by INT(10) UNSIGNED NOT NULL DEFAULT 0,
                                created INT(10) UNSIGNED NOT NULL DEFAULT 0,
                                message TEXT NOT NULL DEFAULT '',
                                zapped INT(10) UNSIGNED,
                                zapped_by INT(10) UNSIGNED,
                                PRIMARY KEY (id)
                        ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "reports (
                                id SERIAL,
                                post_id INT NOT NULL DEFAULT 0,
                                topic_id INT NOT NULL DEFAULT 0,
                                forum_id INT NOT NULL DEFAULT 0,
                                reported_by INT NOT NULL DEFAULT 0,
                                created INT NOT NULL DEFAULT 0,
                                message TEXT NOT NULL DEFAULT '',
                                zapped INT,
                                zapped_by INT,
                                PRIMARY KEY (id)
                        )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "reports (
                                id INTEGER NOT NULL,
                                post_id INTEGER NOT NULL DEFAULT 0,
                                topic_id INTEGER NOT NULL DEFAULT 0,
                                forum_id INTEGER NOT NULL DEFAULT 0,
                                reported_by INTEGER NOT NULL DEFAULT 0,
                                created INTEGER NOT NULL DEFAULT 0,
                                message TEXT NOT NULL DEFAULT '',
                                zapped INTEGER,
                                zapped_by INTEGER,
                                PRIMARY KEY (id)
                        )";
            break;
    }
    $db->query($sql) or BB_Functions::Error('Unable to create table ' . $db_prefix . 'reports. Please check your settings and try again.', __FILE__, __LINE__, $db->error());
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "reputation (
                                id int(10) NOT NULL AUTO_INCREMENT,
                                user_id int(10) NOT NULL default 0,
                                from_user_id int(10) NOT NULL default 0,
                                time int(10) NOT NULL default 0,
                                post_id int(10) NOT NULL default 0,
                                reason text NOT NULL,
                                rep_plus tinyint(1) NOT NULL default 0,
                                rep_minus tinyint(1) NOT NULL default 0,
                                topics_id int(10) NOT NULL default 0,
                                PRIMARY KEY (id)
                        ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "reputation (
                                id SERIAL,
                                user_id INT NOT NULL default 0,
                                from_user_id INT NOT NULL default 0,
                                time INT NOT NULL default 0,
                                post_id INT NOT NULL default 0,
                                reason text NOT NULL,
                                rep_plus SMALLINT NOT NULL default 0,
                                rep_minus SMALLINT NOT NULL default 0,
                                topics_id INT NOT NULL default 0,
                                PRIMARY KEY (id)
                        )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "reputation (
                                id INTEGER NOT NULL,
                                user_id INTEGER NOT NULL default 0,
                                from_user_id INTEGER NOT NULL default 0,
                                time INTEGER NOT NULL default 0,
                                post_id INTEGER NOT NULL default 0,
                                reason text NOT NULL,
                                rep_plus INTEGER NOT NULL default 0,
                                rep_minus INTEGER NOT NULL default 0,
                                topics_id INTEGER NOT NULL default 0,
                                PRIMARY KEY (id)
                        )";
            break;
    }
    $db->query($sql) or BB_Functions::Error('Unable to create table ' . $db_prefix . 'reputation. Please check your settings and try again.', __FILE__, __LINE__, $db->error());
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "search_cache (
                                id INT(10) UNSIGNED NOT NULL DEFAULT 0,
                                ident VARCHAR(200) NOT NULL DEFAULT '',
                                search_data TEXT NOT NULL DEFAULT '',
                                PRIMARY KEY (id)
                        ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "search_cache (
                                id INT NOT NULL DEFAULT 0,
                                ident VARCHAR(200) NOT NULL DEFAULT '',
                                search_data TEXT NOT NULL DEFAULT '',
                                PRIMARY KEY (id)
                        )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "search_cache (
                                id INTEGER NOT NULL DEFAULT 0,
                                ident VARCHAR(200) NOT NULL DEFAULT '',
                                search_data TEXT NOT NULL DEFAULT '',
                                PRIMARY KEY (id)
                        )";
            break;
    }
    $db->query($sql) or BB_Functions::Error('Unable to create table ' . $db_prefix . 'search_cache. Please check your settings and try again.', __FILE__, __LINE__, $db->error());
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "search_matches (
                                post_id INT(10) UNSIGNED NOT NULL DEFAULT 0,
                                word_id MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT 0,
                                subject_match TINYINT(1) NOT NULL DEFAULT 0
                        ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "search_matches (
                                post_id INT NOT NULL DEFAULT 0,
                                word_id INT NOT NULL DEFAULT 0,
                                subject_match SMALLINT NOT NULL DEFAULT 0
                        )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "search_matches (
                                post_id INTEGER NOT NULL DEFAULT 0,
                                word_id INTEGER NOT NULL DEFAULT 0,
                                subject_match INTEGER NOT NULL DEFAULT 0
                        )";
            break;
    }
    $db->query($sql) or BB_Functions::Error('Unable to create table ' . $db_prefix . 'search_matches. Please check your settings and try again.', __FILE__, __LINE__, $db->error());
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "search_words (
                                id MEDIUMINT(8) UNSIGNED NOT NULL AUTO_INCREMENT,
                                word VARCHAR(20) BINARY NOT NULL DEFAULT '',
                                PRIMARY KEY (word),
                                KEY " . $db_prefix . "search_words_id_idx (id)
                        ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "search_words (
                                id SERIAL,
                                word VARCHAR(20) NOT NULL DEFAULT '',
                                PRIMARY KEY (word)
                        )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "search_words (
                                id INTEGER NOT NULL,
                                word VARCHAR(20) NOT NULL DEFAULT '',
                                PRIMARY KEY (id),
                                UNIQUE (word)
                        )";
            break;
    }
    $db->query($sql) or BB_Functions::Error('Unable to create table ' . $db_prefix . 'search_words. Please check your settings and try again.', __FILE__, __LINE__, $db->error());
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "smilies (
                                id int(10) unsigned NOT NULL auto_increment,
                                image varchar(60) NOT NULL default '',
                                text varchar(60) NOT NULL default '',
                                disp_position int(10) NOT NULL default 0,
                                PRIMARY KEY (id)
                        ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "smilies (
                                id SERIAL,
                                image varchar(60) NOT NULL default '',
                                text varchar(60) NOT NULL default '',
                                disp_position int(10) NOT NULL default 0,
                                PRIMARY KEY (id)
                        )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "smilies (
                                id INTEGER NOT NULL,
                                image VARCHAR(60) NOT NULL default '',
                                text VARCHAR(60) NOT NULL default '',
                                disp_position INTEGER NOT NULL default 0,
                                PRIMARY KEY (id)
                        )";
            break;
    }
    $db->query($sql) or BB_Functions::Error('Unable to create table ' . $db_prefix . 'smilies. Please check your settings and try again.', __FILE__, __LINE__, $db->error());
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "spam_protect (
                                ip VARCHAR(15) NOT NULL,
                                time INT(10) NOT NULL,
                                blocked TINYINT(1) NOT NULL,
                                total TINYINT(2) NULL,
                                PRIMARY KEY (ip)
                        ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "spam_protect (
                                ip VARCHAR(15) NOT NULL,
                                time INT(10) NOT NULL,
                                blocked SMALLINT NOT NULL,
                                total SMALLINT NULL,
                                PRIMARY KEY (ip)
                        )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "spam_protect (
                                ip VARCHAR(15) NOT NULL,
                                time INTEGER NOT NULL,
                                blocked INTEGER NOT NULL,
                                total INTEGER NULL,
                                PRIMARY KEY (ip)
                        )";
            break;
    }
    $db->query($sql) or BB_Functions::Error('Unable to create table ' . $db_prefix . 'spam_protect. Please check your settings and try again.', __FILE__, __LINE__, $db->error());
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "subscriptions (
                                user_id INT(10) UNSIGNED NOT NULL DEFAULT 0,
                                topic_id INT(10) UNSIGNED NOT NULL DEFAULT 0,
                                PRIMARY KEY (user_id, topic_id)
                        ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "subscriptions (
                                user_id INT NOT NULL DEFAULT 0,
                                topic_id INT NOT NULL DEFAULT 0,
                                PRIMARY KEY (user_id, topic_id)
                        )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "subscriptions (
                                user_id INTEGER NOT NULL DEFAULT 0,
                                topic_id INTEGER NOT NULL DEFAULT 0,
                                PRIMARY KEY (user_id, topic_id)
                        )";
            break;
    }
    $db->query($sql) or BB_Functions::Error('Unable to create table ' . $db_prefix . 'subscriptions. Please check your settings and try again.', __FILE__, __LINE__, $db->error());
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "topics (
                                id INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
                                poster VARCHAR(200) NOT NULL DEFAULT '',
                                subject VARCHAR(255) NOT NULL DEFAULT '',
                                tags VARCHAR(64) NULL,
                                posted INT(10) UNSIGNED NOT NULL DEFAULT 0,
                                last_post INT(10) UNSIGNED NOT NULL DEFAULT 0,
                                last_post_id INT(10) UNSIGNED NOT NULL DEFAULT 0,
                                last_poster VARCHAR(200),
                                num_views MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT 0,
                                num_replies MEDIUMINT(8) UNSIGNED NOT NULL DEFAULT 0,
                                closed TINYINT(1) NOT NULL DEFAULT 0,
                                sticky TINYINT(1) NOT NULL DEFAULT 0,
                                moved_to INT(10) UNSIGNED,
                                forum_id INT(10) UNSIGNED NOT NULL DEFAULT 0,
                                question varchar(255) NOT NULL default '',
                                yes varchar(30) NOT NULL default '',
                                no varchar(30) NOT NULL default '',
                                icon_topic TINYINT(1) NOT NULL default 0,
                                rating INT(10) UNSIGNED NOT NULL DEFAULT 0,
                                rating_votes INT(10) NOT NULL DEFAULT 0,
                                PRIMARY KEY (id)
                        ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "topics (
                                id SERIAL,
                                poster VARCHAR(200) NOT NULL DEFAULT '',
                                subject VARCHAR(255) NOT NULL DEFAULT '',
                                tags VARCHAR(64) NULL,
                                posted INT NOT NULL DEFAULT 0,
                                last_post INT NOT NULL DEFAULT 0,
                                last_post_id INT NOT NULL DEFAULT 0,
                                last_poster VARCHAR(200),
                                num_views INT NOT NULL DEFAULT 0,
                                num_replies INT NOT NULL DEFAULT 0,
                                closed SMALLINT NOT NULL DEFAULT 0,
                                sticky SMALLINT NOT NULL DEFAULT 0,
                                moved_to INT,
                                forum_id INT NOT NULL DEFAULT 0,
                                question varchar(255) NOT NULL default '',
                                yes varchar(30) NOT NULL default '',
                                no varchar(30) NOT NULL default '',
                                icon_topic SMALLINT(1) NOT NULL default 0,
                                rating INT NOT NULL DEFAULT 0,
                                rating_votes INT NOT NULL DEFAULT 0,
                                PRIMARY KEY (id)
                        )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "topics (
                                id INTEGER NOT NULL,
                                poster VARCHAR(200) NOT NULL DEFAULT '',
                                subject VARCHAR(255) NOT NULL DEFAULT '',
                                tags VARCHAR(64) NULL,
                                posted INTEGER NOT NULL DEFAULT 0,
                                last_post INTEGER NOT NULL DEFAULT 0,
                                last_post_id INTEGER NOT NULL DEFAULT 0,
                                last_poster VARCHAR(200),
                                num_views INTEGER NOT NULL DEFAULT 0,
                                num_replies INTEGER NOT NULL DEFAULT 0,
                                closed INTEGER NOT NULL DEFAULT 0,
                                sticky INTEGER NOT NULL DEFAULT 0,
                                moved_to INTEGER,
                                forum_id INTEGER NOT NULL DEFAULT 0,
                                question VARCHAR(255) NOT NULL default '',
                                yes VARCHAR(30) NOT NULL default '',
                                no VARCHAR(30) NOT NULL default '',
                                icon_topic INTEGER NOT NULL default 0,
                                rating INTEGER NOT NULL DEFAULT 0,
                                rating_votes INTEGER NOT NULL DEFAULT 0,
                                PRIMARY KEY (id)
                        )";
            break;
    }
    $db->query($sql) or BB_Functions::Error('Unable to create table ' . $db_prefix . 'topics. Please check your settings and try again.', __FILE__, __LINE__, $db->error());
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "usergroups (
                                        g_id INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
                                        g_title VARCHAR(50) NOT NULL DEFAULT '',
                                        g_user_title VARCHAR(50),
                                        g_read_board TINYINT(1) NOT NULL DEFAULT 1,
                                        g_post_replies TINYINT(1) NOT NULL DEFAULT 1,
                                        g_post_topics TINYINT(1) NOT NULL DEFAULT 1,
                                        g_post_polls TINYINT(1) NOT NULL DEFAULT 1,
                                        g_edit_posts TINYINT(1) NOT NULL DEFAULT 1,
                                        g_delete_posts TINYINT(1) NOT NULL DEFAULT 1,
                                        g_delete_topics TINYINT(1) NOT NULL DEFAULT 1,
                                        g_set_title TINYINT(1) NOT NULL DEFAULT 1,
                                        g_search TINYINT(1) NOT NULL DEFAULT 1,
                                        g_search_users TINYINT(1) NOT NULL DEFAULT 1,
                                        g_edit_subjects_interval SMALLINT(6) NOT NULL DEFAULT 300,
                                        g_post_flood SMALLINT(6) NOT NULL DEFAULT 30,
                                        g_search_flood SMALLINT(6) NOT NULL DEFAULT 30,
                                        g_color varchar(10) NOT NULL default '',
                                        g_view_users tinyint(1) NOT NULL default 1,
                                        g_chat tinyint(4) NOT NULL default 1,
                                        g_pm int(11) NOT NULL default 1,
                                        g_pm_limit int(11) NOT NULL default 20,
                                        g_invitations int(11) NOT NULL default 0,
                                        g_rep_minus_min INT(10) UNSIGNED DEFAULT 0,
                                        g_rep_plus_min INT(10) UNSIGNED DEFAULT 0,
                                        g_rep_enable SMALLINT DEFAULT 1,
                                        g_global_moderation TINYINT(1) NOT NULL DEFAULT 0,
                                        PRIMARY KEY (g_id)
                                        ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "usergroups (
                                        g_id SERIAL,
                                        g_title VARCHAR(50) NOT NULL DEFAULT '',
                                        g_user_title VARCHAR(50),
                                        g_read_board SMALLINT NOT NULL DEFAULT 1,
                                        g_post_replies SMALLINT NOT NULL DEFAULT 1,
                                        g_post_topics SMALLINT NOT NULL DEFAULT 1,
                                        g_post_polls SMALLINT NOT NULL DEFAULT 1,
                                        g_edit_posts SMALLINT NOT NULL DEFAULT 1,
                                        g_delete_posts SMALLINT NOT NULL DEFAULT 1,
                                        g_delete_topics SMALLINT NOT NULL DEFAULT 1,
                                        g_set_title SMALLINT NOT NULL DEFAULT 1,
                                        g_search SMALLINT NOT NULL DEFAULT 1,
                                        g_search_users SMALLINT NOT NULL DEFAULT 1,
                                        g_edit_subjects_interval SMALLINT NOT NULL DEFAULT 300,
                                        g_post_flood SMALLINT NOT NULL DEFAULT 30,
                                        g_search_flood SMALLINT NOT NULL DEFAULT 30,
                                        g_color VARCHAR(10) NOT NULL default '',
                                        g_view_users SMALLINT(1) NOT NULL default 1,
                                        g_chat SMALLINT(4) NOT NULL default 1,
                                        g_pm INTEGER(11) NOT NULL default 1,
                                        g_pm_limit INTEGER(11) NOT NULL default 20,
                                        g_invitations INTEGER(11) NOT NULL default 0,
                                        g_rep_minus_min INTEGER(10) UNSIGNED DEFAULT 0,
                                        g_rep_plus_min INTEGER(10) UNSIGNED DEFAULT 0,
                                        g_rep_enable SMALLINT DEFAULT 1,
                                        g_global_moderation SMALLINT NOT NULL DEFAULT 0,
                                        PRIMARY KEY (g_id)
                                        )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "usergroups (
                                        g_id INTEGER NOT NULL,
                                        g_title VARCHAR(50) NOT NULL DEFAULT '',
                                        g_user_title VARCHAR(50),
                                        g_read_board INTEGER NOT NULL DEFAULT 1,
                                        g_post_replies INTEGER NOT NULL DEFAULT 1,
                                        g_post_topics INTEGER NOT NULL DEFAULT 1,
                                        g_post_polls INTEGER NOT NULL DEFAULT 1,
                                        g_edit_posts INTEGER NOT NULL DEFAULT 1,
                                        g_delete_posts INTEGER NOT NULL DEFAULT 1,
                                        g_delete_topics INTEGER NOT NULL DEFAULT 1,
                                        g_set_title INTEGER NOT NULL DEFAULT 1,
                                        g_search INTEGER NOT NULL DEFAULT 1,
                                        g_search_users INTEGER NOT NULL DEFAULT 1,
                                        g_edit_subjects_interval INTEGER NOT NULL DEFAULT 300,
                                        g_post_flood INTEGER NOT NULL DEFAULT 30,
                                        g_search_flood INTEGER NOT NULL DEFAULT 30,
                                        g_color VARCHAR(10) NOT NULL default '',
                                        g_view_users INTEGER NOT NULL default 1,
                                        g_chat INTEGER NOT NULL default 1,
                                        g_pm INTEGER NOT NULL default 1,
                                        g_pm_limit INTEGER NOT NULL default 20,
                                        g_invitations INTEGER NOT NULL default 0,
                                        g_rep_minus_min INTEGER UNSIGNED DEFAULT 0,
                                        g_rep_plus_min INTEGER UNSIGNED DEFAULT 0,
                                        g_rep_enable INTEGER DEFAULT 1,
                                        g_global_moderation INTEGER NOT NULL DEFAULT 0,
                                        PRIMARY KEY (g_id)
                                        )";
            break;
    }
    $db->query($sql) or BB_Functions::Error('Unable to create table ' . $db_prefix . 'usergroups. Please check your settings and try again.', __FILE__, __LINE__, $db->error());
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $sql = 'CREATE TABLE ' . $db_prefix . "users (
                                        id INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
                                        gid INT(10) UNSIGNED NOT NULL DEFAULT 4,
                                        username VARCHAR(200) NOT NULL DEFAULT '',
                                        password VARCHAR(40) NOT NULL DEFAULT '',
                                        email VARCHAR(50) NOT NULL DEFAULT '',
                                        title VARCHAR(50),
                                        realname VARCHAR(40),
                                        url VARCHAR(100),
                                        jabber VARCHAR(75),
                                        icq VARCHAR(12),
                                        msn VARCHAR(50),
                                        aim VARCHAR(30),
                                        yahoo VARCHAR(30),
                                        gtalk VARCHAR(30),
                                        skype VARCHAR(30),
                                        xfire VARCHAR(50),
                                        location VARCHAR(30),
                                        use_avatar TINYINT(1) NOT NULL DEFAULT 0,
                                        signature TEXT,
                                        disp_topics TINYINT(3) UNSIGNED,
                                        disp_posts TINYINT(3) UNSIGNED,
                                        email_setting TINYINT(1) NOT NULL DEFAULT 1,
                                        save_pass TINYINT(1) NOT NULL DEFAULT 1,
                                        notify_with_post TINYINT(1) NOT NULL DEFAULT 0,
                                        show_smilies TINYINT(1) NOT NULL DEFAULT 1,
                                        show_img TINYINT(1) NOT NULL DEFAULT 1,
                                        show_img_sig TINYINT(1) NOT NULL DEFAULT 1,
                                        show_avatars TINYINT(1) NOT NULL DEFAULT 1,
                                        show_sig TINYINT(1) NOT NULL DEFAULT 1,
                                        new_window_link TINYINT(1) NOT NULL DEFAULT 1,
                                        timezone FLOAT NOT NULL DEFAULT 0,
                                        language VARCHAR(25) NOT NULL DEFAULT 'English',
                                        template VARCHAR(25) NOT NULL DEFAULT 'Default',
                                        num_posts INT(10) UNSIGNED NOT NULL DEFAULT 0,
                                        last_post INT(10) UNSIGNED,
                                        registered INT(10) UNSIGNED NOT NULL DEFAULT 0,
                                        registration_ip VARCHAR(15) NOT NULL DEFAULT '0.0.0.0',
                                        last_visit INT(10) UNSIGNED NOT NULL DEFAULT 0,
                                        admin_note VARCHAR(30),
                                        activate_string VARCHAR(50),
                                        activate_key VARCHAR(8),
                                        birthday varchar(10) NOT NULL default '0-0-0',
                                        read_topics mediumtext,
                                        sex varchar(10) default NULL,
                                        latitude varchar(100) default NULL,
                                        longitude varchar(100) default NULL,
                                        country varchar(40) default NULL,
                                        reverse_posts TINYINT(1) NOT NULL default 0,
                                        referral_count INT(10) DEFAULT 0,
                                        email_alert tinyint(1) NOT NULL default 0,
                                        absent tinyint(1) NOT NULL default 0,
                                        absence_message varchar(100) NOT NULL default '',
                                        invisible tinyint(1) NOT NULL default 0,
                                        reputation_enable TINYINT(1) NOT NULL default 1,
                                        reputation_enable_adm TINYINT(1) NOT NULL DEFAULT 1,
                                        quicklinks varchar(100) NOT NULL default 'bottom',
                                        PRIMARY KEY  (id)
                                        ) TYPE=MyISAM;";
            break;
        case 'pgsql':
            $sql = 'CREATE TABLE ' . $db_prefix . "users (
                                        id SERIAL,
                                        gid INT NOT NULL DEFAULT 4,
                                        username VARCHAR(200) NOT NULL DEFAULT '',
                                        password VARCHAR(40) NOT NULL DEFAULT '',
                                        email VARCHAR(50) NOT NULL DEFAULT '',
                                        title VARCHAR(50),
                                        realname VARCHAR(40),
                                        url VARCHAR(100),
                                        jabber VARCHAR(75),
                                        icq VARCHAR(12),
                                        msn VARCHAR(50),
                                        aim VARCHAR(30),
                                        yahoo VARCHAR(30),
                                        gtalk VARCHAR(30),
                                        skype VARCHAR(30),
                                        xfire VARCHAR(50),
                                        location VARCHAR(30),
                                        use_avatar SMALLINT NOT NULL DEFAULT 0,
                                        signature TEXT,
                                        disp_topics SMALLINT,
                                        disp_posts SMALLINT,
                                        email_setting SMALLINT NOT NULL DEFAULT 1,
                                        save_pass SMALLINT NOT NULL DEFAULT 1,
                                        notify_with_post SMALLINT NOT NULL DEFAULT 0,
                                        show_smilies SMALLINT NOT NULL DEFAULT 1,
                                        show_img SMALLINT NOT NULL DEFAULT 1,
                                        show_img_sig SMALLINT NOT NULL DEFAULT 1,
                                        show_avatars SMALLINT NOT NULL DEFAULT 1,
                                        show_sig SMALLINT NOT NULL DEFAULT 1,
                                        new_window_link SMALLINT NOT NULL DEFAULT 1,
                                        timezone REAL NOT NULL DEFAULT 0,
                                        language VARCHAR(25) NOT NULL DEFAULT 'English',
                                        template VARCHAR(25) NOT NULL DEFAULT 'Default',
                                        num_posts INT NOT NULL DEFAULT 0,
                                        last_post INT,
                                        registered INT NOT NULL DEFAULT 0,
                                        registration_ip VARCHAR(15) NOT NULL DEFAULT '0.0.0.0',
                                        last_visit INT NOT NULL DEFAULT 0,
                                        admin_note VARCHAR(30),
                                        activate_string VARCHAR(50),
                                        activate_key VARCHAR(8),
                                        birthday varchar(10) NOT NULL default '0-0-0',
                                        read_topics mediumtext,
                                        sex varchar(10) default NULL,
                                        latitude varchar(100) default NULL,
                                        longitude varchar(100) default NULL,
                                        country varchar(40) default NULL,
                                        reverse_posts SMALLINT(1) NOT NULL default 0,
                                        referral_count INT(10) DEFAULT 0,
                                        email_alert SMALLINT(1) NOT NULL default 0,
                                        absent SMALLINT(1) NOT NULL default 0,
                                        absence_message varchar(100) NOT NULL default '',
                                        invisible SMALLINT(1) NOT NULL default 0,
                                        reputation_enable SMALLINT(1) NOT NULL default 1,
                                        reputation_enable_adm TSMALLINT(1) NOT NULL DEFAULT 1,
                                        quicklinks varchar(10) NOT NULL default 'bottom',
                                        PRIMARY KEY (id)
                                        )";
            break;
        case 'sqlite':
            $sql = 'CREATE TABLE ' . $db_prefix . "users (
                                        id INTEGER NOT NULL,
                                        gid INTEGER NOT NULL DEFAULT 4,
                                        username VARCHAR(200) NOT NULL DEFAULT '',
                                        password VARCHAR(40) NOT NULL DEFAULT '',
                                        email VARCHAR(50) NOT NULL DEFAULT '',
                                        title VARCHAR(50),
                                        realname VARCHAR(40),
                                        url VARCHAR(100),
                                        jabber VARCHAR(75),
                                        icq VARCHAR(12),
                                        msn VARCHAR(50),
                                        aim VARCHAR(30),
                                        yahoo VARCHAR(30),
                                        gtalk VARCHAR(30),
                                        skype VARCHAR(30),
                                        xfire VARCHAR(50),
                                        location VARCHAR(30),
                                        use_avatar INTEGER NOT NULL DEFAULT 0,
                                        signature TEXT,
                                        disp_topics INTEGER,
                                        disp_posts INTEGER,
                                        email_setting INTEGER NOT NULL DEFAULT 1,
                                        save_pass INTEGER NOT NULL DEFAULT 1,
                                        notify_with_post INTEGER NOT NULL DEFAULT 0,
                                        show_smilies INTEGER NOT NULL DEFAULT 1,
                                        show_img INTEGER NOT NULL DEFAULT 1,
                                        show_img_sig INTEGER NOT NULL DEFAULT 1,
                                        show_avatars INTEGER NOT NULL DEFAULT 1,
                                        show_sig INTEGER NOT NULL DEFAULT 1,
                                        new_window_link INTEGER NOT NULL DEFAULT 1,
                                        timezone FLOAT NOT NULL DEFAULT 0,
                                        language VARCHAR(25) NOT NULL DEFAULT 'English',
                                        template VARCHAR(25) NOT NULL DEFAULT 'Default',
                                        num_posts INTEGER NOT NULL DEFAULT 0,
                                        last_post INTEGER,
                                        registered INTEGER NOT NULL DEFAULT 0,
                                        registration_ip VARCHAR(15) NOT NULL DEFAULT '0.0.0.0',
                                        last_visit INTEGER NOT NULL DEFAULT 0,
                                        admin_note VARCHAR(30),
                                        activate_string VARCHAR(50),
                                        activate_key VARCHAR(8),
                                        birthday varchar(10) NOT NULL default '0-0-0',
                                        read_topics TEXT,
                                        sex VARCHAR(10) default NULL,
                                        latitude VARCHAR(100) default NULL,
                                        longitude VARCHAR(100) default NULL,
                                        country VARCHAR(40) default NULL,
                                        reverse_posts INTEGER NOT NULL default 0,
                                        referral_count INTEGER DEFAULT 0,
                                        email_alert INTEGER NOT NULL default 0,
                                        absent INTEGER NOT NULL default 0,
                                        absence_message VARCHAR(100) NOT NULL default '',
                                        invisible INTEGER NOT NULL default 0,
                                        reputation_enable INTEGER NOT NULL default 1,
                                        reputation_enable_adm INTEGER NOT NULL DEFAULT 1,
                                        quicklinks VARCHAR(10) NOT NULL default 'bottom',
                                        PRIMARY KEY (id)
                                        )";
            break;
    }
    $db->query($sql) or BB_Functions::Error('Unable to create table ' . $db_prefix . 'users. Please check your settings and try again.', __FILE__, __LINE__, $db->error());
    switch ($db_type)
    {
        case 'mysql':
        case 'mysqli':
            $queries[] = 'ALTER TABLE ' . $db_prefix . 'online ADD INDEX ' . $db_prefix . 'online_user_id_idx(user_id)';
            $queries[] = 'ALTER TABLE ' . $db_prefix . 'posts ADD INDEX ' . $db_prefix . 'posts_topic_id_idx(topic_id)';
            $queries[] = 'ALTER TABLE ' . $db_prefix . 'posts ADD INDEX ' . $db_prefix . 'posts_multi_idx(poster_id, topic_id)';
            $queries[] = 'ALTER TABLE ' . $db_prefix . 'reports ADD INDEX ' . $db_prefix . 'reports_zapped_idx(zapped)';
            $queries[] = 'ALTER TABLE ' . $db_prefix . 'search_matches ADD INDEX ' . $db_prefix . 'search_matches_word_id_idx(word_id)';
            $queries[] = 'ALTER TABLE ' . $db_prefix . 'search_matches ADD INDEX ' . $db_prefix . 'search_matches_post_id_idx(post_id)';
            $queries[] = 'ALTER TABLE ' . $db_prefix . 'topics ADD INDEX ' . $db_prefix . 'topics_forum_id_idx(forum_id)';
            $queries[] = 'ALTER TABLE ' . $db_prefix . 'topics ADD INDEX ' . $db_prefix . 'topics_moved_to_idx(moved_to)';
            $queries[] = 'ALTER TABLE ' . $db_prefix . 'users ADD INDEX ' . $db_prefix . 'users_registered_idx(registered)';
            $queries[] = 'ALTER TABLE ' . $db_prefix . 'search_cache ADD INDEX ' . $db_prefix . 'search_cache_ident_idx(ident(8))';
            $queries[] = 'ALTER TABLE ' . $db_prefix . 'users ADD INDEX ' . $db_prefix . 'users_username_idx(username(8))';
            $queries[] = 'ALTER TABLE ' . $db_prefix . 'messages ADD FULLTEXT INDEX ' . $db_prefix . 'pm_message_idx(message)';
            break;
        default:
            $queries[] = 'CREATE INDEX ' . $db_prefix . 'online_user_id_idx ON ' . $db_prefix . 'online(user_id)';
            $queries[] = 'CREATE INDEX ' . $db_prefix . 'posts_topic_id_idx ON ' . $db_prefix . 'posts(topic_id)';
            $queries[] = 'CREATE INDEX ' . $db_prefix . 'posts_multi_idx ON ' . $db_prefix . 'posts(poster_id, topic_id)';
            $queries[] = 'CREATE INDEX ' . $db_prefix . 'reports_zapped_idx ON ' . $db_prefix . 'reports(zapped)';
            $queries[] = 'CREATE INDEX ' . $db_prefix . 'search_matches_word_id_idx ON ' . $db_prefix . 'search_matches(word_id)';
            $queries[] = 'CREATE INDEX ' . $db_prefix . 'search_matches_post_id_idx ON ' . $db_prefix . 'search_matches(post_id)';
            $queries[] = 'CREATE INDEX ' . $db_prefix . 'topics_forum_id_idx ON ' . $db_prefix . 'topics(forum_id)';
            $queries[] = 'CREATE INDEX ' . $db_prefix . 'topics_moved_to_idx ON ' . $db_prefix . 'topics(moved_to)';
            $queries[] = 'CREATE INDEX ' . $db_prefix . 'users_registered_idx ON ' . $db_prefix . 'users(registered)';
            $queries[] = 'CREATE INDEX ' . $db_prefix . 'users_username_idx ON ' . $db_prefix . 'users(username)';
            $queries[] = 'CREATE INDEX ' . $db_prefix . 'search_cache_ident_idx ON ' . $db_prefix . 'search_cache(ident)';
            $queries[] = 'CREATE INDEX ' . $db_prefix . 'search_words_id_idx ON ' . $db_prefix . 'search_words(id)';
            $queries[] = 'CREATE TABLE ' . $db_prefix . 'pm_message_idx ON ' . $db_prefix . 'messages(message)';
            break;
    }
    @reset($queries);
    while (list(, $sql) = @each($queries))
        $db->query($sql) or BB_Functions::Error('Unable to create indexes. Please check your configuration and try again.', __FILE__, __LINE__, $db->error());
    $now = time();
    $db->query('INSERT INTO ' . $db->prefix . "usergroups (g_title, g_user_title, g_color, g_read_board, g_post_replies, g_post_topics, g_post_polls, g_edit_posts, g_delete_posts, g_delete_topics, g_set_title, g_search, g_search_users, g_edit_subjects_interval, g_post_flood, g_search_flood, g_invitations, g_pm, g_pm_limit) VALUES('Administrators', 'Administrator', '#0813a2', 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 999, 1, 50)") or BB_Functions::Error('Unable to add group', __FILE__, __LINE__, $db->error());
    $db->query('INSERT INTO ' . $db->prefix . "usergroups (g_title, g_user_title, g_color, g_read_board, g_post_replies, g_post_topics, g_post_polls, g_edit_posts, g_delete_posts, g_delete_topics, g_set_title, g_search, g_search_users, g_edit_subjects_interval, g_post_flood, g_search_flood, g_invitations, g_pm, g_pm_limit) VALUES('Moderators', 'Moderator', '#7b088c', 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 50, 1, 30)") or BB_Functions::Error('Unable to add group', __FILE__, __LINE__, $db->error());
    $db->query('INSERT INTO ' . $db->prefix . "usergroups (g_title, g_user_title, g_color, g_read_board, g_post_replies, g_post_topics, g_post_polls, g_edit_posts, g_delete_posts, g_delete_topics, g_set_title, g_search, g_search_users, g_edit_subjects_interval, g_post_flood, g_search_flood, g_invitations, g_pm, g_pm_limit) VALUES('Guest', NULL, '#000000', 1, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0)") or BB_Functions::Error('Unable to add group', __FILE__, __LINE__, $db->error());
    $db->query('INSERT INTO ' . $db->prefix . "usergroups (g_title, g_user_title, g_color, g_read_board, g_post_replies, g_post_topics, g_post_polls, g_edit_posts, g_delete_posts, g_delete_topics, g_set_title, g_search, g_search_users, g_edit_subjects_interval, g_post_flood, g_search_flood, g_invitations, g_pm, g_pm_limit) VALUES('Members', NULL, '#333333', 1, 1, 1, 1, 1, 1, 1, 0, 1, 1, 300, 60, 30, 10, 1, 20)") or BB_Functions::Error('Unable to add group', __FILE__, __LINE__, $db->error());
    $db->query('INSERT INTO ' . $db_prefix . "users (gid, username, password, email) VALUES(3, 'Guest', 'Guest', 'Guest')") or BB_Functions::Error('Unable to add guest user. Please check your configuration and try again.');
    $db->query('INSERT INTO ' . $db_prefix . "users (gid, username, password, email, num_posts, last_post, registered, registration_ip, last_visit) VALUES(1, '" . $db->escape($username) . "', '" . xBB_Hash($password1) . "', '$email', 1, " . $now . ", " . $now . ", '127.0.0.1', " . $now . ')') or BB_Functions::Error('Unable to add administrator user. Please check your configuration and try again.');
    $db->query('INSERT INTO ' . $db_prefix . "bots (id, bot_alias, bot_string, time_stamp) VALUES (1, 'Googlebot', 'googlebot', 0)") or BB_Functions::Error('Unable to insert into table ' . $db_prefix . 'bots. Please check your configuration and try again.');
    $db->query('INSERT INTO ' . $db_prefix . "bots (id, bot_alias, bot_string, time_stamp) VALUES (2, 'MSNBot', 'msnbot', 0)") or BB_Functions::Error('Unable to insert into table ' . $db_prefix . 'bots. Please check your configuration and try again.');
    $db->query('INSERT INTO ' . $db_prefix . "bots (id, bot_alias, bot_string, time_stamp) VALUES (3, 'WISENutbot', 'wisenutbot', 0)") or BB_Functions::Error('Unable to insert into table ' . $db_prefix . 'bots. Please check your configuration and try again.');
    $db->query('INSERT INTO ' . $db_prefix . "bots (id, bot_alias, bot_string, time_stamp) VALUES (4, 'Alexa', 'ia_archiver', 0)") or BB_Functions::Error('Unable to insert into table ' . $db_prefix . 'bots. Please check your configuration and try again.');
    $db->query('INSERT INTO ' . $db_prefix . "bots (id, bot_alias, bot_string, time_stamp) VALUES (5, 'Yahoo Slurp', 'yahoo!', 0)") or BB_Functions::Error('Unable to insert into table ' . $db_prefix . 'bots. Please check your configuration and try again.');
    $db->query('INSERT INTO ' . $db_prefix . "bots (id, bot_alias, bot_string, time_stamp) VALUES (6, 'AskJeeves', 'ask jeeves/teoma', 0)") or BB_Functions::Error('Unable to insert into table ' . $db_prefix . 'bots. Please check your configuration and try again.');
    $db->query('INSERT INTO ' . $db_prefix . "bots (id, bot_alias, bot_string, time_stamp) VALUES (7, 'Google AdSense', 'mediapartners-google', 0)") or BB_Functions::Error('Unable to insert into table ' . $db_prefix . 'bots. Please check your configuration and try again.');
    $db->query('INSERT INTO ' . $db_prefix . "bots (id, bot_alias, bot_string, time_stamp) VALUES (8, 'BoardTracker', 'BoardTracker', 0)") or BB_Functions::Error('Unable to insert into table ' . $db_prefix . 'bots. Please check your configuration and try again.');
    $db->query('INSERT INTO ' . $db_prefix . "bots (id, bot_alias, bot_string, time_stamp) VALUES (9, 'Lycos', 'lycos', 0)") or BB_Functions::Error('Unable to insert into table ' . $db_prefix . 'bots. Please check your configuration and try again.');
    $db->query('INSERT INTO ' . $db_prefix . "bots (id, bot_alias, bot_string, time_stamp) VALUES (10, 'Altavista', 'scooter', 0)") or BB_Functions::Error('Unable to insert into table ' . $db_prefix . 'bots. Please check your configuration and try again.');
    $db->query('INSERT INTO ' . $db_prefix . "bots (id, bot_alias, bot_string, time_stamp) VALUES (11, 'AllTheWeb', 'fast-webcrawler', 0)") or BB_Functions::Error('Unable to insert into table ' . $db_prefix . 'bots. Please check your configuration and try again.');
    $db->query('INSERT INTO ' . $db_prefix . "bots (id, bot_alias, bot_string, time_stamp) VALUES (12, 'Inktomi', 'slurp@inktomi', 0)") or BB_Functions::Error('Unable to insert into table ' . $db_prefix . 'bots. Please check your configuration and try again.');
    $ads_config = array(
        'ads_bot_name' => "'AdBot'",
        'ads_bot_tag' => "'AdsPosting Bot'",
        'ads_exclude_forums' => "''",
        'ads_exclude_groups' => "''",
        'ads_display_after' => "'0'",
        'google_adsense_enabled' => "'0'",
        'google_ad_client' => "'pub-0000000000000000'",
        'google_ad_width' => "'468'",
        'google_ad_height' => "'60'",
        'google_ad_format' => "'468x60_as'",
        'google_ad_channel' => "''",
        'google_ad_type' => "'text'",
        'google_color_border' => "'#000000'",
        'google_color_bg' => "'#FFFFFF'",
        'google_color_link' => "'#005CB1'",
        'google_color_url' => "'#005CB1'",
        'google_color_text' => "'#333333'",
        'google_alternate_color' => "'#CCCCCC'",
        'clicksor_ads_enabled' => "'0'",
        'clicksor_default_url' => "''",
        'clicksor_layer_border_color' => "'#B4D0DC'",
        'clicksor_layer_ad_bg' => "'#ECF8FF'",
        'clicksor_layer_ad_link_color' => "'#0000CC'",
        'clicksor_layer_ad_text_color' => "'#000000'",
        'clicksor_text_link_bg' => "''",
        'clicksor_text_link_color' => "'#000FFF'",
        'clicksor_enable_text_link' => "'true'",
        'clicksor_banner_image_banner' => "'true'",
        'clicksor_banner_border' => "'#6666FF'",
        'clicksor_banner_ad_bg' => "'#CCCCFF'",
        'clicksor_banner_link_color' => "'#FF0000'",
        'clicksor_banner_text_color' => "'#000000'",
        'clicksor_pid' => "'42355'",
        'clicksor_sid' => "'55444'",
        'clicksor_ad_format' => "'1'",
        'yahoo_ads_enabled' => "'0'",
        'yahoo_ad_client' => "'0000000000'",
        'yahoo_ad_width' => "'468'",
        'yahoo_ad_height' => "'60'",
        'yahoo_ad_channel' => "''",
        'yahoo_color_border' => "'#FFFFFF'",
        'yahoo_color_bg' => "'#FFFFFF'",
        'yahoo_color_link' => "'#005CB1'",
        'yahoo_color_url' => "'#005CB1'",
        'yahoo_color_text' => "'#333333'",
        'yahoo_alternate_color' => "'#FFFFFF'",
        'neogen_ads_enabled' => "'0'",
        'neogen_ads_client' => "'0000000000'",
        'neogen_ads_plus' => "'V-%5B%5D0%0Ay%1D'",
        'neogen_ads_type' => "'text/image'",
        'neogen_ads_banner_format' => "'468x60'",
        'neogen_ads_color_border' => "'#336699'",
        'neogen_ads_color_bg' => "'#FFFFFF'",
        'neogen_ads_color_title' => "'#0000FF'",
        'neogen_ads_color_url' => "'#008000'",
        'neogen_ads_color_desc' => "'#000000'",
        'others_ads_enabled' => "'0'",
        'others_ads_code' => "''"
    );
    while (list($conf_name, $conf_value) = @each($ads_config))
    {
        $db->query('INSERT INTO ' . $db_prefix . "advertising_config (conf_name, conf_value) VALUES('$conf_name', $conf_value)") or BB_Functions::Error('Unable to insert into table ' . $db_prefix . 'config. Please check your configuration and try again.');
    }
    $cms_settings = new BB_Settings($db, $db->prefix . 'configuration');
    $res = true;
    $cms_settings->Set_Namespace('xennobb');
    $res &= $cms_settings->Save('bb_cur_version', '1.2.1');
    $res &= $cms_settings->Save('bb_board_title', 'XennoSE');
    $res &= $cms_settings->Save('bb_board_meta', 'XennoSE. Welcome to the future!');
    $res &= $cms_settings->Save('bb_server_timezone', 0);
    $res &= $cms_settings->Save('bb_time_format', 'g:i a');
    $res &= $cms_settings->Save('bb_date_format', 'F j, Y');
    $res &= $cms_settings->Save('bb_timeout_visit', 600);
    $res &= $cms_settings->Save('bb_timeout_online', 300);
    $res &= $cms_settings->Save('bb_redirect_delay', 1);
    $res &= $cms_settings->Save('bb_show_user_info', 1);
    $res &= $cms_settings->Save('bb_show_post_count', 1);
    $res &= $cms_settings->Save('bb_smilies', 1);
    $res &= $cms_settings->Save('bb_smilies_sig', 1);
    $res &= $cms_settings->Save('bb_make_links', 1);
    $res &= $cms_settings->Save('bb_default_lang', 'English');
    $res &= $cms_settings->Save('bb_default_style', 'Default');
    $res &= $cms_settings->Save('bb_default_user_group', 4);
    $res &= $cms_settings->Save('bb_topic_review', 15);
    $res &= $cms_settings->Save('bb_disp_topics_default', 30);
    $res &= $cms_settings->Save('bb_disp_posts_default', 25);
    $res &= $cms_settings->Save('bb_indent_num_spaces', 4);
    $res &= $cms_settings->Save('bb_quickpost', 1);
    $res &= $cms_settings->Save('bb_users_online', 1);
    $res &= $cms_settings->Save('bb_censoring', 0);
    $res &= $cms_settings->Save('bb_ranks', 1);
    $res &= $cms_settings->Save('bb_show_dot', 0);
    $res &= $cms_settings->Save('bb_quickjump', 1);
    $res &= $cms_settings->Save('bb_gzip', 0);
    $res &= $cms_settings->Save('bb_additional_navlinks', $add_links);
    $res &= $cms_settings->Save('bb_report_method', 0);
    $res &= $cms_settings->Save('bb_regs_report', 0);
    $res &= $cms_settings->Save('bb_mailing_list', $email);
    $res &= $cms_settings->Save('bb_avatars', 1);
    $res &= $cms_settings->Save('bb_avatars_dir', 'img/avatars');
    $res &= $cms_settings->Save('bb_avatars_width', 100);
    $res &= $cms_settings->Save('bb_avatars_height', 100);
    $res &= $cms_settings->Save('bb_avatars_size', 32240);
    $res &= $cms_settings->Save('bb_search_all_forums', 1);
    $res &= $cms_settings->Save('bb_admin_email', $email);
    $res &= $cms_settings->Save('bb_webmaster_email', $email);
    $res &= $cms_settings->Save('bb_subscriptions', 1);
    $res &= $cms_settings->Save('bb_smtp_host', '');
    $res &= $cms_settings->Save('bb_smtp_user', '');
    $res &= $cms_settings->Save('bb_smtp_pass', '');
    $res &= $cms_settings->Save('bb_regs_allow', 1);
    $res &= $cms_settings->Save('bb_regs_verify', 0);
    $res &= $cms_settings->Save('bb_announcement', 0);
    $res &= $cms_settings->Save('bb_announcement_message', 'Enter your announcement here.');
    $res &= $cms_settings->Save('bb_rules', 0);
    $res &= $cms_settings->Save('bb_rules_message', 'Enter your rules here.');
    $res &= $cms_settings->Save('bb_maintenance', 0);
    $res &= $cms_settings->Save('bb_maintenance_message', 'The forums are temporarily down for maintenance. Please try again in a few minutes.<br /><br />/Administrator');
    $res &= $cms_settings->Save('bb_mod_edit_users', 1);
    $res &= $cms_settings->Save('bb_mod_rename_users', 0);
    $res &= $cms_settings->Save('bb_mod_change_passwords', 0);
    $res &= $cms_settings->Save('bb_mod_ban_users', 0);
    $res &= $cms_settings->Save('bb_message_bbcode', 1);
    $res &= $cms_settings->Save('bb_message_img_tag', 1);
    $res &= $cms_settings->Save('bb_message_all_caps', 1);
    $res &= $cms_settings->Save('bb_subject_all_caps', 1);
    $res &= $cms_settings->Save('bb_sig_all_caps', 1);
    $res &= $cms_settings->Save('bb_sig_bbcode', 1);
    $res &= $cms_settings->Save('bb_sig_img_tag', 0);
    $res &= $cms_settings->Save('bb_sig_length', 400);
    $res &= $cms_settings->Save('bb_sig_lines', 4);
    $res &= $cms_settings->Save('bb_allow_banned_email', 1);
    $res &= $cms_settings->Save('bb_allow_dupe_email', 0);
    $res &= $cms_settings->Save('bb_force_guest_email', 1);
    $res &= $cms_settings->Save('bb_is_upload', 0);
    $res &= $cms_settings->Save('bb_allowed_ext', 'gif,png,jpg,jpeg');
    $res &= $cms_settings->Save('bb_max_width', 800);
    $res &= $cms_settings->Save('bb_max_height', 600);
    $res &= $cms_settings->Save('bb_max_size', 524288);
    $res &= $cms_settings->Save('bb_thumb_width', 100);
    $res &= $cms_settings->Save('bb_thumb_height', 100);
    $res &= $cms_settings->Save('bb_table_cols', 4);
    $res &= $cms_settings->Save('bb_max_post_images', 4);
    $res &= $cms_settings->Save('bb_upload_path', $upload_url);
    $res &= $cms_settings->Save('bb_reputation_timeout', 300);
    $res &= $cms_settings->Save('bb_reputation_enabled', 1);
    $res &= $cms_settings->Save('bb_guest_information_message', 'Please register!');
    $res &= $cms_settings->Save('bb_guest_information', 0);
    $res &= $cms_settings->Save('bb_advertisement_message', 'Enter your advertisement here.');
    $res &= $cms_settings->Save('bb_advertisement', 0);
    $res &= $cms_settings->Save('bb_information_message', 'Enter your information here.');
    $res &= $cms_settings->Save('bb_timeout_flood', 3600);
    $res &= $cms_settings->Save('bb_information', 0);
    $res &= $cms_settings->Save('bb_poll_max_fields', 6);
    $res &= $cms_settings->Save('bb_regs_verify_image', 1);
    $res &= $cms_settings->Save('bb_most_active', 0);
    $res &= $cms_settings->Save('bb_boardstats_enable', 1);
    $res &= $cms_settings->Save('bb_onlist_enable', 1);
    $res &= $cms_settings->Save('bb_online_users_today', 0);
    $res &= $cms_settings->Save('bb_um_enable', 0);
    $res &= $cms_settings->Save('bb_um_key', '');
    $res &= $cms_settings->Save('bb_um_default_zoom', 12);
    $res &= $cms_settings->Save('bb_um_default_lat', 44.80);
    $res &= $cms_settings->Save('bb_um_default_lng', 25.70);
    $res &= $cms_settings->Save('bb_board_meta_author', 1);
    $res &= $cms_settings->Save('bb_board_meta_keywords', 'xennobb, xenobb, xbb, xenno, xennobb group, php board, php forum, bulletin board');
    $res &= $cms_settings->Save('bb_rewrite_urls', 0);
    $res &= $cms_settings->Save('bb_notes', '');
    $res &= $cms_settings->Save('bb_notes_todo', '');
    $res &= $cms_settings->Save('bb_pms_enabled', 1);
    $res &= $cms_settings->Save('bb_pms_mess_per_page', 20);
    $res &= $cms_settings->Save('bb_profile_fields_enable', 0);
    $res &= $cms_settings->Save('bb_enable_country', 1);
    $res &= $cms_settings->Save('bb_show_legend', 1);
    $res &= $cms_settings->Save('bb_rss_type', 2);
    $res &= $cms_settings->Save('bb_ranks_enable', 1);
    $res &= $cms_settings->Save('bb_formatting', 'BBCode');
    $res &= $cms_settings->Save('bb_spam_settings', 'sbl-xbl.spamhaus.org,3600,5,10,0,0');
    $res &= $cms_settings->Save('bb_spam_protect', 'edit.php,misc.php,post.php,member.php');
    $res &= $cms_settings->Save('bb_show_announcement', 0);
    $res &= $cms_settings->Save('bb_website_url', $base_url);
    $res &= $cms_settings->Save('bb_forum_url', $forum_url);
    $res &= $cms_settings->Save('bb_default_module', 'news');

    // Added in 1.1
    $res &= $cms_settings->Save('bb_quicklinks', 1);
    $res &= $cms_settings->Save('bb_welcoming_post', 0);
    $res &= $cms_settings->Save('bb_welcoming_post_msg', '');
    $res &= $cms_settings->Save('bb_welcoming_post_title', '');
    $res &= $cms_settings->Save('bb_welcoming_post_poster', '');
    $res &= $cms_settings->Save('bb_welcoming_post_fid', '');
    $res &= $cms_settings->Save('bb_welcoming_pm', 0);
    $res &= $cms_settings->Save('bb_welcoming_pm_msg', '');
    $res &= $cms_settings->Save('bb_welcoming_pm_title', '');
    $res &= $cms_settings->Save('bb_welcoming_pm_sender', '');
    $res &= $cms_settings->Save('bb_message_bbcode_media', 1);

    $cms_settings->Set_Namespace('module_news');
    $res &= $cms_settings->Save('bb_module_news', 1);
    $res &= $cms_settings->Save('bb_module_news_mode', 1);
    $res &= $cms_settings->Save('bb_module_news_forum_id', 1);
    $res &= $cms_settings->Save('bb_module_news_num_posts', 5);
    $res &= $cms_settings->Save('bb_module_news_truncat_news', 0);
    $res &= $cms_settings->Save('bb_module_news_date_format', 'F j, Y g:i a');
    $cms_settings->Set_Namespace('block_login');
    $res &= $cms_settings->Save('bb_block_login', 1);
    $cms_settings->Set_Namespace('permissions');
    $res &= $cms_settings->Save('bb_perm_modules', 0);
    $res &= $cms_settings->Save('bb_perm_blocks', 0);
    $res &= $cms_settings->Save('bb_perm_themes', 0);
    $res &= $cms_settings->Save('bb_perm_langs', 0);
    $res &= $cms_settings->Save('bb_perm_module_news', 0);
    $res &= $cms_settings->Save('bb_perm_block_login', 0);
    $cms_settings->Set_Namespace('');

    $db->query('INSERT INTO ' . $db_prefix . "smilies (id, image, text, disp_position) VALUES (1, 'smile.gif', ':)', 0),(2, 'hh.gif', '=)', 0),(3, 'sad.gif', ':(', 0),(4, 'sad.gif', '=(', 0),(5, 'sad.gif', ':sad:', 0),(6, 'smile.gif', ':smile:', 0),(7, 'grin.gif', ':D', 0),(8, 'grin.gif', '=D', 0),(9, 'unsure.gif', ':o', 0),(10, 'unsure.gif', ':O', 0),(11, 'wink.gif', ';)', 0),(12, 'weird.gif', ':weird:', 0),(13, 'tongue.gif', ':P', 0),(14, 'tongue.gif', ':p', 0),(15, 'laugh.gif', ':lol:', 0),(16, 'sick.gif', ':sick:', 0),(17, 'mad.gif', ':mad:', 0),(18, 'rolleyes.gif', ':rolleyes:', 0),(19, 'kiss.gif', ':kiss:', 0),(20, 'grin.gif', ':biggrin:', 0),(21, 'love.gif', ':love:', 0),(22, 'bored.gif', ':bored:', 0),(23, 'cool.gif', ':cool:', 0),(24, 'omg.gif', ':ohmy:', 0),(25, 'ninja.gif', ':ninja:', 0),(26, 'smoking.gif', ':smoking:', 0),(27, 'sleep.gif', ':sleep:', 0),(28, 'bleh.gif', ':bleh:', 0),(29, 'wink.gif', ':wink:', 0),(30, 'shifty.gif', ':shifty:', 0),(31, 'mad2.gif', ':mad2:', 0),(32, 'updown.gif', ':updown:', 0),(33, 'shock.gif', ':shock:', 0),(34, 'cry.gif', ':cry:', 0)") or BB_Functions::Error('Unable to insert into table ' . $db_prefix . 'smilies. Please check your configuration and try again.');
    $db->query('INSERT INTO ' . $db_prefix . "botsconfig (id, display_time, isCaseSensitive, isEnabled) VALUES (1, 10, 0, 1)") or BB_Functions::Error('Unable to insert into table ' . $db_prefix . 'botsconfig. Please check your configuration and try again.');
    $db->query('INSERT INTO ' . $db_prefix . "categories (cat_name, disp_position) VALUES('Test category', 1)") or BB_Functions::Error('Unable to insert into table ' . $db_prefix . 'categories. Please check your configuration and try again.');
    $db->query('INSERT INTO ' . $db_prefix . "forums (forum_name, forum_desc, num_topics, num_posts, last_post, last_post_id, last_poster, disp_position, cat_id) VALUES('Test forum', 'This is just a test forum', 1, 1, " . $now . ", 1, '" . $db->escape($username) . "', 1, 1)") or BB_Functions::Error('Unable to insert into table ' . $db_prefix . 'forums. Please check your configuration and try again.');
    $db->query('INSERT INTO ' . $db_prefix . "topics (poster, subject, posted, last_post, last_post_id, last_poster, forum_id) VALUES('" . $db->escape($username) . "', 'Install Succcessfull', " . $now . ", " . $now . ", 1, '" . $db->escape($username) . "', 1)") or BB_Functions::Error('Unable to insert into table ' . $db_prefix . 'topics. Please check your configuration and try again.');
    $db->query('INSERT INTO ' . $db_prefix . "posts (poster, poster_id, poster_ip, message, posted, topic_id) VALUES('" . $db->escape($username) . "', 2, '127.0.0.1', '[b][color=#009900]The installation of XennoBB was successful and is now complete![/color][/b]\n\n[hr]\n[b]Resources[/b]\n- [url=http://www.xennobb.com]Homepage[/url]\n- [url=http://community.xennobb.com]Community Forums[/url]\n- [url=http://docs.xennobb.com]Documentation[/url]\n- [url=http://docs.xennobb.com/using/faq]FAQ[/url]\n\n[hr]\n[color=#FF0000]Don`t forget to remove the directory /install/ and all of its content.[/color]\n[i]You might also want to delete this post. To do so, click on Delete below.[/i]\n', " . $now . ', 1)') or BB_Functions::Error('Unable to insert into table ' . $db_prefix . 'posts. Please check your configuration and try again.');
    $db->query('INSERT INTO ' . $db_prefix . "ranks (rank, min_posts) VALUES('New member', 0)") or BB_Functions::Error('Unable to insert into table ' . $db_prefix . 'ranks. Please check your configuration and try again.');
    $db->query('INSERT INTO ' . $db_prefix . "ranks (rank, min_posts) VALUES('Member', 10)") or BB_Functions::Error('Unable to insert into table ' . $db_prefix . 'ranks. Please check your configuration and try again.');
    if ($db_type == 'pgsql' || $db_type == 'sqlite')
        $db->end_transaction();
    $config = '<?php' . "\n" . '$db_type = \'' . $db_type . "';\n" . '$db_host = \'' . $db_host . "';\n" . '$db_name = \'' . $db_name . "';\n" . '$db_username = \'' . $db_username . "';\n" . '$db_password = \'' . $db_password . "';\n" . '$db_prefix = \'' . $db_prefix . "';\n" . '$p_connect = false;' . "\n\n" . '$cookie_name = ' . "'forum_cookie';\n" . '$cookie_domain = ' . "'';\n" . '$cookie_path = ' . "'/';\n" . '$cookie_secure = 0;' . "\n" . '$forum_folder = \'community\';' . "\n" . '$cookie_seed = \'' . substr(md5(time()), -8) . "';\ndefine('IN_FORUM', 1);\ndefine('FORUM_ROOT','" . $forum_path . "');\n?>";
    $file = fopen("../include/config.php", 'wb');
    fwrite($file, $config);
    fclose($file);
    ?>
    <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
    <html dir="ltr">
        <head>
            <link rel="shortcut icon" href="../community/img/general/favicon.ico" />
            <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
            <title>XennoBB - Install</title>
            <link rel="stylesheet" type="text/css" href="../include/templates/Default/stylesheet.css" />
        </head>
        <body>
            <div id="wrap">
                <div id="wrap-inner">
                    <div id="main-body">
                        <div id="xenno_wrapper_type1">
                            <div id="xenno_index" class="xenno_main">
                                <div id="xenno_header" class="xenno_block">
                                    <div class="box">
                                        <div id="xenno_title" class="inbox">
                                            <h1><span>&nbsp;</span></h1>
                                        </div>
                                    </div>
                                </div>
                                <div class="blocktable">
                                    <h2><span style="padding-left:10px">XennoBB Installation Wizard - Database Setup</span></h2>
                                    <div class="box">
                                        <div class="inform" style="padding:20px">
                                            <p align="justify">Populating database tables ... completed.</p>
                                            <p align="justify">All tables have been created succesfully. You can proceed now to the next step.</p>
                                            <br /><br />
                                            <div style="border:1px solid #DDDDDD;padding:5px;text-align:center;"><a href="install_step3.php">Click here to proceed to the next step</a></div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div id="footer">
                        <p>powered by <a href="http://www.userdot.net/projects/xennobb"><b>XennoBB</b></a><br />&copy; 2005-2011 <a href="http://www.userdot.net"><b>UserDot</b></a>. All rights reserved.</p>
                    </div>
                </div>
            </div>
        </body>
    </html>
    <?php
}
else
{
    $dual_mysql = false;
    $db_extensions = array();
    if (function_exists('mysqli_connect'))
        $db_extensions[] = array('mysqli', 'MySQL Improved');
    if (function_exists('mysql_connect'))
    {
        $db_extensions[] = array('mysql', 'MySQL Standard');
        if (count($db_extensions) > 1)
            $dual_mysql = true;
    }
    if (function_exists('sqlite_open'))
        $db_extensions[] = array('sqlite', 'SQLite');
    if (function_exists('pg_connect'))
        $db_extensions[] = array('pgsql', 'PostgreSQL');
    if (empty($db_extensions))
        exit('This PHP environment does not have support for any of the databases that XennoBB supports. PHP needs to have support for either MySQL, PostgreSQL or SQLite in order for XennoBB to be installed.');
    ?>
    <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
    <html dir="ltr">
        <head>
            <link rel="shortcut icon" href="../community/img/general/favicon.ico" />
            <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
            <title>XennoBB - Install</title>
            <script type="text/javascript" src="../include/js/lib.js"></script>
            <script type="text/javascript">var ol_textsize = "10px";var ol_fgcolor = "#FFFFFF";</script>
            <script type="text/javascript">
                <!--
                function process_form(the_form)
                {
                    var element_names = new Object()
                    element_names["req_db_type"] = "Database type"
                    element_names["req_db_host"] = "Database server hostname"
                    element_names["req_db_name"] = "Database name"
                    if (document.all || document.getElementById)
                    {
                        for (i = 0; i < the_form.length; ++i)
                        {
                            var elem = the_form.elements[i]
                            if (elem.name && elem.name.substring(0, 4) == "req_")
                            {
                                if (elem.type && (elem.type=="text" || elem.type=="textarea" || elem.type=="password" || elem.type=="file") && elem.value=='')
                                {
                                    alert("\"" + element_names[elem.name] + "\" is a required field in this form.")
                                    elem.focus()
                                    return false
                                }
                            }
                        }
                    }
                    return true
                }
                // -->
            </script>
            <link rel="stylesheet" type="text/css" href="../include/templates/Default/stylesheet.css" />
        </head>
        <body>
            <div id="wrap">
                <div id="wrap-inner">
                    <div id="main-body">
                        <div id="xenno_wrapper_type1">
                            <div id="xenno_index" class="xenno_main">
                                <div id="xenno_header" class="xenno_block">
                                    <div class="box">
                                        <div id="xenno_title" class="inbox">
                                            <h1><span>&nbsp;</span></h1>
                                        </div>
                                    </div>
                                </div>
                                <div class="blocktable">
                                    <h2><span style="padding-left:10px">XennoBB Installation Wizard - Database Setup</span></h2>
                                    <div class="box">
                                        <div class="inform" style="padding:20px">
                                            <p align="justify">Below you can provide the connection parameters for the database server where you want to install XennoBB. If you haven't done it yet, now would be a good time to create the database where you want XennoBB installed.</p>
                                            <form id="install" name="frmDatabase" method="post" action="install_step2.php"><input type="hidden" name="form_sent" value="1" />
                                                <table border="0">
                                                    <tr>
                                                        <th style="border-bottom:0px" width="200">Database Type</th>
                                                        <td style="border-bottom:0px;width:25px">&nbsp;&nbsp;<img src="../community/img/admin/tooltip.png" onmouseover="return xBB_Show_Tooltip('Database type (Supported : MySQL, PostgreSQL, SQLite).');" onmouseout="return nd();" alt="" /></td>
                                                        <td style="border-bottom:0px"><select name="req_db_type">
    <?php
    foreach ($db_extensions as $db_type)
        echo "\t\t\t\t\t\t\t" . '<option value="' . $db_type[0] . '">' . $db_type[1] . '</option>' . "\n";
    ?>
                                                            </select></td>
                                                    </tr>
                                                    <tr>
                                                        <th style="border-bottom:0px">Database Server</th>
                                                        <td style="border-bottom:0px;width:25px">&nbsp;&nbsp;<img src="../community/img/admin/tooltip.png" onmouseover="return xBB_Show_Tooltip('Database server (usually localhost).');" onmouseout="return nd();" alt="" /></td>
                                                        <td style="border-bottom:0px"><input class="textbox" type="text" name="req_db_host" value="localhost" size="30" /></td>
                                                    </tr>
                                                    <tr>
                                                        <th style="border-bottom:0px">Database Name</th>
                                                        <td style="border-bottom:0px;width:25px">&nbsp;&nbsp;<img src="../community/img/admin/tooltip.png" onmouseover="return xBB_Show_Tooltip('The name of the database you want to install XennoBB into (Must be already created).');" onmouseout="return nd();" alt="" /></td>
                                                        <td style="border-bottom:0px"><input class="textbox" type="text" name="req_db_name" value="" size="30" /></td>
                                                    </tr>
                                                    <tr>
                                                        <th style="border-bottom:0px">Database User</th>
                                                        <td style="border-bottom:0px;width:25px">&nbsp;&nbsp;<img src="../community/img/admin/tooltip.png" onmouseover="return xBB_Show_Tooltip('Database username');" onmouseout="return nd();" alt="" /></td>
                                                        <td style="border-bottom:0px"><input class="textbox" type="text" name="db_username" value="" size="30" /></td>
                                                    </tr>
                                                    <tr>
                                                        <th style="border-bottom:0px">Database Password</th>
                                                        <td style="border-bottom:0px;width:25px">&nbsp;&nbsp;<img src="../community/img/admin/tooltip.png" onmouseover="return xBB_Show_Tooltip('Database password');" onmouseout="return nd();" alt="" /></td>
                                                        <td style="border-bottom:0px"><input class="textbox" type="password" name="db_password" value="" size="30" /></td>
                                                    </tr>
                                                    <tr>
                                                        <th style="border-bottom:0px">Database Prefix</th>
                                                        <td style="border-bottom:0px;width:25px">&nbsp;&nbsp;<img src="../community/img/admin/tooltip.png" onmouseover="return xBB_Show_Tooltip('Database prefix (for installations in the same db, leave empty for the installer to generate a random one).');" onmouseout="return nd();" alt="" /></td>
                                                        <td style="border-bottom:0px"><input class="textbox" type="text" name="db_prefix" value="" size="30" /></td>
                                                    </tr>
                                                    <tr>
                                                        <th style="border-bottom:0px">Administrator Username</th>
                                                        <td style="border-bottom:0px;width:25px">&nbsp;&nbsp;<img src="../community/img/admin/tooltip.png" onmouseover="return xBB_Show_Tooltip('The username of the XennoBB administrator account.');" onmouseout="return nd();" alt="" /></td>
                                                        <td style="border-bottom:0px"><input class="textbox" type="text" name="req_username" value="" size="30" /></td>
                                                    </tr>
                                                    <tr>
                                                        <th style="border-bottom:0px">Administrator Password</th>
                                                        <td style="border-bottom:0px;width:25px">&nbsp;&nbsp;<img src="../community/img/admin/tooltip.png" onmouseover="return xBB_Show_Tooltip('The password of the XennoBB administrator account.');" onmouseout="return nd();" alt="" /></td>
                                                        <td style="border-bottom:0px"><input class="textbox" type="password" name="req_password1" value="" size="30" /></td>
                                                    </tr>
                                                    <tr>
                                                        <th style="border-bottom:0px">Confirm Password</th>
                                                        <td style="border-bottom:0px;width:25px">&nbsp;&nbsp;<img src="../community/img/admin/tooltip.png" onmouseover="return xBB_Show_Tooltip('Confirm the password entered above.');" onmouseout="return nd();" alt="" /></td>
                                                        <td style="border-bottom:0px"><input class="textbox" type="password" name="req_password2" value="" size="30" /></td>
                                                    </tr>
                                                    <tr>
                                                        <th style="border-bottom:0px">Administrator E-Mail</th>
                                                        <td style="border-bottom:0px;width:25px">&nbsp;&nbsp;<img src="../community/img/admin/tooltip.png" onmouseover="return xBB_Show_Tooltip('The E-Mail address of the administrator.');" onmouseout="return nd();" alt="" /></td>
                                                        <td style="border-bottom:0px"><input class="textbox" type="text" name="req_email" value="" size="40" /></td>
                                                    </tr>
                                                    <tr>
                                                        <th style="border-bottom:0px">Base Website URL</th>
                                                        <td style="border-bottom:0px;width:25px">&nbsp;&nbsp;<img src="../community/img/admin/tooltip.png" onmouseover="return xBB_Show_Tooltip('The URL of the forum. Prefix with http:// (ex. http://www.myforum.com/forum).');" onmouseout="return nd();" alt="" /></td>
                                                        <td style="border-bottom:0px"><input class="textbox" type="text" name="req_base_url" value="http://<?php echo str_replace('install/install_step2.php', '', $_SERVER['SERVER_NAME'] . $_SERVER['SCRIPT_NAME']); ?>" size="40" /></td>
                                                    </tr>
                                                    <tr>
                                                        <th style="border-bottom:0px">Base Website Path</th>
                                                        <td style="border-bottom:0px;width:25px">&nbsp;&nbsp;<img src="../community/img/admin/tooltip.png" onmouseover="return xBB_Show_Tooltip('The path to the website. Prefix with / (ex. /home/user/public_html/xenno/).');" onmouseout="return nd();" alt="" /></td>
                                                        <td style="border-bottom:0px"><input class="textbox" type="text" name="req_forum_path" value="<?php echo str_replace('\\', '/', str_replace('install', '', dirname(__FILE__))); ?>" size="40" /></td>
                                                    </tr>
                                                </table>
                                            </form>
                                            <br /><br />
                                            <div style="border:1px solid #DDDDDD;padding:5px;text-align:center;"><a href="javascript:document.frmDatabase.submit();">Click here to create XennoBB's database tables and proceed to the next step</a></div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div id="footer">
                        <p>powered by <a href="http://www.userdot.net/projects/xennobb"><b>XennoBB</b></a><br />&copy; 2005-2011 <a href="http://www.userdot.net"><b>UserDot</b></a>. All rights reserved.</p>
                    </div>
                </div>
            </div>
        </body>
    </html>
    <?php
}
?>
